-- {13.1.19.8684_13.2.539.8684}
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


IF  EXISTS (SELECT * FROM sys.triggers WHERE object_id = OBJECT_ID(N'[dbo].[MEASURES_UPDATE_03]'))
DROP TRIGGER [dbo].[MEASURES_UPDATE_03]
GO


create trigger [dbo].[MEASURES_UPDATE_03] ON [dbo].[MEASURES]
for update
as
begin
	if dbo.j_sub_str(dbo.get_val('NASTR_LOGGING_EVENTS','MCASE_VALUE',null),'#',1)&8=8
		begin
			declare @nEventCat int
			select @nEventCat = Id from dbo.EVENT_CATEGORY where Name = ''

			insert ELM_EVENTSLOG(EVENT_TYPE, EVENT_CATEGORY, EVENT_MESSAGE, [OBJECT], [ACTION])
			select
				2,
				@nEventCat,
				left('  "' + isnull((select A.[FULLNAME] from dbo.MEASURES where MEASUREID = A.MEASUREID),'') + '":  '
					+ case when A.FULLNAME = B.FULLNAME then '' else ('"" "' + isnull(B.FULLNAME,'') + '" -> "' + isnull(A.FULLNAME,'') + '" ') end
					+ case when A.SHORTNAME = B.SHORTNAME then '' else ('"" "' + isnull(B.SHORTNAME,'') + '" -> "' + isnull(A.SHORTNAME,'') + '" ') end
					+ case when A.DESCRIPTION = B.DESCRIPTION then '' else ('"" "' + isnull(B.DESCRIPTION,'') + '" -> "' + isnull(A.DESCRIPTION,'') + '" ') end
					+ case when A.PRECISION = B.PRECISION then '' else ('"" "' + convert(varchar(20),isnull(B.PRECISION,'')) + '" -> "' + convert(varchar(20),isnull(A.PRECISION,'')) + '" ') end
					+ case when A.ZERO = B.ZERO then '' else ('"  "="' + case when A.ZERO = 1 then '' else '' end + '" ') end
					+ case when A.MS_TYPE = B.MS_TYPE then '' else ('""="' + case when A.[MS_TYPE] = 0 then '' when A.[MS_TYPE] = 1 then '' when A.[MS_TYPE] = 2 then '' when A.[MS_TYPE] = 3 then '' when A.[MS_TYPE] = 4 then '' when A.[MS_TYPE] = 5 then '' else '' end + '" ') end
					+ case when isnull(A.MS_FORMULA_TYPE,0) = isnull(B.MS_FORMULA_TYPE,0) then '' else ('"  "="' + isnull(convert(varchar(20),A.MS_FORMULA_TYPE),'Null') + '" ') end
					+ case when A.ISGROUP = B.ISGROUP then '' else ('""="' + case when A.ISGROUP = 1 then '' else '' end + '" ') end
				,1000),
				'ID:' + convert(varchar(20),A.measureid),
				2 --  S_ACTION
			from inserted A, deleted B
			where A.measureid = B.measureid and 
				(A.FULLNAME <> B.FULLNAME or A.SHORTNAME <> B.SHORTNAME or A.DESCRIPTION <> B.DESCRIPTION or A.PRECISION <> B.PRECISION or A.ZERO <> B.ZERO
					or A.MS_TYPE <> B.MS_TYPE or A.MS_FORMULA_TYPE <> B.MS_FORMULA_TYPE or A.ISGROUP <> B.ISGROUP)
		end
end
GO




if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[T_RELATION_DELETE_01]') and objectproperty(id, N'IsTrigger') = 1)
	drop trigger [dbo].[T_RELATION_DELETE_01]
GO


create trigger [dbo].[T_RELATION_DELETE_01] ON [dbo].[T_RELATION] 
for delete
as
begin
	set nocount on
	declare @nObjectDTS int
	select @nObjectDTS = dbo.obj_id('DICTIONARY_DATASOURCE')
	
--select * from deleted
	if exists (select * from deleted D, T_RELATION TR, VERSION V where D.CHILDID = TR.CHILDID and TR.CHILDID = V.VersionID and V.OBJECT = @nObjectDTS)
		begin
			declare @nDTS int, @nObjectProj int
			select @nObjectProj = dbo.obj_id('DICTIONARY_PROJECT')
			
			select distinct D.CHILDID as VersionID
			into #TRD_00
			from deleted D, T_RELATION TR, VERSION V
			where D.CHILDID = TR.CHILDID and TR.CHILDID = V.VersionID and V.OBJECT = @nObjectDTS
			
--select '1',* from #TRD_00
			create table #TRD_01 (VersionID int)
			
			while exists(select * from #TRD_00)
				begin
					select top 1 @nDTS = VersionID from #TRD_00

					--      
					-- .          
					insert #TRD_01 (VersionID)
					select V.VersionID
					from deleted D cross apply dbo.tree_version (D.PARENTID, 'UP') TV, VERSION V
					where TV.LINK = V.VersionID and V.[OBJECT] = @nObjectProj and D.CHILDID = @nDTS
					
--select '2',* from #TRD_01

					if exists (select * from #TRD_01)
						begin
							--     
							select distinct D.VERSIONID as Proj, V.VersionID
							into #TRD_02
							from #TRD_01 D cross apply dbo.tree_version (D.VERSIONID, 'DOWN') TV, VERSION V
							where TV.LINK = V.VersionID and V.[OBJECT] = @nObjectDTS
							
--select '3',* from #TRD_02
							if exists(select * from #TRD_02)
								begin
									--         
									select distinct D.Proj, TM.MEASUREID
									into #TRD_03
									from #TRD_02 D, T_MEASURE TM
									where D.VERSIONID = TM.VERSIONID and not exists(select * from deleted where CHILDID = D.VERSIONID)
--select '4',* from #TRD_03
									--     
									delete T_MEASURE_PROJ
									from #TRD_03 T, T_MEASURE_PROJ TMP
									where T.PROJ = TMP.VERSIONID and not exists(select * from #TRD_03 where MEASUREID = TMP.MEASUREID)
									
									--        
									select distinct D.Proj, ST.ClassificatorID
									into #TRD_04
									from #TRD_02 D, SOURCETEMPLATE ST
									where D.VERSIONID = ST.VERSIONID and not exists(select * from deleted where CHILDID = D.VERSIONID)
--select '5',* from #TRD_04
									--     
									delete T_CLASSIFICATORS
									from #TRD_04 T, T_CLASSIFICATORS TC
									where T.PROJ = TC.VERSIONID and not exists(select * from #TRD_04 where CLASSIFICATORID = TC.CLASSIFICATORID)

								end
							else	
								begin
--select '6'
									--    
									delete T_MEASURE_PROJ from #TRD_01 T where T.VERSIONID = T_MEASURE_PROJ.VERSIONID
									--    
									delete T_CLASSIFICATORS from #TRD_01 T where T.VERSIONID = T_CLASSIFICATORS.VERSIONID
								end
	
						end

					delete #TRD_00 where @nDTS = VersionID 
				end		
		end
end
GO




