-- {13.1.19.8684_13.2.539.8684}
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


/****** Object:  StoredProcedure [dbo].[SIGNATURE_INFO]    Script Date: 03/22/2012 08:28:16 ******/
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[SIGNATURE_INFO]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[SIGNATURE_INFO]
GO


/*
:
	  
:
	@cObjCode -	 
	@cTable -    
	@cInto -    
 :
	
 :
	--1-
	create table #wtc_DocInfo (id int, doc_link int, level tinyint, CertServerVersion varchar(50), XPKSwVersion varchar(50), CheckSignature varchar(4), CheckSignatureStatus varchar(500), FindCertificate varchar(4), FindCertificateStatus varchar(500), CheckChain varchar(4), CheckChainStatus varchar(500), Subject varchar(500), SubjectName varchar(500), REASON varchar(500))
	exec Signature_Info @cObjCode = 'DOCUMENTS_T0401002', @cTable = '#wtc', @cInto = '#wtc_DocInfo'

	--2-
	exec Signature_Info @cObjCode = 'DOCUMENTS_T0401002', @cTable = '#wtc'
:
:
	 .
*/
CREATE PROCEDURE [dbo].[SIGNATURE_INFO]
	@cObjCode varchar(30),
	@cTable varchar(100),
	@cInto varchar(100) = ''
AS
BEGIN
SET ARITHABORT ON
SET CONCAT_NULL_YIELDS_NULL ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET NUMERIC_ROUNDABORT OFF
set nocount on
set transaction isolation level read uncommitted

create table #work([order] int, [type] int, [html] varchar(8000))		
create table #si_doc_check (link int)
create table #tSignature (link int, siglink int, signature text, text text, level tinyint, date datetime, nUser int, isValid bit default 0, done bit default 0)

--     xp_checkdigt
create table #si_DocInfo (id int, doc_link int, level tinyint, date datetime, users int, CertServerVersion varchar(50), XPKSwVersion varchar(50), CheckSignature varchar(4), CheckSignatureStatus varchar(500), FindCertificate varchar(4), FindCertificateStatus varchar(500), CheckChain varchar(4), CheckChainStatus varchar(500), CadesCheck varchar(4), CadesCheckStatus varchar(500), Subject varchar(500), SubjectName varchar(500), [Check] varchar(4) default 'OK', REASON varchar(2000) default '', OrganizationName varchar(128), SUBJECTSN varchar(100), ISSUERX500 varchar(1000), SUBJECTX500 varchar(1000))
create table #t_retValues (CertServerVersion varchar(50), XPKSwVersion varchar(50), CheckSignature varchar(4), CheckSignatureStatus varchar(500), FindCertificate varchar(4), FindCertificateStatus varchar(500), CheckChain varchar(4), CheckChainStatus varchar(500), Subject varchar(500), SubjectName varchar(500), error varchar(500), [Check] varchar(4), REASON varchar(2000) default '')
create table #t_retValueXML (xml_text varchar(8000))

declare
	@cErr varchar(8000), @cRepHeader varchar(8000), @cQuery varchar(8000), @hDoc int, @xml varchar(8000),
	@i int, @iDig int, @level tinyint, @sigDate datetime, @sigUser int, @signature varchar(8000),
	@certKeysServerAddr varchar(250), @nastrRevList int, @nastrLocStorage int, @cText varchar(max),
	@dbname varchar(100), @checkDateStr varchar(19), @nastr int, @needCertServer varchar(100), @nastrChDi varchar(500),
	@CRLF varchar(2), @RID uniqueidentifier, @algo_crypt int, @DIGITAL_SIGNATURE int

set @CRLF = char(13)+char(10)
set @dbname=db_name()
set @checkDateStr = convert(varchar(19), null, 120)
set @RID=newid()
select @DIGITAL_SIGNATURE = dbo.obj_id('DIGITAL_SIGNATURE')
exec('insert #si_doc_check (link) select distinct link from '+@cTable)

select @certKeysServerAddr = dbo.get_val('NASTR_DSF_CERT_KEYS_SERVER', 'CHAR_VALUE', 0)
select @nastrRevList = 2-dbo.get_val_case('NASTR_DSF_CHK_REVOCATION_LIST', null, 0)
select @nastrLocStorage = 2-dbo.get_val_case('NASTR_DSF_CHECK_LOCAL_STORAGE', null, 0)
select @needCertServer=dbo.get_val('NASTR_DSF_VERSION_CERTSERVER','CHAR_VALUE',0)
set @nastrChDi=dbo.get_val('NASTR_DSF_CHDI','CHAR_VALUE',0)
set @algo_crypt=dbo.get_val_case('NASTR_DSF_ALGO_CRYPT','CASE_VALUE',0)

set @nastr=@nastrRevList*2 + @nastrLocStorage*4 + 16
set @nastrChDi=@nastrChDi+@CRLF+'SKLIFETIME '+isnull(dbo.get_val('NASTR_DSF_PRIVATE_KEY_VALIDITY','INT_VALUE',0),'366')

if @cObjCode = 'DICTIONARY_DATASOURCE_FILTER'
	begin
		insert #tSignature (siglink, link, signature, date, nUser)
		select t.[LINK], t.[VERSION], t.[SIGNATURE], t.[DATE], t.[USER_ID]
		from #si_doc_check td left join [VERSION_SIGNATURE] t on t.[VERSION] = td.link
		
		select @cRepHeader = '  | : <SPAN ID=INFO>' + V.name + '</SPAN>| : <SPAN ID=INFO>' + F.name + '</SPAN>'
		from #si_doc_check si, [FILTER] F, [VERSION] V
		where si.link = F.FILTERID and F.VERSIONID = V.VERSIONID
	end

if @cObjCode = 'DICTIONARY_ATTACHED_FILE' or @cObjCode = 'DICTIONARY_EXPORTED_FILE'
	begin
		insert #tSignature (siglink, link, signature, date, nUser, text)
		select t.[LINK], t.[VERSION], t.[SIGNATURE], t.[DATE], t.[USER_ID], CAST(af.FILEINFO AS VARCHAR(MAX))
		from #si_doc_check td left join [VERSION_SIGNATURE] t on t.[VERSION] = td.link
		left join ATTACHED_FILES af on af.VERSIONID = t.[VERSION]
		
		SELECT @cRepHeader = '  | : <SPAN ID=INFO>' + F.NAME + '</SPAN>| : <SPAN ID=INFO>' + V.NAME + '</SPAN>'
		  FROM #si_doc_check SI LEFT JOIN [ATTACHED_FILES] A ON SI.LINK = A.VERSIONID LEFT JOIN [VERSION] V ON V.VersionID = A.VERSIONID LEFT JOIN FILTER F ON A.RTID = F.FILTERID
		if @cRepHeader is null
			begin
				SELECT @cRepHeader = '  |: <SPAN ID=INFO>' + V2.NAME + '</SPAN>| : <SPAN ID=INFO>' + V.NAME + '</SPAN>'
				  FROM #si_doc_check SI LEFT JOIN ATTACHED_FILES af ON SI.LINK = af.VERSIONID LEFT JOIN 
						[VERSION] V ON af.[VERSIONID] = V.[VERSIONID] LEFT JOIN
						[T_RELATION] R on V.[VERSIONID] = R.[CHILDID] AND dbo.obj_code(V.[OBJECT]) = 'DICTIONARY_ATTACHED_FILE'
						LEFT JOIN [VERSION] V2 ON V2.[VERSIONID] = R.[PARENTID]
						WHERE af.VERSIONID = SI.LINK
			end
		if @cRepHeader is null
			begin
				SELECT @cRepHeader = '  | : <SPAN ID=INFO>' + V.NAME + '</SPAN>'
				  FROM #si_doc_check SI LEFT JOIN ATTACHED_FILES af ON SI.LINK = af.VERSIONID LEFT JOIN 
						[VERSION] V ON af.[VERSIONID] = V.[VERSIONID]
						WHERE af.VERSIONID = SI.LINK
			end
	end
	
--   
execute HTMLReport @nMode = 0, @cWorkTableName = '#work', @cRepHeader = @cRepHeader

--    
if exists (select 1 from #tSignature where link is null)
	begin
		if @cObjCode = 'DICTIONARY_DATASOURCE_FILTER'
		begin
		insert [#si_DocInfo] (subjectname,reason) values('', '    ')
		end
	
		if @cObjCode = 'DICTIONARY_ATTACHED_FILE' or @cObjCode = 'DICTIONARY_EXPORTED_FILE'
		begin
			insert [#si_DocInfo] (subjectname,reason) values('', '   ')
		end
	
		exec HTMLReport @nMode 	= 1, 
						@cWorkTableName = '#work', 
						@cDataTableName	= '#si_DocInfo',
						@cShowFields		= 'date|subjectname|reason',
						@cFieldsDesc		= ' | |',
						@cOrderFields		= 'date'
		
		exec HTMLReport @nMode 				= 2, 
				@cWorkTableName 	= '#work', @nRepResult = 0
		
		return
	end

exec web_sign_DocsList @cDocCode = @cObjCode, @cTableLinks='#tSignature', @useWorkDate = 0, @out = ''

if (@@ERROR <> 0)
	begin
		set @cErr = dbo.ErrorMessage(@@ProcId,'  [web_sign_DocsList]') 
		raiserror(@cErr, 18, 1)
		return
	end

while exists(select 1 from #tSignature where done = 0)
	begin
		select top 1 @i = link, @iDig = siglink, @cText = [text], @signature = signature, @level = level, @sigDate = date, @sigUser = nUser from #tSignature where done = 0 order by level
		
		if (@iDig is not null)
			begin
				insert dbo.SYS_SIGN (rid,link,siglink,signature,text)
				select @RID,t.link,t.siglink,t.[SIGNATURE],t.text
				from #tSignature t

				exec master..xp_checkdigt01 @dbname,@rid,@certKeysServerAddr,@checkDateStr,@nastr,@nastrChDi,0,@needCertServer
--select * from SYS_SIGN SS
				if (@@ERROR <> 0)
				begin
					set @cErr = dbo.ErrorMessage(@@ProcId,'  [xp_checkdigt01]') 
					raiserror(@cErr, 18, 1) 
					return 
				end
			end
		else -- @iDig is null
			begin
					insert #t_retValues ([Check], REASON) values('FAIL',' .')
			end

		insert #si_DocInfo (id, doc_link, level, date, users, CertServerVersion, XPKSwVersion, CheckSignature, CheckSignatureStatus, FindCertificate, FindCertificateStatus, CheckChain, CheckChainStatus, Subject, SubjectName, REASON)
		select @iDig, @i, @level, @sigDate, @sigUser, CertServerVersion, XPKSwVersion, CheckSignature, CheckSignatureStatus, FindCertificate, FindCertificateStatus, CheckChain, CheckChainStatus, Subject, SubjectName, isnull(error, '')
		from #t_retValues
		
		insert #si_DocInfo (id, doc_link, level, date, users, CertServerVersion, XPKSwVersion, CheckSignature, CheckSignatureStatus, FindCertificate, FindCertificateStatus, CheckChain, CheckChainStatus, CadesCheck, CadesCheckStatus, Subject, SubjectName, REASON, OrganizationName, SUBJECTSN, ISSUERX500, SUBJECTX500)
		select t.siglink,t.link,r.lev,case when @algo_crypt=3 then convert(datetime, left([Timestamp],19))+GETDATE()-GETUTCDATE() else r.date end,r.user_id, CertServerVersion, XPKSwVersion, CheckSignature, CheckSignatureStatus, FindCertificate, FindCertificateStatus, CheckChain, CheckChainStatus, CadesCheck, CadesCheckStatus, Subject, SubjectName, isnull(error,''), t.OrganizationName, t.SUBJECTSN, t.ISSUERX500, t.SUBJECTX500
		from dbo.SYS_SIGN t
		inner join [VERSION_SIGNATURE] r on r.link=t.siglink and t.siglink = @iDig
		where t.RID=@RID

		delete from dbo.SYS_SIGN where rid=@RID
				
		truncate table #t_retValues
		truncate table #t_retValueXML
		
		update #tSignature set done = 1 where (siglink = @iDig and @iDig is not null) or (@iDig is null and link = @i)
	end

insert #si_DocInfo (doc_link, [Check], REASON)
select t.link,'FAIL',' .'
from (select t.link from #tSignature t where t.siglink is null union
      select ch.link from #si_doc_check ch left join #tSignature d on ch.link=d.link where d.link is null) t

update #si_DocInfo
set [Check] = 'FAIL'
where isnull(REASON, '') <> ''

update #si_DocInfo
set REASON = REASON + '  .'
where CheckSignature = 'OK' and isnull(CadesCheck,'')='' and CheckChainStatus not like '%80090317%' 

update #si_DocInfo
set REASON = REASON + '  !'
where CadesCheck = 'OK'

update #si_DocInfo
set REASON = REASON + case when CheckSignatureStatus like '%80090006%'
				then '  .'
				else isnull(' '+CheckSignatureStatus, '') end,
	[Check] = 'FAIL'
where CheckSignature = 'FAIL' and isnull(CadesCheck,'') in ('','FAIL')

update #si_DocInfo
set REASON = REASON + ' !'+CadesCheckStatus+' ',				
	[Check] = 'FAIL'
where CadesCheck = 'FAIL'

if (@nastrLocStorage = 1)
begin
	update #si_DocInfo
	set REASON = REASON + '  .'
	where FindCertificate = 'OK'

	update #si_DocInfo
	set REASON = REASON + case when FindCertificateStatus like '%80092004%' 
					then '     .'
					else isnull(' '+FindCertificateStatus, '') end,
		[Check] = 'FAIL'
	where FindCertificate = 'FAIL'
end

if (@nastrRevList = 1)
begin
	update #si_DocInfo
	set REASON = REASON + '   .'
	where CheckChain = 'OK'

    update #si_DocInfo
    set REASON = REASON + case 
                when CheckChainStatus like '%80090317%' then '  .     .'
				    else isnull(' '+CheckChainStatus, '') end,
	    [Check] = 'FAIL'
    where CheckChain = 'FAIL'
end
--select * from #si_DocInfo
if isnull(@cInto, '') = ''
	begin
		create table #tranHTMLinvalidEDS (link int, number varchar(13), date varchar(20), level varchar(100), subjectname varchar(500), REASON varchar(2000), SUBJECTSN varchar(100),loginame varchar(128),OrganizationName varchar(128), ISSUERX500 varchar(1000), SUBJECTX500 varchar(1000))
		create table #tranHTMLcheckEDS (link int, number varchar(13), date varchar(20), level varchar(100), subjectname varchar(500), REASON varchar(2000), SUBJECTSN varchar(100),loginame varchar(128),OrganizationName varchar(128), ISSUERX500 varchar(1000), SUBJECTX500 varchar(1000), viewsignature varchar(100))

		insert #tranHTMLinvalidEDS (link, date, level, subjectname, REASON, SUBJECTSN, loginame, ISSUERX500, SUBJECTX500)
		select si.[doc_link], convert(varchar(10), si.[date], 104) + ' ' + convert(varchar(8), si.[date], 108), sn.[value], si.SubjectName, ltrim(si.REASON), si.SUBJECTSN, (select SU.LOGINAME from S_USERS SU where UID = si.users), si.ISSUERX500, si.SUBJECTX500
		from #si_DocInfo si
		LEFT JOIN s_note sn ON (sn.object = @DIGITAL_SIGNATURE and replace(sn.code, 'LEVEL', '') = si.level)
		where si.[Check] = 'FAIL' order by si.[level], si.SubjectName
		
		if exists(select 1 from #tranHTMLinvalidEDS)
			begin
				--  
				exec HTMLReport @nMode 				= 1, 
								@cWorkTableName 	= '#work', 
								@cDataDesc 			= '<SPAN ID=WARN>    </SPAN>',
								@cDataTableName		= '#tranHTMLinvalidEDS',
								@cShowFields		= 'date|loginame|OrganizationName|level|subjectname|reason|issuerx500|subjectx500|subjectsn',
								@cFieldsDesc		= ' |||| |||| ',
								@cOrderFields		= 'date'
				
				delete #si_DocInfo from #si_DocInfo t, #tranHTMLinvalidEDS h where t.doc_link = h.link and t.[Check] = 'FAIL'
			end

		insert #tranHTMLcheckEDS (link, date, level, subjectname, REASON, SUBJECTSN, loginame, ISSUERX500, SUBJECTX500, viewsignature)
		select si.[doc_link], convert(varchar(10), si.[date], 104) + ' ' + convert(varchar(8), si.[date], 108), sn.[value], si.SubjectName, ltrim(si.REASON), si.SUBJECTSN, (select SU.LOGINAME from S_USERS SU where UID = si.users), si.ISSUERX500, si.SUBJECTX500, ' '
		from #si_DocInfo si
		LEFT JOIN s_note sn ON (sn.object = @DIGITAL_SIGNATURE and replace(sn.code, 'LEVEL', '') = si.level)
		order by si.[level], si.SubjectName

		if exists(select 1 from #tranHTMLcheckEDS)
			begin
				--  
				exec HTMLReport @nMode 				= 1, 
								@cWorkTableName 	= '#work', 
								@cDataDesc 			= '<SPAN ID=GOOD>   </SPAN>',
								@cDataTableName		= '#tranHTMLcheckEDS',
								@cShowFields		= 'date|loginame|OrganizationName|level|subjectname|reason|viewsignature|issuerx500|subjectx500|subjectsn',
								@cFieldsDesc		= ' |||| || ||| ',
								@cOrderFields		= 'date'
			end
			
		--   html-
		exec HTMLReport @nMode = 2, @cWorkTableName = '#work'
		
	end
else
	if object_id('tempdb..'+@cInto) is null
		begin
			exec('select * into '+@cInto+' from #si_DocInfo order by doc_link, level, id')
			if (@@ERROR <> 0)
				begin
					set @cErr = dbo.ErrorMessage(@@ProcId,'   (select * into @cInto)') 
					raiserror(@cErr, 18, 1) 
					return 
				end
		end
	else
		begin
			exec('insert '+@cInto+' select * from #si_DocInfo order by doc_link, level, id')
			if (@@ERROR <> 0)
				begin
					set @cErr = dbo.ErrorMessage(@@ProcId,'   (insert @cInto select *)') 
					raiserror(@cErr, 18, 1) 
					return 
				end
		end
END

GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8620' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SIGNATURE_INFO'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[CM_SAVE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[CM_SAVE]
GO


/* :

    :

    :

   :
 
   :
		 .
*/

CREATE procedure [dbo].[CM_SAVE]
	@cObject	varchar(100) = null
as
begin
	set nocount on

	declare @cFieldS varchar(200), @cFieldR varchar(200)
	
	if @cObject is null
		select @cFieldR = 'NAME, REPL, SLICE, REMOLDRES, IGNOREEMPTY,AUTOCALC,REMBYDATE', @cFieldS = @cFieldR
	else
		select @cFieldR = 'NAME, REPL, SLICE, REMOLDRES, IGNOREEMPTY, AUTOCALC, REMBYDATE, OBJECT',
			@cFieldS = 'NAME, REPL, SLICE, REMOLDRES, IGNOREEMPTY, AUTOCALC, REMBYDATE, ' + convert(varchar(20), dbo.obj_id(@cObject))

	-- 
	begin transaction 
	begin try
		execute SAVE_TABLE
			@cTable_R = 'CALC_MEASURES',
			@cTable_S = '#cAlias',
			@cFields_R = @cFieldR,
			@cFields_S =  @cFieldS,
			@cKey_R = 'CMID',
			@cKey_S = 'CMID'
	end try
	begin catch
		declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
		select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)

		if @@TRANCOUNT > 0
			rollback transaction
		return 1
	end catch

	if @@TRANCOUNT > 0
		commit transaction

	select CMID as LINK from #cAlias
end

GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8676' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'CM_SAVE'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_DSI]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SELECT_DSI]
GO


/* :  

    :
		@nSTID		= Id 
		
    :
	create table #table ([FILTERID] [int] NOT NULL, [xml] [xml] NULL, [BLOCK] [int] NOT NULL ) 
	insert #table ([FILTERID], [xml], [BLOCK])VALUES('39', '', '1')
	exec SELECT_DSI @nSTID = 2250
				
   :
 
   :
		 .
*/

create procedure [dbo].[SELECT_DSI]
	@nSTID int
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd

	declare @nUser int, @cStr varchar(max), @nSign int,	@nClId int, @nFilterId int,	@XmlDocumentHandle int, @XmlDocument xml, @nVerParent int,
		@nRashDate varchar(8)

	select @nUser = user_id(suser_sname())

	--    
	if @nUser is Null
		begin
		  raiserror (' SA   .', 16, 1)
			return
		end

	--    
	if not exists (select * from dbo.VERSION where VersionID = abs(@nSTID))
		begin
		  raiserror ('  .', 16, 1)
			return
		end

	--     ?
	select @nSign = 1
	
	select @nRashDate = dbo.get_val('NASTR_RASH_DATE', 'DATE_VALUE', @nUser)
	
	if @nSTID < 0
		select @nSign = -1, @nSTID = abs(@nSTID)

	--  
	declare @FACT_STRU table (DEL int default(0), FILT int default(0), SOURCETEMPLATEID int, CLASSIFICATORID int, CODE varchar(70), MUSTINPUT int default(0), MULTISELECTION int)
	
	insert @FACT_STRU (SOURCETEMPLATEID, CLASSIFICATORID, CODE, MUSTINPUT, MULTISELECTION)
	select ID, CLID, CODE, MUSTINPUT, MULTISELECTION
	from dbo.[STORAGE_STRU](@nSTID)
	where DOF = 0
	
	update @FACT_STRU set MUSTINPUT = 0 where MULTISELECTION = 1
	
	--     
	select @nVerParent = dbo.VersionParent(@nSTID)

	if @nSign > 0
		begin
			--    
			select @nFilterId = FILTERID from [#table]
			
			select @cStr = convert(varchar(20), @nFilterId)
			
			--  Xml
			if @nFilterId < 0
				select @XmlDocument = [XML] from #table
			else
				select @XmlDocument = [XML] from FILTER where FILTERID = @cStr
			
			exec sp_xml_preparedocument @XmlDocumentHandle output, @XmlDocument, '<DsiFilter xmlns:diffgr="urn:schemas-microsoft-com:xml-diffgram-v1"/>'
			
			--  
			declare @nMultiUser int, @cHeaderList varchar(1000), @nFilterBlocked int, @nModeEdit int, @uBlockGUID uniqueidentifier, @nTimeOut int
			select @nFilterBlocked = 0
			
			select top 1 @nModeEdit = BLOCK from #table
			
			select @nMultiUser = case when Block = 'true' then 1 else 0 end
			from openxml (@XmlDocumentHandle, '/DsiFilter/Settings/Block', 2)
				with (Block varchar(20) 'text()')
--select @nMultiUser, @nModeEdit
			if @nMultiUser = 1 and @nModeEdit = 1
				begin
					--    .
					select @cHeaderList = stuff((
						select ',' + convert(nvarchar(20), Link) as [text()]
						from openxml (@XmlDocumentHandle, '/DsiFilter/Members/DsiMember/Links/string',2)
							   with (CLID varchar(20) '../../Link', Header varchar(20) '../../Header', Link varchar(max) 'text()')
						where CLID not like 'STR%' and Header = 'true'
						order by Link
					for xml path('')), 1, 1, '')
--select @cHeaderList
					if @nFilterId < 0
						select @nFilterId = FilterId
						from openxml (@XmlDocumentHandle, '/DsiFilter/FilterID',2)
								with (FilterId int 'text()')
--select @nFilterId
					--    
					select @nTimeOut = (select WarningTimeout from openxml (@XmlDocumentHandle, '/DsiFilter/Settings/WarningTimeout',2) with (WarningTimeout int 'text()')) + (select UnblockTimeout from openxml (@XmlDocumentHandle, '/DsiFilter/Settings/UnblockTimeout',2) with (UnblockTimeout int 'text()'))
--select @nTimeOut
					delete FILTER_BLK where FILTERID = @nFilterId and HEADER = @cHeaderList and dateadd(mi,@nTimeOut,DATE_IN) < getdate()
					
    
					--       
					if exists(select * from FILTER_BLK where FILTERID = @nFilterId and HEADER = @cHeaderList)
						select @nFilterBlocked = 0
					else
						begin
							select @uBlockGUID = newid()
							insert FILTER_BLK (FILTERID, UID, HEADER, ROW_ID) values (@nFilterId, @nUser, @cHeaderList, @uBlockGUID)
							select @nFilterBlocked = FBID from FILTER_BLK FB where ROW_ID = @uBlockGUID
						end
				end
			
			
			--   
			create table #FILT_TIME (DATE1 varchar(20), CHECKED varchar(5), DATE datetime, TIMEKEY int)
			
			insert #FILT_TIME (DATE1, CHECKED)
			select DATE1, CHECKED
			from openxml (@XmlDocumentHandle, '/DsiFilter/Members/DsiMember/Dates/DsiDateItem',2)
								 with (DATE1 varchar(20) 'Date', CHECKED varchar(5) 'Checked')

			delete #FILT_TIME where CHECKED = 'false'
			update #FILT_TIME set DATE = convert(datetime, DATE1)
			update #FILT_TIME set TIMEKEY = T.TimeKey from [Time] T where T.FullDate = #FILT_TIME.DATE

			if exists (select * from #FILT_TIME where TIMEKEY is Null)
				insert [TIME] (FullDate) select distinct DATE from #FILT_TIME where TIMEKEY is null

			update #FILT_TIME set TIMEKEY = T.TimeKey from [Time] T where T.FullDate = #FILT_TIME.DATE

			declare @FILTER_DESCRIPTION table (ObjCode varchar(30), Link varchar(20), Horizontal varchar(20), [Columns] varchar(200), Date varchar(10))
			
			insert @FILTER_DESCRIPTION(ObjCode, Link, Horizontal, [Columns], Date)
			select ObjCode, Link, Horizontal, [Columns], Date
			from openxml (@XmlDocumentHandle, '/DsiFilter/Members/DsiMember',2)
								 with (ObjCode varchar(30), Link varchar(20), Horizontal varchar(20) 'Horizontal', Columns varchar(200) 'Columns', Date varchar(10) 'Date')
			where link not like 'STR%'

			update @FILTER_DESCRIPTION set Horizontal = replace(Horizontal, ' ', '')
			delete @FILTER_DESCRIPTION where upper(OBJCODE) = 'TIME'
			--alter table @FILTER_DESCRIPTION drop column [Columns]
			
			--   
			create table #FILT_RATE ([VALUE] int, TIMEKEY int, HASH_CALC int, RATE_TYPE int, TIMEKEY_OUT int)
			
			insert #FILT_RATE ([VALUE], TIMEKEY)
			select
				FD.LINK as [VALUE], convert(int, replace(Date,'-','')) as TIMEKEY
	 		from @FILTER_DESCRIPTION FD
			where upper(FD.OBJCODE) = 'DICTIONARY_MACRO_RATE'
			
			delete @FILTER_DESCRIPTION where upper(OBJCODE) = 'DICTIONARY_MACRO_RATE'

			if not exists(select * from #FILT_RATE)
				begin
					insert #FILT_RATE (VALUE,HASH_CALC) select ID,HASH_CALC from dbo.STORAGE_STRU(@nSTID) where DOF = 1
				end
			
			--    
			update #FILT_RATE set HASH_CALC = ST.HASH_CALC 
			from dbo.STORAGE_STRU(@nSTID) ST
			where ST.ID = #FILT_RATE.VALUE and ST.DOF = 1 and isnull(ST.HASH_CALC,0) > 0 and #FILT_RATE.HASH_CALC is null
			
			--   /
			update #FILT_RATE set RATE_TYPE = MS.DATA_PROPERTY
			from dbo.MEASURES MS
			where MS.MEASUREID = #FILT_RATE.VALUE

			--   			
			update #FILT_RATE set TIMEKEY_OUT = @nRashDate where isnull(RATE_TYPE,0)>0

			-- -  
			create table #FILT_CLASS (CLASSIFICATORID int, VALUE int, PARENT int)

			if @nFilterId < 0
				insert #FILT_CLASS (CLASSIFICATORID, VALUE)
				select convert(varchar(20), a.col.query('../../Link/text()')), convert(varchar(20), a.col.query('text()'))
				from #table cross apply XML.nodes('/DsiFilter/Members/DsiMember/Links/string') a(col)
				where FILTERID = @nFilterId
			else
				insert #FILT_CLASS (CLASSIFICATORID, VALUE)
				select convert(varchar(20), a.col.query('../../Link/text()')), convert(varchar(20), a.col.query('text()'))
				from [FILTER] cross apply XML.nodes('/DsiFilter/Members/DsiMember/Links/string') a(col)
				where FILTERID = @nFilterId
				
			create clustered index AAA on #FILT_CLASS (CLASSIFICATORID,PARENT,VALUE)

			update #FILT_CLASS set PARENT = CL.ParentClassificatorID
			from #FILT_CLASS FC, Classificators CL
			where FC.CLASSIFICATORID is null and FC.VALUE = CL.CLASSIFICATORID

			update #FILT_CLASS set CLASSIFICATORID = FC.PARENT
			from #FILT_CLASS FC, Classificators CL
			where FC.CLASSIFICATORID is null and FC.PARENT = CL.CLASSIFICATORID and CL.ParentClassificatorID is null
			
			declare @nCnt int
			select @nCnt = 1
			while exists(select * from #FILT_CLASS where CLASSIFICATORID is null) and @nCnt <= 32
				begin
					update #FILT_CLASS set PARENT = CL.ParentClassificatorID
					from #FILT_CLASS FC, Classificators CL
					where FC.CLASSIFICATORID is null and FC.PARENT = CL.CLASSIFICATORID

					update #FILT_CLASS set CLASSIFICATORID = FC.PARENT
					from #FILT_CLASS FC, Classificators CL
					where FC.CLASSIFICATORID is null and FC.PARENT = CL.CLASSIFICATORID and CL.ParentClassificatorID is null
					
					select @nCnt = @nCnt + 1
			end

			--    
			create table #FILT_CLASS_COMB (Value int, CLASSIFICATORID int)
			
			insert #FILT_CLASS_COMB (Value, CLASSIFICATORID)
			select distinct Value, 0
			from openxml (@XmlDocumentHandle, '/DsiFilter/Combinations/diffgr:diffgram/DocumentElement//*',2)
			with(Value int 'text()')
			
			update #FILT_CLASS_COMB set CLASSIFICATORID = dbo.ClassificatorIdParent([VALUE]) where CLASSIFICATORID = 0

			delete #FILT_CLASS_COMB
			from #FILT_CLASS FC
			where FC.CLASSIFICATORID = #FILT_CLASS_COMB.CLASSIFICATORID and FC.VALUE <> #FILT_CLASS_COMB.VALUE
			
			insert #FILT_CLASS (CLASSIFICATORID,[VALUE]) select CLASSIFICATORID,[VALUE] from #FILT_CLASS_COMB
			
			--      
			create table #FILT_CLASS_MASK (CLASSIFICATORID int, [MASK] varchar(200))
			select top 0 * into #FILT_CLASS_MASK_VALUE from #FILT_CLASS

			insert #FILT_CLASS_MASK (CLASSIFICATORID, [MASK])
			select CLASSIFICATORID = convert(int,Link), MASK
			from openxml (@XmlDocumentHandle, '/DsiFilter/Members/DsiMember/Mask/Values/string',2)
				with (Link varchar(20) '../../../Link', MASK varchar(max) 'text()')

			--select * from #FILT_CLASS_MASK

			create table #CLASS_MASK (MASK varchar(200))
			while exists(select * from #FILT_CLASS_MASK)
				begin
					select @nClId = CLASSIFICATORID from #FILT_CLASS_MASK
					
					insert #CLASS_MASK (MASK) select MASK from #FILT_CLASS_MASK where CLASSIFICATORID = @nClId

					insert #FILT_CLASS_MASK_VALUE ([VALUE])
					exec SELECT_CL_INFO @nMode = 8, @nVerID = @nVerParent, @nClassId = @nClId

					update #FILT_CLASS_MASK_VALUE set CLASSIFICATORID = @nClId where CLASSIFICATORID is null
					
					truncate table #CLASS_MASK
					delete #FILT_CLASS_MASK where @nClId = CLASSIFICATORID
				end
			drop table #CLASS_MASK
				
			delete #FILT_CLASS_MASK_VALUE
			from #FILT_CLASS FC
			where FC.CLASSIFICATORID = #FILT_CLASS_MASK_VALUE.CLASSIFICATORID and FC.VALUE <> #FILT_CLASS_MASK_VALUE.VALUE
					
			insert #FILT_CLASS (CLASSIFICATORID,[VALUE]) select CLASSIFICATORID,[VALUE] from #FILT_CLASS_MASK_VALUE
				

			--   ,     .       
			create table #NOTFILT (CLASSIFICATORID int)
			
			insert #NOTFILT (CLASSIFICATORID) 
			select FD.[LINK]
			from @FILTER_DESCRIPTION FD
			where
				not FD.[HORIZONTAL]='' and not FD.[LINK] in (select distinct CLASSIFICATORID from #FILT_CLASS)
			
			if exists (select * from [#NOTFILT])
				begin
					while exists(select * from #NOTFILT)
						begin
							select top 1 @nClId = CLASSIFICATORID from #NOTFILT
							insert [#FILT_CLASS] ([VALUE]) exec [SELECT_CL_INFO] @nMode = 8, @nVerID = @nVerParent, @nClassId = @nClId

							if @@ROWCOUNT > 0
								update [#FILT_CLASS] set [CLASSIFICATORID] = @nClId where [CLASSIFICATORID] is null
							else
								update @FACT_STRU set FILT = 1 where CLASSIFICATORID = @nClId
							
							delete #NOTFILT where [CLASSIFICATORID] = @nClId
						end
				end

			exec('alter table [#FILT_CLASS] add SOURCETEMPLATEID int')
			
			--        
			declare @FILT_CLASS_DOP table ([CLASSIFICATORID] int, CNT int)
			
			insert @FILT_CLASS_DOP ([CLASSIFICATORID], CNT)
			select [CLASSIFICATORID], count(*) as CNT
			from #FILT_CLASS
			group by [CLASSIFICATORID]
			having count(*) = 1
			
			
			--    
			--     ,    
			--        ,  .
			--      .
			update [#FILT_RATE] set TIMEKEY = null where TIMEKEY = 0
			
			if exists(select * from [#FILT_TIME])
				update #FILT_RATE set TIMEKEY = (select TIMEKEY from [#FILT_TIME]) where TIMEKEY is null
			else	
				update #FILT_RATE set TIMEKEY = @nRashDate where TIMEKEY is null




			--      
			select *
			into #FILT_RATE_CLASS
			from openxml (@XmlDocumentHandle, '/DsiFilter/MeasureSettings/Classificators/DsiMeasureSettingsClassificator',2)
				with (MeasureId varchar(20) 'MemberId', ClassificatorId varchar(20) 'ParentClassificatorId', VALUE varchar(20) 'ClassificatorId')

			exec sp_xml_removedocument @XmlDocumentHandle
		end


	if @nSign > 0
		begin
			--   
			update @FACT_STRU set MUSTINPUT = 1
			from @FILT_CLASS_DOP FCD, @FILTER_DESCRIPTION FD, @FACT_STRU FS
			where FD.LINK = FCD.CLASSIFICATORID and FD.[HORIZONTAL]='' and FS.CLASSIFICATORID = FD.LINK

			update @FACT_STRU set FILT = 1 where CLASSIFICATORID in (select CLASSIFICATORID from #FILT_CLASS)
			--      ,       
			update @FACT_STRU set MUSTINPUT = 0 where FILT = 0
			--     ,    ,  
			delete @FILT_CLASS_DOP where CLASSIFICATORID in (select CLASSIFICATORID from @FACT_STRU where MUSTINPUT = 0)
			--      ,     
			update @FACT_STRU set MUSTINPUT = 1 where CLASSIFICATORID in (select CLASSIFICATORID from @FILT_CLASS_DOP)
			update #FILT_CLASS set SOURCETEMPLATEID = FT.[SOURCETEMPLATEID] from @FACT_STRU FT where #FILT_CLASS.[CLASSIFICATORID] = FT.[CLASSIFICATORID]
		end
	else
		begin
			update @FACT_STRU set FILT = 1 	
		end

--select count(*) from #FILT_TIME
--select * from #FILT_RATE
--select * from @FILTER_DESCRIPTION
--select * from #NOTFILT
--select * from #FILT_CLASS
--select * from @FILT_CLASS_DOP
--select * from #FILT_RATE_CLASS
--select * from @FACT_STRU
--return


	declare @cMeasureList varchar(4000), @cTimeList varchar(4000), @cTableOut varchar(100)
	
	if @nSign > 0
		begin
			select @cMeasureList = stuff((select ',' + convert(varchar(20),VALUE) as [text()] from #FILT_RATE for xml path('')),1,1,'')
			select @cTimeList = stuff((select distinct ',' + convert(varchar(20),TIMEKEY) as [text()] from #FILT_RATE for xml path('')),1,1,'')

			exec dbo.ST_DEPLOY @nStorageId = @nSTID, @cMeasureList = @cMeasureList, @cTimeList = @cTimeList, @cTable = @cTableOut output

--exec('select 0, * from ' + @cTableOut)
			
			--      
			select @cStr = stuff((select ';delete ' + @cTableOut + ' where MEASUREID = ' + convert(varchar(20),FR.VALUE) + ' and TIMEKEY <> ' + convert(varchar(20),FR.TIMEKEY) as [text()] from #FILT_RATE FR for xml path('')),1,1,'')
			select @cStr = replace(@cStr,'&lt;&gt;','<>')
			execute (@cStr)
			
--exec('select 1, * from ' + @cTableOut)

			--      
			if exists(select * from #FILT_RATE_CLASS)
				begin
					select @cStr = stuff((select ';delete ' + @cTableOut + ' where MEASUREID = ' + convert(varchar(20),FRC.MEASUREID) + ' and not isnull([' + FS.CODE + '],0) in (' + convert(varchar(20),FRC.VALUE) + ')' as [text()] from @FACT_STRU FS, #FILT_RATE_CLASS FRC where FRC.CLASSIFICATORID = FS.CLASSIFICATORID for xml path('')),1,1,'')
					execute (@cStr)
					
					--    "" 
					select * into #FILT_RATE_NOTEXISTS from #FILT_RATE FR where not exists(select * from #FILT_RATE_CLASS FRC where FRC.MEASUREID = FR.VALUE)
					
					if exists(select * from #FILT_RATE_NOTEXISTS)
						begin
							select @cStr = stuff((select ';delete ' + @cTableOut + ' where exists(select * from #FILT_RATE_NOTEXISTS where ' + @cTableOut + '.MEASUREID = VALUE) and not [' + CODE + '] is null and not [' + CODE + '] in (select VALUE from #FILT_CLASS where CLASSIFICATORID = ' + convert(varchar(20),CLASSIFICATORID) + ')' as [text()] from @FACT_STRU where MUSTINPUT = 1 for xml path('')),1,1,'')
							execute (@cStr)
							
							select @cStr = stuff((select ';delete ' + @cTableOut + ' where exists(select * from #FILT_RATE_NOTEXISTS where ' + @cTableOut + '.MEASUREID = VALUE) and [' + CODE + '] is null' as [text()] from @FACT_STRU where MUSTINPUT = 1 for xml path('')),1,1,'')
							execute (@cStr)
						end
						
					insert into #FILT_CLASS (CLASSIFICATORID,VALUE)
					select distinct CLASSIFICATORID,VALUE from #FILT_RATE_CLASS
					
					if exists (select * from @FACT_STRU where MUSTINPUT = 1)
						begin
							select @cStr =
							stuff((
								select ';delete ' + @cTableOut + ' where not [' + FS.CODE + '] in (select VALUE from #FILT_CLASS where CLASSIFICATORID = ' + convert(varchar(20),FS.CLASSIFICATORID) + ')' as [text()]
								from @FACT_STRU FS
								where FS.MUSTINPUT = 1 and exists(select * from #FILT_CLASS FC where FS.CLASSIFICATORID = FC.CLASSIFICATORID) for xml path('')
							),1,1,'')
							execute (@cStr)
						end
				end
			else
				begin
					select @cStr = stuff((select ';delete ' + @cTableOut + ' where not [' + CODE + '] is null and not [' + CODE + '] in (select VALUE from #FILT_CLASS where CLASSIFICATORID = ' + convert(varchar(20),CLASSIFICATORID) + ')' as [text()] from @FACT_STRU where MUSTINPUT = 1 for xml path('')),1,1,'')
					execute (@cStr)
				end

			select @cStr = stuff((select ';delete ' + @cTableOut + ' where [' + CODE + '] is null' as [text()] from @FACT_STRU where MUSTINPUT = 1 for xml path('')),1,1,'')
			execute (@cStr)


--print @cStr				
--exec('select 2, * from ' + @cTableOut)

			--  
			select @cStr = 'alter table ' + @cTableOut + ' add TIME datetime, MODIFY_FLAG int, MEASUREID_STR int, MEASURE_STR varchar(4000), ' + stuff((select ',[' + replace(CODE, 'CL-', 'TSID-') + '] int' as [text()] from @FACT_STRU for xml path('')),1,1,'') + ', HASH_SUM varchar(42), ROW_ID uniqueidentifier'
			execute (@cStr)
									
			--  TSID
			select @cStr = stuff((select ';update ' + @cTableOut + ' set [' + replace(CODE, 'CL-', 'TSID-') + '] = TS.TSID from T_STORAGE TS where TS.STORAGEID = ' + @cTableOut + '.STORAGEID and TS.SOURCETEMPLATEID = ' + convert(varchar(20),SOURCETEMPLATEID) + ' and TS.CLASSIFICATORID = ' + @cTableOut + '.[' + FS.CODE + '] and not '  + @cTableOut + '.[' + FS.CODE + '] is null' as [text()] from @FACT_STRU FS for xml path('')),1,1,'')
			execute (@cStr)
		
			--    
			select @cStr = 'update ' + @cTableOut + ' set TIME = convert(datetime, convert(varchar(20),TIMEKEY))
				
			update ' + @cTableOut + ' set MEASUREID_STR = STA.SAID, MEASURE_STR = left(STA.[VALUE],4000)
			from STORAGE_APP STA, ' + @cTableOut + ' F
			where STA.STORAGEID = F.STORAGEID'
			execute (@cStr)

			if exists(select * from #FILT_RATE where isnull(HASH_CALC,0) > 0)
				begin
					-- Hash
					select @cStr = '
					update ' + @cTableOut + ' set HASH_SUM = STA.HASH_SUM
					from STORAGE_APP STA, ' + @cTableOut + ' F, #FILT_RATE FT
					where STA.STORAGEID = F.STORAGEID and FT.VALUE = F.MEASUREID'
					execute (@cStr)
				end
		end
		
	else
		begin
			select @cTableOut = '[KS_DDLControl].[STD_' + convert(varchar(36), newid()) + ']'
			select @cStr = '
			create table ' + @cTableOut + ' (STORAGEID int, STORAGE_SELF int, MODIFY_FLAG INT, FILTERID int, STRID int, AMOUNT numeric(27, 10), TIME datetime, TIMEKEY int, MEASUREID int, MEASUREID_STR int, MEASURE_STR varchar(4000),'
			+ stuff((select ', [' + CODE + '] int, [' + replace(CODE, 'CL-', 'TSID-') + '] int' as [text()] from @FACT_STRU for xml path('')),1,1,'')
			+ ', HASH_SUM varchar(42), ROW_ID uniqueidentifier)'
			execute (@cStr)
		end
			
	select @cStr = '
	select STORAGEID, STORAGE_SELF, MODIFY_FLAG, FILTERID, STRID, AMOUNT, TIME, TIMEKEY, MEASUREID, MEASUREID_STR, MEASURE_STR, ' + stuff((select ', [' + CODE + '], [' + replace(CODE, 'CL-', 'TSID-') + ']' as [text()] from @FACT_STRU for xml path('')),1,1,'') + ', HASH_SUM, ROW_ID
	from ' + @cTableOut + '
	order by STORAGEID
			
	select top 0 STORAGEID, STORAGE_SELF, MODIFY_FLAG, FILTERID, STRID, AMOUNT, TIME, TIMEKEY, MEASUREID, MEASUREID_STR, MEASURE_STR, ' + stuff((select ', [' + CODE + '], [' + replace(CODE, 'CL-', 'TSID-') + ']' as [text()] from @FACT_STRU for xml path('')),1,1,'') + ', HASH_SUM, ROW_ID
	from ' + @cTableOut + '

	select ' + convert(varchar(20), @nSTID) + ' as VERSIONID, ' + convert(varchar(20), isnull(@nFilterId,-1)) + ' as FILTERID, convert(int, null) as [MEASUREID], ' + convert(varchar(20),isnull(@nFilterBlocked,0)) + ' as [FILTERBLOCKED], convert(varchar(1000),Null) as [HASH]'
	execute (@cStr)

	execute ('drop table ' + @cTableOut)

end

GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8483' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_DSI'
GO



if  exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SELECT_VER_DEPLOY_CL_LNK]') and objectproperty(id,N'IsProcedure') = 1)
	drop procedure [dbo].[SELECT_VER_DEPLOY_CL_LNK]
GO

create procedure [dbo].[SELECT_VER_DEPLOY_CL_LNK]
	@nProjectID int, 
	@nClassId int,
	@nSTID int,
	@cFacts varchar(200)
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd

	declare @cSel varchar(max), @cSel_from varchar(max), @ParentClId int, @Attr int, @Ord int, @ClId int, @Lev int,
		@cColumn varchar(100), @cFacts2 varchar(200),@Lev_Prev int
	
	select @cColumn = '[CL_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), @nClassId) + ']'
	select @cFacts2 = '[KS_DDLControl].[FACTS2_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), @nClassId) + ']'
		
	select @cSel = '
	if not object_id(''' + @cFacts2 + ''') is Null
		drop table ' + @cFacts2 + ''
	exec (@cSel)

	select @cSel = '
	select
		DT.ORD,
		CL.CLASSIFICATORID as ' + @cColumn + ','

	if isnull(@cFacts,'') = ''
		select @cSel_from = '
		into ' + @cFacts2 + '
		from [KS_DDLControl].[FACTS_' + convert(varchar(20), @nProjectID) + '] DT
			inner join [KS_DDLControl].[CL_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), @nClassId) + '] CL on isnull(DT.' + @cColumn + ',0) = CL.CLASSIFICATORID'
	else
		select @cSel_from = '
		into ' + @cFacts2 + '
		from ' + @cFacts + ' DT
			inner join [KS_DDLControl].[CL_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), @nClassId) + '] CL on isnull(DT.' + @cColumn + ',0) = CL.CLASSIFICATORID'

	--   
	select *,convert(int, 0) as DEL into #ATTR1 from dbo.TREE_CLASS(@nClassId) where not ClassId is Null order by Orders

	--    
	select Levels,count(*) as Cnt into #ATTR1_CNT from #ATTR1 where not ClassId is Null group by Levels having count(*) > 1

	select @Lev_Prev = 0

	--   
	while exists (select * from #ATTR1 where DEL = 0)
		begin
			select top 1 @Ord = Orders, @Attr = ATTR, @ClId = ClassId, @ParentClId = ParentClassId, @Lev = Levels from [#ATTR1] where DEL = 0
			
			select @cSel = @cSel + '
			convert(int, CLA' + convert(varchar(20), @Ord) + '.[VALUE]) as CL_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), @ClId) + '_' + convert(varchar(20), @nSTID) + '_' + convert(varchar(20), @Ord) + ','

			-- -   
			if @Lev = 1
				begin
					if @Lev <> @Lev_Prev
						select @cSel_from = @cSel_from + '
							left outer join CLASSIFICATORS_APP CLA' + convert(varchar(20), @Ord) + ' on (CL.CLASSIFICATORID = CLA' + convert(varchar(20), @Ord) + '.CLASSIFICATORID and CLA' + convert(varchar(20), @Ord) + '.CLATTRID = ' + convert(varchar(20), @Attr) + ')'
					else
						select @cSel_from = @cSel_from + '
							left outer join CLASSIFICATORS_APP CLA' + convert(varchar(20), @Ord) + ' on (CL.CLASSIFICATORID = CLA' + convert(varchar(20), @Ord) + '.CLASSIFICATORID and CLA' + convert(varchar(20), @Ord) + '.CLATTRID = ' + convert(varchar(20), @Attr) + ' and isnull(CLA' + convert(varchar(20), @Ord) + '.ORDERS,0) = isnull(CLA' + convert(varchar(20),(select min(Orders) from #ATTR1 where @Lev = Levels)) + '.ORDERS,0))'
				end
				
			if @Lev > 1
				select @cSel_from = @cSel_from + '
					left outer join CLASSIFICATORS_APP CLA' + convert(varchar(20), @Ord) + ' on (CLA' + convert(varchar(20), (select Orders from #ATTR1 where ClassId = @ParentClId and (@Lev-1) = Levels)) + '.[VALUE] = CLA' + convert(varchar(20), @Ord) + '.CLASSIFICATORID and CLA' + convert(varchar(20), @Ord) + '.CLATTRID = ' + convert(varchar(20), @Attr) + ')'
						
			select @Lev_Prev = @Lev

			update [#ATTR1] set DEL = 1 where @Ord = Orders
		end
				
	select @cSel = left(@cSel, len(@cSel)-1) + @cSel_from
	
--select @cSel

	exec (@cSel)

	select @cSel = '
	insert ' + @cFacts2 + ' (ORD)
	select distinct ORD from [KS_DDLControl].[FACTS_' + convert(varchar(20), @nProjectID) + '] DT
	where not exists(select * from ' + @cFacts2 + ' where ORD = DT.ORD)'

--select @cSel
	exec (@cSel)

	--     
	if isnull(@cFacts,'') = ''
		select @cSel = 'alter table [KS_DDLControl].[FACTS_' + convert(varchar(20), @nProjectID) + '] drop column ' + @cColumn
	else
		begin
			if @cFacts like '%FACTS2[_]%'
				select @cSel = 'alter table ' + @cFacts + ' drop column ' + @cColumn
			else	
				select @cSel = 'drop table ' + @cFacts
		end

--select @cSel
	exec (@cSel)
end
GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8414' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_DEPLOY_CL_LNK'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_MACRO_RATE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SELECT_MACRO_RATE]
GO



/*
	:  

   :

   :
		exec SELECT_MACRO_RATE 'DICTIONARY_MACRO_RATE-546'
	
  :
 
  :
		 .
*/

create procedure [dbo].[SELECT_MACRO_RATE]
	@cCode varchar(70) = ''
as

set nocount on

declare @nVerId int, @nMeasure int
select @nMeasure = dbo.obj_id('DICTIONARY_MEASURE')

if @cCode = '' or @cCode = 'DICTIONARY_MACRO_RATE'
	begin
		select convert(int, 0) CHECKED, MS.MEASUREID as RATEID, MS.FULLNAME as [NAME], MS.ROW_ID
		from MEASURES MS
		where MS.[OBJECT] = @nMeasure
	end
else
	begin
		select @nVerId = dbo.j_sub_str(@cCode, '-', 2)

		select
			convert(int, 0) CHECKED, MS.MEASUREID as RATEID, MS.FULLNAME as [NAME], MS.ROW_ID, MS.MEASUREID as CLASSIFICATORID, MS.FULLNAME as CLASSIFICATORCODE
		from T_MEASURE TM, MEASURES MS
		where TM.VERSIONID = @nVerId and TM.MEASUREID = MS.MEASUREID and MS.[OBJECT] = @nMeasure
	end



GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8679' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_MACRO_RATE'
GO



if  exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[MEASURE_SAVE]') and objectproperty(id,N'IsProcedure') = 1)
	drop procedure [dbo].[MEASURE_SAVE]
GO

/* :  

    :

    :

   :
 
   :
		 .
*/

create procedure [dbo].[MEASURE_SAVE]
as
begin
	set nocount on
	
	declare @TranCounter int
	select @TranCounter = @@TRANCOUNT

	-- 
	if exists (select * from #cAlias where isnull(NAME, '') = '' or isnull(SHORTNAME, '') = '')
		begin
			raiserror('      .',16,1)
			return
		end

	if @TranCounter > 0
		save transaction measure_save
	else
		begin transaction
	
	-- 
	begin try
		declare @nObj int
		select @nObj = dbo.obj_id('DICTIONARY_MEASURE')

		update #cAlias set OBJECT = @nObj
		
		select TM.VERSIONID into #UPD_DS from #cAlias A, T_MEASURE TM where isnull(A.MEASUREID,0) > 0 and TM.MEASUREID = A.MEASUREID

		execute SAVE_TABLE
			@cTable_R = 'MEASURES',
			@cTable_S = '#cAlias',
			@cFields_R = 'FULLNAME, SHORTNAME, PRECISION, DESCRIPTION, ZERO, OBJECT, MS_TYPE, ISGROUP, ParentMeasureID, MS_FORMULA_TYPE,HASH_CALC,DATA_TYPE,DATA_PROPERTY',
			@cFields_S = 'NAME, SHORTNAME, PRECISION, DESCRIPTION, ZERO, OBJECT, MS_TYPE, ISGROUP, ParentMeasureID, MS_FORMULA_TYPE,HASH_CALC,DATA_TYPE,DATA_PROPERTY',
			@cKey_R = 'MEASUREID',
			@cKey_S = 'MEASUREID'
			
		update dbo.VERSION set ROW_ID = newid() from #UPD_DS A where A.VERSIONID = dbo.VERSION.VERSIONID
		
		if @TranCounter = 0
			commit transaction
	end try
	begin catch
		if @TranCounter = 0
			rollback transaction
        else
            if xact_state() <> -1
				rollback transaction measure_save
				
		select 'Procedure dbo.MEASURE_SAVE', ERROR_MESSAGE() as ErrorMessage
		return 
	end catch

	select MEASUREID as LINK from #cAlias
end

GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8486' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'MEASURE_SAVE'
GO



if  exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[CLONE_DS]') AND objectproperty(id,N'IsProcedure') = 1)
	drop procedure [dbo].[CLONE_DS]
GO


/* :  

   : 
		@nDS -  
	
    :
		exec [dbo].[CLONE_DS] @nDS = 124

   :
 
   :
		 .
*/
create procedure [dbo].[CLONE_DS]
	@nDS int,
	@nVerId int = 0
as
begin
	set transaction isolation level read uncommitted
	set nocount on

	declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
	declare @uRowId uniqueidentifier, @nLink int
	select @uRowId = newid()

	begin transaction 
	begin try
		print ' '
		insert [VERSION] ([Name],[OBJECT],[ROW_ID],[DATA],[STAT]) 
		select ': ' + [Name],[OBJECT],@uRowId,[DATA],[STAT] from [VERSION] where [VersionID] = @nDS

		select @nLink = [VersionID] from [VERSION] where [ROW_ID] = @uRowId

		if (@nVerId = 0 or @nVerId = dbo.[VersionParent](@nDS))
		begin			
			insert [T_RELATION] ([PARENTID],[CHILDID]) values(dbo.[VersionParent](@nDS),@nLink)
		end
		else
			insert [T_RELATION] ([PARENTID],[CHILDID]) values(@nVerId,@nLink)
			
		insert [T_MEASURE] ([VERSIONID],[MEASUREID])
		select @nLink,[MEASUREID] from [T_MEASURE] where [VersionID] = @nDS

		insert [SOURCETEMPLATE] ([ClassificatorID],[VERSIONID],[DESCRIPTION],[TABLENAME],[ROW_ID],[MULTISELECTION],[MUSTINPUT])
		select [ClassificatorID],@nLink,[DESCRIPTION],[TABLENAME],[ROW_ID],[MULTISELECTION],[MUSTINPUT]
		from [SOURCETEMPLATE]
		where [VersionID] = @nDS
		
		print ' '

		select convert(int,Null) as [FILTERID_NEW], [FILTERID], @nLink as [VERSIONID],[NAME],[USER],[NAVIGATOR],[DATE],[XML],[STAT],[HIDDEN],[TEMPLATE]
		into #FILT
		from [FILTER] where [VersionID] = @nDS
		
  		insert [FILTER] ([VERSIONID],[NAME],[USER],[NAVIGATOR],[DATE],[xml],[STAT],[HIDDEN],[TEMPLATE])
		select [VERSIONID],[NAME],[USER],[NAVIGATOR],[DATE],[xml],[STAT],[HIDDEN],[TEMPLATE]
		from #FILT
		
		update [#FILT] set [FILTERID_NEW] = F.[FILTERID] from [FILTER] F where F.[NAME] = [#FILT].[NAME] and F.[VERSIONID] = @nLink
		
		--      
		insert dbo.T_ACCESS (OBJECT, ID, ACCESS, USERS)
		select [OBJECT], @nLink, ACCESS, USERS
		from dbo.T_ACCESS
		where [OBJECT] = dbo.obj_id('DICTIONARY_DATASOURCE') and ID = @nDS

		insert dbo.T_ACCESS (OBJECT, ID, ACCESS, USERS)
		select T.[OBJECT], F.FILTERID_NEW, T.ACCESS, T.USERS
		from dbo.T_ACCESS T, #FILT F
		where T.[OBJECT] = dbo.obj_id('DICTIONARY_DATASOURCE_FILTER') and ID = F.FILTERID

	end try
	begin catch
		select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
		print 'Procedure dbo.CLONE_DS'

	  
		if @@TRANCOUNT > 0
			rollback transaction
			
		return -1 
	end catch

	begin try
		print ' '
		
		select convert(int,Null) as [STORAGEID_NEW],[STORAGEID],[STORAGE_SELF],@nLink as [VERSIONID],[AMOUNT],[TIMEKEY],newid() as ROW_ID,[MEASUREID],[FILTERID],[STRID],[IMPORT_ID]
		into #ST
		from [STORAGE]
		where [VERSIONID] = @nDS
		
		select TS.[STORAGEID], TS.[ClassificatorID], TS.[SourceTemplateID]
		into #T_ST 
		from #ST S inner join [T_STORAGE] TS on (S.[STORAGEID] = TS.[STORAGEID])
		
		select SA.STORAGEID, SA.[VALUE]
		into #ST_A
		from #ST S inner join STORAGE_APP SA on (S.[STORAGEID] = SA.[STORAGEID])
		
		select S1.[SourceTemplateID], S2.[SourceTemplateID] as [SourceTemplateID_NEW]
		into #SOURCE
		from [SOURCETEMPLATE] S1, [SOURCETEMPLATE] S2
		where S1.[VersionID] = @nDS and S2.[VersionID] = @nLink and S1.[ClassificatorID] = S2.[ClassificatorID]

		update [#ST] set [FILTERID] = F.[FILTERID_NEW] from [#FILT] F where F.[FILTERID] = [#ST].[FILTERID]
		update [#T_ST] set [SourceTemplateID] = S.[SourceTemplateID_NEW] from #SOURCE S where S.[SourceTemplateID] = [#T_ST].[SourceTemplateID]

		select @uRowId = newid()
		update #ST set [IMPORT_ID] = @uRowId

		insert [STORAGE] ([VERSIONID],[AMOUNT],[TIMEKEY],[ROW_ID],[MEASUREID],[FILTERID],[STRID],[IMPORT_ID])
		select [VERSIONID],[AMOUNT],[TIMEKEY],[ROW_ID],[MEASUREID],[FILTERID],[STRID],[IMPORT_ID] from #ST
		
		update [#ST] set [STORAGEID_NEW] = S.[STORAGEID] from [STORAGE] S where S.[ROW_ID] = [#ST].[ROW_ID]
		update [#ST] set [STORAGE_SELF] = S.[STORAGEID_NEW] from [#ST] S, [#ST] where [#ST].[STORAGE_SELF] = S.[STORAGEID] and not [#ST].[STORAGE_SELF] is null
		update [STORAGE] set [STORAGE_SELF] = S.[STORAGE_SELF] from [#ST] S where S.[STORAGEID_NEW] = [STORAGE].[STORAGEID] and not S.[STORAGE_SELF] is null
		
		update [#T_ST] set [STORAGEID] = S.[STORAGEID_NEW] from [#ST] S where S.[STORAGEID] = [#T_ST].[STORAGEID]
		update [#ST_A] set [STORAGEID] = S.[STORAGEID_NEW] from [#ST] S where S.[STORAGEID] = [#ST_A].[STORAGEID]
		
		insert [T_STORAGE] ([STORAGEID],[ClassificatorID],[SourceTemplateID])
		select [STORAGEID],[ClassificatorID],[SourceTemplateID] from [#T_ST]
		
		insert [STORAGE_APP] (STORAGEID, [VALUE])
		select STORAGEID, [VALUE] from [#ST_A]
		
		if (@nVerId > 0)
		begin
			print ' '
			
			select SourceElementID , TargetElementID, dbo.ClassificatorIdParent(SourceElementID) as aaa
			into #aaa
			from dbo.DataMigration
			where
				SourceElementID in (select ClassificatorID from t_version where deleted = 1 and versionid = @nVerId) and
				TargetElementID in (select ClassificatorID from t_version where deleted = 0 and versionid = @nVerId)

			create table #InputClassTable(SourceClassificatorID int,TargetClassificatorID int,Stat int)
			insert #InputClassTable (SourceClassificatorID, TargetClassificatorID)
			select SourceElementID , TargetElementID from #aaa
			exec [PACKAGE_REPLACE] @nVerID = @nVerId, @paramStr='nFilterReplace=1'
				
		end
						
	end try
	begin catch
		select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
		print 'Procedure dbo.CLONE_DS'

		if @@TRANCOUNT > 0
			rollback transaction
		return -2 
	end catch

	if @@TRANCOUNT > 0
		commit transaction
		
	select @nLink
end

GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8567' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'CLONE_DS'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ARM_OpenFolderTree]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[ARM_OpenFolderTree] 
GO

-- =============================================
-- Author:		<Aleksey U. Ivanov>
-- Create date: <09.07.2009>
-- Description:	<       
--				        
--					-   
--					-      
--				          
-- =============================================
CREATE PROCEDURE [dbo].[ARM_OpenFolderTree]  
AS
BEGIN
	SET NOCOUNT ON;
DECLARE @ErrorMessage NVARCHAR(4000);
begin try

declare @nUserId int
select @nUserId = user_id(suser_sname())

create table #folders(id int , parent_id int , name nvarchar(100), mark varbinary(256), tag varchar(10), level int)

if( dbo.AdminIsUserAdm(null)=1)
	-- 
	begin
		with treefld(id, parent_id, name, mark, tag, level )
		as
		(
			select af.id, af.parent_id, cast(su.loginame as nvarchar(100)) name, af.mark, su.type tag, 0 level
			from arm_desktop dt
			inner join arm_folder af on af.id = dt.folder_id
			inner join s_users su on su.uid=dt.user_id
			union all
			select af.id, af.parent_id, cast(af.name as nvarchar(100)) name, af.mark, tf.tag, tf.level+1 
			from arm_folder af
			inner join treefld tf on tf.id = af.parent_id 
		)
		insert into #folders select * from treefld
	end
else
	begin
		with treefld(id, parent_id, name, mark, tag, level )
			as
			(
				select af.id, af.parent_id, cast(su.loginame as nvarchar(100)) name, af.mark, su.type tag, 0 level
				from arm_desktop dt
				inner join arm_folder af on af.id = dt.folder_id
				inner join s_users su on  su.uid=dt.user_id
				where su.uid = @nUserId or su.uid in (select groups from users_groups where users = @nUserId)
				union all
				select af.id, af.parent_id, cast(af.name as nvarchar(100)) name, af.mark, tf.tag, tf.level+1 
				from arm_folder af
				inner join treefld tf on tf.id = af.parent_id 
			)
			insert into #folders select * from treefld
		--	if(not @nUserId in (select distinct user_id from arm_desktop))
	end
	
	select * from #folders
	
	select ash.*, dbo.get_access_node (dbo.obj_id(OBJ_CODE), @nUserId, OBJ_LINK) as access from ARM_shortcut ash 
	inner join #folders f on f.id = ash.folder_id
	
	select ad.folder_id, ad.use_folder_only
				from arm_desktop ad
				where ad.user_id = @nUserId
end try
begin catch
 set @ErrorMessage = ERROR_MESSAGE()
		RAISERROR (N'     .> 
: %s' , -- Message text.
			   16, -- Severity,
			   1, -- State,
			   @ErrorMessage); -- Second 
end catch
END

GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8470' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'ARM_OPENFOLDERTREE'
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[web_sign_DocsList]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[web_sign_DocsList]
GO

CREATE  PROCEDURE web_sign_DocsList
	@cDocCode varchar(200), -- DOCUMENTS_******
	@xmlLinks text = null, -- xml  
	@out varchar(100) = null output,
	@cTableLinks varchar(100) = '', --         @xmlLinks
	@cSqlTable varchar(100) = NULL,	--  ,    ""  (     'CREDIT_DOC',  ;  ., 20.12.2006)
	@useWorkDate int = 1 -- 1 -     ., 0 -     .
AS
begin


if @cDocCode = 'DICTIONARY_DATASOURCE_FILTER'
	begin
		declare @cTableName varchar(128), @nLink int, @nDSId int, @cStr varchar(max)
		
		create table #STRU (CODE varchar(70))

		create table #links (LINK int)
		exec ('insert #links (LINK) select LINK from ' + @cTableLinks)
		
		while exists(select * from #links)
			begin
				select top 1 @nLink = LINK from #links
				select @nDSId = [VERSIONID] from [FILTER] where [FILTERID] = @nLink
				insert #STRU (CODE) values('AMOUNT')
				insert #STRU (CODE) values('TIME')
				insert #STRU (CODE) values('TIMEKEY')
				insert #STRU (CODE) values('MEASUREID')
				insert #STRU (CODE) select CODE from dbo.[STORAGE_STRU](@nDSId) where DOF = 0
				insert #STRU (CODE) select replace(CODE, 'DICTIONARY_CLASSIFICATOR', 'NAME') from #STRU where [CODE] like 'DICTIONARY_CLASSIFICATOR%'
				insert #STRU (CODE) select replace(CODE, 'DICTIONARY_CLASSIFICATOR', 'CODE') from #STRU where [CODE] like 'DICTIONARY_CLASSIFICATOR%'
				select @cTableName = '##TT_' + replace(convert(varchar(36), newid()), '-','')
				exec DTT @cTableName
				exec [SELECT_DSI] @nFilterId = @nLink, @cTableInto = @cTableName
				select @cStr = 'update ' + @cTableLinks + ' set [TEXT] = dbo.MergeCells(''' + @cTableName + ''', ''#STRU'', ''CODE'') where LINK = ' + convert(varchar(20), @nLink)
				execute (@cStr)
				
				exec DTT @cTableName
				delete #links where LINK = @nLink
				delete #STRU
			end		
	end

if @cDocCode = 'DICTIONARY_ATTACHED_FILE' or @cDocCode = 'DICTIONARY_EXPORTED_FILE'
	begin
		declare @nLinkAf INT, @strAf VARCHAR(max)
		create table #linksAf (LINK int)
		exec ('insert #linksAf (LINK) select LINK from ' + @cTableLinks)
		
		while exists(select * from #linksAf)
			begin
				select top 1 @nLinkAf = LINK from #linksAf
				SELECT @strAf = CAST(FILEINFO AS VARCHAR(MAX)) FROM ATTACHED_FILES WHERE VERSIONID = @nLinkAf
				IF isnull(@strAf, '') = ''
					begin
						SELECT @strAf = CAST(RTID AS VARCHAR(MAX)) + CAST(ROW_ID AS VARCHAR(MAX)) + CAST(USERNAME AS VARCHAR(MAX)) + CAST(FILESIZE AS VARCHAR(MAX)) + CAST(FILENAME AS VARCHAR(MAX)) + CAST([object] AS VARCHAR(MAX)) from ATTACHED_FILES WHERE VERSIONID = @nLinkAf
					end
				select @cStr = 'update ' + @cTableLinks + ' set [TEXT] = ''' + @strAf + ''' where LINK = ' + convert(varchar(20), @nLinkAf)
				execute (@cStr)
				
				delete #linksAf where LINK = @nLinkAf
			end		
	end

end

if @out = null
	exec('select * from ' + @cTableLinks)
	
if not @out is null and @out <> ''
	exec('select * into ' + @out + ' from ' + @cTableLinks)
		

GO
 
GO
 
GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8620' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'WEB_SIGN_DOCSLIST'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[CLASIFICATORS_SAVE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[CLASIFICATORS_SAVE]
GO

/* :   

    :

    :

   :
 
   :
		 .
*/

create procedure [dbo].[CLASIFICATORS_SAVE]
	@cTables	varchar(300) = '#cAlias;#cAlias1;#cAlias2;#cAlias3'
as
set nocount on

-- 
declare @cMsg varchar(4000)
select CA.CLATTRID, CA.NAME into #CLATR from #calias A, CLASSIFICATORS_ATTR CA where A.CLASSIFICATORID = CA.CLASSIFICATORID
delete #CLATR from #calias2 A where #CLATR.CLATTRID = A.clattrid

if exists (select * 
			from dbo.CLASSIFICATORS_APP CAP, #CLATR C, T_VERSION TV
			where C.CLATTRID = CAP.CLATTRID and TV.ClassificatorID = CAP.CLASSIFICATORID and TV.Deleted = 0)
	begin
		select @cMsg = '    "' + (select isnull([NAME],'')+',' from #CLATR for xml path(''))
		select @cMsg = left(@cMsg, len(@cMsg) - 1) + '"' + char(13) + '      . '
		raiserror(@cMsg,16,1)
		return
	end

if exists (select A.ClassificatorCode, count(*)
			from (select ClassificatorCode from Classificators where ParentClassificatorID is null
					union all
					select ClassificatorCode from #cAlias where isnull(CLASSIFICATORID, -1) < 0) A
			group by A.ClassificatorCode
			having count(*)>1)
	begin
		select @cMsg = '  .    .'
		raiserror(@cMsg,16,1)
		return
	end

if exists(select LINKEDCLASSIFICATORID,count(*) from #cAlias2 where not LINKEDCLASSIFICATORID is null group by LINKEDCLASSIFICATORID having count(*)>1)
	begin
		select @cMsg = (
			select '"' + isnull(c.NAME,'')+ '",' 
			from Classificators c, (select LINKEDCLASSIFICATORID,count(*) as CNT from #cAlias2 where not LINKEDCLASSIFICATORID is null group by LINKEDCLASSIFICATORID having count(*)>1) b 
			where c.ClassificatorID = b.LINKEDCLASSIFICATORID for xml path('')
			) 
		select @cMsg = '  (): ' + left(@cMsg, len(@cMsg) - 1) + char(13) + + '      .'
		raiserror(@cMsg,16,1)
		return
	end	



declare @TranCounter int
select @TranCounter = @@TRANCOUNT

if @TranCounter > 0
	save transaction clasificators_save
else
	begin transaction

-- 
begin try
	update #cAlias set OBJECT = dbo.obj_id('DICTIONARY_OTHER_DWH') where OBJECT is null
	
	execute SAVE_TABLE
		@cTable_R = 'CLASSIFICATORS',
		@cTable_S = #cAlias,
		@cFields_R = 'CLASSIFICATORCODE, NAME, DESCRIPTION, ISAGGREGATABLE, TYPE, OBJECT',
		@cFields_S = 'CLASSIFICATORCODE, NAME, DESCRIPTION, ISAGGREGATABLE, TYPE, OBJECT',
		@cKey_R = 'CLASSIFICATORID',
		@cKey_S = 'CLASSIFICATORID'

	
    --  
	update #cAlias1 set CLASSIFICATORID = T.CLASSIFICATORID from #cAlias T where isnull(#cAlias1.CLASSIFICATORID, -1) < 0
	
	update #cAlias1 set 
	[STARTPOSITION] = case when patindex('%0%',MASK) = 0 then 1 else patindex('%0%',MASK) end, 
	[LENGTH] = case when patindex('%0%',MASK) = 0 then len(MASK) else len(MASK) - patindex('%0%',reverse(MASK)) - patindex('%0%',MASK) + 2 end

	update #cAlias2 set CLASSIFICATORID = T.CLASSIFICATORID from #cAlias T where isnull(#cAlias2.CLASSIFICATORID, -1) < 0
	
	exec('if col_length(''tempdb..#cAlias1'',''htype'') is null alter table #cAlias1 add htype smallint')

	exec('update #cAlias1 set htype = b.htype from #cAlias1 a inner join #cAlias b on a.classificatorid = b.classificatorid')

	-- /   membersWithData   ClassificatorProperty
	if exists(select propertyId from ClassificatorProperty cp inner join #calias ca on ca.classificatorId=cp.classificatorId)
		update ClassificatorProperty 
		set MembersWithData = isnull(ca.showparentnodes,0), 
			DblControl = isnull(ca.DblControl,1), 
			[ACCESSCONTROL] = isnull(ca.[ACCESSCONTROL],0),
			[SOURCECLASSIFICATORID] = ca.[SOURCECLASSIFICATORID],
			[SOURCECLASSIFICATORFILTER] = ca.[SOURCECLASSIFICATORFILTER]
		from ClassificatorProperty cp inner join #calias ca on ca.ClassificatorId = cp.ClassificatorId
	else
		insert into ClassificatorProperty(classificatorID, membersWithData, DblControl, ACCESSCONTROL, SOURCECLASSIFICATORID, SOURCECLASSIFICATORFILTER)
		select top 1 classificatorId, isnull(showParentNodes,0), isnull(DblControl,1), isnull(ACCESSCONTROL,0), [SOURCECLASSIFICATORID], [SOURCECLASSIFICATORFILTER] from #calias 

	execute SAVE_TABLE
		@cTable_R = 'CLASSIFICATORDESCRIPTION',
		@cTable_S = '#cAlias1',
		@cFields_R = 'CLASSIFICATORID, NAME, MASK, LEVEL, [TYPE], [STARTPOSITION], [LENGTH], htype',
		@cFields_S = 'CLASSIFICATORID, NAME, MASK, LEVEL, [TYPE], [STARTPOSITION], [LENGTH], htype',
		@cKey_R = 'DESCRIPTIONID',
		@cKey_S = 'DESCRIPTIONID',
		@cDel_R = 'CLASSIFICATORID',
		@cDel_S = 'CLASSIFICATORID'
		
	if not exists (select * from #cAlias1)
		delete CLASSIFICATORDESCRIPTION from #cAlias T where T.[CLASSIFICATORID] = CLASSIFICATORDESCRIPTION.[CLASSIFICATORID]
		
	--  ROW_ID
	update #cAlias2 set ROW_ID = newid() where isnull([CLATTRID], -1) < 0

	execute SAVE_TABLE
		@cTable_R = 'CLASSIFICATORS_ATTR',
		@cTable_S = '#cAlias2',
		@cFields_R = 'NAME,CLASSIFICATORID,LINKEDCLASSIFICATORID,[SYSTEM],[UNIQUE],ALIAS,LIST,ATR_TYPE,VISIBLE',
		@cFields_S = 'NAME,CLASSIFICATORID,LINKEDCLASSIFICATORID,[SYSTEM],[UNIQUE],ALIAS,LIST,ATR_TYPE,VISIBLE',
		@cKey_R = 'CLATTRID',
		@cKey_S = 'CLATTRID',
		@cDel_R = 'CLASSIFICATORID',
		@cDel_S = 'CLASSIFICATORID'


	if not exists (select * from #cAlias2)
		begin
			select CLATTRID into #DEL_ATTR from CLASSIFICATORS_ATTR, #cAlias T where T.[CLASSIFICATORID] = CLASSIFICATORS_ATTR.[CLASSIFICATORID] and CLASSIFICATORS_ATTR.[OBJECT] is null
			
			--      
			--    
			if exists(select CLATTRID from #DEL_ATTR)
				delete CLASSIFICATORS_APP where exists (select * from #DEL_ATTR DA where DA.CLATTRID = CLASSIFICATORS_APP.CLATTRID)


			delete CLASSIFICATORS_ATTR from #cAlias T where T.[CLASSIFICATORID] = CLASSIFICATORS_ATTR.[CLASSIFICATORID] and CLASSIFICATORS_ATTR.[OBJECT] is null
		end	
		
	--  ROW_ID
	update #cAlias3 set ROW_ID = newid() where isnull([CLATTRID], -1) < 0

	execute SAVE_TABLE
		@cTable_R = 'CLASSIFICATORS_ATTR',
		@cTable_S = '#cAlias3',
		@cFields_R = 'NAME,CLASSIFICATORID,LINKEDCLASSIFICATORID,[SYSTEM],[UNIQUE],ALIAS,LIST,ATR_TYPE',
		@cFields_S = 'NAME,CLASSIFICATORID,LINKEDCLASSIFICATORID,[SYSTEM],[UNIQUE],ALIAS,LIST,ATR_TYPE',
		@cKey_R = 'CLATTRID',
		@cKey_S = 'CLATTRID',
		@cDel_R = 'CLASSIFICATORID',
		@cDel_S = 'CLASSIFICATORID'
		
	if not exists (select * from #cAlias3)
		delete CLASSIFICATORS_ATTR from #cAlias T where T.[CLASSIFICATORID] = CLASSIFICATORS_ATTR.[CLASSIFICATORID] and not CLASSIFICATORS_ATTR.[OBJECT] is null
		
	update dbo.ClassificatorProperty set CH_GUID = newid() from #cAlias A where A.CLASSIFICATORID = dbo.ClassificatorProperty.ClassificatorID

	if @TranCounter = 0
		commit transaction
end try
begin catch
	if @TranCounter = 0
		rollback transaction
    else
		if xact_state() <> -1
			rollback transaction clasificators_save
    
	--select ERROR_NUMBER() as ErrorNumber, ERROR_SEVERITY() as ErrorSeverity, ERROR_STATE() as ErrorState,	ERROR_PROCEDURE() as ErrorProcedure, ERROR_LINE() as ErrorLine
	--declare @cMsg
	select @cMsg = ERROR_MESSAGE() 
	raiserror(@cMsg, 16, 1)
	return -1
end catch

select CLASSIFICATORID from #cAlias


GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8657' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'CLASIFICATORS_SAVE'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_VER_DEPLOY_MERGE_DS]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SELECT_VER_DEPLOY_MERGE_DS]
GO



/*
:         .

 :
	@nMode -  
					-2 - : ;
					-1 - :   ;
					0 -      ;

 :	

 : 	
		exec dbo.SELECT_VER_DEPLOY_MERGE_DS @nProjectID = 1973

:
	xxxx					- id 
	yyyy					- id 
	zzzz					- id 
	
	FACTS_xxxx				-   
	FACTS_xxxx_yyyy			-    
	FACTS2_xxxx				-       
	FACTS2_xxxx_yyyy		-      ,   
	FACTS2_xxxx_yyyy_zzzz	-     / ,      
	CL_xxxx_zzzz			-   
	CLD_xxxx				-   
	TIME_xxxx				-  
	CLA_xxxx_zzzz			-    

:
	 ..

*/
create procedure [dbo].[SELECT_VER_DEPLOY_MERGE_DS]
	@nProjectID	int
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd

	declare @cStr varchar(max), @nDS int, @cPostfix varchar(200), @cClassList varchar(max), @cMeasureList varchar(max), @cTableOut varchar(100), @cFacts2 varchar(200)
		
	select @cPostfix = convert(varchar(20), @nProjectID)

	if (select count(*) from #DTS)=1
		begin
			--  
			select top 1 @nDS = LINK from #DTS

			select @cStr = '
			if not object_id(''[KS_DDLControl].[FACTS_' + @cPostfix + ']'') is Null
				drop table [KS_DDLControl].[FACTS_' + @cPostfix + ']'
			execute (@cStr)
					
			select @cStr = 'exec dbo.sp_rename ''' + (select DEPLOY_TABLE from #DTS where LINK = @nDS) + ''',''FACTS_' + @cPostfix + ''''
			execute (@cStr)
				
			update #DTS set DEPLOY_TABLE = '[KS_DDLControl].[FACTS_' + @cPostfix + ']'  where LINK = @nDS
			
			execute ('if col_length(''[KS_DDLControl].[FACTS_' + @cPostfix + ']'',''ORD'') is null alter table [KS_DDLControl].[FACTS_' + @cPostfix + '] add ORD int') 
            execute ('declare @a int 
            select @a = max(ORD) from [KS_DDLControl].[FACTS_' + @cPostfix + ']
            select @a = isnull(@a,0)
            update [KS_DDLControl].[FACTS_' + @cPostfix + '] set @a = ORD = @a + 1 where ORD is null')

		end
	else
		begin
			--    
			update #DTS set F1 = 0

			select @cStr = '
			if not object_id(''[KS_DDLControl].[FACTS_' + @cPostfix + ']'') is Null
				drop table [KS_DDLControl].[FACTS_' + @cPostfix + ']'
			execute (@cStr)
			
			select @cClassList = stuff((select distinct ',' + dbo.j_sub_str(DEPLOY_TABLE,'.',2) + ' int' as [text()] from #DTS_CL where MULTISELECTION = 0 for xml path('')) ,1,1,'')
			select @cMeasureList = stuff((select distinct ',[MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + '] numeric(27, 10)' as [text()] from #DTS_M for xml path('')),1,1,'')
			
			--   
			select @cStr = 'create table [KS_DDLControl].[FACTS_' + @cPostfix + '] (VERSIONID int, STORAGEID int, FILTERID int, STRID int, ORD int identity, ORD_OLD int, TIMEKEY int, CLH_' + convert(varchar(20), @nProjectID) + ' int,' + @cMeasureList + ',' + @cClassList + ')'
			execute (@cStr)
			
			create table #F2 (FACTS2 varchar(200))
			
			while exists (select * from #DTS where F1 = 0)
				begin
					select top 1 @nDS = LINK, @cTableOut = DEPLOY_TABLE from #DTS where F1 = 0

					select @cClassList = stuff((select distinct ',' + dbo.j_sub_str(DEPLOY_TABLE,'.',2) as [text()] from #DTS_CL where LINK = @nDS and MULTISELECTION = 0 for xml path('')) ,1,1,'')
					select @cMeasureList = stuff((select ',[MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + ']' as [text()] from #DTS_M where LINK = @nDS for xml path('')),1,1,'')

					if exists(select * from #DTS_CL where LINK = @nDS and not FACTS2 is null)
						begin
							select @cStr = 'insert [KS_DDLControl].[FACTS_' + @cPostfix + '] (VERSIONID, STORAGEID, FILTERID, STRID, TIMEKEY, ORD_OLD, CLH_' + convert(varchar(20), @nProjectID) + ',' + @cMeasureList + ',' + @cClassList + ')
							select VERSIONID, STORAGEID, FILTERID, STRID, TIMEKEY, ORD, CLH_' + convert(varchar(20), @nProjectID) + ',' + @cMeasureList + ',' + @cClassList + '
							from ' + @cTableOut
							
							execute (@cStr)

							insert #F2 (FACTS2) select distinct FACTS2 from #DTS_CL where LINK = @nDS and not FACTS2 is null
					
							while exists(select * from #F2)
								begin
									select top 1 @cFacts2 = FACTS2 from #F2
									
									select @cStr = 'update ' + @cFacts2 + ' set ORD = F.ORD
									from ' + @cFacts2 + ' F2, [KS_DDLControl].[FACTS_' + @cPostfix + '] F
									where F.VERSIONID = ' + convert(varchar(20), @nDS) + ' and  F.ORD_OLD = F2.ORD'
									execute (@cStr)
									
									delete #F2 where @cFacts2 = FACTS2 
								end
						end
					else
						begin
							select @cStr = 'insert [KS_DDLControl].[FACTS_' + @cPostfix + '] (VERSIONID, STORAGEID, FILTERID, STRID, TIMEKEY, CLH_' + convert(varchar(20), @nProjectID) + ',' + @cMeasureList + ',' + @cClassList + ')
							select VERSIONID, STORAGEID, FILTERID, STRID, TIMEKEY, CLH_' + convert(varchar(20), @nProjectID) + ',' + @cMeasureList + ',' + @cClassList + '
							from ' + @cTableOut
							execute (@cStr)							
						end

					execute ('if not object_id(''' + @cTableOut + ''') is Null drop table ' + @cTableOut)

					update #DTS set F1 = 1 where LINK = @nDS
				end

			update #DTS set DEPLOY_TABLE = '[KS_DDLControl].[FACTS_' + @cPostfix + ']'
		end

	exec ('if not col_length(''[KS_DDLControl].[FACTS_' + @cPostfix + ']'',''ORD_OLD'') is null alter table [KS_DDLControl].[FACTS_' + @cPostfix + '] drop column ORD_OLD')
	
end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'7941' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_DEPLOY_MERGE_DS'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[CLEAR_DS]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[CLEAR_DS]
GO

/*
	:      

	:
		@nMode = 1 -   , 2 -   
		@nId = id   
		
	 :
		exec dbo.[CLEAR_DS] @nMode = 1, @nId = 56468
		
	:
	:  .
*/
create procedure [dbo].[CLEAR_DS]
	@nMode int, -- 1 -  , 2 -   
	@nId int
as
begin
	set nocount on

	if @nId = 0 or @nMode = 0
		begin
			print '     '
		end
	else
		begin
			begin tran
			begin try
				create table #qqq (storageid int)
				
				if @nMode = 1
					insert [#qqq] ([storageid]) select [STORAGEID] from [STORAGE] where [VERSIONID] = @nId
					
				if @nMode = 2
					insert [#qqq] ([storageid]) select [STORAGEID] from [STORAGE] where [FILTERID] = @nId
				
				insert [#qqq] ([storageid]) select ST.[STORAGEID] from [STORAGE] ST, [#qqq] Q where ST.[STORAGE_SELF] = Q.storageid
				
				--  
				alter table dbo.STORAGE disable trigger all

				-- STORAGE
				IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_Storage_MEASURES]') AND type = 'F')
					ALTER TABLE [dbo].[STORAGE] DROP CONSTRAINT [FK_Storage_MEASURES]

				IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_Storage_Time]') AND type = 'F')
					ALTER TABLE [dbo].[STORAGE] DROP CONSTRAINT [FK_Storage_Time]

				IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_Storage_Version]') AND type = 'F')
					ALTER TABLE [dbo].[STORAGE] DROP CONSTRAINT [FK_Storage_Version]
					
				IF  EXISTS (SELECT * FROM sys.foreign_keys WHERE object_id = OBJECT_ID(N'[dbo].[FK_STORAGE_STORAGE_SELF]') AND parent_object_id = OBJECT_ID(N'[dbo].[STORAGE]'))
					ALTER TABLE [dbo].[STORAGE] DROP CONSTRAINT [FK_STORAGE_STORAGE_SELF]

				-- T_STORAGE
				IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_T_STORAGE_Classificators]') AND type = 'F')
					ALTER TABLE [dbo].[T_STORAGE] DROP CONSTRAINT [FK_T_STORAGE_Classificators]
				
				IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_T_STORAGE_SourceTemplate]') AND type = 'F')
					ALTER TABLE [dbo].[T_STORAGE] DROP CONSTRAINT [FK_T_STORAGE_SourceTemplate]
			
				IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_T_STORAGE_Storage]') AND type = 'F')
					ALTER TABLE [dbo].[T_STORAGE] DROP CONSTRAINT [FK_T_STORAGE_Storage]
				
				-- STORAGE_APP
				IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[FK_STORAGE_APP_Storage]') AND type = 'F')
					ALTER TABLE [dbo].[STORAGE_APP] DROP CONSTRAINT [FK_STORAGE_APP_Storage]

				if (select count(*) from #qqq) < 1000000
					begin
						delete STORAGE_APP where storageid in (select storageid from #qqq)
						delete T_STORAGE where [STORAGEID] in (select storageid from #qqq)
						delete STORAGE where [STORAGE_SELF] in (select storageid from #qqq)
						delete STORAGE where [STORAGEID] in (select storageid from #qqq)
					end
				else
					begin
						create table #qqq1 (storageid int)
						while exists(select * from #qqq)
							begin
								insert #qqq1 ([STORAGEID]) select top 100000 [STORAGEID] from [#qqq]
								delete STORAGE_APP where [STORAGEID] in (select [STORAGEID] from #qqq1)
								delete T_STORAGE where [STORAGEID] in (select [STORAGEID] from #qqq1)
								delete STORAGE where [STORAGE_SELF] in (select storageid from #qqq)
								delete STORAGE where [STORAGEID] in (select [STORAGEID] from #qqq1)
								delete [#qqq] where [STORAGEID] in (select [STORAGEID] from #qqq1)
								delete [#qqq1]
							end
					end
				

				-- STORAGE_APP
				ALTER TABLE [dbo].[STORAGE_APP] WITH NOCHECK ADD  CONSTRAINT [FK_STORAGE_APP_Storage] FOREIGN KEY([STORAGEID]) REFERENCES [dbo].[STORAGE] ([STORAGEID])
				ALTER TABLE [dbo].[STORAGE_APP] CHECK CONSTRAINT [FK_STORAGE_APP_Storage]

				-- T_STORAGE
				ALTER TABLE [dbo].[T_STORAGE]  WITH NOCHECK ADD  CONSTRAINT [FK_T_STORAGE_Classificators] FOREIGN KEY([ClassificatorID]) REFERENCES [dbo].[Classificators] ([ClassificatorID])
				ALTER TABLE [dbo].[T_STORAGE] CHECK CONSTRAINT [FK_T_STORAGE_Classificators]

				ALTER TABLE [dbo].[T_STORAGE]  WITH NOCHECK ADD  CONSTRAINT [FK_T_STORAGE_SourceTemplate] FOREIGN KEY([SourceTemplateID]) REFERENCES [dbo].[SOURCETEMPLATE] ([SourceTemplateID])
				ALTER TABLE [dbo].[T_STORAGE] CHECK CONSTRAINT [FK_T_STORAGE_SourceTemplate]

				ALTER TABLE [dbo].[T_STORAGE]  WITH NOCHECK ADD  CONSTRAINT [FK_T_STORAGE_Storage] FOREIGN KEY([STORAGEID]) REFERENCES [dbo].[STORAGE] ([STORAGEID])
				ALTER TABLE [dbo].[T_STORAGE] CHECK CONSTRAINT [FK_T_STORAGE_Storage]

				-- STORAGE
				ALTER TABLE [dbo].[STORAGE]  WITH NOCHECK ADD  CONSTRAINT [FK_Storage_MEASURES] FOREIGN KEY([MEASUREID]) REFERENCES [dbo].[MEASURES] ([MEASUREID])
				ALTER TABLE [dbo].[STORAGE] CHECK CONSTRAINT [FK_Storage_MEASURES]

				ALTER TABLE [dbo].[STORAGE]  WITH NOCHECK ADD  CONSTRAINT [FK_Storage_Time] FOREIGN KEY([TimeKey]) REFERENCES [dbo].[Time] ([TimeKey])
				ALTER TABLE [dbo].[STORAGE] CHECK CONSTRAINT [FK_Storage_Time]

				ALTER TABLE [dbo].[STORAGE]  WITH NOCHECK ADD  CONSTRAINT [FK_Storage_Version] FOREIGN KEY([VERSIONID]) REFERENCES [dbo].[VERSION] ([VersionID])
				ALTER TABLE [dbo].[STORAGE] CHECK CONSTRAINT [FK_Storage_Version]
				
				ALTER TABLE [dbo].[STORAGE]  WITH CHECK ADD  CONSTRAINT [FK_STORAGE_STORAGE_SELF] FOREIGN KEY([STORAGE_SELF]) REFERENCES [dbo].[STORAGE] ([STORAGEID])
				ALTER TABLE [dbo].[STORAGE] CHECK CONSTRAINT [FK_STORAGE_STORAGE_SELF]

				--  
				alter table dbo.STORAGE enable trigger all
			end try	
			begin catch
				select ERROR_NUMBER() as ErrorNumber, ERROR_SEVERITY() as ErrorSeverity, ERROR_STATE() as ErrorState,	ERROR_PROCEDURE() as ErrorProcedure, ERROR_LINE() as ErrorLine
				select 'Procedure dbo.CLEAR_DS @nId = ' + + convert(varchar(20),@nId), ERROR_MESSAGE() as ErrorMessage
				
				if @@TRANCOUNT > 0
					rollback transaction

				return
			end catch

			if @@TRANCOUNT > 0
				commit transaction

		end
end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8567' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'CLEAR_DS'
GO



if  exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[CLASIFICATORS_ITEM_SAVE]') and objectproperty(id,N'IsProcedure') = 1)
	drop procedure [dbo].[CLASIFICATORS_ITEM_SAVE]
GO


/* :   

    :

    :

   :
 
   :
		 .
*/

create procedure [dbo].[CLASIFICATORS_ITEM_SAVE]
	@cTables	varchar(300) = '#cAlias;#cAlias1;#cAlias2'
as

set nocount on

declare @cVer varchar(20), @cCL varchar(20), @cFields_S varchar(300), @cObj varchar(20), @nUserId int

select @cCL = convert(varchar(20), dbo.[GetTableValueInt]('#cAlias', 'CLASSIFICATORS', ''))
select @cCL = dbo.ClassificatorIdParent(@cCL)

if exists (select * from ClassificatorProperty cp where cp.ClassificatorID = @cCL and not cp.SourceClassificatorId is null)
	begin
		select @cCL = cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @cCL
		update #cAlias set CLASSIFICATORS = @cCL
	end

select @cVer = convert(varchar(20), dbo.[GetTableValueInt]('#cAlias', 'VERSIONID', ''))

if @cCL is null or @cVer is null
	begin
		raiserror('    .',16,1)
		return
	end

select @nUserId = user_id(suser_sname())


if suser_sname() <> 'sa' and dbo.AdminIsUserAdm(null)=0 and isnull(dbo.get_access_cl (@cVer, @cCL, @nUserId),1) & 16 = 0 
	begin
		raiserror('   /  .',16,1)
		return
	end

-- 
declare @cMsg varchar(4000)
create table #EMPTY (CLASSIFICATORID int)
insert #EMPTY (CLASSIFICATORID) select [CLASSIFICATORID] from #cAlias T where T.ClassificatorId < 0 and T.[Code] is null

if exists (select * from #EMPTY)
	begin
		select @cMsg = '    .    .'
		raiserror(@cMsg,16,1)
		return
	end

--  - ,     
select A.ClassificatorId, TV.VersionID into #VER_MOVE from #cAlias A, dbo.T_VERSION TV where isnull(A.ClassificatorId,0) > 0 and A.ClassificatorId = TV.ClassificatorID and TV.Deleted = 0

-- ,   "".      !
select T.ClassificatorId, DM.TargetElementID
into #CL_EL_DEAD
from #cAlias T, DataMigration DM
where T.ClassificatorId > 0 and T.ClassificatorId = DM.SourceElementID
and exists (select * from T_VERSION TV where TV.ClassificatorId = DM.SourceElementID and TV.VERSIONID = @cVer and TV.DELETED = 0)
and not exists (select * from #VER_MOVE where ClassificatorId = T.ClassificatorId and VERSIONID = @cVer)


update #cAlias1 set CLAPPID = CA.CLAPPID from CLASSIFICATORS_APP CA where CA.ClassificatorId = #cAlias1.ClassificatorId 
and CA.CLATTRID = #cAlias1.CLATTRID and #cAlias1.CLAPPID is null

if exists (select * from #CL_EL_DEAD)
	begin
		update #cAlias set ClassificatorId = CED.TargetElementID from #CL_EL_DEAD CED where CED.ClassificatorId = #cAlias.ClassificatorId
		update #cAlias1 set ClassificatorId = (select top 1 CED.TargetElementID from #CL_EL_DEAD CED)
		update #cAlias1 set CLAPPID = CA.CLAPPID from CLASSIFICATORS_APP CA where CA.ClassificatorId = #cAlias1.ClassificatorId and CA.CLATTRID = #cAlias1.CLATTRID
	end

if exists (select * from dbo.ClassificatorProperty where ClassificatorID = @cCL and DblControl = 1)
	begin
		create table #CONT (CLASSIFICATORID int, [ClassificatorCode] varchar(30), CHK tinyint default(0))
		insert #CONT (CLASSIFICATORID, [ClassificatorCode]) exec [SELECT_CL_INFO] 12, @cVer, @cCL
		update #CONT set CHK = 1 from #cAlias T where T.ClassificatorId < 0 and #CONT.[ClassificatorCode] = T.[Code]
		update #CONT set CHK = 1 from #cAlias T where T.ClassificatorId <> #CONT.ClassificatorId and #CONT.[ClassificatorCode] = T.[Code]

		if exists (select * from [#CONT] where [CHK] = 1)
			begin
				select @cMsg = '     .' + char(13) + char(10) + ' : ' + 
				(select distinct replace((select isnull([ClassificatorCode],'')+';' from [#CONT] where [CHK] = 1 for xml path('')) + '~', ';~','') as dbl_code from [#CONT] A where [CHK] = 1) + '.'
				select @cMsg = @cMsg + char(13) + char(10) + '          .' + char(13) + char(10) + '     .'
				raiserror(@cMsg,16,1)
				return
			end
	end

--  - ,     
--select A.ClassificatorId, TV.VersionID into #VER_MOVE from #cAlias A, dbo.T_VERSION TV where isnull(A.ClassificatorId,0) > 0 and A.ClassificatorId = TV.ClassificatorID and TV.Deleted = 0
delete #VER_MOVE where VersionID = @cVer

-- 
declare @Ord int, @cFields varchar(1000), @cKey varchar(100), @cAttr varchar(20)

-- 
begin transaction
begin try
	if exists (select * from #VER_MOVE)
		begin
			--       
			insert dbo.T_VERSION (ClassificatorID, VersionID, Deleted)
			select ClassificatorID, @cVer, 1 from #VER_MOVE VM
			where not exists (select * from dbo.T_VERSION TV where Tv.ClassificatorID = VM.ClassificatorID and TV.VersionID = @cVer and TV.Deleted = 1)

			--     
			update #cAlias set ClassificatorID = -1 * ClassificatorID where ClassificatorID in (select ClassificatorID from #VER_MOVE)
			update #cAlias1 set ClassificatorID = -1 * ClassificatorID, CLAPPID = -1 * CLAPPID where ClassificatorID in (select ClassificatorID from #VER_MOVE)

			if not object_id('tempdb..#cAlias2') is null
				begin
					select * into #ATTR0 from dbo.TREE_CLASS(@cCL) where not ClassId is null and Levels = 1 order by Orders

					if exists(select * from #ATTR0)
						begin
							while exists(select * from #ATTR0)
								begin
									select @Ord = min(Orders) from #ATTR0
									select @cKey = 'CLAPPID_' + convert(varchar(20),[Attr]) from #ATTR0 where @Ord = Orders
									exec ('update #cAlias2 set ClassificatorID = -1 * ClassificatorID, ' + @cKey + ' = -1 * ' + @cKey + ' where ClassificatorID in (select ClassificatorID from #VER_MOVE)')
									delete #ATTR0 where @Ord = Orders
								end
						end
				end
		end	

	--  
	update #cAlias set ROW_ID = newid() where isnull(CLASSIFICATORID, -1) < 0
	update #cAlias1 set ROW_ID = newid() where isnull(CLAPPID, -1) < 0

	select @cObj = convert(varchar(20),[OBJECT]) from [CLASSIFICATORS] where CLASSIFICATORID = convert(int, @cCL)
	select @cFields_S = 'CODE, NAME, DESCRIPTION, CLASSIFICATORS,' + @cObj

	--      link_self   
	create table #SYNC (CLASSIFICATORID int, CLASSIFICATORID_OLD int, ROW_ID uniqueidentifier)
	insert #SYNC (CLASSIFICATORID, CLASSIFICATORID_OLD, ROW_ID) select CLASSIFICATORID, CLASSIFICATORID, ROW_ID from #cAlias where CLASSIFICATORID <= 0
	update #cAlias set CODE = ltrim(rtrim(CODE)) , NAME = ltrim(rtrim(NAME)), DESCRIPTION = ltrim(rtrim(DESCRIPTION))

	--  escape-
	update #cAlias set 
		CODE = dbo.RegExReplace(isnull(CODE,''),'[\u0000-\u001F]',''),
		NAME = dbo.RegExReplace(isnull(NAME,''),'[\u0000-\u001F]',''),
		[DESCRIPTION] = dbo.RegExReplace(isnull([DESCRIPTION],''),'[\u0000-\u001F]','')

	execute SAVE_TABLE
		@cTable_R = 'CLASSIFICATORS',
		@cTable_S = '#cAlias',
		@cFields_R = 'CLASSIFICATORCODE, NAME, DESCRIPTION, PARENTCLASSIFICATORID, OBJECT',
		@cFields_S = @cFields_S,
		@cKey_R = 'CLASSIFICATORID',
		@cKey_S = 'CLASSIFICATORID'

	--  
	update #SYNC set CLASSIFICATORID = S.CLASSIFICATORID from #cAlias S where #SYNC.ROW_ID = S.ROW_ID
	insert T_VERSION (VERSIONID, CLASSIFICATORID, [DELETED]) select @cVer, CLASSIFICATORID, 0 from #SYNC

	--  /       
	if (select count(*) from #cAlias) > 1
		update #cAlias1 set CLASSIFICATORID = S.CLASSIFICATORID from #SYNC S, #cAlias1 T1 where S.CLASSIFICATORID_OLD = T1.CLASSIFICATORID
	else
		update #cAlias1 set CLASSIFICATORID = (select top 1 CLASSIFICATORID from #cAlias)

	delete CLASSIFICATORS_APP where CLAPPID in (select CLAPPID from #cAlias1 where isnull(VALUE,'') = '')
	delete #cAlias1 where isnull(VALUE,'') = ''
	delete #cAlias1 where CLATTRID is null

	update classificators set guid = newid() where classificatorid in (select classificatorid from #calias) and guid is null
	execute SAVE_TABLE
		@cTable_R = 'CLASSIFICATORS_APP',
		@cTable_S = '#cAlias1',
		@cFields_R = 'CLASSIFICATORID,CLATTRID,VALUE',
		@cFields_S = 'CLASSIFICATORID,CLATTRID,VALUE',
		@cKey_R = 'CLAPPID',
		@cKey_S = 'CLAPPID'	

	if not object_id('tempdb..#cAlias2') is null
		begin
			if exists(select * from #cAlias2)
				begin
					update #cAlias2 set CLASSIFICATORID = T.CLASSIFICATORID from #cAlias T
					declare @nCnt int
					select @nCnt = 0
					update #cAlias2 set @nCnt = ORDERS = @nCnt + 1

					select * into #ATTR1 from dbo.TREE_CLASS(@cCL) where not ClassId is null and Levels = 1 order by Orders

					if exists(select * from #ATTR1)
						begin
							while exists(select * from #ATTR1)
								begin
									select @Ord = min(Orders) from #ATTR1
									select @cAttr = [Attr] from #ATTR1 where @Ord = Orders
									select @cFields = 'CLASSIFICATORID, ' + @cAttr + ',ATTR_CL_' + @cAttr + ',ORDERS'
									select @cKey = 'CLAPPID_' + @cAttr

									exec ('
									delete CLASSIFICATORS_APP
									from CLASSIFICATORS_APP CA, #cAlias T1
									where
										CA.CLATTRID = ' + @cAttr + ' and T1.CLASSIFICATORID = CA.CLASSIFICATORID and
										not exists (select * from #cAlias2 T2 where T2.[' + @cKey + '] = CA.CLAPPID and not T2.[' + @cKey + '] is null)')

									execute SAVE_TABLE
										@cTable_R = 'CLASSIFICATORS_APP',
										@cTable_S = '#cAlias2',
										@cFields_R = 'CLASSIFICATORID,CLATTRID,VALUE,ORDERS',
										@cFields_S = @cFields,
										@cKey_R = 'CLAPPID',
										@cKey_S = @cKey

									delete #ATTR1 where @Ord = Orders
								end
						end
				end
			else
				begin
					select * into #ATTR11 from dbo.TREE_CLASS(@cCL) where not ClassId is null and Levels = 1 order by Orders
					if exists(select * from #ATTR11)
						begin
							while exists(select * from #ATTR11)
								begin
									select @Ord = min(Orders) from #ATTR11
									select @cAttr = [Attr] from #ATTR11 where @Ord = Orders

									exec('
									delete CLASSIFICATORS_APP
									from CLASSIFICATORS_APP CA, #cAlias T2
									where CA.CLATTRID = ' + @cAttr + ' and T2.CLASSIFICATORID = CA.CLASSIFICATORID')

									delete #ATTR11 where @Ord = Orders
								end
						end
				end	
		end

		if exists (select * from #VER_MOVE)
		begin
			--        insert  T_VERSION
			delete from  dbo.T_CL_ACCESS where ClassificatorID in (select ClassificatorID from #SYNC)

			--  
			insert dbo.T_CL_ACCESS (ClassificatorID, VersionID, UID, Access)
			select S.CLASSIFICATORID, @cVer, TCL.UID, TCL.Access
			from #VER_MOVE VM, #SYNC S, dbo.T_CL_ACCESS TCL
			where (VM.ClassificatorID * -1) = S.CLASSIFICATORID_OLD and VM.ClassificatorID = TCL.ClassificatorID and TCL.VersionID = @cVer

			--   
			insert dbo.DataMigration (SourceElementID, TargetElementID, KoefDirect, KoefInverse, ConfidenceDirect, ConfidenceInverse)
			select VM.ClassificatorID, S.ClassificatorID, 1, 1, 1, 1
			from #VER_MOVE VM, #SYNC S
			where (VM.ClassificatorID * -1) = S.CLASSIFICATORID_OLD

			--    
			create table #InputClassTable(SourceClassificatorID int,TargetClassificatorID int,Stat int)

			insert #InputClassTable (SourceClassificatorID, TargetClassificatorID)
			select VM.ClassificatorID, S.ClassificatorID from #VER_MOVE VM, #SYNC S where (VM.ClassificatorID * -1) = S.CLASSIFICATORID_OLD

			--     
			update Classificators set ParentClassificatorID = ICT.TargetClassificatorID
			from #InputClassTable ICT
			where ICT.SourceClassificatorID = Classificators.ParentClassificatorID
			
			exec [PACKAGE_REPLACE] @nVerID = @cVer, @paramStr='nFilterReplace=1'
		end

		update dbo.ClassificatorProperty set CH_GUID = newid() where ClassificatorID = @cCL
		update dbo.ClassificatorProperty set CH_GUID = newid() where SourceClassificatorId = @cCL
end try
begin catch
	select ERROR_NUMBER() as ErrorNumber, ERROR_SEVERITY() as ErrorSeverity, ERROR_STATE() as ErrorState,	ERROR_PROCEDURE() as ErrorProcedure, ERROR_LINE() as ErrorLine
	select 'Procedure dbo.CLASIFICATORS_ITEM_SAVE. ', ERROR_MESSAGE() as ErrorMessage

	if @@TRANCOUNT > 0
		rollback transaction

	return
end catch

if @@TRANCOUNT > 0
	commit transaction

-- sync
declare  @clid int
set @clid= convert(int, @cCL)
if (convert(int, @cVer) = dbo.get_Nsi_Version() and dbo.get_Nsi_Object(@clid) is not null)
begin

	delete s_corr_nsi
	delete s_bcorr_nsi
	delete s_kbk_nsi

	declare @attrlist varchar(2000), @clname varchar(200), @versionid int, @id int
	set @versionid = convert(int, @cVer)
	set @clname = [dbo].[get_Nsi_clname] (@clid)

	create table #clattrs(id int, name varchar(200))				
	insert #clattrs exec get_Nsi_Cl_atts @clid
	select @attrlist = '<list>'
	select @attrlist = @attrlist + '<id val="' + convert(varchar, id)+ '"/>"' from #clattrs
	select @attrlist = @attrlist + '</list>'
	drop table #clattrs

		create table #tempcl(clid int, pclid int, 
			[CODE] varchar(30), [SNAME] varchar(1000), [NAME] varchar(1024), [INN] varchar(4000), 
			[CORR_ID] varchar(4000),
			[BCORR_ID] varchar(4000), [ved] varchar(4000))

		if (@clname = '')
	    begin			
			insert #tempcl(clid, pclid, [CODE], [SNAME], [NAME], [INN], [ved])
			exec select_cl_elems @versionid, @clid, 0, @attrlist
			update #tempcl set pclid = -1 where clid in (select CLASSIFICATORID from #cAlias)
			delete #tempcl where pclid <> -1


				INSERT INTO [S_CORR_NSI]([LINK_DICT],[OBJ_CODE],[CODE],[SNAME],[NAME],[INN],[GUID],[ROW_ID], sendrows)
				select @clid, 'DICTIONARY_CORR', left(t.[CODE], 7), left(t.[SNAME], 45), left(t.[NAME], 250), left(t.[INN], 13), 
						c.guid, c.row_id, 1
				from #tempcl t join classificators c on t.clid = c.classificatorid			


		end
		else 
		begin
			if (@clname = '')
			begin 			
				insert #tempcl(clid, pclid, [CODE], [SNAME],[CORR_ID])
				exec select_cl_elems @versionid, @clid, 0, @attrlist
				update #tempcl set pclid = -1 where clid in (select CLASSIFICATORID from #cAlias)
				delete #tempcl where pclid <> -1

					INSERT INTO [S_BCORR_NSI]([LINK_DICT],[OBJ_CODE],[CODE],[BNAME],[CORR_GUID],[GUID],[ROW_ID], sendrows)

					select @clid, 'DICTIONARY_BUDJET_EXP', left(t.[CODE], 10), left(t.[SNAME], 254), 
							(select guid from classificators where classificatorid = convert(int,t.[CORR_ID])),  
							c.guid, c.row_id, 1
					from #tempcl t join classificators c on t.clid = c.classificatorid


			end
			else
			begin
				insert #tempcl(clid, pclid, [CODE], [SNAME], [NAME], [BCORR_ID])
				exec select_cl_elems @versionid, @clid, 0, @attrlist
				update #tempcl set pclid = -1 where clid in (select CLASSIFICATORID from #cAlias)
				delete #tempcl where pclid <> -1


					INSERT INTO [S_KBK_NSI]([LINK_DICT],[OBJ_CODE],[CODE],[SNAME],[NAME],[BCORR_GUID],[GUID],[ROW_ID], sendrows)
					select @clid, case @clname
							when '()' then 'DICTIONARY_KBK_INC'
							when '()' then 'DICTIONARY_KBK_SOUR'
							when '' then 'DICTIONARY_DEPARTMENT'
							when '' then 'DICTIONARY_DIVISION'
							when '' then 'DICTIONARY_TARGET_ITEM'
							when '' then 'DICTIONARY_EXPEND'
							when '' then 'DICTIONARY_ITEM'
							when '' then 'DICTIONARY_ADD_BK'
							end, 
							left(t.[CODE], 20), left(t.[SNAME], 50), left(t.[NAME], 2000), 
							(select guid from classificators where classificatorid = convert(int,t.[BCORR_ID])), 
							c.guid, c.row_id, 1
					from #tempcl t join classificators c on t.clid = c.classificatorid


			end
		end


end



select CLASSIFICATORID from #cAlias
GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8363' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'CLASIFICATORS_ITEM_SAVE'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_CM]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SELECT_CM]
GO



/*
	:  

   :

   :
	
  :
 
  :
		 .
*/

create procedure [dbo].[SELECT_CM]
	@nLink int = 0,
	@cObject varchar(100) = null
as
begin
	set nocount on

	if @nLink = 0
		begin
			declare @nObj int
			set @nObj = isnull(dbo.obj_id(@cObject),0)
			
			select convert(int,0) as CHECKED, CMID, NAME, case when REPL = 1 then '' else '' end as REPL, 
			case when REMOLDRES= 1 then '' else '' end as REMOLDRES, 
			case when IGNOREEMPTY= 1 then '' else ''end as IGNOREEMPTY, 
			case when AUTOCALC = 1 then '' else '' end as AUTOCALC,
			REMBYDATE
			from dbo.CALC_MEASURES 
			where isnull(object,0)=@nObj
			order by NAME
		end
	else
		begin
			select CMID, NAME, REPL, SLICE, REMOLDRES, IGNOREEMPTY,AUTOCALC,REMBYDATE into #CM from dbo.CALC_MEASURES where CMID = @nLink
			
			if @nLink > 0 and isnull(@cObject,'') = ''
				begin
				
					declare @XmlDocumentHandleCalc int, @XmlDocumentCalc xml, @SourceDsId int, @TargetDsId int
					select @XmlDocumentCalc = SLICE from #CM
					
					exec sp_xml_preparedocument @XmlDocumentHandleCalc output, @XmlDocumentCalc
							
					--   :  - 
					select @SourceDsId = case when a.col.exist('@SourceDsId')=1 then a.col.value('@SourceDsId', 'int') else null end
					from @XmlDocumentCalc.nodes('//SourceMeasureSlice') a(col)

					--   :  - 
					select @TargetDsId = case when a.col.exist('@TargetDsId')=1 then a.col.value('@TargetDsId', 'int') else null end
					from @XmlDocumentCalc.nodes('//SourceMeasureSlice') a(col)

					if not exists (select * from dbo.VERSION where VersionID = @SourceDsId) or
						not exists (select * from dbo.VERSION where VersionID = @TargetDsId)
						begin
							raiserror('    .   .',16,1)
							update #CM set SLICE = null
						end
					
					exec sp_xml_removedocument @XmlDocumentHandleCalc
				end
			
			select * from #CM
		end

end
	
GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8586' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_CM'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_CALC]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SELECT_CALC]
GO


/* :  

    :
		
    :
				
   :
 select * from calc_measures
   :
		 .
*/

create procedure [dbo].[SELECT_CALC]
	@nCMId	int
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd
	 
	declare @cStr varchar(max), @cStr_exec varchar(max), @cSTId varchar(100), @XmlDocumentHandleCalc int,
		@XmlDocumentCalc xml, @cValue varchar(20), @SourceDsId int, @cSourceMeasure varchar(2000), @TargetDsId int, @cTargetMeasure varchar(20), @nRepl int,
		@cMsg varchar(4000), @cGuid varchar(36), @nClearPrevCalc int, @nRemoveZero int,
		@cTableOut1 varchar(100), @cTableOut2 varchar(100), @nUser int, @nRemoveByDate int
		
	select @nUser = user_id(suser_sname())
		
	if not exists (select * from CALC_MEASURES where CMID = @nCMId)
		begin
			raiserror('  ',16,1)
			return
		end

	-- Guid 
	select @cGuid = ROW_ID, @nClearPrevCalc = REMOLDRES, @nRemoveZero = IGNOREEMPTY, @nRemoveByDate = isnull(REMBYDATE,0) from CALC_MEASURES where CMID = @nCMId

	if @nClearPrevCalc > 0 and @nRemoveByDate = 0
		begin
			--  ,      
			create table #DelPrevCalc (STORAGEID int)
			
			if @nClearPrevCalc = 1
				insert #DelPrevCalc (STORAGEID) select STORAGEID from dbo.STORAGE where IMPORT_ID = @cGuid

			if @nClearPrevCalc = 2
				insert #DelPrevCalc (STORAGEID) select STORAGEID from dbo.STORAGE where IMPORT_ID = @cGuid and FILTERID is null and STRID is null
				
			delete dbo.STORAGE_APP where STORAGEID in (select STORAGEID from #DelPrevCalc)
			delete dbo.T_STORAGE where STORAGEID in (select STORAGEID from #DelPrevCalc)
			delete dbo.STORAGE where STORAGEID in (select STORAGEID from #DelPrevCalc)
			drop table #DelPrevCalc
		end
		
	--  
	select @XmlDocumentCalc = SLICE, @nRepl = REPL from dbo.CALC_MEASURES where CMID = @nCMId
	exec sp_xml_preparedocument @XmlDocumentHandleCalc output, @XmlDocumentCalc
			
	--   :  - 
	select @SourceDsId = case when a.col.exist('@SourceDsId')=1 then a.col.value('@SourceDsId', 'int') else null end
	from @XmlDocumentCalc.nodes('//SourceMeasureSlice') a(col)

	--   :  - 
	select @TargetDsId = case when a.col.exist('@TargetDsId')=1 then a.col.value('@TargetDsId', 'int') else null end
	from @XmlDocumentCalc.nodes('//SourceMeasureSlice') a(col)

	if not exists (select * from dbo.VERSION where VersionID = @SourceDsId) or
	not exists (select * from dbo.VERSION where VersionID = @TargetDsId)
	begin
		raiserror('    .   .',16,1)
		return
	end

	--    
	--select @cTargetMeasure = case when a.col.exist('@TargetMeasure')=1 then a.col.value('@TargetMeasure', 'int') else null end
	--from @XmlDocumentCalc.nodes('//SourceMeasureSlice') a(col)
	
	select distinct *
	into #TargetMeasure
	from openxml (@XmlDocumentHandleCalc, '/SourceMeasureSlice/Measures/TargetMeasure', 2)
	with ([Order1] varchar(20) '../Order', Id varchar(20) 'text()')

	-- - ------------------------------------------------------------------
	create table #FILT_TIME (DATE_BEG datetime, DATE_END datetime, TIMEKEY_BEG int, TIMEKEY_END int)
	create table #FILT_CLASS (CLASSIFICATORID int, [VALUE] int, SOURCETEMPLATEID int, LEV int)
	create table #FILT_CLASS_MASK (VERID int, CLASSIFICATORID int, [MASK] varchar(200))
	create table #FILTER_DESCRIPTION (ObjCode varchar(80), Link varchar(20), DEL int default(0), MUSTINPUT int default(0), LEV_S int, LEV_T int, DEPLOY varchar(100), CALCLEVEL varchar(10))
	create table #FILT_CLASS_DOP ([CLASSIFICATORID] int, CNT int)
	create table #FACT_STRU (DEL int default(0), FILT int default(0), SOURCETEMPLATEID int, CLASSIFICATORID int, CODE varchar(70), MUSTINPUT int default(0))
	
	--     
	insert #FILT_TIME (DATE_BEG, DATE_END)
	select
		case
			when a.col.exist('@begin')=1 then
											case
												when a.col.value('@begin', 'varchar(24)') = '. ' then dbo.get_val('NASTR_RASH_DATE', 'DATE_VALUE', @nUser)
												else a.col.value('@begin', 'varchar(24)')
											end
			else null
		end,
		case when a.col.exist('@end')=1 then a.col.value('@end', 'varchar(24)') else null END
	from @XmlDocumentCalc.nodes('//SourceMeasureSlice/sourceTime/timePeriods/TimePeriod') a(col)

	update #FILT_TIME set TIMEKEY_BEG = T.TimeKey from dbo.[Time] T where T.FullDate = #FILT_TIME.DATE_BEG
	update #FILT_TIME set TIMEKEY_END = T.TimeKey from dbo.[Time] T where T.FullDate = #FILT_TIME.DATE_END

	--     Time
	if exists (select * from #FILT_TIME where TIMEKEY_BEG is Null)
		begin
			insert [TIME] (FullDate) select distinct DATE_BEG from #FILT_TIME where TIMEKEY_BEG is null
			update #FILT_TIME set TIMEKEY_BEG = T.TimeKey from dbo.[Time] T where T.FullDate = #FILT_TIME.DATE_BEG and #FILT_TIME.TIMEKEY_BEG is null
		end
	if exists (select * from #FILT_TIME where TIMEKEY_END is Null)
		begin
			insert [TIME] (FullDate) select distinct DATE_END from #FILT_TIME where TIMEKEY_END is null
			update #FILT_TIME set TIMEKEY_END = T.TimeKey from dbo.[Time] T where T.FullDate = #FILT_TIME.DATE_END and #FILT_TIME.TIMEKEY_END is null
		end

	--   .
	--select @cSourceMeasure = case when a.col.exist('@SourceMeasure')=1 then a.col.value('@SourceMeasure', 'varchar(2000)') else '' end
	--from @XmlDocumentCalc.nodes('//SourceMeasureSlice') a(col)
	--select @cSourceMeasure = replace(rtrim(ltrim(@cSourceMeasure)),' ', ',')
	
	select distinct *
	into #SourceMeasure
	from openxml (@XmlDocumentHandleCalc, '/SourceMeasureSlice/Measures/SourceMeasure/Measure', 2)
	with ([Order1] varchar(20) '../../Order', [Order2] varchar(20) 'Order', Id varchar(20) 'Id')

	--    
	insert #FILTER_DESCRIPTION (LINK, LEV_S, LEV_T, CALCLEVEL)
	select SCL.LINK, SCL.LEV_S, TCL.LEV_T, TCL.CALCLEVEL
	from 
		(select
			case when a.col.exist('@ClfId')=1 then dbo.j_sub_str(a.col.value('@ClfId', 'varchar(100)'), '-', 3) else null end as LINK,
			case when a.col.exist('@Level')=1 then a.col.value('@Level', 'int') else null end as LEV_S
		from @XmlDocumentCalc.nodes('//SourceMeasureSlice/sourceSlices/colSlice') a(col)) SCL
		left outer join
		(select
			case when a.col.exist('@ClfId')=1 then dbo.j_sub_str(a.col.value('@ClfId', 'varchar(100)'), '-', 3) else null end as LINK,
			case when a.col.exist('@Level')=1 then a.col.value('@Level', 'int') else null end as LEV_T,
			case when a.col.exist('@IsCalcLevel')=1 then a.col.value('@IsCalcLevel', 'varchar(10)') else null end as CALCLEVEL
		from @XmlDocumentCalc.nodes('//SourceMeasureSlice/targetSlices/colSlice') a(col)) TCL
	on SCL.LINK = TCL.LINK
		

	delete #FILTER_DESCRIPTION where Link is null

	-- -    
	insert #FILT_CLASS (CLASSIFICATORID, [VALUE])
	select dbo.j_sub_str(s.n.value('@ClfId','varchar(200)'), '-', 3),  m.n.value('.','int')
	from @XmlDocumentCalc.nodes('/SourceMeasureSlice/sourceSlices/colSlice') s(n)
		cross apply s.n.nodes('elements/el') m(n)

	--      
	insert #FILT_CLASS_MASK (VERID, CLASSIFICATORID, [MASK])
	select dbo.j_sub_str(s.n.value('@ClfId','varchar(200)'), '-', 2), dbo.j_sub_str(s.n.value('@ClfId','varchar(200)'), '-', 3), m.n.value('.','varchar(200)')
	from @XmlDocumentCalc.nodes('/SourceMeasureSlice/sourceSlices/colSlice') s(n)
		cross apply s.n.nodes('maskItems/mask') m(n)
		
	declare @nVerId int, @nClid int
	create table #CLASS_MASK (MASK varchar(200))

	while exists(select * from #FILT_CLASS_MASK)
		begin
			select top 1 @nVerId = VERID, @nClId = CLASSIFICATORID from #FILT_CLASS_MASK
			
			insert #CLASS_MASK (MASK) select MASK from #FILT_CLASS_MASK where CLASSIFICATORID = @nClId

			insert #FILT_CLASS ([VALUE])
			exec SELECT_CL_INFO @nMode = 8, @nVerID = @nVerId, @nClassId = @nClId

			update #FILT_CLASS set CLASSIFICATORID = @nClId where CLASSIFICATORID is null
			
			truncate table #CLASS_MASK
			delete #FILT_CLASS_MASK where @nClId = CLASSIFICATORID
		end
	drop table #CLASS_MASK

	--   ,  -  
	select *, convert(int,0) as FL1 into #LEV from #FILTER_DESCRIPTION where LEV_S > 0
	if exists (select * from #LEV)
		begin
			declare @cTableOutLev varchar(80), @nLev_S int, @nLev_T int
			select @nVerId = dbo.VersionParent(@SourceDsId)
		
			while exists(select * from #LEV where FL1 = 0)
				begin
					select top 1 @nClid = Link, @nLev_S = LEV_S, @nLev_T = LEV_T from #LEV where FL1 = 0

					execute dbo.CL_LEV_DEPLOY @nVerId = @nVerId, @nClId = @nClid, @cTable = @cTableOutLev output
					
					update #LEV set FL1 = 1, DEPLOY = @cTableOutLev where @nClid = Link
					
					--      
					select @cStr = '
					insert #FILT_CLASS (CLASSIFICATORID, VALUE, LEV)
					select distinct ' + convert(varchar(20),@nClid) + ', TD.CLASSIFICATORID, TD.LEV
					from ' + @cTableOutLev + ' TD
					where
						TD.LEV between ' + convert(varchar(20),@nLev_S) + ' and ' + convert(varchar(20),@nLev_T) + ' and
						not exists(select * from #FILT_CLASS where VALUE = TD.CLASSIFICATORID)'
					
					execute (@cStr)
				end
		end

	--       
	insert #FILT_CLASS_DOP ([CLASSIFICATORID], CNT)
	select [CLASSIFICATORID], count(*) from #FILT_CLASS group by [CLASSIFICATORID] having count(*)=1

	--     
	insert #FACT_STRU (SOURCETEMPLATEID, CLASSIFICATORID, CODE)
	select ID, CLID, CODE
	from dbo.[STORAGE_STRU](@SourceDsId) ST, #FILTER_DESCRIPTION FD
	where ST.DOF = 0 and ST.CLID = FD.Link

	update #FACT_STRU set FILT = 1 where CLASSIFICATORID in (select CLASSIFICATORID from #FILT_CLASS)
	update #FACT_STRU set MUSTINPUT = 1 from [#FILTER_DESCRIPTION] FD where #FACT_STRU.CLASSIFICATORID = FD.LINK and FD.[MUSTINPUT] = 1

	update [#FILT_CLASS] set SOURCETEMPLATEID = FT.[SOURCETEMPLATEID] from [#FACT_STRU] FT where [#FILT_CLASS].[CLASSIFICATORID] = FT.[CLASSIFICATORID]

	-- - ------------------------------------------------------------------
	create table #FILT_TIME1 (ID int identity, DATE datetime, TIMEKEY int)
	create table #FILT_CLASS1 (CLASSIFICATORID int, [VALUE] int, SOURCETEMPLATEID int)
	create table #FILTER_DESCRIPTION1 (ObjCode varchar(80), Link varchar(20), DEL int default(0), MUSTINPUT int default(0), LEV int)
	create table #FILT_CLASS_DOP1 ([CLASSIFICATORID] int, CNT int)
	create table #AMOUNT (STORAGEID int, ID int, AMOUNT numeric(27, 10))
	create table #FACT_STRU1 (DEL int default(0), FILT int default(0), SOURCETEMPLATEID int, CLASSIFICATORID int, CODE varchar(70), MUSTINPUT int default(0))
	create table #FILT_CLASS_TREE (VERID int, CLASSIFICATORID int, [LEVEL] varchar(200), [MASK] varchar(200))


	--     
	insert #FILT_TIME1 (DATE)
	select
		case
		when a.col.exist('@begin')=1 then
										case
											when a.col.value('@begin', 'varchar(24)') = '. ' then dbo.get_val('NASTR_RASH_DATE', 'DATE_VALUE', @nUser)
											else a.col.value('@begin', 'varchar(24)')
										end
			else null
		end
	from @XmlDocumentCalc.nodes('//SourceMeasureSlice/targetTime/timePeriods/TimePeriod') a(col)

	delete #FILT_TIME1 where ID > (select min(ID) from #FILT_TIME1) --     
	update #FILT_TIME1 set TIMEKEY = T.TimeKey from dbo.[Time] T where T.FullDate = #FILT_TIME1.DATE
	
	--     Time
	if exists (select * from #FILT_TIME1 where TIMEKEY is Null)
		begin
			insert [TIME] (FullDate) select distinct DATE from #FILT_TIME1 where TIMEKEY is null
			update #FILT_TIME1 set TIMEKEY = T.TimeKey from dbo.[Time] T where T.FullDate = #FILT_TIME1.DATE and #FILT_TIME1.TIMEKEY is null
		end


	if @nRemoveByDate > 0
		begin
			--  ,          
			create table #DelPrevCalcDate (STORAGEID int)
			
			if @nClearPrevCalc = 1
				insert #DelPrevCalcDate (STORAGEID)
				select ST.STORAGEID
				from dbo.STORAGE ST, #FILT_TIME1 FT1
				where ST.IMPORT_ID = @cGuid and ST.TimeKey = FT1.TIMEKEY

			if @nClearPrevCalc = 2
				insert #DelPrevCalcDate (STORAGEID)
				select ST.STORAGEID
				from dbo.STORAGE ST, #FILT_TIME1 FT1
				where ST.IMPORT_ID = @cGuid and ST.FILTERID is null and ST.STRID is null and ST.TimeKey = FT1.TIMEKEY
				
			delete dbo.STORAGE_APP where STORAGEID in (select STORAGEID from #DelPrevCalcDate)
			delete dbo.T_STORAGE where STORAGEID in (select STORAGEID from #DelPrevCalcDate)
			delete dbo.STORAGE where STORAGEID in (select STORAGEID from #DelPrevCalcDate)
			drop table #DelPrevCalcDate
		end

	--    
	insert #FILTER_DESCRIPTION1 (LINK, LEV)
	select
		case when a.col.exist('@ClfId')=1 then dbo.j_sub_str(a.col.value('@ClfId', 'varchar(100)'), '-', 3) else null end,
		case when a.col.exist('@Level')=1 then a.col.value('@Level', 'int') else null end
	from @XmlDocumentCalc.nodes('//SourceMeasureSlice/targetSlices/colSlice') a(col)

	delete #FILTER_DESCRIPTION1 where Link is null

	-- -    
	insert #FILT_CLASS1 (CLASSIFICATORID, [VALUE])
	select dbo.j_sub_str(s.n.value('@ClfId','varchar(200)'), '-', 3),  m.n.value('.','int')
	from @XmlDocumentCalc.nodes('/SourceMeasureSlice/targetSlices/colSlice') s(n)
		cross apply s.n.nodes('elements/el') m(n)

	--        
	insert #FILT_CLASS_DOP1 ([CLASSIFICATORID], CNT)
	select [CLASSIFICATORID], count(*) as CNT from #FILT_CLASS1 group by [CLASSIFICATORID] having count(*) = 1

	--     
	insert #FACT_STRU1 (SOURCETEMPLATEID, CLASSIFICATORID, CODE)
	select ID, CLID, replace(CODE,'DICTIONARY_CLASSIFICATOR-','CL-')
	from dbo.[STORAGE_STRU](@TargetDsId) ST, #FILTER_DESCRIPTION1 FD
	where ST.DOF = 0 and ST.CLID = FD.Link

	update #FACT_STRU1 set FILT = 1 where CLASSIFICATORID in (select CLASSIFICATORID from #FILT_CLASS1)
	update #FACT_STRU1 set MUSTINPUT = 1 from [#FILTER_DESCRIPTION1] FD where #FACT_STRU1.CLASSIFICATORID = FD.LINK and FD.[MUSTINPUT] = 1

	update [#FILT_CLASS1] set SOURCETEMPLATEID = FT.[SOURCETEMPLATEID] from [#FACT_STRU] FT where [#FILT_CLASS1].[CLASSIFICATORID] = FT.[CLASSIFICATORID]
	
	--      
	insert #FILT_CLASS_TREE (VERID, CLASSIFICATORID, [LEVEL], [MASK])
	select
		dbo.j_sub_str(s.n.value('@ClfId','varchar(200)'), '-', 2),
		dbo.j_sub_str(s.n.value('@ClfId','varchar(200)'), '-', 3),
		l.n.value('@hierarchyMask','varchar(200)'),
		m.n.value('.','varchar(200)')
	from @XmlDocumentCalc.nodes('/SourceMeasureSlice/targetSlices/colSlice') s(n)
		cross apply s.n.nodes('hierarchy/hierarchy') l(n)
		cross apply l.n.nodes('hierarchElements/hierarchyElements') m(n)
	

	if exists(select [CLASSIFICATORID], count(*) as CNT from #FILT_CLASS1 group by [CLASSIFICATORID] having count(*) > 1)
		begin
			raiserror ('   -.', 16, 1)
			goto ERRORS
		end

	if @cSourceMeasure = ''
		begin
			raiserror ('     .', 16, 1)
			goto ERRORS
		end

--select * from #FILTER_DESCRIPTION
--select * from #FILTER_DESCRIPTION1
--select * from #FILT_CLASS
--select * from #FILT_CLASS1
--select * from #FILT_CLASS_DOP
--select * from #FILT_CLASS_DOP1
--select * from #FILT_TIME
--select * from #FILT_TIME1

	--   
	select @cStr = 'declare @cnt int
	
	if not object_id(''tempdb..#F'') is Null
		drop table #F

	create table #F (FILTERID int, STRID int, AMOUNT numeric(27, 10), TIMEKEY int, '
	
	
	declare @cStr_ins varchar(max), @cStr_from varchar(max), @cStr_flds varchar(max), @cUpd varchar(max), @cStr_where varchar(max),
	@nExstTime int, @nExstTime1 int, @cCode1 varchar(100), @cCode2 varchar(100)

	select @cStr_ins = ''
	select @cStr_from = ''
	select @cStr_flds = ''
	select @cStr_where = ''
	
	--   
	if exists(select * from #FILT_TIME)
		select @nExstTime = 1

	--   
	if exists(select * from #FILT_TIME1)
		select @nExstTime1 = 1

	--      
	delete #FACT_STRU where not exists(select * from #FILTER_DESCRIPTION FD where #FACT_STRU.CLASSIFICATORID = FD.LINK)
	delete #FACT_STRU1 where not exists(select * from #FILTER_DESCRIPTION1 FD1 where #FACT_STRU1.CLASSIFICATORID = FD1.LINK)

	select A.DEL, A.CLASSIFICATORID into #SHARE_STRU from #FACT_STRU A, #FACT_STRU1 A1 where A.CLASSIFICATORID = A1.CLASSIFICATORID
	
	-- ,     
	select A.DEL, A.CLASSIFICATORID, A.CODE, A.SOURCETEMPLATEID
	into #ONLY_SOURCE
	from #FACT_STRU A
	where not exists (select * from #FACT_STRU1 A1 where A.CLASSIFICATORID = A1.CLASSIFICATORID)

	-- ,     
	select A1.DEL, A1.CLASSIFICATORID, A1.CODE
	into #ONLY_TARGET
	from #FACT_STRU1 A1
	where not exists (select * from #FACT_STRU A where A.CLASSIFICATORID = A1.CLASSIFICATORID)

	--  

	select @cTableOut1 = '<TableOut1>'

	--  
	while exists(select * from #SHARE_STRU where DEL = 0)
		begin
			select top 1 @nClId = CLASSIFICATORID from #SHARE_STRU where DEL = 0
			
			select @cSTId = SOURCETEMPLATEID, @cCode1 = CODE from #FACT_STRU where CLASSIFICATORID = @nClId
			select @cCode2 = CODE from #FACT_STRU1 where CLASSIFICATORID = @nClId
			
			select @cStr_ins = @cStr_ins + '[' + @cCode2 + '],'

			if exists (select top 1 1 from #FILT_CLASS_DOP where CLASSIFICATORID = @nClId)
				begin
					select @cValue = (select ltrim(rtrim([VALUE])) from [#FILT_CLASS] where CLASSIFICATORID = @nClId)
					if @cStr_where = '' select @cStr_where = ' where '
					select @cStr_where = @cStr_where + '
						A.[' + @cCode1 + '] = ' + @cValue + ' and '
				end
			else
				begin
					if exists (select top 1 1 from #FILT_CLASS where CLASSIFICATORID = @nClId)
						begin
							if @cStr_where = '' select @cStr_where = ' where '
							select @cStr_where = @cStr_where + '
							exists (select * from #FILT_CLASS where CLASSIFICATORID = ' + convert(varchar(20),@nClId) + ' and A.[' + @cCode1 + '] = VALUE) and'
						end
				end

			if exists(select * from #FILT_CLASS1 where CLASSIFICATORID = @nClId)
				select @cStr_flds = @cStr_flds + (select ltrim(rtrim([VALUE])) from [#FILT_CLASS1] where CLASSIFICATORID = @nClId) + ','
			else
				select @cStr_flds = @cStr_flds + ' A.[' + @cCode1 + '],'

			select @cStr = @cStr + '[' +  @cCode2 + '] int,'
			
			update #SHARE_STRU set DEL = 1 where @nClId = CLASSIFICATORID
		end

--select * from #ONLY_TARGET
--SELECT * FROM [#FILT_CLASS1]
--SELECT * FROM #FILT_CLASS_DOP1
--select @cStr
--select @cStr_flds
--select @cStr_ins

	--    
	if exists(select * from #ONLY_TARGET)
		begin
			while exists(select * from #ONLY_TARGET where DEL = 0)
				begin
					select top 1 @nClId = CLASSIFICATORID, @cCode1 = CODE from #ONLY_TARGET where DEL = 0
					
					select @cStr = @cStr + '[' +  @cCode1 + '] int,'
					
					if exists (select top 1 1 from #FILT_CLASS_DOP1 where CLASSIFICATORID = @nClId)
						begin
							select @cStr_flds = @cStr_flds + (select ltrim(rtrim([VALUE])) from [#FILT_CLASS1] where CLASSIFICATORID = @nClId) + ','
						end

					if exists (select * from #ONLY_TARGET OT where OT.CLASSIFICATORID = @nClId and
							not exists (select * from #FILT_CLASS_DOP1 FCD1 where FCD1.CLASSIFICATORID = OT.CLASSIFICATORID))
						begin
							declare @nVer int
							select @nVer = dbo.VersionParent(@TargetDsId)
							insert #FILT_CLASS1 (VALUE) exec dbo.SELECT_CL_INFO @nMode = 8, @nVerID = @nVer, @nClassId = @nClId
							update #FILT_CLASS1 set CLASSIFICATORID = @nClId where CLASSIFICATORID is null
							
							select @cStr_flds = @cStr_flds + ' FC' + convert(varchar(20), @nClId) + '.VALUE,'
							select @cStr_from = @cStr_from + ',(select distinct VALUE from #FILT_CLASS1 where CLASSIFICATORID = ' + convert(varchar(20),@nClId) + ') FC' + convert(varchar(20), @nClId)
						end

					select @cStr_ins = @cStr_ins + '[' + @cCode1 + '],'
					
					update #ONLY_TARGET set DEL = 1 where @nClId = CLASSIFICATORID
				end
		end

	--    
	if exists(select * from #ONLY_SOURCE)
		begin
			while exists(select * from #ONLY_SOURCE where DEL = 0)
				begin
					select top 1 @nClId = CLASSIFICATORID, @cCode1 = CODE, @cSTId = SOURCETEMPLATEID from #ONLY_SOURCE where DEL = 0
					
					if exists (select top 1 1 from #FILT_CLASS_DOP where CLASSIFICATORID = @nClId)
						begin
							select @cValue = (select ltrim(rtrim([VALUE])) from [#FILT_CLASS] where CLASSIFICATORID = @nClId)
							if @cStr_where = '' select @cStr_where = ' where '
							select @cStr_where = @cStr_where + '
								A.[' + @cCode1 + '] = ' + @cValue + ' and '
						end
					else
						begin
							if exists (select top 1 1 from #FILT_CLASS where CLASSIFICATORID = @nClId)
								begin
									if @cStr_where = '' select @cStr_where = ' where '
									select @cStr_where = @cStr_where + '
									exists (select * from #FILT_CLASS where CLASSIFICATORID = ' + convert(varchar(20),@nClId) + ' and A.[' + @cCode1 + '] = VALUE) and '
								end									
						end

					update #ONLY_SOURCE set DEL = 1 where @nClId = CLASSIFICATORID
				end
		end

	select @cStr = left(@cStr, len(@cStr) - 1) + ')' + char(13) + char(13)
		
	select @cStr_ins = left(@cStr_ins, len(@cStr_ins) - 1)
	select @cStr_flds = left(@cStr_flds, len(@cStr_flds) - 1)

	if isnull(@cStr_where, '') <> ''
		select @cStr_where = left(@cStr_where, len(@cStr_where) - 3)


	select @cStr = @cStr + '
	insert #F (FILTERID, STRID, TIMEKEY, AMOUNT,' + @cStr_ins +')
	select A.FILTERID, floor(A.STRID/100), ' + 
	case 
		when exists (select * from #FILT_TIME1) then (select top 1 convert(varchar(20), TIMEKEY) from #FILT_TIME1)
		else 'A.TIMEKEY'
	end + ', A.AMOUNT,' + @cStr_flds

	if not @nExstTime is null
		begin
			select @cStr = @cStr + '
			from
				(select * from #FILT_TIME FT, ' + @cTableOut1 + ' ST where ST.TIMEKEY between FT.TIMEKEY_BEG and FT.TIMEKEY_END) A
				' + @cStr_from + @cStr_where
		end	
	else
		begin
			select @cStr = @cStr + '
			from 
				(select * from ' + @cTableOut1 + ') A
				' + @cStr_from + @cStr_where
		end
				
	select @cStr = @cStr + '
	select @cnt = count(*) from #F
	print ''    ''
	print @cnt

	select top 0 identity(int,1,1) as ID, convert(int, Null) as STORAGEID, AMOUNT, TIMEKEY, ' + @cStr_ins + ',convert(uniqueidentifier, null) as [ROW_ID] into #FACTS from #F'


	if exists(select * from dbo.[STORAGE_STRU](@SourceDsId) ST, #FILTER_DESCRIPTION FD where ST.DOF = 0 and ST.CLID = FD.Link and ST.MULTISELECTION = 1)
		select @cStr = @cStr + '
			select top 0 AMOUNT, TIMEKEY, ' + @cStr_ins + ' into #F1 from #F
			
			insert #F1 (AMOUNT, TIMEKEY,' + @cStr_ins + ')
			select max(AMOUNT), TIMEKEY, ' + replace(replace(@cStr_ins, '[', 'max(['), ']', '])') + '
			from #F
			where not STRID is null
			group by FILTERID, STRID, TIMEKEY
			union all
			select AMOUNT, TIMEKEY, ' + replace(replace(@cStr_ins, '[', '(['), ']', '])') + '
			from #F
			where FILTERID is null and STRID is null
			
			'

--select * from #FILT_CLASS_TREE

	declare @cLev varchar(200), @cMask varchar(200)
	if exists (select * from #FILT_CLASS_TREE)
		begin
			create table #FILT_CLASS_TREE1 ([VALUE] int)
			
			while exists(select * from #FILT_CLASS_TREE)
				begin
					select @nVerId = VERID, @nClid = CLASSIFICATORID, @cLev = [LEVEL], @cMask = [MASK] from #FILT_CLASS_TREE
					select @cCode1 = CODE from #FACT_STRU where CLASSIFICATORID = @nClId

					insert #CLASS_MASK (MASK) values (@cLev)

					insert #FILT_CLASS_TREE1 ([VALUE])
					exec SELECT_CL_INFO @nMode = 8, @nVerID = @nVerId, @nClassId = @nClId

					-- ,   
					if exists(select * from #FILT_CLASS_TREE1)
						begin
							select @cStr = @cStr + '
							update #F1 set [' + @cCode1 + '] = ' + isnull((select top 1 convert(varchar(20), [VALUE]) from #FILT_CLASS_TREE1), 'Null') + ' where [' + @cCode1 + '] in ('
										
							delete #CLASS_MASK
							delete #FILT_CLASS_TREE1
							
							insert #CLASS_MASK (MASK) values (@cMask)
							insert #FILT_CLASS_TREE1 ([VALUE])
							exec SELECT_CL_INFO @nMode = 8, @nVerID = @nVerId, @nClassId = @nClId
							
							--         #FILT_CLASS_TREE1
							select @cStr = @cStr + (select stuff((select ',' + convert(nvarchar(20), [VALUE]) as [text()] from #FILT_CLASS_TREE1 for xml path('')), 1, 1, '')) + ')'
							
						end
					
					delete #CLASS_MASK
					delete #FILT_CLASS_TREE1
					delete #FILT_CLASS_TREE where @nVerId = VERID and @nClid = CLASSIFICATORID and @cLev = [LEVEL] and @cMask = [MASK]
				end
			
		end

	if exists(select * from dbo.[STORAGE_STRU](@SourceDsId) ST, #FILTER_DESCRIPTION FD where ST.DOF = 0 and ST.CLID = FD.Link and ST.MULTISELECTION = 1)
		select @cStr = @cStr + '
		
		insert #FACTS (AMOUNT, TIMEKEY, ' + @cStr_ins + ')
		select sum(AMOUNT), TIMEKEY, ' + @cStr_ins + ' from #F1 group by TIMEKEY, ' + @cStr_ins + '

	--select * from #FACTS
		'
	else
		select @cStr = @cStr + '
		
		insert #FACTS (AMOUNT, TIMEKEY, ' + @cStr_ins + ')
		select sum(AMOUNT), TIMEKEY, ' + @cStr_ins + ' from #F group by TIMEKEY, ' + @cStr_ins + '

	--select * from #FACTS
		'
			

	if exists (select * from #LEV)
		begin
			declare @cFieldsLev varchar(100)
			update #LEV set FL1 = 0
		
			while exists(select * from #LEV where FL1 = 0)
				begin
					select top 1 @nClid = Link, @nLev_S = LEV_S, @nLev_T = LEV_T, @cTableOutLev = DEPLOY from #LEV where FL1 = 0

					while @nLev_S > @nLev_T
						begin
							select @cFieldsLev = replace(replace(replace(@cStr_ins, 'CL-' + convert(varchar(20), @TargetDsId) + '-' + convert(varchar(20), @nClid), 'L' + convert(varchar(20),@nLev_S)), '[CL-', 'F.[CL-'), '[L', 'TL.[L')
							
--select @cStr_ins
--select @cFieldsLev
							--      
							select @cStr = @cStr + '
							
							insert #FACTS (AMOUNT, TIMEKEY, ' + @cStr_ins + ')
							select F.AMOUNT, F.TIMEKEY, ' + @cFieldsLev + '
							from #FACTS F, ' + @cTableOutLev + ' TL
							where F.[CL-' + convert(varchar(20), @TargetDsId) + '-' + convert(varchar(20), @nClid) + '] = TL.CLASSIFICATORID and TL.LEV = ' + convert(varchar(20),@nLev_S)
							
							select @nLev_S = @nLev_S - 1
						end
					
					update #LEV set FL1 = 1 where @nClid = Link
				end
				
			select @cStr = @cStr + '
			select * into #FACTS_LEV from #FACTS
			delete #FACTS
			
			insert #FACTS (AMOUNT, TIMEKEY, ' + @cStr_ins + ')
			select sum(AMOUNT), TIMEKEY, ' + @cStr_ins + ' from #FACTS_LEV group by TIMEKEY, ' + @cStr_ins
	
		end

	
	if not @nExstTime1 is null
		begin
				select @cStr = @cStr + '
--select * from #FACTS
				select @cnt = count(*) from #FACTS
				print ''    ''
				print @cnt'
		end
		
	if @nRemoveZero > 0
		begin
				select @cStr = @cStr + '
				select @cnt = count(*) from #FACTS where AMOUNT = 0
				delete #FACTS where AMOUNT = 0

				print ''    ''
				print @cnt'
		end

	update #FACT_STRU1 set DEL = 0

	--   
	--  
	declare @cUpd_where varchar(max)
	select @cUpd_where = ''

	while exists(select * from #FACT_STRU1 where DEL = 0)
		begin
			select top 1 @cSTId = SOURCETEMPLATEID from #FACT_STRU1 where DEL = 0
			select @cCode1 = CODE from #FACT_STRU1 where SOURCETEMPLATEID = @cSTId
			
			select @cUpd_where = @cUpd_where + '
				isnull(ST.[' + @cCode1 + '], 0) = isnull(F.[' + @cCode1 + '], 0) and'

			update #FACT_STRU1 set DEL = 1 where SOURCETEMPLATEID = @cSTId
		end
		select @cUpd_where = left(@cUpd_where, len(@cUpd_where) - 3)

	--    T_STORAGE
	--update #FACT_STRU set SOURCETEMPLATEID = T.ID from dbo.STORAGE_STRU(@TargetDsId) T where T.CLID = #FACT_STRU.[CLASSIFICATORID]
	update #FACT_STRU1 set DEL = 0

	declare @cIns varchar(max)
	select @cIns = ''
	while exists(select * from #FACT_STRU1 where DEL = 0)
		begin
			select top 1 @cSTId = SOURCETEMPLATEID from #FACT_STRU1 where DEL = 0
			select @cCode1 = CODE from #FACT_STRU1 where SOURCETEMPLATEID = @cSTId
			
			select @cIns = @cIns + '
				insert T_STORAGE (STORAGEID,CLASSIFICATORID,SOURCETEMPLATEID)
				select STORAGEID,[' + @cCode1 + '],' + @cSTId + ' from #FACTS where not [' + @cCode1 + '] is null'
				
			update #FACT_STRU1 set DEL = 1 where SOURCETEMPLATEID = @cSTId
		end	
	--select @cIns
	
	--     ,     .   .
	declare @cUpd_DM varchar(max)
	select @cUpd_DM = ''
	if dbo.ParentId(@SourceDsId, 'VERSION') <> dbo.ParentId(@TargetDsId, 'VERSION')
		begin
			declare @nTargetVer int
			select @nTargetVer = dbo.ParentId(@TargetDsId, 'VERSION')
			
			select SourceElementID , TargetElementID, dbo.ClassificatorIdParent(SourceElementID) as ClId
			into #DataMigration
			from dbo.DataMigration
			where SourceElementID in (select ClassificatorID from dbo.T_VERSION where Deleted = 1 and VersionID = @nTargetVer)

			declare CL scroll cursor for select distinct DM.ClId from #DataMigration DM, #FILTER_DESCRIPTION1 FD1 where FD1.LINK = DM.ClId
			open CL
			if @@CURSOR_ROWS > 0
				begin
					fetch next from CL into @nClId

					while @@FETCH_STATUS = 0
						begin
							select @cUpd_DM = @cUpd_DM + '
							update #FACTS set [CL-' + convert(varchar(20),@TargetDsId) + '-' + convert(varchar(20),@nClId) + '] = DM.TargetElementID
							from #DataMigration DM
							where DM.ClId = ' + convert(varchar(20),@nClId) + ' and DM.SourceElementID = #FACTS.[CL-' + convert(varchar(20),@TargetDsId) + '-' + convert(varchar(20),@nClId) + ']
							'
							fetch next from CL into @nClId
						end
				end
			close CL
			deallocate CL

				
			update dbo.T_STORAGE set ClassificatorID = A.TargetElementID
			from dbo.STORAGE ST, dbo.T_STORAGE TS, #DataMigration A
			where ST.IMPORT_ID = @cGuid and ST.VERSIONID in (@TargetDsId) and ST.STORAGEID = TS.STORAGEID and TS.ClassificatorID = A.SourceElementID
		end
	
	--    
	select @cTargetMeasure = '<TargetMeasure>', @cTableOut2 = '<TableOut2>'

	select @cUpd = '
--select 1,* from #FACTS	
	'+ @cUpd_DM+ '
--select 2,* from #FACTS
		if exists(select * from #FACTS)
			insert #AMOUNT (STORAGEID, ID, AMOUNT)
			select ST.STORAGEID, F.ID, F.AMOUNT
			from #FACTS F, ' + @cTableOut2 + ' ST
			where isnull(F.TIMEKEY,0) = isnull(ST.TIMEKEY,0) and ' + @cUpd_where


--select @cStr

	select @cStr = @cStr + char(13) + char(13) + @cUpd + '

		select @cnt = count(*) from #AMOUNT
		print ''   ''
		print @cnt
--select * from #AMOUNT'

	if @nRepl  = 1 --  
		select @cStr = @cStr + '
			update STORAGE set Amount = A.AMOUNT, IMPORT_ID = ''' + @cGuid + ''' from #AMOUNT A where A.STORAGEID = STORAGE.STORAGEID
			'
	else
		select @cStr = @cStr + '
			update STORAGE set Amount = STORAGE.Amount + A.AMOUNT, IMPORT_ID = ''' + @cGuid + ''' from #AMOUNT A where A.STORAGEID = STORAGE.STORAGEID'
			
	select @cStr = @cStr + '		
		delete #FACTS where ID in (select ID from #AMOUNT)
		
		--   
		if exists(select * from #FACTS)
			begin
				select @cnt = count(*) from #FACTS
				print '' ''
				print @cnt
				
				update #FACTS set [ROW_ID] = newid()
				
				insert STORAGE (VERSIONID,AMOUNT,TIMEKEY,MEASUREID,ROW_ID,IMPORT_ID)
				select ' + convert(varchar(20),@TargetDsId) + ',AMOUNT,TIMEKEY,' + @cTargetMeasure + ',ROW_ID,''' + @cGuid + ''' from #FACTS

				update #FACTS set STORAGEID = A.STORAGEID from STORAGE A, #FACTS B where A.ROW_ID = B.ROW_ID
				
				' + @cIns + '
				
--select * from #FACTS
			end'

--select * from #FILT_TIME
--select * from [#FILT_CLASS]
--select * from [#FILT_CLASS1]

--DROP TABLE ##FILT_TIME
--DROP TABLE ##FILT_TIME1
--DROP TABLE ##FILT_CLASS
--DROP TABLE ##FILT_CLASS1
--DROP TABLE ##FILT_CLASS_DOP
--select * into ##FILT_TIME from #FILT_TIME
--select * into ##FILT_TIME1 from #FILT_TIME1
--select * into ##FILT_CLASS from [#FILT_CLASS]
--select * into ##FILT_CLASS1 from [#FILT_CLASS1]
--select * into ##FILT_CLASS_DOP from #FILT_CLASS_DOP
--print @cStr
--return

	

	if @cStr is null
		begin
			raiserror('    .',16,1)
			return
		end


	begin transaction 
	begin try
		declare @nOrder1 int, @cSourceIncList varchar(8000), @cTargetIncList varchar(8000)
		while exists (select * from #TargetMeasure)
			begin
				select @nOrder1 = min(Order1) from #TargetMeasure
				print @nOrder1
				
				--   -
				select @cSourceMeasure = stuff((select ',' + Id as [text()] from #SourceMeasure where @nOrder1 = Order1 for xml path('')), 1, 1, '')
				select @cSourceIncList = stuff((select ',' + convert(nvarchar(20), LINK) as [text()] from #FILTER_DESCRIPTION for xml path('')), 1, 1, '')
				exec dbo.ST_DEPLOY @nStorageId = @SourceDsId, @cMeasureList = @cSourceMeasure, @cClInclList = @cSourceIncList, @cTable = @cTableOut1 output

				--    
				select @cTargetMeasure = stuff((select ',' + Id as [text()] from #TargetMeasure where @nOrder1 = Order1 for xml path('')), 1, 1, '')
				select @cTargetIncList = stuff((select ',' + convert(nvarchar(20), LINK) as [text()] from #FILTER_DESCRIPTION1 for xml path('')), 1, 1, '')
				exec dbo.ST_DEPLOY @nStorageId = @TargetDsId, @cMeasureList = @cTargetMeasure, @cClInclList = @cTargetIncList, @cTable = @cTableOut2 output
				
				--    
				select @cStr_exec = @cStr
				select @cStr_exec = replace(@cStr_exec, '<TableOut1>',@cTableOut1)
				select @cStr_exec = replace(@cStr_exec, '<TableOut2>',@cTableOut2)
				select @cStr_exec = replace(@cStr_exec, '<TargetMeasure>',@cTargetMeasure)

--print @cStr_exec
				execute (@cStr_exec)
		
				execute ('drop table ' + @cTableOut1)
				execute ('drop table ' + @cTableOut2)
				delete #AMOUNT

				delete #TargetMeasure where @nOrder1 = Order1
				print '----'
			end
	end try
	begin catch
		declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
		select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
		if @@TRANCOUNT > 0
			rollback transaction
		return 1
	end catch

	if @@TRANCOUNT > 0
		commit transaction

	--  
	delete #FACT_STRU
	delete #FILT_TIME
	delete #FILT_CLASS
	delete #FILT_CLASS1
	delete #FILT_CLASS_DOP
	delete #FILTER_DESCRIPTION
	delete #FILTER_DESCRIPTION1
	
	while exists(select * from #LEV)
		begin
			select top 1 @nClid = Link, @cTableOutLev = DEPLOY from #LEV
			execute ('drop table ' + @cTableOutLev)
			delete #LEV where @nClid = Link
		end


ERRORS: exec sp_xml_removedocument @XmlDocumentHandleCalc

end

GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8589' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_CALC'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ImportAnyXml_inner]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[ImportAnyXml_inner]
GO

CREATE proc [dbo].[ImportAnyXml_inner]
	@ssistemplatelink int,
	@import_id uniqueidentifier,
	@file varchar(200)
as
begin

	declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int			

	-- context
	declare @version int, @dsid int, @vmode int, @doc_date varchar(10), @date datetime, @codepage int, @notUpdate varchar(7), @notaddelems varchar(7), @updatesums varchar(7)
	select @date= getdate()	
	select top 1 @vmode = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'V_MODE'
	select top 1 @version = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'VERSION_ID'
	select top 1 @dsid = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_ID'
	select top 1 @notUpdate = [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'NOTUPDATE_ATTRIBUTES'
	select top 1 @notaddelems = [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'NOTADD_NEWELEMENTS'
	select top 1 @updatesums = [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'UPDATE_SUMS'
	if (exists(select top 1 * from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_IsTimeConst' and value='True'))
	begin
		select top 1 @doc_date = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_TimeConst'		
	end
	if (exists(select * from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CodePage'))
	begin
		select @codepage = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CodePage'		
	end

	
	-- xml declare from template	
	create table #xmldecl(Name varchar(200), Parent varchar(200), [level] int, fullpath varchar(4000), [Enable] bit, [Type] int, Id int, 
			Attribut int, IsKey bit, ForeignId int, ForeignAttribut int, nodetype int, ExternId int, ForeignExternID int, BlockID int, Blockids varchar(200), key1 bit, key2 bit, mBlock varchar(7),
			delsums varchar(7), notadd varchar(7))

	declare @paramcount int
	select @paramcount = (select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_ColumnCount')
	while (@paramcount>0)
	begin
		insert #xmldecl
		select 
		(select value from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Name'),
		(select value from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Parent'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Level'),
		(select value from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_FullPath'),
		(select case value when 'true' then 1 else 0 end from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Enable'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Type'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Id'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Attribut'),
		(select case value when 'true' then 1 else 0 end from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_IsKey'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_ForeignId'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_ForeignAttribut'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_NodeType'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_ExternSourceClId'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_ForeignExternSourceClId'),
		(select CONVERT(int, value) from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_BlockID'),
		(select value from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_BlocksIDs'),
		(select case value when 'true' then 1 else 0 end from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Key1'),
		(select case value when 'true' then 1 else 0 end from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_Key2'),
		(select value from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_MainID'),
		(select value from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_ToDelete'),
		(select value from SSISTemplateDescription where LINK_UP=@ssistemplatelink and PARAMETER='FILE_SECTION1_COLUMN' + CONVERT(varchar(4), @paramcount) + '_NotToAddNewElems')
		select @paramcount = @paramcount - 1
	end	
		
	-- file
	DECLARE @idoc int, @nsString varchar(1000), @doc nvarchar(max)
	exec readxml @file,  @doc output, @codepage

	if (patindex('%?%', @doc) > 0)
		select @doc =substring (@doc , patindex('%?>%', @doc) + 2, len(@doc)- patindex('%?>%', @doc) - 1)
		
	-- get all xml declare
	EXEC sp_xml_preparedocument @idoc OUTPUT, @doc
	SELECT * into #aaa FROM OPENXML (@idoc, '') 
	EXEC sp_xml_removedocument @idoc

	-- get the namespace decalre
	select @nsString='<'+VALUE from SSISTemplateDescription where PARAMETER='FILE_SECTION1_COLUMN1_Name' and LINK_UP=@ssistemplatelink
	select distinct isnull(prefix, 'tag') as prefix, namespaceuri into #ns from #aaa where namespaceuri is not  null
	drop table #aaa	
	select @nsString=@nsString+ ' xmlns:' + prefix + '="' + namespaceuri +'"' from #ns
	select @nsString=@nsString+' />' 
	drop table #ns			
	EXEC sp_xml_preparedocument @idoc OUTPUT, @doc, @nsString	

	select distinct Name, Parent, [level], fullpath, [Enable], [Type], Id, Attribut, key2 iskey, 
			null as ForeignId, null as ForeignAttribut, nodetype, ForeignExternID as ExternID, null as ForeignExternID, blockids, mblock, delsums, notadd into #sclrs from #xmldecl 
		where id not in (select ForeignId from #xmldecl where ForeignId is not null) and [type]=0
	union
	select distinct Name, Parent, [level], fullpath, [Enable], [Type], Id, Attribut, Key1 iskey, 
			null as ForeignId, null as ForeignAttribut, nodetype, ExternID as ExternID, null as ForeignExternID, blockids, mblock, delsums, notadd from #xmldecl 
		where id in (select ForeignId from #xmldecl where ForeignId is not null) and [type]=0
	union	
	select distinct Name, Parent, [level], fullpath, [Enable], [Type], ForeignId, ForeignAttribut, null iskey, Id, Attribut, nodetype, 
			ExternID as ExternID, ForeignExternID as ForeignExternID, blockids, mblock, delsums, notadd from #xmldecl 
		where Foreignid is not null and [type]=0
	alter table #sclrs add buftable varchar(600)

	declare @ClrInV table(classificatorid int, classificatorcode varchar(30), name varchar(1000), description varchar(2000), obj_code varchar(30))
	insert into @ClrInV exec dbo.GetClassificatorsInVersion @version
	declare @classificators table (	rownum int IDENTITY (1, 1) Primary key NOT NULL, id int not null, existing int, objectID int)
	create table #attrAlias(Attribut int, fullpath varchar(4000), IsKey bit, ForeignId int, ForeignAttribut int, upRelation int, name varchar(200), nodetype int, ForeignOriginal int, iskey2 int)

	declare @dsname varchar(64)
	if @dsid = -1 or @dsid is null
	begin
		select top 1 @dsname = left([value],64) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_NAME'
		if isnull(@dsname,'')=''
			set @dsname = '  '+convert(varchar(30),@date,104)
		exec InsertVersion @version,@dsname,@dsname,@date,null,'DICTIONARY_DATASOURCE',@dsid output
	end
	
	declare @addrow int
	set @addrow = 0
	while (exists(select * from #sclrs where buftable is null)) -- foreach classificator - checking version
	begin	
		declare @sclid int, @sclsourceid int, @minlevel int, @script nvarchar(max), @buftable varchar(600), @parentpath varchar(2000), @notadd varchar(7)
		select @buftable = '[KS_DDLControl].[ImportXML_C_' + convert(varchar(500), NEWID()) + ']'
		
		if(exists(select ID from #sclrs where Id not in (select Id from #sclrs where ForeignId is not null) and buftable is null))
		begin
			select @notadd = notadd, @sclid = id, @sclsourceid = case when ExternID is null then id else ExternID end from #sclrs where buftable is null 
						and Id not in (select Id from #sclrs where ForeignId is not null)
		end
		else
		begin
			select @notadd = notadd, @sclid = id, @sclsourceid = case when ExternID is null then id else ExternID end from #sclrs where buftable is null 
						and Id in (select Id from #sclrs where ForeignId is not null)
		end

		update #sclrs set buftable = @buftable where @sclid = id
		select @minlevel = min([level])  from #sclrs where @sclid = id
		
		select top 1 @parentpath = left(fullpath, len(fullpath) - len(name) - 1) from #sclrs	where [level] = @minlevel and ID = @sclid
		select top 1 @script = 'if  exists (select * from sys.objects where object_id = object_id(N''' + @buftable + ''') and type in (N''U''))
			drop table ' + @buftable + ' SELECT distinct * into ' + @buftable + ' FROM OPENXML (@idoc, ''' + 
			@parentpath + ''', 3) with (' 			
		
		select * into #attr_import from #sclrs where id = @sclid and foreignid is null

		create table #doubleattrs(attribut int, onepath varchar(4000))
		insert #doubleattrs(attribut) select attribut from #attr_import group by attribut having count(*) > 1
		update #doubleattrs set onepath = (select top 1 fullpath from #attr_import where #attr_import.attribut=#doubleattrs.attribut)
		delete #attr_import where attribut in (select attribut from #doubleattrs) and fullpath not in (select onepath from #doubleattrs)
		drop table #doubleattrs
		
		select @script = @script + '[' + fullpath + '] varchar(4000) ''' + 
			case nodetype when 2 then replace(right(fullpath, len(fullpath) - len(@parentpath) - 1), name, '') + '@' + name 
									else right(fullpath, len(fullpath) - len(@parentpath) - 1) end
			 + ''','  from #attr_import
				
		select @script = left(@script, len(@script) - 1) + ') '
		exec sp_executesql @script, N'@idoc int', @idoc = @idoc
		
		select @script = ' update ' + @buftable + ' set '
		select @script = @script + '[' + fullpath + '] = dbo.RegExALLfresh([' + fullpath + ']),'  from #attr_import
		select @script = left(@script, len(@script) - 1)
		exec sp_executesql @script
		
		delete #attrAlias 		
		insert #attrAlias (Attribut, fullpath, IsKey, ForeignId, ForeignAttribut, upRelation)
		select Attribut, fullpath, IsKey, case when ForeignExternID is null then ForeignId else ForeignExternID end ForeignID, ForeignAttribut, 0 from #attr_import

		declare @add int
		exec dbo.CheckImportClassificatorVersion @buftable, @version, @sclsourceid, @add output		
		
		if (@notaddelems='True' or @notadd='True')
		begin
			select @script = ' delete ' + @buftable + ' where addflag is not null '
			exec sp_executesql @script
		end
		
		select @addrow = @addrow + @add		
		drop table #attr_import	
		
		insert into @classificators(id, existing, objectID)
		select @sclsourceid, case when exists(select * from @ClrInV where classificatorid=@sclsourceid) then 1 else 0 end, null			
	--end		


	--if @vmode = 0
	--begin
	--	if @addrow + case when exists(select * from @classificators where existing = 0) then 1 else 0 end > 0
	--	begin
		
	--		declare @newname varchar(64)
	--		select top 1 @newname = isnull(left(value,64),' ') from ssistemplatedescription  where link_up = @ssisTemplateLink and parameter = 'V_NAME'
	--		exec InsertVersion @version,@newname,@newname, @date, null, 'DICTIONARY_VERSION', @version output
	--	end
	--	select top 1 @dsname = left([value],64) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_NAME'
	--	if isnull(@dsname,'')=''
	--		set @dsname = '  '+convert(varchar(30),@date,104)
	--	exec InsertVersion @version,@dsname,@dsname,@date,null,'DICTIONARY_DATASOURCE',@dsid output
	--end
	--else
	--if @dsid = -1 or @dsid is null
	--begin
	--	select top 1 @dsname = left([value],64) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_NAME'
	--	if isnull(@dsname,'')=''
	--		set @dsname = '  '+convert(varchar(30),@date,104)
	--	exec InsertVersion @version,@dsname,@dsname,@date,null,'DICTIONARY_DATASOURCE',@dsid output
	--end

	insert into t_version(classificatorid,versionid,deleted) 
	select distinct id, @version, 0 from @classificators where existing = 0
	delete @classificators
	
	declare @object int
	set @object = dbo.obj_id('DICTIONARY_OTHER_DWH')
				
	if(@sclid not in (select Id from #sclrs where ForeignId is not null))	
	--while (exists(select * from #sclrs where buftable is not null 
	--			and Id not in (select Id from #sclrs where ForeignId is not null))) -- foreach classificator - insert into dwh
	begin	
		
		--select @sclid = id, @sclsourceid = case when ExternID is null then id else ExternID end, @buftable = buftable from #sclrs where --buftable is not null 
		--	Id not in (select Id from #sclrs where ForeignId is not null)			
		--update #sclrs set buftable = null where Id = @sclid				
	
		delete #attrAlias				
		insert #attrAlias(fullpath, Attribut, iskey) select fullpath, Attribut, iskey from #sclrs where Id = @sclid
		exec dbo.InsertImportClassificator @buftable, @version, @sclsourceid, @object, @idoc, @import_id, @notUpdate
		
		select @script = 'if  exists (select * from sys.objects where object_id = object_id(N''' + @buftable + ''') and type in (N''U''))
			drop table ' + @buftable 		
		exec(@script)
		
		if not exists(select * from dbo.SOURCETEMPLATE where VERSIONID = @dsid and ClassificatorID = @sclid)
			insert into dbo.SourceTemplate(ClassificatorID,VersionID,[description])	select @sclid, @dsid, '' 
	
	end	

	if(@sclid in (select Id from #sclrs where ForeignId is not null))
	--while (exists(select * from #sclrs where buftable is not null 
	--			and Id in (select Id from #sclrs where ForeignId is not null))) -- foreach classificator with relation - insert into dwh
	begin	
	
		--select @sclid = id, @sclsourceid = case when ExternID is null then id else ExternID end, @buftable = buftable from #sclrs where --buftable is not null 
		--	Id in (select Id from #sclrs where ForeignId is not null)			
		--update #sclrs set buftable = null where Id = @sclid
	
		delete #attrAlias		
		insert #attrAlias(fullpath, Attribut, ForeignId, ForeignAttribut, upRelation, name, nodetype, ForeignOriginal, iskey, iskey2)
		select s1.fullpath, s1.Attribut, case when s1.ForeignExternID is null then s1.ForeignId else s1.ForeignExternID end ForeignID, s1.ForeignAttribut, 0, s1.name, s1.nodetype, s1.ForeignId,
		 s1.iskey, (select iskey from #sclrs s2 where s2.fullpath=s1.fullpath and s2.foreignid is null and s2.id<>s1.id) from #sclrs s1 where s1.Id = @sclid		 

		--create table #doubleattrs2(attribut int, onepath varchar(4000))
		--insert #doubleattrs2(attribut) select attribut from #attrAlias group by attribut having count(*) > 1
		--update #doubleattrs2 set onepath = (select top 1 fullpath from #attrAlias where #attrAlias.attribut=#doubleattrs2.attribut)
		--delete #attrAlias where attribut in (select attribut from #doubleattrs2) and fullpath not in (select onepath from #doubleattrs2)
		--drop table #doubleattrs2	
		
		exec dbo.InsertImportClassificator @buftable, @version, @sclsourceid, @object, @idoc, @import_id, @notUpdate
				
		select @script = 'if  exists (select * from sys.objects where object_id = object_id(N''' + @buftable + ''') and type in (N''U''))
			drop table ' + @buftable 
		exec(@script)
	
		if not exists(select * from dbo.SOURCETEMPLATE where VERSIONID = @dsid and ClassificatorID = @sclid)
			insert into dbo.SourceTemplate(ClassificatorID,VersionID,[description])	select @sclid, @dsid, '' 
	end	
	end
	select *, convert(varchar(600), null) as buftable, convert(varchar(4000), null) as timecol  into #measures from #xmldecl where type = 1

	declare @timepath varchar(4000)	
	while (exists(select * from #measures where buftable is null)) -- foreach measure - create buftable
	begin	
		declare @mid int, @blockid varchar(7), @mainblock int
		select @buftable = '[KS_DDLControl].[IMportXml_M_' + CONVERT(varchar(500), newid()) +']'
		select @mid = id, @blockid = '%'+convert(varchar(7), blockid)+'%', @mainblock = convert(int, mblock) from #measures where buftable is null 			
		update #measures set buftable = @buftable where Id = @mid
		
		select distinct name, fullpath, level, nodetype into #fields from #sclrs where patindex('%'+@blockid+'%', blockids)>0
		
		if (exists(select * from #xmldecl where patindex(@blockid, blockids)>0 and TYPE = 2))
		begin
		insert #fields
			select top 1 name, fullpath, level, nodetype from #sclrs where patindex('%'+@blockid+'%', blockids)>0 and TYPE = 2
			update #measures set timecol = (select top 1 fullpath from #sclrs where patindex('%'+@blockid+'%', blockids)>0 and TYPE = 2)
			where ID=@mid
		end	

		select @minlevel = min(level) from #fields 
		if (@minlevel < (select level from #measures where ID = @mid))
			select top 1 @parentpath = left(fullpath, len(fullpath) - len(name) - 1) from #fields where level=@minlevel
		else
			select top 1 @parentpath = left(fullpath, len(fullpath) - len(name) - 1) from #measures left join MEASURES on #measures.Id = measures.MEASUREID where ID = @mid
		if @mainblock >0 and @mainblock is not null
			select @parentpath = fullpath from #xmldecl where blockid = @mainblock
				
		select top 1 @script = 'if  exists (select * from sys.objects where object_id = object_id(N''' + @buftable + ''') and type in (N''U''))
			drop table ' + @buftable + ' SELECT distinct * into ' + @buftable + ' FROM OPENXML (@idoc, ''' + 
			@parentpath + ''', 3) with ([' + 
			fullpath + '] ' + 
			case MEASURES.ms_type when 3 then 'varchar(4000) ''' else 'varchar(4000) ''' end + 			
			case nodetype when 2 then replace(right(fullpath, len(fullpath) - len(@parentpath) - 1), name, '') + '@' + name 
									else right(fullpath, len(fullpath) - len(@parentpath) - 1) end + ''','
			from #measures left join MEASURES on #measures.Id = measures.MEASUREID where ID = @mid
								
			
		select @script = @script + '[' + fullpath + '] varchar(4000) ''' + 
			case nodetype when 2 then replace(right(fullpath, len(fullpath) - len(@parentpath) - 1), name, '') + '@' + name 
									else right(fullpath, len(fullpath) - len(@parentpath) - 1) end
			 + ''','  from #fields	where len(fullpath) - len(@parentpath) - 1 >0 and patindex('%' + @parentpath + '%', fullpath)>0			 
			 
		select @script = @script + '[' + fullpath + '] varchar(4000) ''' + 
			case nodetype when 2 then replace(fullpath, name, '') + '@' + name 
									else fullpath end
			 + ''','  from #fields	where (len(fullpath) - len(@parentpath) - 1 <=0 or patindex('%' + @parentpath + '%', fullpath)=0)
			 and patindex('%' + replace(fullpath, name, '') + '%', @parentpath)=0

		select @script = @script + '[' + fullpath + '] varchar(4000) ''' + 
			case nodetype when 2 then dbo.getdottedxmlpath(fullpath, @parentpath) + '@' + name 
									else dbo.getdottedxmlpath(fullpath, @parentpath) + name end
			 + ''','  from #fields	where (len(fullpath) - len(@parentpath) - 1 <=0 or patindex('%' + @parentpath + '%', fullpath)=0)
			 and patindex('%' + replace(fullpath, name, '') + '%', @parentpath)>0
	 
		select @script = left(@script, len(@script) -1) + ') '		
		exec sp_executesql @script, N'@idoc int', @idoc = @idoc	

		while exists(select * from #fields)
		begin
			declare @repfield varchar(800)
			select @repfield = fullpath from #fields
			select @script = 'if not exists(select * from ' + @buftable + ' where [' + @repfield + '] is not null)
			begin
				declare @rep varchar(4000)
				select top 1 @rep = [' + @repfield + '] FROM OPENXML (@idoc, ''' + 
				@repfield + ''', 3) with ([' + @repfield + '] varchar(4000) ''.'')
				update ' + @buftable + ' set [' + @repfield + ']= @rep 
			end' 		
			exec sp_executesql @script, N'@idoc int', @idoc = @idoc	
			delete #fields where fullpath=@repfield			
		end	
		
		select @repfield = fullpath from #measures where @mid = id
		select @script = 'if not exists(select * from ' + @buftable + ' where [' + @repfield + '] is not null)
		begin
			declare @rep varchar(4000)
			select top 1 @rep = [' + @repfield + '] FROM OPENXML (@idoc, ''' + 
			@repfield + ''', 3) with ([' + @repfield + '] varchar(4000) ''.'')
			update ' + @buftable + ' set [' + @repfield + ']= @rep 
		end '
		exec sp_executesql @script, N'@idoc int', @idoc = @idoc	
			
		select @script = ' alter table ' + @buftable + ' add notsynccolumn uniqueidentifier, notsynccolumn2 uniqueidentifier '
		exec sp_executesql @script
		
		drop table #fields			
	end
	alter table #measures add up int
	EXEC sp_xml_removedocument @idoc
	
	update #sclrs set buftable = null
	while (exists(select * from #sclrs where buftable is null)) -- foreach classificator - get to buf from dwh
	begin	
	
		select @buftable = '[KS_DDLControl].[IMportXml_L_' + CONVERT(varchar(500), newid()) +']'
		select @sclid = id, @sclsourceid = case when ExternID is null then id else ExternID end from #sclrs where buftable is null 			
		update #sclrs set buftable = @buftable where Id = @sclid
		
		delete #attrAlias		
		insert #attrAlias(fullpath, Attribut, ForeignId, ForeignAttribut, upRelation, iskey)
		select fullpath, Attribut, case when ForeignExternID is null then ForeignId else ForeignExternID end ForeignID, ForeignAttribut, 0, iskey from #sclrs where Id = @sclid
				and not exists(select * from #sclrs s2 where s2.ForeignId = @sclid)

		if(exists (select * from #attrAlias))
		begin		
			--create table #doubleattrs3(attribut int, onepath varchar(4000), foreignid int)
			--insert #doubleattrs3(attribut) select attribut from #attrAlias group by attribut having count(*) > 1
			--update #doubleattrs3 set onepath = (select top 1 fullpath from #attrAlias where #attrAlias.attribut=#doubleattrs3.attribut)		
			--delete #attrAlias where attribut in (select attribut from #doubleattrs3) and fullpath not in (select onepath from #doubleattrs3)
			--drop table #doubleattrs3

			if (exists(select * from #attrAlias where IsKey = 1))		
				delete #attrAlias where IsKey <> 1 or iskey is null
			else
			begin
				declare @key int
				if exists(select * from #attrAlias where Attribut<0)
					select @key=MAX(Attribut) from #attrAlias where Attribut<0
				else
					select @key=min(Attribut) from #attrAlias
				delete #attrAlias where Attribut<>@key			
				update #sclrs set iskey = 1 where attribut=@key and @sclid = id
			end			

			select @script = 'if  exists (select * from sys.objects where object_id = object_id(N''' + @buftable + ''') and type in (N''U''))
					drop table ' + @buftable + ' create table ' + @buftable + '(classificatorid int, parentclassificatorid int, '
			select @script = @script + '[' + fullpath + '] varchar(4000), ' from #attrAlias order by Attribut		
			select @script = LEFT(@script, len(@script) - 1) + ') declare @list varchar(4000) select @list = ''<list>'
			select @script = @script + '<id val="' + CONVERT(varchar(200), Attribut) + '"/>' from #attrAlias order by Attribut
			select @script = @script + '</list>'' '
			select @script = @script + 'insert ' + @buftable + ' exec select_cl_elems ' + convert(varchar(20), @version) + ', ' + CONVERT(varchar(20), @sclsourceid) + ', 0, @list '

			exec(@script)

			update #measures set up = null
			while (exists(select * from #measures where up is null)) -- foreach measure - update buftable
			begin			
				declare @mbuf varchar(600)
				select @mbuf = buftable, @blockid='%'+convert(varchar(7), blockid)+'%' from #measures where up is null 			
				update #measures set up = 1 where buftable=@mbuf
								
				select * into #fields2 from #sclrs where patindex(@blockid, blockids)>0 

				if not exists(select * from #attrAlias where fullpath not in (select fullpath from #fields2))
				begin		
					select @script = ''
					select @script = @script +' alter table ' + @mbuf + ' add [' + fullpath + '_1] varchar(4000)'  from #attrAlias
					exec (@script)					
					select @script = ''
					select @script = @script +'update ' + @mbuf + ' set [' + fullpath + '_1] = [' + fullpath + '] '  from #attrAlias
					exec (@script)					
					select @script = ' update ' + @mbuf + ' set notsynccolumn2 = newid(), '					
					select @script = @script + '[' + fullpath + '] = b.classificatorid, ' from #attrAlias
					select @script = LEFT(@script, len(@script) - 1) + ' from ' + @mbuf + ' a inner join ' + @buftable + ' b on ' 				
					select @script = @script + 'left(isnull(a.[' + fullpath + '],''''),'+
						case when attribut =-1 then '30'
						when attribut =-2 then '1000'
						when attribut =-3 then '1024'
						else '4000' end
						+') = isnull(b.[' + fullpath + '],'''') and ' from #attrAlias
					select @script = LEFT(@script, LEN(@script) - 4)					
					select @script = @script +' update ' +@mbuf + ' set notsynccolumn = newid() where notsynccolumn2 is null ' 
					select @script = @script +' update ' +@mbuf + ' set notsynccolumn2 = null ' 					
					exec (@script)					

				end	
				drop table #fields2		
		
			end
		end		

	end	
	drop table #attrAlias
	
	update #measures set up = null
	while (exists(select * from #measures where up is null)) -- foreach measure - into storage
	begin			
		declare @timecol varchar(4000), @amountname varchar(4000), @mtype int
		select @mbuf = buftable, @timecol = timecol, 
			@amountname = case ms_type when 3 then '[' + fullpath + ']' else ' case isnumeric([' + fullpath + ']) when 1 then convert(numeric(27, 10), [' + fullpath + ']) else 0 end ' end, 
			@mtype= ms_type, @blockid='%'+convert(varchar(7), blockid)+'%', @mid=id
			from #measures left join measures on #measures.Id=MEASURES.MEASUREID where up is null 
		update #measures set up = 1 where buftable=@mbuf								
		
		select *, -1 as sourcetemplateid into #fields3 from #sclrs where patindex(@blockid, blockids)>0 
				and not exists(select * from #sclrs s2 where s2.ForeignId = #sclrs.ID) and iskey=1	

		update #fields3 set sourcetemplateid = (select sourcetemplateid from SOURCETEMPLATE where VERSIONID=@dsid and ClassificatorID=#fields3.Id)

			create table #doublefields(id int, onepath varchar(4000), foreignid int)
			insert #doublefields(id) select id from #fields3 group by id having count(*) > 1
			update #doublefields set onepath = (select top 1 fullpath from #fields3 where #fields3.id=#doublefields.id)		
			delete #fields3 where id in (select id from #doublefields) and fullpath not in (select onepath from #doublefields)
			drop table #doublefields
			
		select @script = ' insert importlogsteps(message, import_id)select '' : ''+'		
		select @script = @script + 'left([' + fullpath +'_1],30) + ''... :'' + ' from #fields3
		select @script = @script + 'convert(varchar(127),' + @amountname + '), '''+ convert(nvarchar(100), @import_id) +''' from ' + @mbuf + ' where notsynccolumn is not null '
		exec(@script)	
		
		select @script = ' delete ' +@mbuf +' where notsynccolumn is not null alter table ' +@mbuf + ' add row_id uniqueidentifier '
		exec(@script)
		select @script = ''
		if (@doc_date is not null)
			select @script = 'insert [time] (fulldate)	values(''' + convert(varchar(50), convert(datetime, @doc_date)) +''') '
		else
			if (@timecol is not null)
				select @script = 'insert [time] (fulldate)	select convert(datetime, [' + @timecol + ']) from ' + @mbuf
			else 
				select @script = 'insert [time] (fulldate)	select replace(convert(varchar(10), getdate(), 20), ''-'', '''')'	
		
		select @script = @script + ' update ' + @mbuf + ' set row_id = newid()'
			
		if (@updatesums='True')
		begin
			declare @script1 nvarchar(max), @cTableOut2 varchar(200), @tableMUdate varchar(200)
			select @script1=' declare @cTable2 varchar(200) exec dbo.ST_DEPLOY @nStorageId = ' + convert(varchar(15), @dsid) + ', @cTable = @cTable2 output select @cTableOut2 = @cTable2'
			exec sp_executesql @script1, N'@cTableOut2 varchar(200) out', @cTableOut2 = @cTableOut2 out
		
			declare @deployCount int
			select @deployCount = count(*) from #fields3
			select @tableMUdate = '[KS_DDLControl].[tableMUdate-' +convert(varchar(200),newid()) +']'
			select @script=@script + ' select ts.storageid into ' + @tableMUdate + ' from  ' + @cTableOut2 + ' t join ' + @mbuf + ' m on ' 
			select @script=@script + 't.[CL-' + convert(varchar(15), @dsid) + '-' + convert(varchar(15), id)+ '] = m.[' + fullpath + '] and ' from  #fields3
			select @script=LEFT(@script, len(@script)- 4)+ ' join t_storage ts on ts.storageid = t.storageid group by ts.storageid having count(ts.storageid) = ' + convert(varchar(3), @deployCount)
				+ 'delete t_storage where storageid in (select storageid from ' + @tableMUdate + ')
					delete storage_app where storageid in (select storageid from ' + @tableMUdate + ')
					delete storage where storageid in (select storageid from ' + @tableMUdate + ')'				
		end
		exec (@script)
		
		select @script=''
		if (exists(select * from #fields3 where delsums='True'))
		begin			
			declare @cTableOut3 varchar(200), @tableMDel varchar(200)
			select @script1=' declare @cTable3 varchar(200) exec dbo.ST_DEPLOY @nStorageId = ' + convert(varchar(15), @dsid) + ', @cTable = @cTable3 output select @cTableOut3 = @cTable3'
			exec sp_executesql @script1, N'@cTableOut3 varchar(200) out', @cTableOut3 = @cTableOut3 out

			select @deployCount = count(*) from #fields3
			select @tableMDel = '[KS_DDLControl].[tableMDel-' +convert(varchar(200),newid()) +']'
			select @script=' select t.storageid into ' + @tableMDel + ' from  ' + @cTableOut3 + ' t join ' + @mbuf + ' m on ' 
			select @script=@script + 't.[CL-' + convert(varchar(15), @dsid) + '-' + convert(varchar(15), id)+ '] is not null and ' from  #fields3 where delsums = 'False'
			select @script = @script +'('
			select @script=@script + 't.[CL-' + convert(varchar(15), @dsid) + '-' + convert(varchar(15), id)+ '] = m.[' + fullpath + '] and ' from  #fields3 where delsums = 'True'
			select @script = LEFT(@script, len(@script)- 3) + ')'
			select @script=@script + '  and storageid in (select storageid from t_storage group by storageid having count(*)= ' + convert(varchar(3), @deployCount) +')'
				+ 'delete t_storage where storageid in (select storageid from ' + @tableMDel + ')
					delete storage_app where storageid in (select storageid from ' + @tableMDel + ')
					delete storage where storageid in (select storageid from ' + @tableMDel + ')'				
		end

		select @script = @script + 			
			' insert into storage(versionid, amount, timekey, row_id, measureid, import_id)
			select ' + convert(varchar(20), @dsid) + ', ' + 
			case @mtype when 3 then 'null' else @amountname end + ', ' + 			
			case when @doc_date is not null then '''' +replace(left(@doc_date, 10), '-', '') + '''' 
				 else (case when @timecol is null then replace(convert(varchar(10), getdate(), 20), '-', '') 
							else 'replace(left([' + @timecol + '], 10), ''-'', '''')' 
					   end) 
			end +  
			', row_id, ' + 
			convert(varchar(20), @mid) + ', ''' + 
			CONVERT(varchar(500), @import_id) + 
			''' from ' + @mbuf + 'where ' + @amountname + ' is not null ' 				

		if (exists(select * from #fields3))
		begin
			select @script = @script + ' insert into t_storage(storageid, classificatorid, sourcetemplateid) '		
			select @script = @script +' select b.storageid, a.['+fullpath+'], ' + convert(varchar(20), sourcetemplateid) + '  from '+@mbuf+' a inner join storage b on a.row_id = b.row_id		
				where a.['+fullpath+'] is not null union all '  from #fields3					
			select @script = LEFT(@script, len(@script)- 9) 
		end
		drop table #fields3
	
		if (@mtype = 3)
		begin
			select @script = @script + 'insert into storage_app(storageid, value)
				select b.storageid, a.' + @amountname + ' from ' + @mbuf + ' a inner join storage b on a.row_id = b.row_id
				where ' + @amountname + ' is not null ' 					
		end
		select @script = @script + ' drop table ' + @mbuf + ' '		
		
		if (@updatesums='True')	
		begin
			select @script = @script + ' drop table ' + @cTableOut2 + ' '		
			select @script = @script + ' drop table ' + @tableMUdate + ' '		
		end
		exec (@script)

	end

	exec [InsertMeasures] @versionid = @dsid
		
	select distinct bufTable into #dclrs from #sclrs
	drop table #sclrs
	select @script = ''
	select @script = @script + 'if  exists (select * from sys.objects where object_id = object_id(N''' + buftable + ''') and type in (N''U'')) drop table ' + bufTable + ' ' from #dclrs
	exec (@script)
	
 	drop table #dclrs
	drop table #xmldecl

end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8538' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'IMPORTANYXML_INNER'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[ImportAnyXml]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[ImportAnyXml]
GO

CREATE proc [dbo].[ImportAnyXml]
	@ssistemplatelink int,
	@import_id uniqueidentifier
as
begin

	DECLARE @file_path varchar(400), @file_mask varchar(100), @isRemoteMode varchar(7), @checkrepeatload int, @unionfiles varchar(7)		
	select @file_path=VALUE from SSISTemplateDescription where PARAMETER='FILE_FilePath' and LINK_UP=@ssistemplatelink
	select @file_mask=VALUE from SSISTemplateDescription where PARAMETER='FILE_FileMask' and LINK_UP=@ssistemplatelink	
	select @isRemoteMode = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'IsRemoteMode'	
	select @unionfiles = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'UnionFiles'
	select @checkrepeatload = case value when 'True' then 1 else 0 end from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CheckRepeatImport'	
	if exists(select * from SSISTemplateDescription where parameter='UseProxy' and link_up=@ssisTemplateLink and value = 'False')
		select @isremotemode = 'False'
	if substring(@file_path,len(@file_path),1) != '\'
	begin
		set @file_path = @file_path + '\'
	end
	
	declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int		
	declare @dsid int, @clear_ds int
	select top 1 @dsid = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_ID'
	select top 1 @clear_ds = case when [value] = 'True' then 1 else 0 end from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'CLEAR_DS'
	
	begin try
	if @clear_ds = 1 and @dsid > 0
			exec clear_ds @nMode = 1, @nId = @dsid
	end try
	begin catch
		select @ErrorMessage = '   :'+ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE();
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState);
		return
	end catch
	
	create table #files (name varchar(255), date datetime)
	if (@isRemoteMode = 'True')
	begin
		while (exists (select * from SSISTemplateUploadFileLinks where used <> 2 and  link_up = @ssisTemplateLink))
			begin
				declare @rpath varchar(300), @fullpath varchar(4000)
				select @rpath = hashcode from SSISTemplateUploadFileLinks where used <> 2 and  link_up = @ssisTemplateLink
				select @fullpath = dbo.get_val('NASTR_UPLOAD_FILES_PATH','CHAR_VALUE',0) + '/' + @rpath
				insert #files([name])	values(@fullpath)				
				update SSISTemplateUploadFileLinks set used = 2 where link_up = @ssisTemplateLink and @rpath = hashcode
			end
	end
	else	
		insert #files
		exec dbo.getfilesbymask @file_path, @file_mask, @checkrepeatload
	
	if (@unionfiles='True')
	begin
		declare @files varchar(max)
		select @files =''
		select @files = @files + name + '$' from #files
		delete #files
		insert #files (name)
		select  dbo.unionxmlfiles(@file_path, @files)
	end	
	
	while (exists(select * from #files))
	begin
		declare @file varchar(255)
		select @file = name from #files		
		set @file_mask = @file_path + @file
		
		exec ImportAnyXml_inner @ssistemplatelink, @import_id, @file_mask		
		delete #files where name=@file
	end
	
	update fileloadedhash set successload = 1 where successload = 0 and import_id = @import_id
end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8217' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'IMPORTANYXML'
GO



 IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ExportAnyXML]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ExportAnyXML]
GO


CREATE PROCEDURE [dbo].[ExportAnyXML]
	@template_link int,
	@filename varchar(254)
AS

BEGIN
	
	SET NOCOUNT ON;
	
	
	
	declare @info xml, @IsStructured varchar(6), @StrucDelimiter varchar(5), @StrucDelimiterInEnd varchar(6), 
		@isMinfinFilenameFormat varchar(6), @date varchar(19), @codepage int, @UnionFiles varchar(6), @isfxdbks varchar(6), @isrro varchar(6), @onlychanges varchar(6)
		, @loadToDB varchar(7)
	select @info = template from export_template where link = @template_link
	set @loadToDB = @info.value('(/ExportTemplate/LoadToDB)[1]','varchar(7)')
	set @codepage = @info.value('(/ExportTemplate/CodePage)[1]','int')	
	if @codepage is null set @codepage = 1251	
	
	declare @connection varchar(255)
	select 
		@connection = '<Connection>
			<Mode>0</Mode>
			<Server>' + c.n.value('Server[1]','varchar(255)') + '</Server>
			<Database>' + c.n.value('Database[1]','varchar(255)') + '</Database>
			<NTLM>' + case when c.n.value('IsNtlm[1]','varchar(7)') = 'true' then '1' else '0' end + '</NTLM>
			<User>' + c.n.value('User[1]','varchar(31)') + '</User>
			<Pwd>' + c.n.value('Pwd[1]','varchar(31)') + '</Pwd></Connection>'
	from @info.nodes('/ExportTemplate/DbConnectionSync') c(n)			
	
	declare @dsid int, @StateDictId int, @StateId int, @hash varchar(31), @numbmask varchar(255),  @numbMeasureid int
	select 
		@dsid = c.n.value('DS[1]','int'),
		@StateDictid = c.n.value('StateDictionary[1]', 'int'),
		@StateId =c.n.value('StateId[1]', 'int'),
		@hash = c.n.value('Hash[1]', 'varchar(31)'),
		@numbmask = c.n.value('NumbMask[1]', 'varchar(255)'),
		@numbMeasureid = c.n.value('NumbMeasure[1]', 'int')		
  	from @info.nodes('/ExportTemplate/SyncRR') c(n)
	
	select 
		c.n.value('.', 'int') h
	into #RRMesHashes
  	from @info.nodes('/ExportTemplate/SyncRR/Hashes/int') c(n)

	select @info = convert(xml, c.n.value('AnyXML[1]','varchar(max)')) from @info.nodes('/ExportTemplate') c(n)	
	
	create table #xmlitems(Name varchar(200), Parent varchar(200), IsAttribute varchar(6), [Key] varchar(200), Field varchar(200), 
		querylink varchar(200), InnerQuery varchar(200), IsDWHProperties varchar(200),	mdx varchar(4000), [xml] xml, dtable xml, rtablename varchar(600),
		DocPath varchar(400), DocNameDelimiter varchar(6), DocNameMask varchar(200), cutelement varchar(200), writeintofile varchar(200),
		concate varchar(6), checking varchar(6), const varchar(200), delimafter varchar(6), cquery varchar(200),
		converting varchar(200), identitytemplate varchar(200), checkcut varchar(200), Alias varchar(200), AsElement varchar(6), Number int, Options varchar(200), isblockrr varchar(6),
		buffered bit)
	
	insert #xmlitems
	select c.n.value('@Name','varchar(max)'),
		c.n.value('@Parent','varchar(max)'),
		c.n.value('@IsAttribute','varchar(max)'),
		c.n.value('@Key','varchar(max)'),
		c.n.value('@Field','varchar(max)'),
		c.n.value('@querylinks','varchar(200)'),
		c.n.value('@InnerQuery','varchar(200)'),
		c.n.value('@IsDWHProperties','varchar(200)'),
		B.mdx, 
		B.xml, 
		B.datatable, 
		null, 
		c.n.value('@DocPath','varchar(400)'),
		c.n.value('@DocNameDelimiter','varchar(6)'),
		c.n.value('@DocNameMask','varchar(200)'),
		c.n.value('@CutElement','varchar(200)'),		
		c.n.value('@WriteIntoFile','varchar(200)'),	
		c.n.value('@Concat','varchar(6)'),
		c.n.value('@Checking','varchar(6)'),
		c.n.value('@Const','varchar(200)'),
		c.n.value('@DelimiterAfter','varchar(6)'),
		c.n.value('@CQuery','varchar(200)'),
		c.n.value('@Converting','varchar(200)'),
		c.n.value('@IdentityTemplate','varchar(200)'),
		c.n.value('@CheckingCut','varchar(200)'),
		c.n.value('@Alias','varchar(200)'),
		c.n.value('@AsElement','varchar(200)'),
		c.n.value('@Number','int'),
		c.n.value('@Option','varchar(200)'),
		c.n.value('@IsBlockRR','varchar(6)'),
		null 
	from @info.nodes('/anyxml1/item') c(n) left join ExportXMLQueries B on c.n.value('@querylinks','varchar(200)')  = B.name	

	update #xmlitems set mdx = (select A1.mdx from ExportXMLQueries A1 where InnerQuery=A1.name), 
						[xml] = (select A2.[xml] from ExportXMLQueries A2 where InnerQuery=A2.name), 
						dtable = (select A3.datatable from ExportXMLQueries A3 where InnerQuery=A3.name)
	where InnerQuery is not null and InnerQuery <>''
	
	update #xmlitems set mdx = (select A1.mdx from ExportXMLQueries A1 where CQuery=A1.name), 
						[xml] = (select A2.[xml] from ExportXMLQueries A2 where CQuery=A2.name)
	where CQuery is not null and CQuery <>''

	update #xmlitems set rtablename = '[KS_DDLControl].[AnyXMLExport' + convert(varchar(500), newid()) + ']', buffered = 0 where isattribute='false'
	
	select @IsStructured		= c.n.value('@IsStructuredFile','varchar(6)'),
			@StrucDelimiter		= c.n.value('@Delimiter','varchar(5)'),
			@StrucDelimiterInEnd = c.n.value('@DelimiterInEnd','varchar(6)'),	
			@isMinfinFilenameFormat = c.n.value('@IsMinfinFName','varchar(6)'),
			@UnionFiles = c.n.value('@UnionFiles','varchar(6)'),
			@isfxdbks = c.n.value('@IsFXDBKS','varchar(6)'),
			@isrro = c.n.value('@IsRRO', 'varchar(6)'),
			@onlychanges = c.n.value('@OnlyChanged','varchar(6)')
	from @info.nodes('/anyxml1/StructuredFile') c(n)


	select c.n.value('prefix[1]','varchar(63)') prefix,
			c.n.value('uri[1]','varchar(255)') uri,
			0 buffered
	into #namespaces from @info.nodes('/anyxml1/DocumentElement/ns') c(n)

	if (select count(*) from #xmlitems where cutelement is not null and cutelement<>'')>1 and @IsStructured='false'
	begin
		raiserror('       xml!', 16, 1)
		return
	end
	
	-- validate
	declare @errmess varchar(100)
	if exists(select * from #xmlitems where isattribute='true' 
		and isnull(field, '')='' and isnull(const,'')='' and isnull([options], '')='')
	begin	
		select @errmess = '     "' + name + '";  "' + parent + '"'
			from #xmlitems where isattribute='true' and isnull(field, '')='' and isnull(const,'')='' and isnull([options], '')=''
		raiserror(@errmess, 16, 1)
		return
	end

	if exists(select * from #xmlitems where isattribute='true' 
		and (case isnull(field, '') when '' then 0 else 1 end + 
			case isnull(const, '') when '' then 0 else 1 end +
			case isnull(options, '') when '' then 0 else 1 end) > 1)
	begin	
		select @errmess = '  "' + name + '"    ;  "' + parent + '"'
			from #xmlitems where isattribute='true' 
			and (case isnull(field, '') when '' then 0 else 1 end + 
			case isnull(const, '') when '' then 0 else 1 end +
			case isnull(options, '') when '' then 0 else 1 end) > 1
		raiserror(@errmess, 16, 1)
		return
	end

	if exists(select * from #xmlitems where isattribute='false' 
		and isnull(mdx, '')='' and isdwhproperties='false' and  isnull(docpath, '')='')
	begin	
		select @errmess = '     "' + name + '"'
			from #xmlitems where isattribute='false' 
		and isnull(mdx, '')='' and isdwhproperties='false' and  isnull(docpath, '')=''
		raiserror(@errmess, 16, 1)
		return
	end
				
	select @date = case @isMinfinFilenameFormat 
		when 'true' then replace(replace(replace(left(convert(varchar(40), getdate(), 126), 19), '-', ''), ':', ''), 'T', '') 
		else '' end
	
	create table #rep_props(ind int, link int, clear_name varchar(500), name varchar(500), code varchar(100), 
					                    link_self int, orders int, access int, old_access int, [disable] int, del_pr int)
					                    
    insert #rep_props exec admin_Object_List_Order @CodeObject=NASTR_D_CATALOG exec admin_Obj_Prop_Value 0,'REPORT_CATALOG','',NULL,2
                
	-- create and load buffer tables
	while(exists (select * from #xmlitems where buffered = 0))
	begin
			
		declare @xml xml, @dt xml, @mdx varchar(4000), @linkedsrv varchar(200), 
				@rt varchar(600), @cols varchar(max), @name varchar(200),
				@innerquery varchar(200), @isdwhproperty varchar(200), 
				@DocPath varchar(400), @IsDocDelimiter varchar(6), @DocMask varchar(200)
				
		select @xml=xml, @mdx=mdx, @dt=dtable, @rt= rtablename, @name=name, @innerquery=innerquery, @isdwhproperty=isdwhproperties,
				@docpath=docpath, @isdocdelimiter = docnamedelimiter, @docmask = docnamemask
			from #xmlitems where buffered = 0				

		if (@mdx is not null and @mdx<>'' and @dt is not null and convert(varchar(max), @dt)<>'') -- mdx and inner mdx
		begin					
			-- get linked srv
			select @linkedsrv='olapServer_'
			select 
				c.n.value('ParamName[1]', 'varchar(200)') as n,
				c.n.value('ParamValue[1]', 'varchar(200)') as v 
			into #lsrv
			from @xml.nodes('/NewDataSet/ScriptModel') c(n) 
			
			if exists(select * from #lsrv A where A.n = 'LinkedServerName')
				begin
					select @linkedsrv = @linkedsrv + A.v + '_'	from #lsrv A where A.n = 'LinkedServerName'
					select @linkedsrv = @linkedsrv + A.v		from #lsrv A where A.n = 'LinkedDbName'		
				end
			else
				select @linkedsrv = [dbo].[get_val]('NASTR_LINKED_SERVERS','CHAR_VALUE',0)	
					
			drop table #lsrv
				
			-- get datatable columns									
			select @cols = convert(varchar(max), @dt)						
			declare @columns table (name varchar(4000), id int identity(1, 1), c int)
			insert @columns(name) exec GetDtColumns @cols
			select * into #errcol from @columns
			update @columns set c = (select count(*) from #xmlitems B where B.Field= [@columns].Name and B.parent = @name)
			
			if exists(select * from @columns where c > 1)
			begin
				select @errmess = '  "' + @name + '"      : 
'
				select @errmess = @errmess + e.name + '
' from #errcol e join @columns c on e.id = c.id and c.c > 1
				raiserror(@errmess, 16, 1)
				return
			end
			update @columns set [@columns].name = (select B.name from #xmlitems B where B.Field= [@columns].Name and B.parent = @name)								

			if exists(select * from @columns where name is null)
			begin
				select @errmess = '  "' + @name + '"    : 
'
				select @errmess = @errmess + e.name + ' 
' from #errcol e join @columns c on e.id = c.id and c.name is null
				raiserror(@errmess, 16, 1)
				return
			end
			drop table #errcol
			
			declare @ctq varchar(max), @olapquery varchar(max), @mpc int
			select name, field, identitytemplate, converting into #mdxitems from #xmlitems where parent = @name and isattribute='true' 
				and Field='=IDENTITY(1, 1)'

			select @ctq = 
				'if  exists (select * from sys.objects where object_id = object_id(N''' + @rt + ''') and type in (N''U''))
				drop table ' + @rt + ' create table ' + @rt + '('
			select @ctq = @ctq + '[' + name + '] varchar(4000),' from @Columns		
			select @ctq = @ctq + '[' + name + '] varchar(4000),' from #mdxitems
			select @ctq = @ctq + ' innerkey varchar(3))'			
			exec (@ctq)					

			-- exec mdx
			select @olapquery = 'insert ' + @rt + ' select *, ' 
			select @olapquery = @olapquery + 'null,' from #mdxitems
			select @olapquery = @olapquery + ' ''$$$'' from openquery("'+@linkedsrv+'", ''' + @mdx + ''')'
			begin try
				exec (@olapquery)
			end try
			begin catch
				select @errmess = '  "' + @name + '"    MDX  '
				raiserror(@errmess, 16, 1)
				return
			end catch
			
			if exists(select  * from #mdxitems)
			begin									
				select @olapquery = 'insert ' + @rt + ' select ' 
				select @olapquery = @olapquery + '[' + name + '],' from @Columns	
				select @olapquery = @olapquery + 					
						case identitytemplate when '' then 'convert(varchar(40), row_number() over(order by newid())),'
													else	replace(identitytemplate, '$', '+''/''+') + 
																'+''/''+'+
																case when converting is not null and converting <>'' then 'right(' else '' end+
																'convert(varchar(40), '+
																case when converting is not null and converting <>'' then '1'+replace(converting,'-> ','') +'+' else '' end+
																'row_number() over(partition by ' + 
																replace(identitytemplate, '$', ',') + ' order by ' +replace(identitytemplate, '$', ',') + ')),'+
																case when converting is not null and converting <>'' then convert(varchar(5),len(replace(converting,'-> ','')))+'),' else '' end end
												from #mdxitems
				select @olapquery = @olapquery + ' innerkey from ' + @rt + ' delete ' + @rt + ' where '
				select top 1 @olapquery = @olapquery + name from #mdxitems
				select @olapquery = @olapquery + ' is null'
									
				exec (@olapquery)
			end
			drop table #mdxitems
			delete @columns		
		end		
		else
		begin
			if (@isdwhproperty ='true') -- dwh properties
			begin				
				select name, field into #childXitem from #xmlitems where parent = @name and isattribute='true'						
                               				
				update #childxitem set field = 
					case field when '=GLOBALID()' then convert(varchar(500), newid())
					when '=GETDATE()' then convert(varchar(500), getdate())
					else isnull(dbo.get_val((select code from  #rep_props where link_self in 
										(select link from  #rep_props where code in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG')) 
												and code not in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG') 
												and name = field)
									 , 'char_value', 0), '')+
						isnull(dbo.get_val((select code from  #rep_props where link_self in 
										(select link from  #rep_props where code in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG')) 
												and code not in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG') 
												and name = field)
									 , 'case_value', 0), '')+
						isnull(dbo.get_val((select code from  #rep_props where link_self in 
										(select link from  #rep_props where code in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG')) 
												and code not in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG') 
												and name = field)
									 , 'date_value', 0), '') end

				declare @clprop varchar(max)
				select @clprop = 
					'if  exists (select * from sys.objects where object_id = object_id(N''' + @rt + ''') and type in (N''U''))
					drop table ' + @rt + ' create table ' + @rt + '('
				select @clprop = @clprop + '[' + name + '] varchar(4000),' from #childXitem				
				select @clprop = @clprop + ' innerkey varchar(3)) insert ' + @rt + 'values('
				select @clprop = @clprop + '''' + field + ''',' from #childXitem
				select @clprop = @clprop + '''$$$'') '
				exec (@clprop)								
				
				drop table #childXitem
			end
			else 
			begin
				if (@mdx is not null and @mdx<>'' and (@dt is null or convert(varchar(max), @dt)='')) -- copmlex queries
				begin		
					declare @complexquery varchar(max), @sprestable varchar(700), @spc int
					select @sprestable = '[KS_DDLControl].[AnyXMLExport' + convert(varchar(600), newid()) + ']'										
					select @complexquery =
						'if  exists (select * from sys.objects where object_id = object_id(N''' + @sprestable + ''') and type in (N''U''))
							drop table ' + @sprestable + ' exec [KS_DDLControl].[' + @mdx + '] @nmode = 0, @table_name_result = ''' + @sprestable + ''', @cProject = 0'
					begin try
						exec (@complexquery)
					end try
					begin catch
						select @errmess = '  "' + @name + '"     "' + @mdx +'"'
						raiserror(@errmess, 16, 1)
						return
					end catch
					
					select name, field, identitytemplate, converting into #spitems from #xmlitems where parent = @name and isattribute='true'
					
					set @spc=0
					while (@spc<(select COUNT(*) from #spitems where identitytemplate is not null and identitytemplate<>''))
					begin
						declare @spname varchar(200), @ident varchar(200)						
						select @spname=name, @ident=identitytemplate from #spitems where identitytemplate is not null and identitytemplate<>''
						
						declare @idents table (ident varchar(200), ord int)
						insert @idents select * from dbo.StrSplit(@ident, '$')						
						update @idents set ident = (select field from #spitems where #spitems.Name=ident)
						select @ident='['
						select @ident=@ident+ident +']$[' from @idents
						select @ident=LEFT(@ident, len(@ident)-2)
						update #spitems set identitytemplate=@ident where Name=@spname
						set @spc=@spc+1
						delete @idents
					end
					
					select @complexquery = 
						'if  exists (select * from sys.objects where object_id = object_id(N''' + @rt + ''') and type in (N''U''))
						drop table ' + @rt + ' create table ' + @rt + '('
					select @complexquery = @complexquery + '[' + name + '] varchar(4000),' from #spitems where Field is not null and Field<>''			
					select @complexquery = @complexquery + ' innerkey varchar(3)) '					
					exec (@complexquery)

					select @complexquery = 'insert into ' + @rt + '('
					select @complexquery = @complexquery + '[' + name + '], ' from #spitems  where Field is not null and Field<>''
					select @complexquery = @complexquery + ' innerkey) select '
					select @complexquery = @complexquery + 
						case Field when '=IDENTITY(1, 1)' then 
								case identitytemplate when '' then 'convert(varchar(40), row_number() over(order by newid())),'
														else	replace(identitytemplate, '$', '+''/''+') + 
																'+''/''+'+
																case when converting is not null and converting <>'' then 'right(' else '' end+
																'convert(varchar(40), '+
																case when converting is not null and converting <>'' then '1'+replace(converting,'-> ','') +'+' else '' end+
																'row_number() over(partition by ' + 
																replace(identitytemplate, '$', ',') + ' order by ' +replace(identitytemplate, '$', ',') + ')),'+
																case when converting is not null and converting <>'' then convert(varchar(5),len(replace(converting,'-> ','')))+'),' else '' end end
						else 'isnull(convert(varchar(4000), [' + field + ']), ''''), ' end from #spitems  where Field is not null and Field <> ''
					select @complexquery = @complexquery + '''$$$'' from ' + @sprestable + ' drop table ' + @sprestable	
					exec (@complexquery)
	
					drop table #spitems					
				end
				else
				begin
					if (@DocPath is not null and @DocPath<>'') -- docs image's
					begin	
						select name, field into #Docitems from #xmlitems where parent = @name and isattribute='true'
						
						declare @docq varchar(max)
						select @docq = 
							'if  exists (select * from sys.objects where object_id = object_id(N''' + @rt + ''') and type in (N''U''))
							drop table ' + @rt + ' create table ' + @rt + '('
						select @docq = @docq + '[' + name + '] varchar(max),' from #Docitems			
						select @docq = @docq + ' innerkey varchar(3)) '
						exec (@docq)
						
						declare @partcount int, @imagestable varchar(700), @i int					
						select @partcount = dbo.GetFilesImagesCountParts(@docpath, @isdocdelimiter, @docmask)					
						select @imagestable = '[KS_DDLControl].[AnyXMLExport' + convert(varchar(600), newid()) + ']'										
						select @docq =
						'if  exists (select * from sys.objects where object_id = object_id(N''' + @imagestable + ''') and type in (N''U''))
							drop table ' + @imagestable + ' create table ' + @imagestable + '('
						set @i=0
						while (@partcount>@i)
						begin
							select @docq = @docq + 'part' + convert(varchar(5), @i) + ' varchar( 200), '
							set @i=@i+1
						end
						select @docq = @docq + 'filename varchar(200), filecreatedate varchar(200), fileinner varchar(max), filebase64 varchar(max))
							insert ' + @imagestable + ' exec GetFilesImages '''+ @Docpath + ''', ''' + @isdocdelimiter + ''', '''+ @docmask + '''
							insert ' + @rt + ' select '
							
						update #Docitems set field = replace(field, '=FILENAMEPART(', 'part')
						update #Docitems set field = replace(field, '=FILENAME(', 'filename')
						update #Docitems set field = replace(field, '=FILECREATEDATE', 'filecreatedate')
						update #Docitems set field = replace(field, '=FILEINNER(', 'fileinner')
						update #Docitems set field = replace(field, '=FILEBASE64(', 'filebase64')									
						update #Docitems set field = replace(field, ')', '')	
						
						select @docq = @docq + field  + ',' from #docitems
						select @docq = @docq + '''$$$'' from ' + @imagestable + ' drop table ' + @imagestable
						exec(@docq)
								
						drop table #Docitems
						
					end
					else -- empty xml item
					begin
						declare @emptq varchar(1000)
						select @emptq = 'if  exists (select * from sys.objects where object_id = object_id(N''' + @rt + ''') and type in (N''U''))
										drop table ' + @rt + ' create table ' + @rt + '(innerkey varchar(3)) insert ' +@rt + ' values(''$$$'')'
						exec(@emptq)				
					end
				end
			end
		end
			
		update #xmlitems set buffered = 1 where rtablename=@rt				
	end	

	-- validate field's values
	while (exists(select * from #xmlitems where isattribute='true' and buffered is null))
	begin
		declare @parent varchar(200), @validq nvarchar(3000), @v int, @const varchar(200), @checking varchar(6), @convert varchar(200), @Identityt varchar(200), @option varchar(200)
		select @name = name, @parent = parent, @const= const, @checking=checking, @convert=converting, @Identityt=identitytemplate, @option= options 
			from #xmlitems where isattribute='true' and buffered is null
		select @rt= rtablename, @mdx = mdx from #xmlitems where name= @parent
		
		--const
		if (@const is not null and @const <> '')
		begin
			if(@mdx is not null and @mdx<>'')
			begin
				select @validq = ' alter table' + @rt + ' add ' + @name + ' varchar(4000)'
				exec(@validq)		
			end
			select @validq = ' update ' +@rt + ' set ' + @name + '=''' + @const + ''''
			exec(@validq)			
		end
		
				--option
		if (@option is not null and @option <> '')
		begin			
			if(@mdx is not null and @mdx<>'')
			begin
				select @validq = ' alter table' + @rt + ' add ' + @name + ' varchar(4000)'
				exec(@validq)		
			end
			select @option = case @option when '=GLOBALID()' then convert(varchar(500), newid())
					else isnull(dbo.get_val((select code from  #rep_props where link_self in 
										(select link from  #rep_props where code in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG')) 
												and code not in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG') 
												and name = @option)
									 , 'char_value', 0), '')+
						isnull(dbo.get_val((select code from  #rep_props where link_self in 
										(select link from  #rep_props where code in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG')) 
												and code not in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG') 
												and name = @option)
									 , 'case_value', 0), '')+
						isnull(dbo.get_val((select code from  #rep_props where link_self in 
										(select link from  #rep_props where code in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG')) 
												and code not in ('REPORT_CATALOG', 'DATE_CATALOG', 'PERIOD_DATE_CATALOG', 'UNLOAD_REPORT_CATALOG') 
												and name = @option)
									 , 'date_value', 0), '') end
									 					
			select @validq = ' update ' +@rt + ' set ' + @name + '=''' + @option + ''''
			exec(@validq)			
		end
		
		--checking 
		if @checking='true'
		begin
			select @validq = 'if exists( select ' + @name +' from ' + @rt+ ' where ' + @name +' is null or ' +@name + ' ='''') select @v=1'
			EXEC sp_executesql @validq, N'@v int output', @v = @v OUTPUT	
			if (@v=1)
			begin 
				select @errmess = '  "' + @parent + '"      ' + @name
				raiserror(@errmess,16,1)
			end
		end
		
		--replace empty measures
		select @validq = ' update ' +@rt + ' set ' + @name + '=0' + ' where ' + @name + ' is null '
		exec(@validq)	

		if (@convert is not null and @convert<>'' and (@Identityt is null or @Identityt=''))
		begin
			select @validq = ' update ' +@rt + ' set ' + @name + '=' +
				case @convert when '-> #0' then 'convert(varchar(4000), round(convert(numeric(27,0), cast (' + @name + ' as float) ), 0))' 
					when '-> #0.0' then  'convert(varchar(4000), round(convert(numeric(27,1), cast (' + @name + ' as float) ), 1))'
                    when '-> #0.00' then  'convert(varchar(4000), round(convert(numeric(27,2), cast (' + @name + ' as float) ), 2))'
                    when '-> #0.000' then  'convert(varchar(4000), round(convert(numeric(27,3), cast (' + @name + ' as float) ), 3))'
                    when '-> #0.0000' then  'convert(varchar(4000), round(convert(numeric(27,4), cast (' + @name + ' as float) ), 4))'
                    when '-> #0.00000' then  'convert(varchar(4000), round(convert(numeric(27,5), cast (' + @name + ' as float) ), 5))'
                    when '-> #0.000000' then  'convert(varchar(4000), round(convert(numeric(27,6), cast (' + @name + ' as float) ), 6))'
                    when '-> #0.0000000' then  'convert(varchar(4000), round(convert(numeric(27,7), cast (' + @name + ' as float) ), 7))'
                    when 'yyyymmdd -> dd.mm.yyyy' then 'case when isnull(' + @name + ','''') = '''' then '''' when ' + @name + '=0 then '''' else right(' + @name + ', 2) + ''.'' + substring(' + @name +', 5, 2) + ''.'' + left(' + @name+ ', 4) end ' 
                    when 'dd.mm.yyyy -> yyyymmdd' then 'case when isnull(' + @name + ','''') = '''' then '''' when ' + @name + '=0 then '''' else right(' + @name+ ', 4) + substring(' + @name +', 4, 2) + left(' + @name + ', 2) end ' 
                    when '-> datetime' then 'case when isnull(' + @name + ','''') = '''' then '''' when ' + @name + '=0 then '''' else replace(convert(varchar(4000), convert(datetime, ' + @name+ '), 20), '' '', ''T'') end '
                    when '-> 00' then  'right(convert(varchar(4000), 100+convert(int,' + @name + ')),2)'
                    when '-> 000' then  'right(convert(varchar(4000), 1000+convert(int,' + @name + ')),3)'
                    when '-> 0000' then  'right(convert(varchar(4000), 10000+convert(int,' + @name + ')),4)'                    
                    else '' end
			exec(@validq)		
		end
		
		-- update unnownmembers
		select @validq = ' update ' +@rt + ' set ' + @name + '=''''' + ' where ' + @name + '=''-'''
		exec(@validq)	
		
		update #xmlitems set buffered = 0 where isattribute='true' and @name = name and @parent = parent
	end
	update #xmlitems set buffered = null where isattribute='true'

	-- select cut item
	declare @cuttable varchar(600), @cutfield varchar(200), @getcutsscript nvarchar(1000)
	select @cuttable = rtablename, @cutfield = cutelement from #xmlitems where cutelement is not null and cutelement<>''
	if (exists(select * from #xmlitems where isblockrr='True') )
		select @cuttable = rtablename, @cutfield = cutelement from #xmlitems where cutelement is not null and cutelement<>'' and isblockrr='True'
		
	declare @root varchar(200), @rootns varchar(200), @rtf varchar(200), @mainscript nvarchar(max), @x xml, @xc varchar(max), @checked bit, @mainselect varchar(max)			
	
	create table #t_parts(part varchar(max),n int, root varchar(200))				
	if (@cutfield is not null and @cutfield<>'') -- with cutting
	begin
		create table #cutitems(it varchar(4000)) -- cut values
		select @getcutsscript = 'select ' + @cutfield + ' from ' + @cuttable
		insert #cutitems exec (@getcutsscript)
		
		if (@onlychanges = 'true' and EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[KS_DDLControl].[ExportList]') AND type in (N'U')))
		begin
			delete #cutitems where it not in(select f from [KS_DDLControl].[ExportList])
		end
				
		declare @number int
		set @number=1	
		while (exists(select * from #cutitems))
		begin
		
			declare @cutvalue varchar(4000)
			select @cutvalue = it from #cutitems
			-- getting xml auto			
			select @root = name, @rootns = '<' + name, @rtf = rtablename from #xmlitems where parent is null or parent = ''
			
			if (@IsStructured='false')
			begin
				exec ExportAnyXmlCreateXML @root, @rtf, @cutvalue, @mainscript out, @checked out
				
				if(@checked=1)
				begin					
					select @mainselect = 'IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N''[KS_DDLControl].[ExpotrXMLTempProc]'') AND type in (N''P'', N''PC''))
						DROP PROCEDURE [KS_DDLControl].[ExpotrXMLTempProc]'
					exec (@mainselect)
					select @mainselect = 'create proc [KS_DDLControl].[ExpotrXMLTempProc] as '
					if (exists(select * from #namespaces))
					begin
						select @mainselect = @mainselect + 'with xmlnamespaces('
						select @mainselect = @mainselect + case when prefix is null or prefix='' then 'default ''' + uri + '''' else '''' + uri + ''' as ' + prefix end + ', ' from #namespaces
						select @mainselect = left(@mainselect, len(@mainselect) - 1) + ') '
					end 
					select @mainselect = @mainselect + ' select '		    
					select @mainselect=@mainselect+name+ case AsElement when 'false' then ' as "@' + name + '",' else ',' end
						from #xmlitems where parent = @root and isattribute='true' and writeintofile='false'  order by AsElement asc
					select @mainselect = case right(@mainselect, 1) when ',' then left(@mainselect, len(@mainselect)-1) else @mainselect+' innerkey as "@innerkey" ' end 
					select @mainscript = @mainselect + @mainscript + ' from ' + @rtf +' for xml path(''' + @root + '''), elements, type'										
					exec (@mainscript)
					
					create table #restemproc(r xml)
					insert #restemproc exec [KS_DDLControl].[ExpotrXMLTempProc]					
					select @xc = convert(varchar(max), r) from #restemproc
					drop table #restemproc
								
					-- rename tegs			
					while (exists(select * from #xmlitems where isattribute='false' and buffered=1))
					begin
						select @name = case when alias is null or alias = '' then name else alias end, 
								@rt = rtablename from #xmlitems where isattribute='false' and buffered=1						
						select @xc = replace(@xc, ' innerkey="$$$"', '')					
						select @xc = replace(@xc, ' default1="#$#$"', '')
						update #xmlitems set buffered = 0 where rtablename=@rt
					end
					update #xmlitems set buffered = 1 where isattribute='false'

					update #namespaces set buffered=0
					while (exists(select * from #namespaces where buffered=0))
					begin
						declare @prefixdel varchar(4000) 
						select @prefixdel = case when prefix is null or prefix='' then ' xmlns="' + uri + '"' else ' xmlns:' + prefix + '="' + uri + '"' end from #namespaces where buffered=0
						select @xc = replace(@xc, @prefixdel, '')
						select @xc = replace(@xc, @rootns, @rootns+@prefixdel)
						update #namespaces set buffered=1 where case when prefix is null or prefix='' then ' xmlns="' + uri + '"' else ' xmlns:' + prefix + '="' + uri + '"' end = @prefixdel
					end
				end
		    end
		    else
		    begin
				exec ExportAnyXmlCreateTXT @root, @rtf, @cutvalue, @StrucDelimiter, @StrucDelimiterInEnd, @xc out, @checked out
		    end

		    if (@checked=1)
		    begin				
				declare @newfilename varchar(600)
				select @newfilename = replace(@filename, '.xml', '') + 
					case @IsStructured when 'false' then '_' + 	@cutvalue + '_' + @date + '_' + right(convert(varchar(4), @number+1000), 3) + '.xml' 
								else @cutvalue + dbo.from10ToBase(day(getdate()), 36) +
											   + case len(dbo.from10ToBase(@number, 36)) when 1 then '0' else '' end + dbo.from10ToBase(@number, 36)  + '.TT' +
											   + dbo.from10ToBase(month(getdate()), 36) + '.txt' end
					
				if (@isfxdbks='true' and @IsStructured='true')  select @newfilename = replace(replace(@newfilename, '.TT', '.TS'), '.txt', '')
						  
				if (@IsStructured='false') 
					select @xc = '<?xml version = "1.0" encoding = "' + dbo.getencodingwebname(@codepage) + '"?>' + @xc 
					
				if (@isfxdbks='true'  and @IsStructured='true')	
				begin													
				
					select value, orders, convert(varchar(255), null) v into #numbmask from dbo.strsplit(@numbmask, '/')					
					delete #numbmask where value is null or value = ''
					while (exists( select * from #numbmask where v is null))
					begin		
						declare @cfield varchar(200), @cval varchar(200)															
						select @getcutsscript = ' select top 1 @cval = ' + value + ' from ' + @cuttable + ' where ' + @cutfield + ' = ''' +@cutvalue +'''', 
							@cfield= value from #numbmask where v is null
						EXEC sp_executesql @getcutsscript, N'@cval varchar(200) output',  @cval = @cval OUTPUT							
						update #numbmask set v= @cval where value=@cfield
					end

					declare @numbmask1 varchar(255)
					select @numbmask1=''
					select @numbmask1 = @numbmask1 + v + '/' from #numbmask order by orders

					create table #maxdn(n varchar(16))
					select @getcutsscript = ' declare @clink int
							select @clink = link from s_corr where code = ''' + @cutvalue + '''
							exec [dbo].[GET_NUM_DOC] @cObjCode = ''DOCUMENTS_0531722'', @dDate = '''', @nColumnLen = 13,	
							@cTemplate = ''' + @numbmask1 + '%%'',	@nNumberCount = 0, @nNumberWithZero = 1, @corr = @clink'
					insert #maxdn exec execat @getcutsscript, 1, @connection											
					select @numbmask1=n from #maxdn
					drop table #numbmask					
					drop table #maxdn
					
					select @getcutsscript = ' select top 1 @cval = ' + @hash + ' from ' + @cuttable + ' where ' + @cutfield + ' = ''' +@cutvalue +''''
					EXEC sp_executesql @getcutsscript, N'@cval varchar(200) output',  @cval = @cval OUTPUT

					select @xc = replace (@xc, @cval, @numbmask1)
					
					
					select storageid, measureid into #st from storage where measureid in (select h from #RRMesHashes union select @numbMeasureid) 
						and versionid = @dsid and storageid in (select storageid from storage_app where [hash_sum] = @cval)										
					update storage_app set value = @numbmask1 where [hash_sum] = @cval and storageid in (select storageid from #st where measureid = @numbMeasureid)
					
					update t_storage set classificatorid = @stateid where classificatorid in 
						(select classificatorid from classificators where parentclassificatorid = @statedictid)
						and storageid in (select storageid from #st)
					drop table #st					
					update storage_app set [hash_sum] = null where [hash_sum] = @cval
				end
				
				if (@isrro = 'true') select @xc = dbo.CalcRROCRC (@xc)
						
				if (@loadtodb='true')				
				begin
					declare @anyversionid int, @bytes varbinary(max), @fobj int
					select @bytes = convert(varbinary(max), @xc), @fobj = dbo.obj_id( 'DICTIONARY_EXPORTED_FILE')
					insert version (name, object, row_id, BeginDateTime) values (@newfilename, @fobj, NEWID(), GETDATE())
					select @anyversionid = IDENT_CURRENT('version')
					insert attached_files (versionid, rtid, filecontent, row_id, username, filesize, filename, object)
					values(@anyversionid, @template_link, @bytes, newid(), system_user, len(@bytes), @newfilename, @fobj)
				end
				else				
					exec writetofile @newfilename, @xc, @codepage				
				
				if (@isfxdbks='true'  and @IsStructured='true')	
				begin
					declare @tablefilename varchar(255)
					select @tablefilename = right(@newfilename, len(@newfilename) - charindex('\', reverse(@newfilename)) + 1)
					--insert bks_exportfiles select @xc, @tablefilename
					--exec NSI_DOC_HRAN_EXPORT
				end
			end
			delete #cutitems where it = @cutvalue
			set @number = @number + 1
		end

		while (exists(select * from #xmlitems where isattribute='false'))
		begin
			select @rt = rtablename from #xmlitems where isattribute='false'
			select @ctq = 'drop table ' + @rt
			exec(@ctq)
			delete #xmlitems where rtablename=@rt
		end
		
	end	
	else
	begin -- without cutting
		
		-- getting xml auto
		select @root = name, @rootns = '<' + name, @rtf = rtablename from #xmlitems where parent is null or parent = ''
		
		if (@IsStructured='false')
		begin
			exec ExportAnyXmlCreateXML @root, @rtf, null, @mainscript out, @checked out
			
			select @mainselect = 'IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N''[KS_DDLControl].[ExpotrXMLTempProc]'') AND type in (N''P'', N''PC''))
						DROP PROCEDURE [KS_DDLControl].[ExpotrXMLTempProc]'
			exec (@mainselect)
			select @mainselect = 'create proc [KS_DDLControl].[ExpotrXMLTempProc] as '
			if (exists(select * from #namespaces))
			begin
				select @mainselect = @mainselect + 'with xmlnamespaces('
				select @mainselect = @mainselect + case when prefix is null or prefix='' then 'default ''' + uri + '''' else '''' + uri + ''' as ' + prefix end + ', ' from #namespaces
				select @mainselect = left(@mainselect, len(@mainselect) - 1) + ') '
			end 
			select @mainselect = @mainselect + ' select '
		    select @mainselect = @mainselect + name+ case AsElement when 'false' then ' as "@' + name + '",' else ',' end
				from #xmlitems where parent = @root and isattribute='true' and writeintofile='false'  order by AsElement asc
		    select @mainselect = case right(@mainselect, 1) when ',' then left(@mainselect, len(@mainselect)-1) else @mainselect+' innerkey as "@innerkey" ' end 
			select @mainscript = @mainselect + @mainscript + ' from ' + @rtf +' for xml path(''' + @root + '''), elements, type'				
			exec (@mainscript)
				
			create table #restemproc2(r xml)
			insert #restemproc2 exec [KS_DDLControl].[ExpotrXMLTempProc]			
			select @xc = convert(varchar(max), r) from #restemproc2
			drop table #restemproc2
			
			-- rename tegs
			while (exists(select * from #xmlitems where isattribute='false'))
			begin
				select @name = case when alias is null or alias = '' then name else alias end, 
						 @rt = rtablename from #xmlitems where isattribute='false'				
				select @xc = replace(@xc, ' innerkey="$$$"', '')
				select @xc = replace(@xc, ' default1="#$#$"', '')
				select @ctq = 'drop table ' + @rt
				exec(@ctq)
				
				delete #xmlitems where rtablename=@rt
			end
			
			while (exists(select * from #namespaces ))
			begin				
				select @prefixdel = case when prefix is null or prefix='' then ' xmlns="' + uri + '"' else ' xmlns:' + prefix + '="' + uri + '"' end from #namespaces
				select @xc = replace(@xc, @prefixdel, '')
				select @xc = replace(@xc, @rootns, @rootns+@prefixdel)
				delete from #namespaces where case when prefix is null or prefix='' then ' xmlns="' + uri + '"' else ' xmlns:' + prefix + '="' + uri + '"' end = @prefixdel
			end
		
		end
		else
		begin
			exec ExportAnyXmlCreateTXT @root, @rtf, null, @StrucDelimiter, @StrucDelimiterInEnd, @xc out, @checked out
			while (exists(select * from #xmlitems where isattribute='false'))
			begin
				select @name = name, @rt = rtablename from #xmlitems where isattribute='false'
				select @ctq = 'drop table ' + @rt
				exec(@ctq)				
				delete #xmlitems where rtablename=@rt
			end
		end
		
		select @newfilename = replace(@filename, '.xml', '') + 
								case @IsStructured when 'false' then '_' + @date + '_001.xml' 
								else dbo.from10ToBase(day(getdate()), 36) + '01.TT' +
										dbo.from10ToBase(month(getdate()), 36) + '.txt' end
		
		if (@isfxdbks='true' and @IsStructured='true')  select @newfilename = replace(replace(@newfilename, '.TT', '.TS'), '.txt', '')
									
		if (@IsStructured='false')
			select @xc = '<?xml version = "1.0" encoding = "' + dbo.getencodingwebname(@codepage) + '" standalone="yes"?>' + @xc 		
		
		if (@isrro = 'true') select @xc = dbo.CalcRROCRC (@xc)
				
		if (@loadtodb='true')
		begin
			select @bytes = convert(varbinary(max), @xc), @fobj = dbo.obj_id( 'DICTIONARY_EXPORTED_FILE')
			insert version (name, object, row_id, BeginDateTime) values (@newfilename, @fobj, NEWID(), GETDATE())
			select @anyversionid = IDENT_CURRENT('version')
			insert attached_files (versionid, rtid, filecontent, row_id, username, filesize, filename, object)
			values(@anyversionid, @template_link, @bytes, newid(), system_user, len(@bytes), @newfilename, @fobj)
		end
		else				
			exec writetofile @newfilename, @xc, @codepage
		
		if (@isfxdbks='true'  and @IsStructured='true')	
		begin			
			select @tablefilename = right(@newfilename, len(@newfilename) - charindex('\', reverse(@newfilename)) + 1)
			--insert bks_exportfiles select @xc, @tablefilename
			--exec NSI_DOC_HRAN_EXPORT						
		end
	end
	
	-- union files
	if (@UnionFiles = 'true')
	begin
		declare @path varchar(255)
		select @path = left(@filename, len(@filename) - charindex('\', reverse(@filename), 0) + 1)			
		exec UnionFiles @path, @codepage
	end
END
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8641' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'EXPORTANYXML'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ImportExportedFile]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ImportExportedFile]
GO


CREATE PROCEDURE [dbo].[ImportExportedFile] 
	@ssisTemplateLink int,
	@import_id uniqueidentifier
AS
BEGIN
	
	SET NOCOUNT ON;

    declare @version int, @dsid int, @vname varchar(200), @dsname varchar(200), @fullname varchar(4000), @date datetime, @replace int, @checkrepeatload int	
		,@file_path varchar(200), @file_mask varchar(200), @xmlfromtemplate varchar(max), @xmltemplate xml, @IsRemoteMode varchar(10), @codepage int
			
	select @version = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'VERSION_ID'
	select @dsid = -1
	select @dsid = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_ID'
	select @vname = [name] from ssistemplate where link = @ssisTemplateLink
	select @dsname = [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_NAME'
	select @file_path = [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_FilePath'
	select @file_mask = [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_FileMask'
	select @IsRemoteMode = [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'IsRemoteMode'
	select @checkrepeatload = case value when 'True' then 1 else 0 end from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CheckRepeatImport'	
	declare @cachres int
	exec dbo.DoFileCach @file_path, @file_mask, @checkrepeatload,  @cachres out
	if (@cachres = 0) return	
	
	if exists(select * from SSISTemplateDescription where parameter='UseProxy' and link_up=@ssisTemplateLink and value = 'False')
		select @isremotemode = 'False'
	if (exists(select * from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CodePage'))
	begin
		select @codepage = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CodePage'		
	end
	select @replace = case [value] when 'True' then 1 else 0 end from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'CLEAR_DS'
	
	select @xmlfromtemplate = ''                                                                                                                                                                                                                               
	declare @countstr int, @count int                                                                                                                                                                                                                                      
	select @countstr = convert(int, value), @count=0 from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'ImportXMLCount_'                                                                                                                    
	while (@countstr>@count)                                                                                                                                                                                                                                        
	begin	                                                                                                                                                                                                                                                     		                                                                                                                                                                                                                         
		select @xmlfromtemplate = @xmlfromtemplate + [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'ImportXML' + convert(varchar(3), @count) + '_'                                                                    
		select @count = @count + 1 
	end	    
	
	if left(isnull(@file_path,''),1)=''
	begin
		raiserror('   ',16,1)
		return
	end

	if left(isnull(@file_mask,''),1)=''
	begin
		raiserror('   ',16,1)
		return
	end

	if substring(@file_path,len(@file_path),1) != '\'
	begin
		set @file_path = @file_path + '\'
	end
	set @fullname = @file_path + @file_mask
	
	--select @fullname = [value] from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'XmlFileName'


	set @date = getdate()

	declare @info xml, @tmp_info varchar(max)
	
	if (@isRemoteMode = 'True')
	begin
		select @fullname = hashcode from SSISTemplateUploadFileLinks where link_up = @ssisTemplateLink and used = 1
		if (@fullname is null or @fullname = '')
		begin
			raiserror('      ',16,1)
			return
		end
		update SSISTemplateUploadFileLinks set used = 1 where link_up = @ssisTemplateLink and @fullname = HashCode
		select @fullname = dbo.get_val('NASTR_UPLOAD_FILES_PATH','CHAR_VALUE',0) + '\' + @fullname
	end
	
	exec ReadXML @fullname, @tmp_info output, @codepage
	set @info = convert(xml,@tmp_info)

	if (@info.exist('/export/filters')=1)
	begin		
		select @dsid dsid,
			m.n.value('name[1]', 'varchar(250)') as name,
			1 as navigator,
			convert(xml ,m.n.query('DsiFilter[1]')) as [xml] into #filters
			from  @info.nodes('/export/filters/filter') m(n)
	end	

	if (@xmlfromtemplate <> '')
	begin
		select @xmltemplate = convert(xml, @xmlfromtemplate)	
		-- meta data replacing
		-- template cl-rs
		create table #cls_templ(id int identity(1, 1), oldcode varchar(30), x varchar(max), oldid varchar(40), cid varchar(40))
		insert #cls_templ
		select m.n.value('oldCode[1]', 'varchar(30)'),	
		convert(varchar(max), m.n.query('.')),
		m.n.value('oldId[1]', 'varchar(40)'),
		m.n.value('@id', 'varchar(40)')
		from @xmltemplate.nodes('/root/classificators/classificator') m(n)

		-- cl-rs elements
		create table #cls_file(id int identity(1, 1), code varchar(30), x varchar(max))
		insert #cls_file
		select m.n.value('code[1]', 'varchar(30)'),
		convert(varchar(max), m.n.query('elements'))
		from @info.nodes('/export/classificator') m(n)

		-- cl-rs + elements
		update #cls_templ
		set #cls_templ.x = 
			replace(
			 #cls_templ.x + 
			(select #cls_file.x from #cls_file where code = oldcode),
			'</classificator>','') + '</classificator>'
		where oldcode is not null

		declare @source varchar(max)
		select @source = convert(varchar(max), m.n.query('.'))
		from @info.nodes('/export/source') m(n)
		
		-- rplace attr old ids	
		declare @count_cl int
		select @count_cl = count(*) from #cls_templ
		create table #rep_attrs(oldid varchar(40), id varchar(40), oldname varchar(4000), name varchar(4000))
		while (@count_cl>0)
		begin
			declare @cl varchar(max), @clx xml, @oldclid varchar(40), @clid varchar(40)
			select @cl = x, @clx = convert(xml, x), @oldclid = oldid, @clid = cid from #cls_templ where id = @count_cl		
			
			if (@clx.exist('/classificator/attributes/attribute/oldId')=1)
			begin
				insert #rep_attrs
				select m.n.value('oldId[1]' , 'varchar(40)'),
				m.n.value('@id' , 'varchar(40)'),	
				m.n.value('oldName[1]' , 'varchar(4000)'),
				m.n.value('@name' , 'varchar(4000)')
				from @clx.nodes('/classificator/attributes/attribute')	m(n)
				
				while(exists(select * from #rep_attrs))
				begin
					declare @oldid varchar(40), @aid varchar(40), @oldname varchar(40), @aname varchar(40)
					select @oldid = oldId, @aid = id, @oldname = oldname, @aname = name from #rep_attrs		
					select @cl = replace(@cl, 'attr_' + @oldid, 'attr_' + @aid)
					delete #rep_attrs where @oldid = oldId and @aid = id and @oldname = oldname and @aname = name
				end								
			end
			
			select @cl = replace(@cl, 'pclid="' + @oldclid + '"', 'pclid="' + @clid + '"')		
			select @source = replace(@source, 'clid="' + @oldclid + '"', 'clid="' + @clid + '"')		
			
			if (@info.exist('/export/filters')=1)
				update #filters set [xml]= convert(xml, replace(convert(varchar(max), [xml]), @oldclid, @clid))
			
			update #cls_templ set x = @cl where id = @count_cl
			select @count_cl =  @count_cl - 1
		end
		drop table #rep_attrs	
		
		declare @insert_cl varchar(max)
		select @insert_cl = ''
		select @insert_cl = @insert_cl + x from #cls_templ

		set @info.modify(' delete /export/classificator')	
		set @info.modify(' delete /export/measures')			
		set @info.modify(' delete /export/source')	
		
		select @info = convert(xml, replace(convert(varchar(max), @info), '</export>',  '') + @insert_cl + '</export>')
		set @info.modify(' delete /export/classificator/attributes/attribute/oldId')	
		set @info.modify(' delete /export/classificator/attributes/attribute/oldName')	
		set @info.modify(' delete /export/classificator/oldId')
		set @info.modify(' delete /export/classificator/oldCode')

		declare @insert_s varchar(max), @sql nvarchar(max)
		select @insert_s = ' insert (' + @source + ') into (/export)[1]'
		select @sql = 'set @info.modify(''' + @insert_s + ''')'
		exec sp_executesql @sql, N'@info xml output', @info=@info output
				
		-- measures replace
		declare @m_templ xml
		select @m_templ = m.n.query('.')
		from @xmltemplate.nodes('/root/measures') m(n)

		declare @insert_m varchar(max)
		select @insert_m = ' insert (' + convert(varchar(max), @m_templ) + ') into (/export)[1]'
		select @sql = 'set @info.modify(''' + @insert_m + ''')'
		exec sp_executesql @sql, N'@info xml output', @info=@info output

		if (@xmltemplate.exist('/root/measures/measure/oldId')=1)
		begin
			create table #rep_measure(oldid varchar(40), id varchar(40))
			insert #rep_measure
			select m.n.value('oldId[1]', 'varchar(40)'),
			m.n.value('@id', 'varchar(40)')
			from @xmltemplate.nodes('/root/measures/measure') m(n)	

			select @tmp_info = convert(varchar(max), @info)
			while (exists(select * from #rep_measure))
			begin
				declare @oldmid varchar(40),@mid varchar(40)
				select @oldmid = oldid, @mid = id from #rep_measure
				select @tmp_info= replace(@tmp_info, 'mid="' + @oldmid + '"', 'mid="' + @mid + '"')
				
				if (@info.exist('/export/filters')=1)
					update #filters set [xml]= convert(xml, replace(convert(varchar(max), [xml]), @oldmid, @mid))
				
				delete from #rep_measure where @oldmid = oldid and @mid = id 							
			end	
			drop table #rep_measure
			select @info = convert(xml, @tmp_info)
			set @info.modify(' delete /export/measures/measure/oldId')
		end

		drop table #cls_file
		drop table #cls_templ
		-- end meta data replacing
	end

	if '0.01' != @info.value('(/export/version)[1]','varchar(128)')
	begin
		raiserror('    ',16,1)
		return
	end

	begin try
		if @replace = 1 and @dsid > 0
			exec clear_ds @nMode = 1, @nId = @dsid
	end try
	begin catch
		declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
		select @ErrorMessage = '   :'+ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE();
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState);
		return
	end catch

	
	declare @i int, @i_max int, @id int

	create table #measures (id int, shortname varchar(50), fullname varchar(500), dest_id int)
	insert #measures(id, shortname, fullname)
	select m.n.value('@id','int'),m.n.value('@shortname','varchar(50)'),m.n.value('@fullname','varchar(500)')
	from @info.nodes('/export/measures/measure') m(n)

	insert into measures(fullname, shortname, [object])
	select a.fullname, a.shortname, dbo.obj_id('DICTIONARY_MEASURE')
	from #measures a left outer join measures b on a.shortname = b.shortname
	where b.shortname is null

	update #measures
	set dest_id = b.measureid
	from #measures a inner join measures b on a.shortname = b.shortname

	create table #cls(ord int identity(1,1), id int, code varchar(30), objcode varchar(30), [name] varchar(1000), [description] varchar(2000), [type] int, row_id uniqueidentifier, dest_id int, levelsovveride varchar(6))
	insert #cls(id, code, objcode, [name], [description], [type], levelsovveride)
	select	c.n.value('@id','int')
		   ,c.n.value('code[1]','varchar(30)')
		   ,c.n.value('objcode[1]','varchar(30)')	
		   ,c.n.value('name[1]','varchar(1000)')
		   ,c.n.value('description[1]','varchar(2000)')
		   ,c.n.value('type[1]','int')
		   ,c.n.value('levelsOvveride[1]','varchar(6)')
	from @info.nodes('/export/classificator') c(n)

	create table #elems(id int, pid int, code varchar(30), [name] varchar(1000), descr varchar(1000), row_id uniqueidentifier, clid int, delflag int default(0), migration int, dest_id int)

	create table #elems_attr(clattrid int identity(1,1), [name] varchar(200), clid int)
	create table #elems_app(clid int,[value] varchar(4000),clattrid int)
	create table #cl_desc([name] varchar(128), lvl int, mask varchar(24), start int,ln int,clid int,[type] int, htype int)

	declare @query nvarchar(max)

	declare @code varchar(30), @objcode varchar(30), @idc int
	set @i = 1
	select @i_max = count(*) from #cls

	create table #attrs([name] varchar(200), clattrid int, dest_attrid int, row_id uniqueidentifier default(newid()))
	create table #clr(classificatorid int, code varchar(30), [name] varchar(1000), pclid int, clid int)

	declare @corrLinks table(id int)
	declare @corr int set @corr = dbo.obj_id('DICTIONARY_CORR_DWH')
	insert @corrLinks
	select classificatorid from classificators where parentclassificatorid is null and [object]=@corr

	create table #deleted(classificatorid int)

	declare @add int
	set @add = 0

	create table #elems_code(id int, code varchar(30))
	create table #elems_name(id int, code varchar(30), name varchar(1000))
	create table #elems_upd(oldid int, id int)
	create table #elems_min(oldid int, id int)

	while @i <= @i_max
	begin
		declare @levelsovver varchar(6)
		select @id = id, @code = code, @objcode = objcode, @levelsovver = levelsovveride from #cls where ord = @i
		
		set @query = N'select e.n.value(''@clid'',''int''), e.n.value(''@pclid'',''int''), e.n.value(''@code'',''varchar(30)''),
			e.n.value(''@name'',''varchar(1000)''),e.n.value(''@description'',''varchar(1000)'') from @info.nodes(''/export/classificator[@id="'+convert(varchar(20),@id)+'"]/elements/element'') e(n)'
		insert #elems(id, pid, code, [name], descr)
		exec sp_executesql @query, N'@info xml',@info = @info
		update #elems
		set clid = @id
		where clid is null

		set @idc = null
		select @idc = classificatorid from classificators
		where parentclassificatorid is null and classificatorcode=@code and dbo.obj_code([object])=@objcode
		if @idc is null
		begin
			update #cls
			set row_id = newid()
			where ord = @i

			insert classificators(classificatorcode, [name], [description], [type], [object], row_id)
			select dbo.RegExALLfresh(code), dbo.RegExALLfresh([name]), dbo.RegExALLfresh([description]), [type], dbo.obj_id(objcode), row_id from #cls where ord = @i
			
			--remove row_id ?
			set @idc = scope_identity()

			update #cls
			set dest_id = @idc
			where ord = @id

			set @query = 'select d.n.value(''@name'',''varchar(128)''), d.n.value(''@level'',''int''), d.n.value(''@mask'',''varchar(24)'')
				, d.n.value(''@startposition'',''int'') , d.n.value(''@length'',''int'') 
				, '+convert(varchar(20),@idc)+',d.n.value(''@type'',''int''), d.n.value(''@htype'',''int'') from @info.nodes(''/export/classificator[@id="'+convert(varchar(20),@id)+'"]/levels/level'') d(n)'

			insert into classificatordescription([name], [level], mask, startposition, [length], classificatorid, [type], htype)
			exec sp_executesql @query, N'@info xml',@info = @info

			
			truncate table #attrs
			set @query = 'select a.n.value(''@name'',''varchar(200)''),a.n.value(''@id'',''int'') from @info.nodes(''/export/classificator[@id="'+convert(varchar(20),@id)+'"]/attributes/attribute'') a(n)'
			insert #attrs([name],clattrid)
			exec sp_executesql @query, N'@info xml',@info = @info

			if exists(select * from #attrs)
			begin
				insert into classificators_attr([name], classificatorid, row_id)
				select [name], @idc, row_id
				from #attrs

				update #attrs
				set dest_attrid = classificators_attr.clattrid
				from #attrs inner join classificators_attr on #attrs.row_id = classificators_attr.row_id
			end

		end
		update ClassificatorProperty set CH_GUID = NEWID() where ClassificatorID = @idc
		
		if(@levelsovver='true')
		begin
			delete from classificatordescription where classificatorid=@idc
			
			set @query = 'select d.n.value(''@name'',''varchar(128)''), d.n.value(''@level'',''int''), d.n.value(''@mask'',''varchar(24)'')
				, d.n.value(''@startposition'',''int'') , d.n.value(''@length'',''int'') 
				, '+convert(varchar(20),@idc)+',d.n.value(''@type'',''int''), d.n.value(''@htype'',''int'') from @info.nodes(''/export/classificator[@id="'+convert(varchar(20),@id)+'"]/levels/level'') d(n)'

			insert into classificatordescription([name], [level], mask, startposition, [length], classificatorid, [type], htype)
			exec sp_executesql @query, N'@info xml',@info = @info
		end

		update #cls
		set dest_id = @idc
		where ord = @i

		if exists(select * from #attrs)
		begin
			declare @fields nvarchar(max),@fields_def nvarchar(max)
				set @fields = ''
				set @fields_def = ''

				set @query = 'create table #tmp(clid int,'
				select @fields = @fields + '[attr_'+convert(varchar(20),[clattrid])+']' + ' varchar(4000),', @fields_def = @fields_def + '[attr_'+convert(varchar(20),[clattrid])+'],'
				from #attrs

				set @fields = left(@fields,len(@fields)-1)
				set @fields_def = left(@fields_def,len(@fields_def)-1)

				set @query = @query + @fields +')'

				set @fields = 'e.n.value(''@clid'',''int''),'
				select @fields = @fields + 'e.n.value(''@attr_' + convert(varchar(20),[clattrid]) + ''',''varchar(4000)''),'
				from #attrs
				

				set @fields = left(@fields,len(@fields)-1)
				set @query = @query + ' insert #tmp(clid,'+@fields_def+') select '+ @fields +' from @info.nodes(''/export/classificator[@id="'+convert(varchar(20),@id)+'"]/elements/element'') e(n)'
				set @query = @query + ' select clid,val,attr,-1 as clattrid into #tmp2 from (select * from #tmp) a unpivot (val for attr in ('+@fields_def+')) b'

				set @query = @query + ' update #tmp2 set clattrid = b.dest_attrid from #tmp2 a inner join #attrs b on a.attr = ''attr_''+convert(varchar(20),b.clattrid)'
					+ ' select clid,val,clattrid from #tmp2'
				insert #elems_app(clid,[value],clattrid)
				exec sp_executesql @query, N'@info xml',@info = @info
		end
		
		insert #clr(classificatorid, pclid, code, [name])
		exec select_cl_elems @version, @idc, 0, '<list><id val="-1"/><id val="-2"/></list>'
		
		 
		update #clr
		 set clid = @idc
		 where clid is null

		 if not exists(select id from @corrLinks where id = @idc)
		 begin
			delete from #clr where code is null and clid = @idc
			
			delete from #elems where clid = @id and code is null
			truncate table #elems_code
			insert #elems_code(id, code)
			select min(id), code from #elems 
			where clid = @id
			group by code
			insert #elems_min(oldid, id)
			select a.id, (select id from #elems_code where code = a.code)
			from #elems a left outer join #elems_code b on a.id = b.id
			where a.clid = @id and b.id is null
			
			delete from #elems where id in (select oldid from #elems_min)
					
			--delete #elems from #elems left outer join (select min(id) as id,code from #elems where clid = @id group by code) as b on #elems.id = b.id where #elems.clid = @id and b.id is null
			
			delete #clr from #clr left outer join (select min(classificatorid) as classificatorid,code from #clr where clid = @idc group by code) as b on #clr.classificatorid = b.classificatorid where #clr.clid = @idc and b.classificatorid is null
			update #elems 
			set row_id = newid(), migration = #clr.classificatorid
			output inserted.migration into #deleted
			from #elems inner join #clr on #elems.code = #clr.code
			where #elems.clid = @id and #clr.clid = @idc and #elems.name <> #elems.name
			update #elems
			set row_id = newid()
			where clid = @id and not exists(select * from #clr where #clr.clid = @idc and #clr.code = #elems.code)
		 end
		 else
		 begin
			delete from #elems where clid = @id and (code is null or [name] is null)
			
			truncate table #elems_name
			insert #elems_name(id, code, name)
			select min(id), code, name from #elems 
			where clid = @id
			group by code,name
			
			insert #elems_min(oldid, id)
			select a.id, (select id from #elems_name where code = a.code and name = a.name)
			from #elems a left outer join #elems_name b on a.id = b.id
			where a.clid = @id and b.id is null
			
			delete from #elems where id in (select oldid from #elems_min)
			
			--delete #elems from #elems left outer join (select min(id) as id,code,[name] from #elems where clid = @id group by code,[name]) as b on #elems.id = b.id where #elems.clid = @id and b.id is null
			delete from #clr where clid = @idc and (code is null or [name] is null)
			delete #clr from #clr left outer join (select min(classificatorid) as classificatorid,code,name from #clr where clid = @idc group by code,name) as b on #clr.classificatorid = b.classificatorid where #clr.clid = @idc and b.classificatorid is null
			update #elems 
			set row_id = newid(), migration = #clr.classificatorid
			output inserted.migration into #deleted
			from #elems inner join #clr on (#elems.code = #clr.code and #elems.name <> #elems.name)
			where #elems.clid = @id and #clr.clid = @idc and #elems.descr <> #elems.descr
			update #elems
			set row_id = newid()
			where clid = @id and not exists(select * from #clr where #clr.clid = @idc and #clr.code = #elems.code and #clr.name = #elems.name)
		 end
		set @add = @add + case when exists(select * from #elems where clid = @id and row_id is not null) then 1 else 0 end
		set @i = @i + 1
	end

	declare @ClrInV table(classificatorid int, classificatorcode varchar(30), name varchar(1000), description varchar(1024), obj_code varchar(30))
		insert into @ClrInV exec dbo.GetClassificatorsInVersion @version
		declare @classificators table (rownum int IDENTITY (1,1) Primary key NOT NULL, id int not null, existing int, objectID int)
		insert into @classificators(id, existing, objectID)
		select dest_id, case when exists(select * from @ClrInV where classificatorid = dest_id) then 1 else 0 end, null
		from #cls


		if @dsid = -1
		begin
			exec InsertVersion @version,@dsname,@dsname,@date,null,'DICTIONARY_DATASOURCE',@dsid output
		end	
		
		insert into t_version(classificatorid,versionid,deleted) select id, @version, 0 from @classificators where existing = 0

		--optimize. 
		insert into classificators(parentclassificatorid, classificatorcode, [name], [description], [object], row_id, import_id, updated) 
		select b.dest_id,dbo.RegExALLfresh(a.code),dbo.RegExALLfresh(a.[name]),dbo.RegExALLfresh(a.[descr]), dbo.obj_id(b.objcode), a.row_id, @import_id, 0 from #elems a inner join #cls b on a.clid = b.id
		where a.row_id is not null
		
     	--

		insert into t_version(classificatorid, versionid, deleted) 
		select a.classificatorid, @version, 0 from classificators a inner join #elems b on a.row_id = b.row_id
		insert into datamigration(sourceelementid, targetelementid, koefdirect, koefinverse, confidencedirect, confidenceinverse) 
		select b.migration, a.classificatorid, 1,1,1,1 from classificators a inner join #elems b on a.row_id = b.row_id
		where b.migration is not null

	truncate table #clr
	set @i = 1
	while @i <= @i_max
	begin
		select @id = id, @code = code, @objcode = objcode from #cls where ord = @i
		select @idc = classificatorid from classificators
		where parentclassificatorid is null and classificatorcode=@code and dbo.obj_code([object])=@objcode
		insert #clr(classificatorid, pclid, code, [name])
		exec select_cl_elems @version, @idc, 0, '<list><id val="-1"/><id val="-2"/></list>'
		update #clr
		set clid = @idc
		where clid is null
		set @i = @i + 1
	end
	--update pids. test first
	update #elems
	set dest_id = b.classificatorid
	from #elems a inner join #cls c on (a.clid = c.id) inner join #clr b on (c.dest_id = b.clid and a.code = b.code)
	where not exists (select id from @corrLinks where id = a.clid)

	update #elems
	set dest_id = b.classificatorid
	from #elems a inner join #cls c on (a.clid = c.id) inner join #clr b on (c.dest_id = b.clid and a.code = b.code and a.[name] = b.[name])
	where a.clid in (select id from @corrLinks)

	--test correcting parents
	update classificators
	set parentclassificatorid = c.dest_id
	from classificators a inner join #elems b on a.row_id = b.row_id
	inner join #elems c on b.pid = c.id

	select dest_id id , id oid into #fff from #elems	
	if (@info.exist('/export/filters')=1)
	begin
		while (exists (select * from #fff))
		begin
			declare @fid varchar(7), @foid varchar(7)
			select @fid = convert(varchar(7), id) , @foid= convert(varchar(7), oid) from #fff
			update #filters set [xml]= convert(xml, replace(convert(varchar(max), [xml]), @foid, @fid))
			delete #fff where @fid=convert(varchar(7), id) and @foid=convert(varchar(7), oid)
		end
	end	
	drop table #fff
		
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.dest_id,dbo.RegExALLfresh(a.[value]),a.clattrid
	from #elems_app a inner join #elems b on a.clid = b.id

	--source template

	create table #st(id int, clid int, alias varchar(50), multiselection int, mustinput int, grp int, dest_id int, dest_stid int)

	insert into #st(id, clid, alias, multiselection, mustinput, grp)
	select st.n.value('@id','int'), st.n.value('@clid','int'),st.n.value('@alias','varchar(50)'),st.n.value('@multiselection','int'),
		st.n.value('@mustinput','int'),st.n.value('@grp','int')
	from @info.nodes('/export/source/st') st(n)

	--optimize - check for clid only
	insert into sourcetemplate(classificatorid, versionid, [description],multiselection,mustinput,grp)
	select b.dest_id, @dsid, a.alias, a.multiselection, mustinput, grp
	from #st a inner join #cls b on a.clid = b.id
	except
	select classificatorid,versionid,isnull([description],''),multiselection, 
		mustinput, grp from sourcetemplate where versionid = @dsid

	update #st
	set dest_id = b.classificatorid, dest_stid = b.sourcetemplateid
	from #st a inner join #cls c on a.clid = c.id inner join
		 (select sourcetemplateid,classificatorid from sourcetemplate where versionid = @dsid) b on c.dest_id = b.classificatorid

	--storage

	set @query = 'create table #storage(row_id uniqueidentifier default(newid()),amount numeric(27,10),date datetime,measureid int,strid int, timekey int, dest_mid int'

	declare @tmp varchar(max),@tmp2 varchar(max),@tmp3 varchar(max),@tmp4 varchar(max),@tmp5 varchar(max), @tmp6 varchar(max)

	set @tmp = ''
	set @tmp2 = ''
	set @tmp3 = ''
	set @tmp4 = ''
	set @tmp5 = ''
	set @tmp6 = ''

	if exists(select * from #st)
	begin
		select @tmp = @tmp + ',st' + convert(varchar(20),id)+' int,dest_st'+convert(varchar(20),id)+' int',
			   @tmp2 = @tmp2 + ',st' + convert(varchar(20),id),
			   @tmp3 = @tmp3 + ',r.n.value(''@st' + convert(varchar(20),id)+''',''int'')',
			   @tmp4 = @tmp4 + ' update #storage set dest_st'+convert(varchar(20),id)+' = b.dest_id from #storage a inner join #elems b on a.st'
				+convert(varchar(20),id)+' = b.id',
			   @tmp5 = @tmp5 + ',dest_st' + convert(varchar(20),id),
			   @tmp6 = @tmp6 + ' update #storage set st'+ convert(varchar(20),id)
			   +' = b.id from #storage a inner join #elems_min b on a.st'+ convert(varchar(20),id)+' = b.oldid '
		from #st

		set @query = @query + @tmp +') insert #storage(amount, date, measureid, strid' + @tmp2+
		')	select r.n.value(''@v'',''numeric(27,10)''), r.n.value(''@dt'',''datetime''), r.n.value(''@mid'',''int''), r.n.value(''@strid'',''int'')'
		+ @tmp3 + '	from @info.nodes(''/export/dataflow/row'') r(n) update #storage set timekey = b.timekey from #storage a inner join time b on a.date = b.fulldate 
		update #storage set dest_mid = b.dest_id from #storage a inner join #measures b on a.measureid = b.id'
		+ @tmp6 + @tmp4

		set @query = @query + ' create table #rels(id int,row_id uniqueidentifier) select *,0 as dest_stid into #st2 from (select row_id'
		+ @tmp5+' from #storage) a unpivot (clid for st in ('+substring(@tmp5,2,len(@tmp5))+
		')) b insert into storage(versionid,amount,timekey,row_id,measureid,strid,import_id) output inserted.storageid,inserted.row_id into #rels select '
		+convert(varchar(20),@dsid)+',amount,timekey,row_id,dest_mid,strid,@imp_id from #storage '
		+' update #st2 set dest_stid = b.dest_stid from #st2 a inner join #st b on convert(int,substring(a.st,8,len(a.st)-7)) = b.id'

		+' insert into t_storage(storageid, classificatorid, sourcetemplateid) select a.id, b.clid, b.dest_stid from #rels a inner join #st2 b on a.row_id = b.row_id'
		+' exec InsertMeasures '+convert(varchar(20), @dsid)
	end
	else
	begin
		set @query = @query + ') insert #storage(amount, date, measureid, strid) '
		+' select r.n.value(''@v'',''numeric(27,10)''), r.n.value(''@dt'',''datetime''), r.n.value(''@mid'',''int''), r.n.value(''@strid'',''int'')'
		+ ' from @info.nodes(''/export/dataflow/row'') r(n) update #storage set timekey = b.timekey from #storage a inner join time b on a.date = b.fulldate 
		update #storage set dest_mid = b.dest_id from #storage a inner join #measures b on a.measureid = b.id '
		+ ' insert into storage(versionid,amount,timekey,row_id,measureid,strid,import_id) select '
		+convert(varchar(20),@dsid)+',amount,timekey,row_id,dest_mid,strid,@imp_id from #storage'
		+' exec InsertMeasures '+convert(varchar(20), @dsid)
	end
	
	
	exec sp_executesql @query, N'@info xml, @imp_id uniqueidentifier',@info = @info, @imp_id = @import_id

	if (@info.exist('/export/filters')=1)
	begin
		update #filters set dsid = @dsid
		insert Filter(VERSIONID, NAME, navigator, xml )
		select * from #filters
	end	
	
	update fileloadedhash set successload = 1 where successload = 0 and import_id = @import_id
END
GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8524' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'IMPORTEXPORTEDFILE'
GO



if exists(select * from sys.objects where object_id = object_id(N'[dbo].[ImportRROBKS]') and type in (N'P', N'PC'))
	drop procedure [dbo].[ImportRROBKS]
GO

/*
	:       -   -

	:
		@cfg - xml     linked server, :
		@cfg = '<Connection><Mode>0</Mode><Server>ksdb1\bks</Server><Database>bks_chuv_rro</Database><NTLM>0</NTLM><User>duke</User><Pwd></Pwd></Connection>'
		@source_name -   ,      (   ,   )

	 :
		exec [dbo].[ImportRROBKS]
			@cfg = '<Connection><Mode>0</Mode><Server>ksdb1\bks</Server><Database>bks_upd_120301_2780_test</Database><NTLM>0</NTLM><User>duke</User><Pwd></Pwd></Connection>',
			@source_name = ''

	:  .. (05.12.2012)
*/

create procedure [dbo].[ImportRROBKS]
	@cfg xml,
	@source_name varchar(254)
as
begin
	set nocount on

	declare @error nvarchar(4000)
	declare @proc nvarchar(512)

	set @proc = ' [dbo].[' + object_name(@@PROCID) + ']: '

	if @cfg is null
	begin
		set @error = @proc + '   '
		raiserror(@error, 16, 1)

		return
	end

	if isnull(@source_name,'') = ''
	begin
		set @error = @proc + '    '
		raiserror(@error, 16, 1)

		return
	end

	begin try
		exec [dbo].[ExecAt] 'select 1 as test', 0, @cfg
	end try
	begin catch
		set @error = @proc + error_message()
		raiserror(@error,16,1)

		return
	end catch

	declare @DICTIONARY_DATASOURCE int
	set @DICTIONARY_DATASOURCE = [dbo].[obj_id]('DICTIONARY_DATASOURCE')

	declare @data_source int --  

	if not exists(select * from [dbo].[VERSION] where [object] = @DICTIONARY_DATASOURCE and [name] = @source_name)
	begin
		set @error = @proc + '  <' + rtrim(ltrim(@source_name)) + '>  '
		raiserror(@error, 16, 1)

		return
	end
	else
	begin
		select @data_source = [versionid] from [dbo].[VERSION] where [name] = @source_name and [object] = @DICTIONARY_DATASOURCE
	end

	declare @DICTIONARY_VERSION int
	set @DICTIONARY_VERSION = [dbo].[obj_id]('DICTIONARY_VERSION')

	declare @version int

	select @version = V.[versionid] from [dbo].[VERSION] V inner join [dbo].[T_RELATION] TR on V.[versionid] = TR.[parentid]
		inner join [dbo].[VERSION] V2 on TR.[childid] = V2.[versionid] and V2.[versionid] = @data_source and V.[object] = @DICTIONARY_VERSION

	declare @calc_table int --  
	select @calc_table = [filterid] from [dbo].[FILTER] where [versionid] = @data_source

	if @calc_table is null
	begin
		set @error = @proc + '    <' + rtrim(ltrim(@source_name)) + '>   '
		raiserror(@error, 16, 1)

		return
	end

	--  
	declare @DICTIONARY_OTHER_DWH int
	set @DICTIONARY_OTHER_DWH = [dbo].[obj_id]('DICTIONARY_OTHER_DWH')

	declare @parentcode varchar(30)
	set @parentcode = '_'

	declare @parentlink int
	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_OTHER_DWH and [classificatorcode] = @parentcode
		and [parentclassificatorid] is null

	declare @stidversbudg int
	select @stidversbudg = [sourcetemplateid] from [dbo].[SourceTemplate] where [versionid] = @data_source and [classificatorid] = @parentlink

	declare @RID uniqueidentifier
	set @RID = newid()

	declare @IMPORTID uniqueidentifier
	set @IMPORTID = newid()

	----    " () ",    -    
	--insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
	--select @parentlink, convert(varchar(12), getdate(), 108), '  ', '     ' + convert(varchar(12), getdate(), 104), 1, 0, null, null, @DICTIONARY_OTHER_DWH, @rid, @IMPORTID

	declare @versbudg int
	--select @versbudg = [classificatorid] from [dbo].[Classificators] where [row_id] = @rid

	----   
	--insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
	--select @versbudg, @version, 0

	select @versbudg = [classificatorid] from [dbo].[Classificators] where [parentclassificatorid] = @parentlink and [name] = ' ' and [classificatorcode] = '0.00'

	--  ""
	update [dbo].[ClassificatorProperty]
		set [Ch_guid] = newid()
	where [ClassificatorID] = @parentlink

	declare @declaration nvarchar(254)
	declare @sql nvarchar(1000)

	set @declaration = 'declare @rro int,@sdr int,@act int,@plan int;set @rro=dbo.obj_id(''documents_reestr_ro'');set @sdr=dbo.obj_id(''documents_reestr_sdr'');set @act=dbo.obj_id(''actual_sum_reestr_ro'');set @plan=dbo.obj_id(''plan_sum_reestr_ro'');'

	-- 
	declare @DICTIONARY_DEPARTMENT_DWH int
	set @DICTIONARY_DEPARTMENT_DWH = [dbo].[obj_id]('DICTIONARY_DEPARTMENT_DWH')

	declare @dep table([dep] int, [cdep] varchar(3), [name] varchar(2000), [classificatorid] int, [row_id] uniqueidentifier default newid(), [sourcetemplateid] int)

	set @sql = @declaration + 'select distinct V.dep,V.cdep,SA.name from dbo.OBJECT_CREDIT OC inner join dbo.V_DICTIONARY_BK_IST V on OC.kbk=V.link
	inner join dbo.S_KBK_APP SA on V.dep=SA.link_up
	where OC.object in (@rro,@sdr) and OC.object_dict in (@act,@plan) and year(OC.date_first)>=2011 and year(OC.date_first)<=2015'

	insert into @dep([dep],[cdep],[name])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update D
		set [classificatorid] = CS.[classificatorid]
	from @dep D inner join [dbo].[Classificators] CS on D.[cdep] = CS.[classificatorcode]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
		inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_DEPARTMENT_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] is not null

	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_DEPARTMENT_DWH and [parentclassificatorid] is null

	update D
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @dep D

	if exists(select * from @dep where [classificatorid] is null)
	begin
		--    ""
		insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
		select @parentlink, [cdep], [name], [name], 1, 0, null, null, @DICTIONARY_DEPARTMENT_DWH, [row_id], @IMPORTID
		from @dep where [classificatorid] is null

		update D
			set [classificatorid] = CS.[classificatorid]
		from @dep D inner join [dbo].[Classificators] CS on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_DEPARTMENT_DWH
		where D.[classificatorid] is null
		--   
		insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
		select D.[classificatorid], @version, 0
		from [dbo].[Classificators] CS inner join @dep D on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_DEPARTMENT_DWH
		--  ""
		update [dbo].[ClassificatorProperty]
			set [Ch_guid] = newid()
		where [ClassificatorID] = @parentlink
	end

	-- 
	declare @DICTIONARY_DIVISION_DWH int
	set @DICTIONARY_DIVISION_DWH = [dbo].[obj_id]('DICTIONARY_DIVISION_DWH')

	declare @div table([div] int, [cdiv] varchar(4), [name] varchar(2000), [classificatorid] int, [row_id] uniqueidentifier default newid(), [sourcetemplateid] int)

	set @sql = @declaration + 'select distinct V.div,V.cdiv,SA.name from dbo.OBJECT_CREDIT OC inner join dbo.V_DICTIONARY_BK_IST V on OC.kbk=V.link
	inner join dbo.S_KBK_APP SA on V.div=SA.link_up
	where OC.object in (@rro,@sdr) and OC.object_dict in (@act,@plan) and year(OC.date_first)>=2011 and year(OC.date_first)<=2015'

	insert into @div([div],[cdiv],[name])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update D
		set [classificatorid] = CS.[classificatorid]
	from @div D inner join [dbo].[Classificators] CS on D.[cdiv] = CS.[classificatorcode]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
		inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_DIVISION_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] is not null

	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_DIVISION_DWH and [parentclassificatorid] is null

	update D
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @div D

	if exists(select * from @div where [classificatorid] is null)
	begin
		--    ""
		insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
		select @parentlink, [cdiv], [name], [name], 1, 0, null, null, @DICTIONARY_DIVISION_DWH, [row_id], @IMPORTID
		from @div where [classificatorid] is null

		update D
			set [classificatorid] = CS.[classificatorid]
		from @div D inner join [dbo].[Classificators] CS on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_DIVISION_DWH
		where D.[classificatorid] is null
		--   
		insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
		select D.[classificatorid], @version, 0
		from [dbo].[Classificators] CS inner join @div D on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_DIVISION_DWH
		--  ""
		update [dbo].[ClassificatorProperty]
			set [Ch_guid] = newid()
		where [ClassificatorID] = @parentlink
	end

	--  
	declare @DICTIONARY_EXPEND_DWH int
	set @DICTIONARY_EXPEND_DWH = [dbo].[obj_id]('DICTIONARY_EXPEND_DWH')

	declare @exp table([exp] int, [cexp] varchar(3), [name] varchar(2000), [classificatorid] int, [row_id] uniqueidentifier default newid(), [sourcetemplateid] int)

	set @sql = @declaration + 'select distinct V.exp,V.cexp,SA.name from dbo.OBJECT_CREDIT OC inner join dbo.V_DICTIONARY_BK_IST V on OC.kbk=V.link
	inner join dbo.S_KBK_APP SA on V.exp=SA.link_up
	where OC.object in (@rro,@sdr) and OC.object_dict in (@act,@plan) and year(OC.date_first)>=2011 and year(OC.date_first)<=2015'

	insert into @exp([exp],[cexp],[name])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update D
		set [classificatorid] = CS.[classificatorid]
	from @exp D inner join [dbo].[Classificators] CS on D.[cexp] = CS.[classificatorcode]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
		inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_EXPEND_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] is not null

	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_EXPEND_DWH and [parentclassificatorid] is null

	update D
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @exp D

	if exists(select * from @exp where [classificatorid] is null)
	begin
		--    " "
		insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
		select @parentlink, [cexp], [name], [name], 1, 0, null, null, @DICTIONARY_EXPEND_DWH, [row_id], @IMPORTID
		from @exp where [classificatorid] is null

		update D
			set [classificatorid] = CS.[classificatorid]
		from @exp D inner join [dbo].[Classificators] CS on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_EXPEND_DWH
		where D.[classificatorid] is null
		--   
		insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
		select D.[classificatorid], @version, 0
		from [dbo].[Classificators] CS inner join @exp D on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_EXPEND_DWH
		--  ""
		update [dbo].[ClassificatorProperty]
			set [Ch_guid] = newid()
		where [ClassificatorID] = @parentlink
	end

	--  
	declare @DICTIONARY_TARGET_ITEM_DWH int
	set @DICTIONARY_TARGET_ITEM_DWH = [dbo].[obj_id]('DICTIONARY_TARGET_ITEM_DWH')

	declare @tgt table([tgt] int, [ctgt] varchar(7), [name] varchar(2000), [classificatorid] int, [row_id] uniqueidentifier default newid(), [sourcetemplateid] int)

	set @sql = @declaration + 'select distinct V.tgt,V.ctgt,SA.name from dbo.OBJECT_CREDIT OC inner join dbo.V_DICTIONARY_BK_IST V on OC.kbk=V.link
	inner join dbo.S_KBK_APP SA on V.tgt=SA.link_up
	where OC.object in (@rro,@sdr) and OC.object_dict in (@act,@plan) and year(OC.date_first)>=2011 and year(OC.date_first)<=2015'

	insert into @tgt([tgt],[ctgt],[name])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update D
		set [classificatorid] = CS.[classificatorid]
	from @tgt D inner join [dbo].[Classificators] CS on D.[ctgt] = CS.[classificatorcode]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
		inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_TARGET_ITEM_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] is not null

	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_TARGET_ITEM_DWH and [parentclassificatorid] is null

	update D
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @tgt D

	if exists(select * from @tgt where [classificatorid] is null)
	begin
		--    " "
		insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
		select @parentlink, [ctgt], [name], [name], 1, 0, null, null, @DICTIONARY_TARGET_ITEM_DWH, [row_id], @IMPORTID
		from @tgt where [classificatorid] is null

		update D
			set [classificatorid] = CS.[classificatorid]
		from @tgt D inner join [dbo].[Classificators] CS on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_TARGET_ITEM_DWH
		where D.[classificatorid] is null
		--   
		insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
		select D.[classificatorid], @version, 0
		from [dbo].[Classificators] CS inner join @tgt D on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_TARGET_ITEM_DWH
		--  ""
		update [dbo].[ClassificatorProperty]
			set [Ch_guid] = newid()
		where [ClassificatorID] = @parentlink
	end

	-- 
	declare @DICTIONARY_ITEM_DWH int
	set @DICTIONARY_ITEM_DWH = [dbo].[obj_id]('DICTIONARY_ITEM_DWH')

	declare @item table([item] int, [citem] varchar(3), [name] varchar(2000), [classificatorid] int, [row_id] uniqueidentifier default newid(), [sourcetemplateid] int)

	set @sql = @declaration + 'select distinct V.item,V.citem,SA.name from dbo.OBJECT_CREDIT OC inner join dbo.V_DICTIONARY_BK_IST V on OC.kbk=V.link
	inner join dbo.S_KBK_APP SA on V.item=SA.link_up
	where OC.object in (@rro,@sdr) and OC.object_dict in (@act,@plan) and year(OC.date_first)>=2011 and year(OC.date_first)<=2015'

	insert into @item([item],[citem],[name])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update D
		set [classificatorid] = CS.[classificatorid]
	from @item D inner join [dbo].[Classificators] CS on D.[citem] = CS.[classificatorcode]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
		inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_ITEM_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] is not null

	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_ITEM_DWH and [parentclassificatorid] is null

	update D
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @item D

	if exists(select * from @item where [classificatorid] is null)
	begin
		--    ""
		insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
		select @parentlink, [citem], [name], [name], 1, 0, null, null, @DICTIONARY_ITEM_DWH, [row_id], @IMPORTID
		from @item where [classificatorid] is null

		update D
			set [classificatorid] = CS.[classificatorid]
		from @item D inner join [dbo].[Classificators] CS on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_ITEM_DWH
		where D.[classificatorid] is null
		--   
		insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
		select D.[classificatorid], @version, 0
		from [dbo].[Classificators] CS inner join @item D on D.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_ITEM_DWH
		--  ""
		update [dbo].[ClassificatorProperty]
			set [Ch_guid] = newid()
		where [ClassificatorID] = @parentlink
	end

	--    
	declare @mtd table([mtd] int, [code] varchar(30),[cmtd] varchar(254), [classificatorid] int, [row_id] uniqueidentifier default newid(), [sourcetemplateid] int)
	set @sql = 'declare @mtd int;set @mtd=dbo.obj_id(''DICTIONARY_CALC_RRO'');select link,left([number],30),left(name,254) from dbo.CREDIT_DOC where object=@mtd'

	insert into @mtd([mtd],[code],[cmtd])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	set @parentcode = '  '

	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_OTHER_DWH and [parentclassificatorid] is null
			and [classificatorcode] = @parentcode

	update M
		set [classificatorid] = CS.[classificatorid]
	from @mtd M inner join [dbo].[Classificators] CS on M.[code] = CS.[classificatorcode]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
			inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_OTHER_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] = @parentlink

	update M
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @mtd M

	if exists(select * from @mtd where [classificatorid] is null)
	begin
		insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
		select @parentlink, [code], [cmtd], [cmtd], 1, 0, null, null, @DICTIONARY_OTHER_DWH, [row_id], @IMPORTID
		from @mtd M where [classificatorid] is null

		update M
			set [classificatorid] = CS.[classificatorid]
		from @mtd M inner join [dbo].[Classificators] CS on M.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		where M.[classificatorid] is null
		--   
		insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
		select M.[classificatorid], @version, 0
		from [dbo].[Classificators] CS inner join @mtd M on M.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH

		--  ""
		update [dbo].[ClassificatorProperty]
			set [Ch_guid] = newid()
		where [ClassificatorID] = @parentlink
	end

	-- 
	declare @DICTIONARY_CORR_DWH int
	set @DICTIONARY_CORR_DWH = [dbo].[obj_id]('DICTIONARY_CORR_DWH')

	declare @corr table
	(	[corr] 	int,
		[inn] 	varchar(13),
		[sname] varchar(45),
		[name] 	varchar(250),
		[cdep] 	varchar(3),
		[cpp] 	varchar(9),
		[classificatorid] int,
		[row_id] uniqueidentifier default newid(),
		[sourcetemplateid] int
	)

	set @sql = 'select distinct R.link,R.inn,R.sname,R.name,R.cdep,R.cpp from dbo.CORR R inner join dbo.RRO D on R.link=D.linkcorr'

	insert into @corr([corr],[inn],[sname],[name],[cdep],[cpp])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update R
		set [classificatorid] = CS.[classificatorid]
	from @corr R inner join [dbo].[Classificators] CS on R.[inn] = CS.[classificatorcode]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
			inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_CORR_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] is not null

	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_CORR_DWH and [parentclassificatorid] is null

	update R
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @corr R

	if exists(select * from @corr where [classificatorid] is null)
	begin
		insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
		select @parentlink, [inn], [sname], [name], 1, 0, null, null, @DICTIONARY_CORR_DWH, [row_id], @IMPORTID
		from @corr where [classificatorid] is null

		update R
			set [classificatorid] = CS.[classificatorid]
		from @corr R inner join [dbo].[Classificators] CS on R.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_CORR_DWH
		where R.[classificatorid] is null
		--   
		insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
		select R.[classificatorid], @version, 0
		from [dbo].[Classificators] CS inner join @corr R on R.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_CORR_DWH
		--  ""
		update [dbo].[ClassificatorProperty]
			set [Ch_guid] = newid()
		where [ClassificatorID] = @parentlink

		-- 
		insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
		select R.[classificatorid], R.[inn], R.[row_id], CA.[clattrid]
		from @corr R inner join [dbo].[Classificators] CS on R.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_CORR_DWH
			inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

		-- 
		insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
		select R.[classificatorid], R.[cpp], R.[row_id], CA.[clattrid]
		from @corr R inner join [dbo].[Classificators] CS on R.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_CORR_DWH
			inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

		--  
		insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
		select R.[classificatorid], R.[cdep], R.[row_id], CA.[clattrid]
		from @corr R inner join [dbo].[Classificators] CS on R.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_CORR_DWH
			inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ' '
	end

	-- 
	declare @poln table([poln] int, [code] varchar(40), [name] varchar(1000), [classificatorid] int, [row_id] uniqueidentifier default newid(), [sourcetemplateid] int)
	set @sql = 'declare @poln int;set @poln=dbo.obj_id(''DICTIONARY_SODERG_RO'');select distinct CD.link,left(CD.number,40),left(CD.name,1000) from dbo.CREDIT_DOC CD inner join dbo.RRO D on D.linkpoln=CD.link'

	insert into @poln([poln],[code],[name])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	set @parentcode = ' - '

	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_OTHER_DWH and [classificatorcode] = @parentcode
		and [parentclassificatorid] is null

	update P
		set [classificatorid] = CS.[classificatorid]
	from @poln P inner join [dbo].[Classificators] CS on P.[code] = CS.[classificatorcode]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
			inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_OTHER_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] = @parentlink

	update P
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @poln P

	if exists(select * from @poln where [classificatorid] is null)
	begin
		insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
		select @parentlink, [code],[name],[name], 1, 0, null, null, @DICTIONARY_OTHER_DWH, [row_id], @IMPORTID
		from @poln where [classificatorid] is null

		update P
			set [classificatorid] = CS.[classificatorid]
		from @poln P inner join [dbo].[Classificators] CS on P.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		where P.[classificatorid] is null
		--   
		insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
		select P.[classificatorid], @version, 0
		from [dbo].[Classificators] CS inner join @poln P on P.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		--  ""
		update [dbo].[ClassificatorProperty]
			set [Ch_guid] = newid()
		where [ClassificatorID] = @parentlink
	end

	-- ()  
	declare @status table([classificatorid] int, [classificatorcode] varchar(30), [status] int, [sourcetemplateid] int)

	set @parentcode = ' '
	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_OTHER_DWH and [classificatorcode] = @parentcode
		and [parentclassificatorid] is null

	insert into @status([classificatorid], [classificatorcode], [status])
	select [classificatorid], [classificatorcode],  [classificatorcode] % 2
	from [dbo].[Classificators] where [object] = @DICTIONARY_OTHER_DWH and [parentclassificatorid] = @parentlink

	update S
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @status S

	--   
	declare @memo table([memolink] int, [classificatorid] int,[name] varchar(1000), [sourcetemplateid] int)
	set @sql = 'declare @memo int;set @memo=dbo.obj_id(''dictionary_memo_ro'');select link,left(name,1000) from dbo.CREDIT_DOC where object=@memo'

	set @parentcode = ' - '
	select @parentlink = [classificatorid] from [dbo].[Classificators] where [object] = @DICTIONARY_OTHER_DWH and [classificatorcode] = @parentcode
		and [parentclassificatorid] is null

	insert into @memo([memolink],[name])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update M
		set [classificatorid] = CS.[classificatorid]
	from @memo M inner join [dbo].[Classificators] CS on M.[name] = CS.[name]
		inner join [dbo].[T_VERSION] TV on CS.[classificatorid] = TV.[classificatorid]
			inner join dbo.[VERSION] V on V.[versionid] = TV.[versionid] and V.[versionid] = @version
	where CS.[object] = @DICTIONARY_OTHER_DWH and TV.[deleted] = 0 and CS.[parentclassificatorid] = @parentlink

	update M
		set [sourcetemplateid] = (select [sourcetemplateid] from [dbo].[SourceTemplate] where [classificatorid] = @parentlink and [versionid] = @data_source)
	from @memo M

	-- 
	declare @DICTIONARY_MEASURE int
	set @DICTIONARY_MEASURE = [dbo].[obj_id]('DICTIONARY_MEASURE')

	declare @measures table([measureid] int, [shortname] varchar(50))

	insert into @measures([measureid],[shortname])
	select [measureid], [shortname] from [dbo].[Measures]
	where [object] = @DICTIONARY_MEASURE and [shortname] in ('+1','+2','','','','')

	declare @sums table
	(
		[status]	int,
		[statusid]	int,
		[statusst]	int,

		[polnlink]  int,
		[polnid] 	int,
		[polnstid]	int,

		[corrlink]	int,
		[corrid]	int,
		[corrstid]	int,

		[mtdlink]	int,
		[mtdid] 	int,
		[mtdstid]	int,

		[deplink] 	int,
		[depid]		int,
		[depstid]	int,

		[divlink]	int,
		[divid]		int,
		[divstid]	int,

		[explink]	int,
		[expid]		int,
		[expstid]	int,

		[tgtlink]	int,
		[tgtid]		int,
		[tgtstid]	int,

		[itemlink]	int,
		[itemid]	int,
		[itemstid]	int,

		[memolink]	int,
		[memoid]	int,
		[memostid]	int,

		[year]		int,
		[type]		int,	-- 1: , 0: 
		[summa]		money,

		[measureid]	int,
		[TimeKey]	int default(20120101),
		[row_id]	uniqueidentifier default newid(),
		[storageid]	int
	)

	set @sql = 'declare @rro int;set @rro=dbo.obj_id(''documents_reestr_ro'');declare @act int;set @act=dbo.obj_id(''actual_sum_reestr_ro'');
	declare @plan int;set @plan=dbo.obj_id(''plan_sum_reestr_ro'');
	select R.orders as status,R.linkpoln as polnlink,R.linkcorr as corrlink,case when OC.object_dict=@act then 0 else 1 end as type,OC.credit as mtdlink,V.dep as deplink,V.div as divlink,V.[exp] as explink,V.tgt as tgtlink,V.item as itemlink,
	max(R.memolink) as memolink,year(OC.date_first) as year,sum(OC.summa) as summa
	from dbo.RRO R inner join dbo.OBJECT_CREDIT OC on R.link=OC.link_up and R.object=@rro and OC.object=@rro and OC.object_dict in (@act,@plan)
	inner join dbo.V_DICTIONARY_BK_IST V on OC.kbk=V.link
	where year(OC.date_first)>=2011 and year(OC.date_first)<=2015
	group by R.orders,R.linkpoln,R.linkcorr,OC.object_dict,OC.credit,V.dep,V.div,V.exp,V.tgt,V.item,OC.date_first'

	insert into @sums([status],[polnlink],[corrlink],[type],[mtdlink],[deplink],[divlink],[explink],[tgtlink],[itemlink],[memolink],[year],[summa])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update S
		set [polnid] 	= P.[classificatorid],
			[polnstid]	= P.[sourcetemplateid]
	from @sums S inner join @poln P on S.[polnlink] = P.[poln]

	update S
		set [corrid]	= R.[classificatorid],
			[corrstid]	= R.[sourcetemplateid]
	from @sums S inner join @corr R on S.[corrlink] = R.[corr]

	update S
		set [depid] 	= D.[classificatorid],
			[depstid] 	= D.[sourcetemplateid]
	from @sums S inner join @dep D on S.[deplink] = D.[dep]

	update S
		set [divid] 	= D.[classificatorid],
			[divstid] 	= D.[sourcetemplateid]
	from @sums S inner join @div D on S.[divlink] = D.[div]

	update S
		set [tgtid] 	= D.[classificatorid],
			[tgtstid] 	= D.[sourcetemplateid]
	from @sums S inner join @tgt D on S.[tgtlink] = D.[tgt]

	update S
		set [expid] 	= D.[classificatorid],
			[expstid] 	= D.[sourcetemplateid]
	from @sums S inner join @exp D on S.[explink] = D.[exp]

	update S
		set [itemid] 	= D.[classificatorid],
			[itemstid] 	= D.[sourcetemplateid]
	from @sums S inner join @item D on S.[itemlink] = D.[item]

	update S
		set [mtdid] 	= M.[classificatorid],
			[mtdstid] 	= M.[sourcetemplateid]
	from @sums S inner join @mtd M on S.[mtdlink] = M.[mtd]

	update S
		set [memoid]	= M.[classificatorid],
			[memostid]	= M.[sourcetemplateid]
	from @sums S inner join @memo M on S.[memolink] = M.[memolink]

	update S
		set [statusid] = ST.[classificatorid],
			[statusst] = ST.[sourcetemplateid]
	from @sums S inner join @status ST on S.[status] = ST.[status]

	update S
		set [measureid] = M.[measureid]
	from @sums S inner join @measures M on S.[type] = 0 and S.[year] = 2011 and M.[shortname] = ''

	update S
		set [measureid] = M.[measureid]
	from @sums S inner join @measures M on S.[type] = 1 and S.[year] = 2011 and M.[shortname] = ''

	update S
		set [measureid] = M.[measureid]
	from @sums S inner join @measures M on S.[type] = 1 and S.[year] = 2012 and M.[shortname] = ''

	update S
		set [measureid] = M.[measureid]
	from @sums S inner join @measures M on S.[type] = 1 and S.[year] = 2013 and M.[shortname] = ''

	update S
		set [measureid] = M.[measureid]
	from @sums S inner join @measures M on S.[type] = 1 and S.[year] = 2014 and M.[shortname] = '+1'

	update S
		set [measureid] = M.[measureid]
	from @sums S inner join @measures M on S.[type] = 1 and S.[year] = 2015 and M.[shortname] = '+2'

	insert into [dbo].[Storage]([versionid],[Amount],[TimeKey],[row_id],[measureid],[filterid],[import_id],[date_in])
	select @data_source, [summa], [TimeKey], [row_id], [measureid], @calc_table, @IMPORTID, getdate()
	from @sums

	update S
		set [storageid] = ST.[storageid]
	from @sums S inner join [dbo].[Storage] ST on S.[row_id] = ST.[row_id] and ST.[import_id] = @IMPORTID

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [statusid], [statusst] from @sums
	where [statusid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [polnid], [polnstid] from @sums
	where [polnid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [corrid], [corrstid] from @sums
	where [corrid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [mtdid], [mtdstid] from @sums
	where [mtdid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [depid], [depstid] from @sums
	where [depid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [divid], [divstid] from @sums
	where [divid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [expid], [expstid] from @sums
	where [expid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [tgtid], [tgtstid] from @sums
	where [tgtid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [itemid], [itemstid] from @sums
	where [itemid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], [memoid], [memostid] from @sums
	where [memoid] is not null

	insert into [dbo].[T_STORAGE]([storageid],[classificatorid],[sourcetemplateid])
	select [storageid], @versbudg, @stidversbudg from @sums

	--  "  "
	declare @precs table
	( 	[classificatorid] int,
		[polnlink]	int,
		[polnid] 	int,
		[preclink]	int,
		[precid] 	int,
		[preccode]	varchar(100),
		[precname]	varchar(6000),
		[npalink]	int,
		[npaid]		int,
		[npacode]	varchar(100),
		[npaname]	varchar(6000),
		[npadate]	datetime,
		[npadatebegin]	datetime,
		[npadateend]	datetime,
		[npaclevel]	varchar(25),
		[npactype]	varchar(254),
		[razdel]	varchar(254),
		[glava]		varchar(254),
		[statia]	varchar(254),
		[punkt]		varchar(254),
		[abzac]		varchar(254),
		[chast]		varchar(254),
		[podpunkt]	varchar(254),
		[podstatia]	varchar(254),
		[precrowid] uniqueidentifier default newid()
	)

	set @sql = 'declare @rro int,@prec int;set @rro=dbo.obj_id(''documents_reestr_ro'');set @prec=dbo.obj_id(''dictionary_prec_doc'');
	select R.linkpoln,RNP.link,RNP.code,RNP.name,RNP.linknpa as npalink,RNP.npa_code,CD.name as npaname, RNP.npa_date,RNP.npa_date_begin,RNP.npa_date_end,RNP.npa_clevel,RNP.npa_type,RNP.razdel,RNP.glava,RNP.statia,RNP.punkt,RNP.abzac,RNP.chast,RNP.podpunkt,RNP.podstatia
	from dbo.RRO R inner join dbo.OBJECT_CREDIT OC on R.link=OC.link_up and OC.object=R.object and OC.object_dict=@prec and R.object=@rro
	inner join dbo.RRO_NPA_PRECS RNP on OC.credit=RNP.link inner join dbo.CREDIT_DOC CD on RNP.linknpa=CD.link'

	insert into @precs([polnlink],[preclink],[preccode],[precname],[npalink],[npacode],[npaname],[npadate],[npadatebegin],[npadateend],[npaclevel],[npactype],[razdel],[glava],[statia],[punkt],[abzac],[chast],[podpunkt],[podstatia])
	exec [dbo].[ExecAt] @sql, 1, @cfg

	update I
		set [polnid] = P.[classificatorid]
	from @precs I inner join @poln P on I.[polnlink] = P.[poln]

	declare @fields table
	(	[link]		int identity(1,1), --    varchar    [classificatorcode]
		[classificatorid]	int,
		[precname]	varchar(6000),
		[razdel]	varchar(254),
		[glava]		varchar(254),
		[statia]	varchar(254),
		[punkt]		varchar(254),
		[abzac]		varchar(254),
		[chast]		varchar(254),
		[podpunkt]	varchar(254),
		[podstatia]	varchar(254),
		[row_id]	uniqueidentifier default newid()
	)

	insert into @fields([precname],[razdel],[glava],[statia],[punkt],[abzac],[chast],[podpunkt],[podstatia])
	select distinct [precname], [razdel], [glava], [statia], [punkt], [abzac], [chast], [podpunkt], [podstatia]
	from @precs

	set @parentcode = ''
	select @parentlink = [classificatorid] from [dbo].[Classificators] where [classificatorcode] = @parentcode and [object] = @DICTIONARY_OTHER_DWH
		and [parentclassificatorid] is null
	declare @precparentlink int
	set @precparentlink = @parentlink

	insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
	select @parentlink, replicate('0', 4 - len(ltrim(rtrim(str([link]))))) + ltrim(rtrim(str([link]))), [precname], '-', 1, 0, null, null, @DICTIONARY_OTHER_DWH, [row_id], @IMPORTID
	from @fields

	--   
	insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
	select CS.[classificatorid], @version, 0
	from [dbo].[Classificators] CS inner join @fields F on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH

	--  ""
	update [dbo].[ClassificatorProperty]
		set [Ch_guid] = newid()
	where [ClassificatorID] = @parentlink

	update F
		set [classificatorid] = CS.[classificatorid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID

	--  
	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select F.[classificatorid], F.[razdel], F.[row_id], CA.[clattrid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select F.[classificatorid], F.[statia], F.[row_id], CA.[clattrid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select F.[classificatorid], F.[chast], F.[row_id], CA.[clattrid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select F.[classificatorid], F.[punkt], F.[row_id], CA.[clattrid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select F.[classificatorid], F.[podpunkt], F.[row_id], CA.[clattrid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select F.[classificatorid], F.[abzac], F.[row_id], CA.[clattrid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select F.[classificatorid], F.[glava], F.[row_id], CA.[clattrid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select F.[classificatorid], F.[podstatia], F.[row_id], CA.[clattrid]
	from @fields F inner join [dbo].[Classificators] CS on F.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	update P
		set [precid] 	= F.[classificatorid],
			[precrowid] = F.[row_id]
	from @precs P inner join @fields F on isnull(P.[razdel],'') = isnull(F.[razdel],'') and isnull(P.[glava],'') = isnull(F.[glava],'')
		and isnull(P.[statia],'') = isnull(F.[statia],'') and isnull(P.[punkt],'') = isnull(F.[punkt],'') and isnull(P.[abzac],'') = isnull(F.[abzac],'')
		and isnull(P.[chast],'') = isnull(F.[chast],'') and isnull(P.[podpunkt],'') = isnull(F.[podpunkt],'') and isnull(P.[podstatia],'') = isnull(F.[podstatia],'')

	declare @npa table
	(	[link]			int identity(128,1),
		[classificatorid] int,
		[npalink]		int,
		[npacode]		varchar(100),
		[npaname]		varchar(6000),
		[npadate]		datetime,
		[npadatebegin]	datetime,
		[npadateend]	datetime,
		[npaclevel]		varchar(25),
		[npactype]		varchar(254),
		[row_id]		uniqueidentifier default newid()
	)

	insert into @npa([npalink])
	select distinct [npalink] from @precs

	update N
		set [npacode] = P.[npacode],
			[npaname] = P.[npaname],
			[npadate] = P.[npadate],
			[npadatebegin] = P.[npadatebegin],
			[npadateend] = P.[npadateend],
			[npaclevel]	 = P.[npaclevel],
			[npactype]	 = P.[npactype]
	from @npa N inner join @precs P on N.[npalink] = P.[npalink]

	set @parentcode = ''
	select @parentlink = [classificatorid] from [dbo].[Classificators] where [classificatorcode] = @parentcode and [name] = @parentcode and [object] = @DICTIONARY_OTHER_DWH
		and [parentclassificatorid] is null

	declare @npaparentlink int
	set @npaparentlink = @parentlink

	insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
	select @parentlink, rtrim(ltrim(str([link]))), left([npaname],1000), left([npaname],2000), 1, 0, null, null, @DICTIONARY_OTHER_DWH, [row_id], @IMPORTID
	from @npa

	--   
	insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
	select CS.[classificatorid], @version, 0
	from [dbo].[Classificators] CS inner join @npa N on N.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH

	--  ""
	update [dbo].[ClassificatorProperty]
		set [Ch_guid] = newid()
	where [ClassificatorID] = @parentlink

	update N
		set [classificatorid] = CS.[classificatorid]
	from @npa N inner join [dbo].[Classificators] CS on N.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID

	--  
	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select N.[classificatorid], N.[npacode], N.[row_id], CA.[clattrid]
	from @npa N inner join [dbo].[Classificators] CS on N.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select N.[classificatorid], convert(varchar(10), N.[npadate], 104), N.[row_id], CA.[clattrid]
	from @npa N inner join [dbo].[Classificators] CS on N.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select N.[classificatorid], convert(varchar(10), N.[npadatebegin], 104), N.[row_id], CA.[clattrid]
	from @npa N inner join [dbo].[Classificators] CS on N.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ' '

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select N.[classificatorid], convert(varchar(10), N.[npadateend], 104), N.[row_id], CA.[clattrid]
	from @npa N inner join [dbo].[Classificators] CS on N.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ' '

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select N.[classificatorid], N.[npactype], N.[row_id], CA.[clattrid]
	from @npa N inner join [dbo].[Classificators] CS on N.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid])
	select N.[classificatorid], N.[npaclevel], N.[row_id], CA.[clattrid]
	from @npa N inner join [dbo].[Classificators] CS on N.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ' '

	update P
		set [npaid] = N.[classificatorid]
	from @precs P inner join @npa N on P.[npalink] = N.[npalink]

	declare @npaprecs table
	(	
		[link]	int identity(1,1),
		[classificatorid] int,
		[npaid]		int,
		[precid]	int,
		[name] varchar(1000),
		[description] varchar(2000),
		[row_id]	uniqueidentifier default newid()
	)

	insert into @npaprecs([npaid],[precid])
	select distinct [npaid], [precid] from @precs

	update NP
		set [name] = left(isnull('' + P.[npacode],'') + isnull('  ' + convert(varchar(12), P.[npadate], 104),'') + ' ' + P.[npaname] + ' ' + P.[precname],1000),
			[description] = left(isnull('' + P.[npacode],'') + isnull('  ' + convert(varchar(12), P.[npadate], 104),'') + ' ' + P.[npaname] + ' ' + P.[precname],2000)
	from @npaprecs NP inner join @precs P on NP.[npaid] = P.[npaid] and NP.[precid] = NP.[precid]

	set @parentcode = '  '
	select @parentlink = [classificatorid] from [dbo].[Classificators] where [classificatorcode] = @parentcode and [object] = @DICTIONARY_OTHER_DWH
		and [parentclassificatorid] is null

	insert into [dbo].[Classificators]([ParentClassificatorId],[ClassificatorCode],[name],[description],[type],[IsAggregatable],[Level],[LoadFlag],[object],[row_id],[import_id])
	select @parentlink, str([link]), [name], [description], 1, 0, null, null, @DICTIONARY_OTHER_DWH, [row_id], @IMPORTID
	from @npaprecs

	--   
	insert into [dbo].[T_VERSION]([classificatorid],[versionid],[deleted])
	select distinct CS.[classificatorid], @version, 0
	from [dbo].[Classificators] CS inner join @npaprecs P on P.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
	where not exists(select * from [dbo].[T_VERSION] where [classificatorid] = CS.[classificatorid] and [versionid] = @version)

	--  ""
	update [dbo].[ClassificatorProperty]
		set [Ch_guid] = newid()
	where [ClassificatorID] = @parentlink

	update P
		set [classificatorid] = CS.[classificatorid]
	from @npaprecs P inner join [dbo].[Classificators] CS on P.[row_id] = CS.[row_id] and CS.[import_id] = @IMPORTID

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid],[orders])
	select P.[classificatorid], P.[npaid], null, CA.[clattrid], 1
	from @npaprecs P inner join [dbo].[Classificators] CS on P.[classificatorid] = CS.[classificatorid] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid],[orders])
	select P.[classificatorid], P.[precid], null, CA.[clattrid], 1
	from @npaprecs P inner join [dbo].[Classificators] CS on P.[classificatorid] = CS.[classificatorid] and CS.[import_id] = @IMPORTID and CS.[object] = @DICTIONARY_OTHER_DWH
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''

	insert into [dbo].[Classificators_app]([classificatorid],[value],[row_id],[clattrid],[orders])
	select distinct P.[polnid], P.[classificatorid], null, CA.[clattrid], row_number() over (order by P.[polnid] asc, P.[classificatorid] asc)
	from @precs P inner join [dbo].[Classificators] CS on P.[polnid] = CS.[classificatorid]
		inner join [dbo].[Classificators_attr] CA on CS.[parentclassificatorid] = CA.[classificatorid] and CA.[name] = ''
	where not exists(select * from [dbo].[Classificators_App] where [classificatorid] = P.[polnid] and [clattrid] = CA.[clattrid])
end

GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8040' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'IMPORTRROBKS'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[GetLastImportLog]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[GetLastImportLog]
GO



CREATE PROCEDURE [dbo].[GetLastImportLog]
	@import_id uniqueidentifier = null
AS
BEGIN
	
	SET NOCOUNT ON;
   
    select id as link,
    case i.run_status when 1 then '' else ' ' end as [Status], 
	s.name as Template, i.starttime as Start, i.endtime as [End], i.msg as Msg, 
	i.[summary] as summary, i.import_id as import_id
	from importlog i inner join ssistemplate s on i.ssis_template = s.link
	where i.import_id = @import_id
    
end
GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8110' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'GETLASTIMPORTLOG'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ImportLogUpdate]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ImportLogUpdate]
GO


CREATE PROCEDURE [dbo].[ImportLogUpdate]
	@action bit,  -- 0 - start 1 - end
	@run_status int = null,
	@ssis_template int = null,
	@summary varchar(1024) = null,
	@msg varchar(max) = null,
	@import_id uniqueidentifier = null,
	@id int output	
AS
BEGIN

	SET NOCOUNT ON;
	
	declare @time datetime
	set @time = getdate()
	
	if  (@action = 0 and @ssis_template is null) or
		(@action = 1 and (@run_status is null or @id is null))
	begin
		raiserror('    [ImportLogUpdate]', 16,1)
		return
	end
	
	if @action = 0
	begin	
		insert into ImportLog(ssis_template, starttime, summary, userid)
		values(@ssis_template, @time, @summary, user_id(suser_sname()))
		set @id = scope_identity()
	end	
	else
		update ImportLog
		set run_status = @run_status, endtime = @time, msg = @msg, import_id = @import_id
		where id = @id
END
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8195' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'IMPORTLOGUPDATE'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ExecImport_inner]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ExecImport_inner]
GO


CREATE PROCEDURE [dbo].[ExecImport_inner]
	@ssisTemplateLink int,
	@mode int  = 0,
	@import_id uniqueidentifier
/*
	mode
		0 - execute
		1 - debug
*/
AS
BEGIN
	
	SET NOCOUNT ON;
 
	declare @importType varchar(250), @version varchar(250)
	select top 1 @importType = [value] from [SSISTemplateDescription] where parameter = 'DS_TYPE' and link_up = @ssisTemplateLink
	if isnull(@importType, '') = ''
	begin
		raiserror('    -  ',16,1)
		return
	end
	
	select top 1 @version = [value] from [SSISTemplateDescription] where parameter = 'VERSION_ID' and link_up = @ssisTemplateLink
	if not exists(select * from version where dbo.obj_name(object)='' and versionid = @version)
	begin
		raiserror('     .',16,1)
		return
	end
	
	BEGIN
		declare @FMask varchar(400), @FPath varchar(400), @deleteFiles varchar(7)
		select top 1 @FMask = isnull([value],'')from [SSISTemplateDescription] where [parameter] = 'FILE_FileMask' and link_up = @ssisTemplateLink
		select top 1 @FPath  = isnull([value],'')from [SSISTemplateDescription] where [parameter] = 'FILE_FilePath' and link_up = @ssisTemplateLink							
		select top 1 @deleteFiles  = isnull([value],'')from [SSISTemplateDescription] where [parameter] = 'FILE_DeleteFilesAfterImport' and link_up = @ssisTemplateLink							
		IF @importType = 'LOADFILES'
		BEGIN
			--   xml
			EXEC LoadFile @FMask, @FPath
		END
		ELSE
		BEGIN
			declare @id int, @summary varchar(1024),@run_status int, @message varchar(max)
			set @summary = dbo.GetSSISTemplateSummary(@ssisTemplateLink)
			set @run_status = 0
			exec ImportLogUpdate @action = 0, @run_status = 0, @ssis_template = @ssisTemplateLink, 
					@summary = @summary, @id = @id output
			
			begin try		
			
			--   
				IF @importType = 'LoadFilterStrings'
				BEGIN									 		
					exec dbo.ImportFilterStringsNew @ssisTemplateLink, @import_id
				END			
				ELSE		
				begin												
					if @importType = 'RRODBF'
					begin
						exec ImportRRODBF @ssisTemplateLink, @import_id
					end
					else
					begin
						if @importType = 'RROXML'
						begin
							exec ImportRROXML @ssisTemplateLink, @import_id
						end
						else
						begin
							if @importType = 'PPBKS'
							begin
								exec ImportPPBKS @ssisTemplateLink
							end
							else
							begin
								if @importType = 'BKSModel'
								begin
									exec dbo.ImportBKSModel @ssisTemplateLink, @import_id
								end	
								else
								begin
									if @importType = 'BKSDocs'
									begin
										exec dbo.ImportBKSDoc @ssisTemplateLink
									end
									else
									begin
										if @importType = 'Syncronize'
										begin
											exec dbo.NSISyncronize @ssisTemplateLink
										end
										else
										begin
											if @importType = 'BKSReporting'
											begin
												exec dbo.ImportBKSReport @ssisTemplateLink, @import_id
											end
											else
											begin
												if @importType = 'AnyXML'
												begin
													exec dbo.ImportAnyXml @ssisTemplateLink, @import_id
												end
												else
												begin
													exec CustomImport @ssisTemplateLink, @import_id, @mode
												end
											end	
										end
									end
								end
							end
						end
					end									
				END
				
			if (@deleteFiles='True')
			begin				
				EXEC DeleteFiles @FPath, @FMask
			end
			
			set @run_status = 1
			end try
			begin catch
				set @message = error_message()
			end catch
			declare @msg varchar(max)
			if (exists (select *from fileloadedhash where import_id=@import_id))
			begin
				select  @msg = isnull(@msg, '') + '
 :'
				select  @msg = @msg + '
'+ name  from fileloadedhash where import_id = @import_id and successload=1
				select  @msg = @msg + '
				
,   :'
				select  @msg = @msg + '
'+ name  from fileloadedhash where import_id = @import_id and successload=-1
			end	
			
			select @msg = isnull(@message, '') + isnull(@msg, '')

			if (exists (select *from IMportLogSteps where import_id=@import_id))
			begin
				select  @msg = isnull(@msg, '') + '
				
 :'
				select  @msg = @msg + '
'+ [message] from IMportLogSteps where import_id = @import_id order by id				
			end				
			
			exec ImportLogUpdate @action = 1, @run_status = @run_status, @msg = @msg, @import_id = @import_id, @id = @id
			if len(isnull(@message,''))>0
			begin
				raiserror(@message,16,1)
				return
			end
		end
	END
END
GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8146' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'EXECIMPORT_INNER'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ExecImport]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ExecImport]
GO


-- rev 1.5
CREATE PROCEDURE [dbo].[ExecImport] 
	@ssisTemplateLink int,
	@mode int  = 0,
	@import_id uniqueidentifier
/*
	mode
		0 - execute
		1 - debug
*/
AS
BEGIN
	
	SET NOCOUNT ON;

	if @ssisTemplateLink is null
		begin
			raiserror('    ExecImport', 16, 1)
			return
		end
	
    declare @result int
	declare @resourceName nvarchar(255), @lock_owner nvarchar(32)
	set @resourceName = dbo.ImportLockName()
	set @lock_owner = 'Session'
	
    exec @result = sp_getapplock @Resource = @resourceName, @LockMode = 'Exclusive', @LockOwner = @lock_owner
    if @result not in (0, 1)
	begin
		raiserror ( '  ', 16, 1 )
	end
	else
	begin
		begin try
			exec [ExecImport_inner] @ssisTemplateLink, @mode, @import_id
		end try
		begin catch
			exec sp_releaseapplock @Resource = @resourceName, @LockOwner = @lock_owner
			declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
			select @ErrorMessage = ERROR_MESSAGE(),	@ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE();
			raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState);
			return
		end catch 	
		exec sp_releaseapplock @Resource = @resourceName, @LockOwner = @lock_owner
	end	
END
GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8110' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'EXECIMPORT'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ExportAnyXmlCreateTXT]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ExportAnyXmlCreateTXT]
GO


CREATE PROCEDURE [dbo].[ExportAnyXmlCreateTXT]
	@root varchar(200),
	@rtf varchar(200),
	@cutvalue varchar(200),
	@Delimiter varchar(5),
	@DelimiterInEnd varchar(7),
	@part varchar(max) out,
	@checked bit out
AS
BEGIN
	
	SET NOCOUNT ON;			
		
	declare @part2 varchar(max), @script nvarchar(max), @cutelement varchar(200), @writeintofile varchar(200), @concat varchar(6), @checkcut varchar(200), @alias varchar(200)
	select @cutelement = cutelement, @writeintofile = writeintofile, @concat=concate, @checkcut=checkcut, 
			@alias = case when alias is null or alias = '' then name else alias end from #xmlitems where name=@root 
	select @part2 = ''
	
	if (@writeintofile = 'true' or exists(select * from #xmlitems where parent = @root and isattribute='true' and writeintofile='false'))
	begin
		select @script = 'select @part2='''' select @part2 = @part2     +' + case @writeintofile when 'false' then '' else ''''+@alias + @Delimiter+'''    +' end
		select @script = @script + 'isnull(' + name + ','''')+'''+ case delimafter when 'true' then '' else @Delimiter end + '''+'  from #xmlitems where parent = @root and isattribute='true' and writeintofile='false'
			order by number asc

		select @script = left(@script, len(@script)-case @DelimiterInEnd when 'true' then 1 else 5 end) + case @concat when 'false' then '+''
'' from ' else case @DelimiterInEnd when 'true' then '' else @Delimiter end + ' from ' end + @rtf	

		if @cutelement is not null and @cutelement<>''
		begin
			select @script = @script+ ' where ' + @cutelement + '=''' + @cutvalue+''''
		end

		EXEC sp_executesql @script, N'@part2 varchar(max) output', @part2 = @part2 OUTPUT	

		select @checked=1
		if(@checkcut='true' and (@part2 is null or @part2=''))
		begin
			select @checked=0
			return
		end
	end
	
	select * into #childxmlitems from #xmlitems where parent=@root and isattribute='false'	
	while(exists(select * from #childxmlitems))
	begin
			
		declare @name varchar(200), @rt varchar(600), @part1 varchar(max), @checked1 bit
		select @name = name, @rt=rtablename from #childxmlitems	order by number desc								
		exec ExportAnyXmlCreateTXT @name, @rt, @cutvalue, @Delimiter, @DelimiterInEnd, @part1 out, @checked1 out
		if (@checked1=0) 
		begin
			select @checked=0
			return
		end
		select @part2 = @part2 + @part1
		delete #childxmlitems where @rt=rtablename								
	end
	
	select @part = @part2
		
end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8552' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'EXPORTANYXMLCREATETXT'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[EXPORTTEMPLATE_DEL]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[EXPORTTEMPLATE_DEL]
GO

CREATE procedure [dbo].[EXPORTTEMPLATE_DEL]
as

set nocount on;


	declare @name varchar(250)  
	create table #used(link int)

	insert into #used(link)
	exec [dbo].[GET_SCHEDULED_EXPORTS]
	
	select top 1 @name = (select name from export_template where link = a.link)
	from #t_doc_links a where convert(int,a.link) in (select link from #used)
	if @@rowcount = 1
	begin
		raiserror(' "%s"   ',16,1,@name)
		return
	end
		
	delete from export_template where link in (select convert(int,link) from #t_doc_links)
	
GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8122' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'EXPORTTEMPLATE_DEL'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ImportRRODBF]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ImportRRODBF]
GO


CREATE PROCEDURE [dbo].[ImportRRODBF]
	@ssisTemplateLink int,
	@import_id uniqueidentifier
AS
BEGIN
	
	SET NOCOUNT ON;

	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[rro]') and type in (N'U'))
		drop table [KS_DDLControl].[rro]
	
	CREATE TABLE [KS_DDLControl].[rro](
	[link] [int] NULL,
	[number] [varchar](100) NULL,
	[date] [datetime] NULL,
	[name] [varchar](max) NULL,
	[obj_code] [varchar](30) NULL,
	[date_class] [datetime] NULL,
	[num_class] [varchar](20) NULL,
	[obj_class] [varchar](30) NULL,
	[date_first] [datetime] NULL,
	[date_last] [datetime] NULL,
	[summa] [numeric](19, 2) NULL,
	[orders] [int] NULL,
	[inn_corr] [varchar](13) NULL,
	[cppu_corr] [varchar](9) NULL,
	[cate] [varchar](max) null,
	[credit] [int] NULL,
	[note_obj] [varchar](30) NULL,
	[note_code] [varchar](50) NULL,
	[note_name] [varchar](254) NULL,
	[prim] [varchar](max) NULL)

	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m2rro]') and type in (N'U'))
		drop table [KS_DDLControl].[m2rro]
	
	CREATE TABLE [KS_DDLControl].[m2rro](
	[link_up] [int] NULL,
	[obj_code] [varchar](30) NULL,
	[summa] [numeric](19, 2) NULL,
	[date] [datetime] NULL,
	[credit] [int] NULL,
	[code_cr] [varchar](100) NULL,
	[name_cr] [varchar](max) NULL,
	[code_mtd] [varchar](100) NULL,
	[name_mtd] [text] NULL,
	[code_req] [varchar](50) NULL,
	[name_req] [varchar](254) NULL,
	[code_kbk] [varchar](20) NULL,
	[name_kbk] [text] NULL)

	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m3rro]') and type in (N'U'))
		drop table [KS_DDLControl].[m3rro]
	
	CREATE TABLE [KS_DDLControl].[m3rro](
	[link_up] [int] NULL,
	[obj_code] [varchar](22) NULL,
	[kbk_code] [varchar](20) NULL)

	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m4rro]') and type in (N'U'))
		drop table [KS_DDLControl].[m4rro]
	
	CREATE TABLE [KS_DDLControl].[m4rro](
	[link_up] [int] NULL,
	[credit] [int] NULL,
	[obj_code] [varchar](30) NULL,
	[objd_code] [varchar](30) NULL,
	[value] [varchar](254) NULL,
	[code] [varchar](50) NULL,
	[name] [varchar](254) NULL)

	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m5rro]') and type in (N'U'))
		drop table [KS_DDLControl].[m5rro]
	
	CREATE TABLE [KS_DDLControl].[m5rro](
	[link] [int] NULL,
	[number] [varchar](100) NULL,
	[name] [varchar](max) NULL,
	[date] [datetime] NULL,
	[link_class] [int] NULL,
	[obj_code] [varchar](50) NULL,
	[datef] [datetime] NULL,
	[datel] [datetime] NULL,
	[value] [varchar](254) NULL,
	[inn_corr] [varchar](13) NULL,
	[cppu_corr] [varchar](9) NULL,
	[credit] [int] NULL,
	[lev_code] [varchar](50) NULL)

	declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
	begin try
		exec [LoadDBFData] @ssisTemplateLink, null, '[KS_DDLControl].[rro]'
		exec [LoadDBFData] @ssisTemplateLink, null, '[KS_DDLControl].[m2rro]'
		exec [LoadDBFData] @ssisTemplateLink, null, '[KS_DDLControl].[m3rro]'
		exec [LoadDBFData] @ssisTemplateLink, null, '[KS_DDLControl].[m4rro]'
		exec [LoadDBFData] @ssisTemplateLink, null, '[KS_DDLControl].[m5rro]'
	end try
	begin catch
		
		select @ErrorMessage = '   dbf :'+ERROR_MESSAGE(),	@ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE();
		
			if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[rro]') and type in (N'U'))
				drop table [KS_DDLControl].[rro]
			if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m2rro]') and type in (N'U'))
				drop table [KS_DDLControl].[m2rro]
			if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m3rro]') and type in (N'U'))
				drop table [KS_DDLControl].[m3rro]
			if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m4rro]') and type in (N'U'))
				drop table [KS_DDLControl].[m4rro]
			if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m5rro]') and type in (N'U'))
				drop table [KS_DDLControl].[m5rro]
		
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState);
		return
	end catch
--
	begin try
		begin transaction
		exec dbo.ImportRRODBF_inner @ssisTemplateLink, @import_id
		update fileloadedhash set successload = 1 where successload = 0 and import_id = @import_id
		commit transaction
	end try
	begin catch
		select @ErrorMessage = '  (dbf) :'+ERROR_MESSAGE(),	@ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE();
		if @@trancount > 0 rollback	transaction
		if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[rro]') and type in (N'U'))
			drop table [KS_DDLControl].[rro]
		if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m2rro]') and type in (N'U'))
			drop table [KS_DDLControl].[m2rro]
		if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m3rro]') and type in (N'U'))
			drop table [KS_DDLControl].[m3rro]
		if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m4rro]') and type in (N'U'))
			drop table [KS_DDLControl].[m4rro]
		if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m5rro]') and type in (N'U'))
			drop table [KS_DDLControl].[m5rro]
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState);
		return
	end catch
	
	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[rro]') and type in (N'U'))
		drop table [KS_DDLControl].[rro]
	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m2rro]') and type in (N'U'))
		drop table [KS_DDLControl].[m2rro]
	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m3rro]') and type in (N'U'))
		drop table [KS_DDLControl].[m3rro]
	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m4rro]') and type in (N'U'))
		drop table [KS_DDLControl].[m4rro]
	if  exists (select * from sys.objects where object_id = object_id(N'[KS_DDLControl].[m5rro]') and type in (N'U'))
		drop table [KS_DDLControl].[m5rro]
END
GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'7968' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'IMPORTRRODBF'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ImportRROXML]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[ImportRROXML]
GO


CREATE PROCEDURE [dbo].[ImportRROXML]
	@ssisTemplateLink int,
	@import_id uniqueidentifier
AS
BEGIN
	
	SET NOCOUNT ON;

    declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int

	declare @plan_prev int, @fact_prev int, @plan_curr int, @plan_next int, @plan_next_1 int, @plan_next_2 int

	select top 1 @plan_prev = convert(int,value) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'plan_prev'
	if not exists(select 1 from measures where measureid = @plan_prev)
	begin
		raiserror('   "%s"',16,1,'  ')
		return
	end
	select top 1 @fact_prev = convert(int,value) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'fact_prev'
	if not exists(select 1 from measures where measureid = @plan_prev)
	begin
		raiserror('   "%s"',16,1,'  ')
		return
	end
	select top 1 @plan_curr = convert(int,value) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'plan_curr'
	if not exists(select 1 from measures where measureid = @plan_prev)
	begin
		raiserror('   "%s"',16,1,'  ')
		return
	end
	select top 1 @plan_next = convert(int,value) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'plan_next'
	if not exists(select 1 from measures where measureid = @plan_prev)
	begin
		raiserror('   "%s"',16,1,'  ')
		return
	end
	select top 1 @plan_next_1 = convert(int,value) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'plan_next_1'
	if not exists(select 1 from measures where measureid = @plan_prev)
	begin
		raiserror('   "%s"',16,1,' (+1) ')
		return
	end
	select top 1 @plan_next_2 = convert(int,value) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'plan_next_2'
	if not exists(select 1 from measures where measureid = @plan_prev)
	begin
		raiserror('   "%s"',16,1,' (+2) ')
		return
	end

	declare @path nvarchar(1000),@path2 nvarchar(254), @file varchar(max), @xml xml, @isRemoteMode varchar(10), @codepage int, @checkrepeatload int	

	select top 1 @path = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_FilePath'
	select top 1 @path2 = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_FileMask'
	select top 1 @isRemoteMode = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'IsRemoteMode'
	select @checkrepeatload = case value when 'True' then 1 else 0 end from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CheckRepeatImport'	
	declare @cachres int
	exec dbo.DoFileCach @path, @path2, @checkrepeatload,  @cachres out
	if (@cachres = 0) return
	
	if exists(select * from SSISTemplateDescription where parameter='UseProxy' and link_up=@ssisTemplateLink and value = 'False')
		select @isremotemode = 'False'
	if (exists(select * from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CodePage'))
	begin
		select @codepage = value from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'FILE_CodePage'		
	end
	
	if isnull(@path,'')=''
	begin
		set @path = @path2
	end
	else
	begin
		set @path = @path + case when substring(@path,len(@path),1)='\' then '' else '\' end + @path2
	end
	
	if isnull(@path2,'')=''
	begin
		raiserror('    ',16,1)
		return
	end

	if (@isRemoteMode = 'True')
	begin
		select @path = hashcode from SSISTemplateUploadFileLinks where link_up = @ssisTemplateLink and used = 1
		if (@path is null or @path = '')
		begin
			raiserror('      ',16,1)
			return
		end
		update SSISTemplateUploadFileLinks set used = 1 where link_up = @ssisTemplateLink and @path = hashcode
		select @path = dbo.get_val('NASTR_UPLOAD_FILES_PATH','CHAR_VALUE',0) + '\' + @path
	end

	exec ReadXML @path, @file output, @codepage
	
	set @xml = convert(xml,@file)
	
	DECLARE @idoc int
	EXEC sp_xml_preparedocument @idoc OUTPUT, @xml, '<PacketED xmlns:myns="urn:mfrf-ru:ed:v2.0"/>'

	create table #t1(id int,gr0 varchar(50),gr1 varchar(1000),gr2 varchar(9),gr3 varchar(255),
						gr10 numeric(27,10),gr11 numeric(27,10),gr12 numeric(27,10),gr13 numeric(27,10),gr14 numeric(27,10),gr15 numeric(27,10),gr16 varchar(1024)
						,soder_link int, prim_link int)
	insert #t1(id,gr0,gr1,gr2,gr3,gr10,gr11,gr12,gr13,gr14,gr15,gr16)
	SELECT id,dbo.RegExALLfresh(gr0),dbo.RegExALLfresh(gr1),dbo.RegExALLfresh(gr2),dbo.RegExALLfresh(gr3),gr10,gr11,gr12,gr13,gr14,gr15,dbo.RegExALLfresh(gr16)
	FROM OPENXML (@idoc, '/myns:PacketED/myns:ED58701/myns:StrR01')
	with
	(
		id int '@mp:id',
		gr0 varchar(50) '@Gr0',
		gr1 varchar(1000) '@Gr1',
		gr2 varchar(9) '@Gr2',
		gr3 varchar(255) '@Gr3',
		gr10 numeric(27,10) '@Gr10',
		gr11 numeric(27,10) '@Gr11',
		gr12 numeric(27,10) '@Gr12',
		gr13 numeric(27,10) '@Gr13',
		gr14 numeric(27,10) '@Gr14',
		gr15 numeric(27,10) '@Gr15',
		gr16 varchar(1024) '@Gr16'
	)

	create table #t12(parent_id int,brank char(1),bclass varchar(255),bdate varchar(1000),bnumb varchar(255),
						bname varchar(1000),brubric varchar(50),bsubpar varchar(50),bparagr varchar(50),
						bpart varchar(50),bparticle varchar(50),bdatebeg varchar(1000),
						bdateend varchar(1000), rnk int, npa_link int, vypnpa_link int)
	insert #t12(parent_id,brank,bclass,bdate,bnumb,bname,brubric,bsubpar,bparagr,
						bpart,bparticle,bdatebeg,bdateend,rnk)
	SELECT 
		parent_id,brank,dbo.RegExALLfresh(bclass),convert(varchar(20),bdate,104),dbo.RegExALLfresh(bnumb),dbo.RegExALLfresh(bname),dbo.RegExALLfresh(brubric),dbo.RegExALLfresh(bsubpar),
						dbo.RegExALLfresh(bparagr),	dbo.RegExALLfresh(bpart),dbo.RegExALLfresh(bparticle),
						convert(varchar(20),case bdatebeg when '20090101' then null else bdatebeg end,104),convert(varchar(20),bdateend,104),
		row_number() over (partition by parent_id order by parent_id) as rnk
	FROM OPENXML (@idoc, '/myns:PacketED/myns:ED58701/myns:StrR01/myns:Bill')
	with
	(
		parent_id int '@mp:parentid',
		brank char(1) '@BRank',
		bclass varchar(255) '@BClass',
		bdate  datetime '@BDate',
		bnumb varchar(255) '@BNumb',
		bname varchar(1000) '@BName',
		brubric varchar(50) '@BRubric',
		bsubpar varchar(50) '@BSubpar',
		bparagr varchar(50) '@BParagr',
		bpart varchar(50) '@BPart',
		bparticle varchar(50) '@BParticle',
		bdatebeg datetime '@BDateBeg',
		bdateend datetime '@BDateEnd'
	)

	insert #t1(id,gr0,gr1,gr2,gr3,gr10,gr11,gr12,gr13,gr14,gr15,gr16)
	SELECT id,dbo.RegExALLfresh(gr0),dbo.RegExALLfresh(gr1),dbo.RegExALLfresh(gr2),dbo.RegExALLfresh(gr3),gr13,gr14,gr15,gr16,gr17,gr18,dbo.RegExALLfresh(gr19)
	FROM OPENXML (@idoc, '/myns:PacketED/myns:ED58702/myns:StrR02')
	with
	(
		id int '@mp:id',
		gr0 varchar(50) '@Gr0',
		gr1 varchar(1000) '@Gr1',
		gr2 varchar(9) '@Gr2',
		gr3 varchar(255) '@Gr3',
		gr13 numeric(27,10) '@Gr13',
		gr14 numeric(27,10) '@Gr14',
		gr15 numeric(27,10) '@Gr15',
		gr16 numeric(27,10) '@Gr16',
		gr17 numeric(27,10) '@Gr17',
		gr18 numeric(27,10) '@Gr18',
		gr19 varchar(1024) '@Gr19'
	)

	insert #t12(parent_id,brank,bclass,bdate,bnumb,bname,brubric,bsubpar,bparagr,
						bpart,bparticle,bdatebeg,bdateend,rnk)
	SELECT 
		parent_id,brank,dbo.RegExALLfresh(bclass),convert(varchar(20),bdate,104),dbo.RegExALLfresh(bnumb),dbo.RegExALLfresh(bname),dbo.RegExALLfresh(brubric),dbo.RegExALLfresh(bsubpar),
		dbo.RegExALLfresh(bparagr),dbo.RegExALLfresh(bpart),dbo.RegExALLfresh(bparticle),convert(varchar(20),bdatebeg,104),convert(varchar(20),bdateend,104),
		row_number() over (partition by parent_id order by parent_id) as rnk
	FROM OPENXML (@idoc, '/myns:PacketED/myns:ED58702/myns:StrR02/myns:Bill')
	with
	(
		parent_id int '@mp:parentid',
		brank char(1) '@BRank',
		bclass varchar(255) '@BClass',
		bdate  datetime '@BDate',
		bnumb varchar(255) '@BNumb',
		bname varchar(1024) '@BName',
		brubric varchar(50) '@BRubric',
		bsubpar varchar(50) '@BSubpar',
		bparagr varchar(50) '@BParagr',
		bpart varchar(50) '@BPart',
		bparticle varchar(50) '@BParticle',
		bdatebeg datetime '@BDateBeg',
		bdateend datetime '@BDateEnd'
	)

	EXEC sp_xml_removedocument @idoc

	--select * from #t1
	--select * from #t12

	select 
		a.id, b.value,row_number() over (partition by a.id order by a.id) as part_id,
		convert(int,null) as div_link
	into #t111 
	from #t1 a cross apply dbo.StrSplit2(a.gr3,',') b 
	where isnull(b.value,'') != ''

	--select * from #t111

	--select * from #t3

	declare @version int, @dsid int, @date datetime, @vmode int, @doc_date datetime
	set @date = getdate()

	select top 1 @vmode = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'V_MODE'
	select top 1 @version = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'VERSION_ID'
	select top 1 @dsid = convert(int,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_ID'
	begin try
		select top 1 @doc_date = convert(datetime,[value]) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DATE'
		if @doc_date is null
			raiserror('   ',16,1)
	end try
	begin catch
		select @ErrorMessage = error_message()
		raiserror('    "%s"',16,1,@ErrorMessage)
		return
	end catch

	declare @clid_prim int, @clid_division int, @clid_soder int, @clid_npa int, @clid_vypnpa int
	
	declare @object int
	set @object = dbo.obj_id('DICTIONARY_OTHER_DWH')
	declare @attr_id int
	
	select top 1 @clid_prim = classificatorid from classificators where parentclassificatorid is null and [name] = ' -   '
	if @clid_prim is null
	begin
		insert into classificators(classificatorcode,[name],description,type,[object])
		values(' - ',' -   ',' -   ',1, @object)
		select top 1 @clid_prim = classificatorid from classificators where parentclassificatorid is null and [name] = ' -   '
	end

	select top 1 @clid_division = classificatorid from classificators where parentclassificatorid is null and classificatorcode = 'DICTIONARY_DIVISION_DWH'
	if @clid_division is null
	begin
		insert into classificators(classificatorcode,[name],description,type,[object])
		values('DICTIONARY_DIVISION_DWH','','',1, dbo.obj_id('DICTIONARY_DIVISION_DWH'))
		select top 1 @clid_division = classificatorid from classificators where parentclassificatorid is null and classificatorcode = 'DICTIONARY_DIVISION_DWH'
	end

	select top 1 @clid_soder = classificatorid from classificators where parentclassificatorid is null and [name] = ' -  '
	if @clid_soder is null
	begin
		insert into classificators(classificatorcode,[name],description,type,[object])
		values(' - ',' -  ',' -  ',1, @object)
		select top 1 @clid_soder = classificatorid from classificators where parentclassificatorid is null and [name] = ' -  '
		insert into classificators_attr(name,classificatorid) values ('',@clid_soder)
	end

	select top 1 @clid_npa = classificatorid from classificators where parentclassificatorid is null and [name] = '  '
	if @clid_npa is null
	begin
		insert into classificators(classificatorcode,[name],description,type,[object])
		values('','  ','  ',1, @object)
		select top 1 @clid_npa = classificatorid from classificators where parentclassificatorid is null and [name] = '  '
		insert into classificators_attr(name,classificatorid) values ('',@clid_npa)
		insert into classificators_attr(name,classificatorid) values ('',@clid_npa)
		insert into classificators_attr(name,classificatorid) values (' ',@clid_npa)
		insert into classificators_attr(name,classificatorid) values (' ',@clid_npa)
		insert into classificators_attr(name,classificatorid) values (' ',@clid_npa)
		insert into classificators_attr(name,classificatorid) values ('',@clid_npa)
	end

	select top 1 @clid_vypnpa = classificatorid from classificators where parentclassificatorid is null and [name] = '  '
	if @clid_vypnpa is null
	begin
		insert into classificators(classificatorcode,[name],description,type,[object])
		values('  ','  ','  ',1, @object)
		select top 1 @clid_vypnpa = classificatorid from classificators where parentclassificatorid is null and [name] = '  '
		insert into classificators_attr(name,classificatorid) values ('',@clid_vypnpa)
		insert into classificators_attr(name,classificatorid) values ('',@clid_vypnpa)
		insert into classificators_attr(name,classificatorid) values ('',@clid_vypnpa)
		insert into classificators_attr(name,classificatorid) values ('',@clid_vypnpa)
	end

	declare @add int
	set @add = 0
	
	create table #L_prim([name] varchar(1000), addflag uniqueidentifier)
	insert #L_prim([name]) select distinct left(gr16,1000) from #t1
	create table #C_prim(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024))
	insert #C_prim(classificatorid, parentclassificatorid, classificatorcode, [name], [description])
	exec select_cl_elems @version, @clid_prim, 0, '<list><id val="-1"/><id val="-2"/><id val="-3"/></list>'

--	delete #L_prim where [name] is null
--	delete #C_prim where [name] is null

	update #L_prim
	set addflag = newid()
	where not exists(select * from #C_prim ce where isnull(#L_prim.name,'') = isnull(ce.name,''))
	set @add = @add + @@rowcount

	---

	create table #L_division([code] varchar(30), addflag uniqueidentifier)
	insert into #L_division(code)
	select distinct left(value,30) from #t111

	create table #C_division(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024))
	insert into #C_division(classificatorid, parentclassificatorid, classificatorcode, [name], [description])
	exec select_cl_elems @version, @clid_division, 0, '<list><id val="-1"/><id val="-2"/><id val="-3"/></list>'

	delete #L_division where [code] is null
	delete #C_division where [classificatorcode] is null

	update #L_division
	set addflag = newid()
	where not exists(select * from #C_division ce where #L_division.code = ce.classificatorcode)
	set @add = @add + @@rowcount

	--soder
	if not exists(select * from classificators_attr where classificatorid = @clid_soder and [name] = '')
	begin
		raiserror('      -  ',16,1) 
		return
	end

	create table #L_soder([code] varchar(30), [name] varchar(1000), [description] varchar(2000), codestr varchar(4000), addflag uniqueidentifier)
	insert into #L_soder(code, [name], [description], codestr)
	select distinct left(gr2,30), left(gr1,1000), left(gr1,1000), gr0 from #t1

	create table #C_soder(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(2000), codestr varchar(4000))
	insert into #C_soder(classificatorid, parentclassificatorid, classificatorcode, [name], [description], codestr)
	exec select_cl_elems @version, @clid_soder, 1, '<list><id val=""/><id val=""/><id val=""/><id val=""/></list>'

--	update #L_soder
--	set codestr = ''
--	where codestr is null
--
--	update #C_soder
--	set codestr = ''
--	where codestr is null
--
--	update #L_soder
--	set code = ''
--	where code is null
--
--	update #C_soder
--	set classificatorcode = ''
--	where classificatorcode is null
--	
--	update #L_soder
--	set name = ''
--	where name is null
--
--	update #C_soder
--	set name = ''
--	where name is null

	update #L_soder
	set addflag = newid()
	where not exists(select * from #C_soder ce where isnull(#L_soder.code,'') = isnull(ce.classificatorcode,'') 
				and isnull(#L_soder.codestr,'') = isnull(ce.codestr,''))
	set @add = @add + @@rowcount

	--npa
	if not exists(select * from classificators_attr where classificatorid = @clid_npa and [name] = '')
	begin
		raiserror('     ',16,1) 
		return
	end

	if not exists(select * from classificators_attr where classificatorid = @clid_npa and [name] = '')
	begin
		raiserror('     ',16,1) 
		return
	end

	if not exists(select * from classificators_attr where classificatorid = @clid_npa and [name] = ' ')
	begin
		raiserror('      ',16,1) 
		return
	end

	if not exists(select * from classificators_attr where classificatorid = @clid_npa and [name] = ' ')
	begin
		raiserror('      ',16,1) 
		return
	end

	if not exists(select * from classificators_attr where classificatorid = @clid_npa and [name] = ' ')
	begin
		raiserror('      ',16,1) 
		return
	end

	if not exists(select * from classificators_attr where classificatorid = @clid_npa and [name] = '')
	begin
		raiserror('      ',16,1) 
		return
	end

	create table #L_npa([code] varchar(30), [name] varchar(1000), [description] varchar(1000), date varchar(1000), 
	number varchar(4000), vid varchar(4000), lvl varchar(4000), beginD varchar(1000), endD varchar(1000), addflag uniqueidentifier)

	insert into #L_npa(number, [name], beginD, endD, date, lvl, vid)
	select distinct bnumb,left(bname,1000),bdatebeg,bdateend,bdate,brank,bclass  from #t12 

	create table #C_npa(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024), date varchar(1000), 
	number varchar(4000), vid varchar(4000), lvl varchar(4000), beginD varchar(1000), endD varchar(1000))
	insert into #C_npa(classificatorid, parentclassificatorid, classificatorcode, [name], [description], date, number, vid, lvl, beginD, endD)
	exec select_cl_elems @version, @clid_npa, 1, '<list><id val=""/><id val=""/><id val=""/><id val=""/>
			<id val=""/><id val=""/><id val=" "/><id val=" "/><id val=" "/></list>'

--	update #L_npa
--	set number = ''
--	where number is null
--
--	update #L_npa
--	set lvl = ''
--	where lvl is null
--
--	update #L_npa
--	set vid = ''
--	where vid is null
--	
--	update #L_npa
--	set date = ''
--	where date is null
--
--	update #C_npa
--	set number = ''
--	where number is null
--
--	update #C_npa
--	set lvl = ''
--	where lvl is null
--
--	update #C_npa
--	set vid = ''
--	where vid is null
--	
--	update #C_npa
--	set date = ''
--	where date is null
	
	update #L_npa
	set addflag = newid()
	where not exists(select * from #C_npa ce where isnull(#L_npa.number,'') = isnull(ce.number,'') 
		and isnull(#L_npa.lvl,'') = isnull(ce.lvl,'') and isnull(#L_npa.vid,'') = isnull(ce.vid,'') 
		and isnull(#L_npa.date,'') = isnull(ce.date,''))
	set @add = @add + @@rowcount
	
	---
	if not exists(select * from classificators_attr where classificatorid = @clid_vypnpa and [name] = '')
	begin
		raiserror('       ',16,1)
		return
	end
	
	if not exists(select * from classificators_attr where classificatorid = @clid_vypnpa and [name] = '')
	begin
		raiserror('       ',16,1) 
		return
	end
	
	if not exists(select * from classificators_attr where classificatorid = @clid_vypnpa and [name] = '')
	begin
		raiserror('       ',16,1) 
		return
	end
	
	if not exists(select * from classificators_attr where classificatorid = @clid_vypnpa and [name] = '')
	begin
		raiserror('       ',16,1) 
		return
	end

	create table #L_vypnpa([code] varchar(30), [name] varchar(1000), [description] varchar(1000),
	razdel varchar(4000), stat varchar(4000), punkt varchar(4000), podpunkt varchar(4000), addflag uniqueidentifier)

	insert into #L_vypnpa([name], razdel, stat, punkt, podpunkt)
	select distinct '',brubric,bparticle,bparagr,bsubpar
	from #t12

	create table #C_vypnpa(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024),razdel varchar(4000), stat varchar(4000), punkt varchar(4000), podpunkt varchar(4000))
	insert into #C_vypnpa(classificatorid, parentclassificatorid, classificatorcode, [name], [description],
	razdel, stat, punkt, podpunkt)
	exec select_cl_elems @version, @clid_vypnpa, 1, '<list><id val=""/><id val=""/><id val=""/><id val=""/><id val=""/><id val=""/><id val=""/></list>'

--	update #L_vypnpa
--	set [name] = ' '
--	where isnull([name],'')=''

--	update #L_vypnpa
--	set [name] = ''
--	where name is null
--
--	update #L_vypnpa
--	set [razdel] = ''
--	where [razdel] is null
--
--	update #L_vypnpa
--	set stat = ''
--	where stat is null
--
--	update #L_vypnpa
--	set punkt = ''
--	where punkt is null
--
--	update #L_vypnpa
--	set podpunkt = ''
--	where podpunkt is null
--
--	update #C_vypnpa
--	set [name] = ''
--	where name is null
--
--	update #C_vypnpa
--	set [razdel] = ''
--	where [razdel] is null
--
--	update #C_vypnpa
--	set stat = ''
--	where stat is null
--
--	update #C_vypnpa
--	set punkt = ''
--	where punkt is null
--
--	update #C_vypnpa
--	set podpunkt = ''
--	where podpunkt is null

	update #L_vypnpa
	set addflag = newid()
	where not exists(select * from #C_vypnpa ce where isnull(#L_vypnpa.name,'') = isnull(ce.name,'') 
					and isnull(#L_vypnpa.razdel,'') = isnull(ce.razdel,'') and isnull(#L_vypnpa.stat,'') = isnull(ce.stat,'') 
					and isnull(#L_vypnpa.punkt,'') = isnull(ce.punkt,'') and isnull(#L_vypnpa.podpunkt,'') = isnull(ce.podpunkt,''))
	set @add = @add + @@rowcount

	---------
	declare @ClrInV table(classificatorid int, classificatorcode varchar(30), name varchar(1000), description varchar(2000), obj_code varchar(30))
	insert into @ClrInV exec dbo.GetClassificatorsInVersion @version
    declare @classificators table (	rownum int IDENTITY (1, 1) Primary key NOT NULL, id int not null, existing int, objectID int)
    insert into @classificators(id, existing, objectID)
	select @clid_prim, case when exists(select * from @ClrInV where classificatorid=@clid_prim) then 1 else 0 end, null
	union all
	select @clid_division, case when exists(select * from @ClrInV where classificatorid=@clid_division) then 1 else 0 end, null
	union all
	select @clid_soder, case when exists(select * from @ClrInV where classificatorid=@clid_soder) then 1 else 0 end, null
	union all
	select @clid_npa, case when exists(select * from @ClrInV where classificatorid=@clid_npa) then 1 else 0 end, null
	union all
	select @clid_vypnpa, case when exists(select * from @ClrInV where classificatorid=@clid_vypnpa) then 1 else 0 end, null
	
	declare @dsname varchar(64)
	if @vmode = 0
	begin
		if @add + case when exists(select * from @classificators where existing = 0) then 1 else 0 end > 0
		begin
			declare @newname varchar(64)
			select top 1 @newname = left(value,64) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'V_NAME'
			if isnull(@newname,'')=''
				set @newname = '  '
			exec InsertVersion @version,@newname,@newname, @date, null, 'DICTIONARY_VERSION', @version output
		end
		select top 1 @dsname = left([value],64) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_NAME'
		if isnull(@dsname,'')=''
			set @dsname = '    '+convert(varchar(30),@date,104)
		exec InsertVersion @version,@dsname,@dsname,@date,null,'DICTIONARY_DATASOURCE',@dsid output
	end
	else
	if @dsid = -1
	begin
		select top 1 @dsname = left([value],64) from ssistemplatedescription where link_up = @ssisTemplateLink and parameter = 'DS_NAME'
		if isnull(@dsname,'')=''
			set @dsname = '    '+convert(varchar(30),@date,104)
		exec InsertVersion @version,@dsname,@dsname,@date,null,'DICTIONARY_DATASOURCE',@dsid output
	end

	insert into t_version(classificatorid,versionid,deleted) 
	select id, @version, 0 from @classificators where existing = 0
	
	update ClassificatorProperty set CH_GUID = NEWID() where ClassificatorID in (select id from @classificators)

	---	

	insert into classificators(parentclassificatorid, classificatorcode, [name], [description], [object], row_id, import_id, updated) 
	select @clid_prim,'',[name],[name], @object, addflag, @import_id, 0 from #L_prim
	where addflag is not null
	insert into t_version(classificatorid, versionid, deleted) 
	select a.classificatorid, @version, 0 from classificators a inner join #L_prim b on a.row_id = b.addflag
	
	insert into classificators(parentclassificatorid, classificatorcode, [name], [description], [object], row_id, import_id, updated) 
	select @clid_division,code,code,code, @object, addflag, @import_id, 0 from #L_division
	where addflag is not null
	insert into t_version(classificatorid, versionid, deleted) 
	select a.classificatorid, @version, 0 from classificators a inner join #L_division b on a.row_id = b.addflag
	
	insert into classificators(parentclassificatorid, classificatorcode, [name], [description], [object], row_id, import_id, updated) 
	select @clid_soder,code,[name],[description], @object, addflag, @import_id, 0 from #L_soder
	where addflag is not null
	
	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_soder and [name] = ''
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, codestr,@attr_id from #L_soder a inner join classificators b on b.row_id = a.addflag
	where a.codestr is not null

	insert into t_version(classificatorid, versionid, deleted) 
	select a.classificatorid, @version, 0 from classificators a inner join #L_soder b on a.row_id = b.addflag
	
	insert into classificators(parentclassificatorid, classificatorcode, [name], [description], [object], row_id, import_id, updated) 
	select @clid_npa,'',[name],[name], @object, addflag, @import_id, 0 from #L_npa
	where addflag is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ''
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, date,@attr_id from #L_npa a inner join classificators b on b.row_id = a.addflag
	where a.date is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ''
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, number,@attr_id from #L_npa a inner join classificators b on b.row_id = a.addflag
	where a.number is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ' '
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, lvl,@attr_id from #L_npa a inner join classificators b on b.row_id = a.addflag
	where a.lvl is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ' '
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, beginD,@attr_id from #L_npa a inner join classificators b on b.row_id = a.addflag
	where a.beginD is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ' '
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, endD,@attr_id from #L_npa a inner join classificators b on b.row_id = a.addflag
	where a.endD is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ''
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, vid,@attr_id from #L_npa a inner join classificators b on b.row_id = a.addflag
	where a.vid is not null

	insert into t_version(classificatorid, versionid, deleted) 
	select a.classificatorid, @version, 0 from classificators a inner join #L_npa b on a.row_id = b.addflag
	
	insert into classificators(parentclassificatorid, classificatorcode, [name], [description], [object], row_id, import_id, updated) 
	select @clid_vypnpa,'',[name],[name], @object, addflag, @import_id, 0 from #L_vypnpa
	where addflag is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_vypnpa and [name] = ''
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, razdel,@attr_id from #L_vypnpa a inner join classificators b on b.row_id = a.addflag
	where a.razdel is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_vypnpa and [name] = ''
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, stat,@attr_id from #L_vypnpa a inner join classificators b on b.row_id = a.addflag
	where a.stat is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_vypnpa and [name] = ''
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, punkt,@attr_id from #L_vypnpa a inner join classificators b on b.row_id = a.addflag
	where a.punkt is not null

	select top 1 @attr_id = clattrid from classificators_attr where classificatorid = @clid_vypnpa and [name] = ''
	insert into classificators_app(classificatorid,[value],clattrid)
	select b.classificatorid, podpunkt,@attr_id from #L_vypnpa a inner join classificators b on b.row_id = a.addflag
	where a.podpunkt is not null

	insert into t_version(classificatorid, versionid, deleted) 
	select a.classificatorid, @version, 0 from classificators a inner join #L_vypnpa b on a.row_id = b.addflag

	---
	insert into dbo.SourceTemplate(ClassificatorID,VersionID,[description])
	select @clid_prim, @dsid, '' 
	union all
	select @clid_division, @dsid, '' 
	union all
	select @clid_soder, @dsid, '' 
	union all
	select @clid_npa, @dsid, '' 
	union all
	select @clid_vypnpa, @dsid, '' 
	except 
	select classificatorid,versionid,isnull(description,'') from [SOURCETEMPLATE] where versionid=@dsid

	update dbo.sourcetemplate
	set multiselection = 1
	where versionid = @dsid and classificatorid in (@clid_division, @clid_npa, @clid_vypnpa)

	declare @st_prim int, @st_division int, @st_soder int, @st_npa int, @st_vypnpa int

	select @st_prim = sourcetemplateid from sourcetemplate where versionid = @dsid and classificatorid = @clid_prim
	select @st_division = sourcetemplateid from sourcetemplate where versionid = @dsid and classificatorid = @clid_division
	select @st_soder = sourcetemplateid from sourcetemplate where versionid = @dsid and classificatorid = @clid_soder
	select @st_npa = sourcetemplateid from sourcetemplate where versionid = @dsid and classificatorid = @clid_npa
	select @st_vypnpa = sourcetemplateid from sourcetemplate where versionid = @dsid and classificatorid = @clid_vypnpa

	---
	create table #M_prim(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024))
	insert #M_prim(classificatorid, parentclassificatorid, classificatorcode, [name], [description])
	exec select_cl_elems @version, @clid_prim, 0, '<list><id val="-1"/><id val="-2"/><id val="-3"/></list>'

	update #t1
	set prim_link = b.classificatorid
	from #t1 a inner join #M_prim b on isnull(a.gr16,'') = isnull(b.name,'')

	---
	create table #M_division(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024))
	insert into #M_division(classificatorid, parentclassificatorid, classificatorcode, [name], [description])
	exec select_cl_elems @version, @clid_division, 0, '<list><id val="-1"/><id val="-2"/><id val="-3"/></list>'

	update #t111
	set div_link = b.classificatorid
	from #t111 a inner join #M_division b on isnull(a.value,'') = isnull(b.classificatorcode,'')
	---
	create table #M_soder(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024), codestr varchar(4000))
	insert into #M_soder(classificatorid, parentclassificatorid, classificatorcode, [name], [description], codestr)
	exec select_cl_elems @version, @clid_soder, 1, '<list><id val=""/><id val=""/><id val=""/><id val=""/></list>'

	update #t1
	set soder_link = b.classificatorid
	from #t1 a inner join #M_soder b on
	(isnull(a.gr2,'') = isnull(b.classificatorcode,''))	
	--and (isnull(a.gr1,'') = isnull(b.name,'')) 
	and (isnull(a.gr0,'') = isnull(b.codestr,''))

--	update #t1
--	set measure_link = b.measureid
--	from #t1 a inner join (select measureid, fullname from measures) b on a.measure = b.fullname

	--
	create table #M_npa(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024), date varchar(4000), 
	number varchar(4000), vid varchar(4000), lvl varchar(4000), beginD varchar(4000), endD varchar(4000))
	insert into #M_npa(classificatorid, parentclassificatorid, classificatorcode, [name], [description], date, number, vid, lvl, beginD, endD)
	exec select_cl_elems @version, @clid_npa, 1, '<list><id val=""/><id val=""/><id val=""/><id val=""/>
			<id val=""/><id val=""/><id val=" "/><id val=" "/><id val=" "/></list>'

	update #t12
	set npa_link = b.classificatorid
	from #t12 a inner join #M_npa b on (isnull(a.bnumb,'') = isnull(b.number,''))
	and (isnull(a.brank,'') = isnull(b.lvl,''))
	and (isnull(a.bdate,'') = isnull(b.date,'')) and (isnull(a.bclass,'') = isnull(b.vid,'')) 

	--
	create table #M_vypnpa(classificatorid int, parentclassificatorid int, classificatorcode varchar(30), [name] varchar(1000), 
	[description] varchar(1024),razdel varchar(4000), stat varchar(4000), punkt varchar(4000), podpunkt varchar(4000))
	insert into #M_vypnpa(classificatorid, parentclassificatorid, classificatorcode, [name], [description],
	razdel, stat, punkt, podpunkt)
	exec select_cl_elems @version, @clid_vypnpa, 1, '<list><id val=""/><id val=""/><id val=""/><id val=""/><id val=""/><id val=""/><id val=""/></list>'

	update #t12
	set vypnpa_link = b.classificatorid
	from #t12 a inner join #M_vypnpa b on 
		(isnull(a.brubric,'')=isnull(b.razdel,'')) and (isnull(a.bparticle,'')=isnull(b.stat,''))
		and (isnull(a.bparagr,'')=isnull(b.punkt,'')) and (isnull(a.bsubpar,'')=isnull(b.podpunkt,''))

--	declare @m_obj int set @m_obj = dbo.obj_id('DICTIONARY_MEASURE')
--
--	insert measures(fullname, shortname,[object])
--	select mcode, mname, mobj
--	from
--	(
--		select '10' as mcode,'10' as mname,@m_obj as mobj
--		union all
--		select '11' as mcode,'11' as mname,@m_obj as mobj
--		union all
--		select '12' as mcode,'12' as mname,@m_obj as mobj
--		union all
--		select '13' as mcode,'13' as mname,@m_obj as mobj
--		union all
--		select '14' as mcode,'14' as mname,@m_obj as mobj
--		union all
--		select '15' as mcode,'15' as mname,@m_obj as mobj
--	) a
--	left outer join (select fullname from measures where [object] = @m_obj) b on a.mname = b.fullname
--	where b.fullname is null
--
--	declare @gr10 int,@gr11 int,@gr12 int,@gr13 int,@gr14 int,@gr15 int
--	select top 1 @gr10 = measureid from measures where fullname = '10'
--	select top 1 @gr11 = measureid from measures where fullname = '11' 
--	select top 1 @gr12 = measureid from measures where fullname = '12' 
--	select top 1 @gr13 = measureid from measures where fullname = '13' 
--	select top 1 @gr14 = measureid from measures where fullname = '14' 
--	select top 1 @gr15 = measureid from measures where fullname = '15' 

	create table #data(id int, strid int, amount numeric(27,10),mlink int,soder_link int,prim_link int, date datetime, row_id uniqueidentifier default(newid()))
	insert #data(id, amount, mlink, soder_link, prim_link, date)
	select id, gr10,@plan_prev,soder_link,prim_link,@doc_date
	from #t1
	union all
	select id, gr11,@fact_prev,soder_link,prim_link,@doc_date
	from #t1
	union all
	select id, gr12,@plan_curr,soder_link,prim_link,@doc_date
	from #t1		
	union all
	select id, gr13,@plan_next,soder_link,prim_link,@doc_date
	from #t1
	union all
	select id, gr14,@plan_next_1,soder_link,prim_link,@doc_date
	from #t1
	union all
	select id, gr15,@plan_next_2,soder_link,prim_link,@doc_date
	from #t1

	select row_id, soder_link, prim_link, convert(int,null) as strid, date
	into #m
	from #data

	update #m
	set prim_link = -1
	where prim_link is null

	update #m
	set soder_link = -1
	where soder_link is null

	create table #m2(strid int identity(100,100), clid_prim int, clid_soder int, date datetime)
	insert #m2(clid_prim, clid_soder, date)
	select distinct prim_link, soder_link, date
	from #m

	update #m
	set strid = b.strid
	from #m a inner join #m2 b
	on a.prim_link=b.clid_prim and a.soder_link=b.clid_soder and a.date = b.date

	update #data
	set strid = b.strid
	from #data a inner join #m b on a.row_id = b.row_id

	select a.parent_id, a.npa_link, a.vypnpa_link, b.div_link, b.id into #t3 
	from #t12 a full outer join #t111 b on a.parent_id = b.id and a.rnk = b.part_id
	
	select 
			a.strid  as strid, row_number() over (order by a.strid,a.mlink,isnull(npa_link,-2),isnull(vypnpa_link,-2),isnull(div_link,-2)) as id2,			
			a.amount, a.mlink, a.prim_link, a.soder_link, b.npa_link, b.vypnpa_link, b.div_link, a.date 
	into #data2
	from #data a left join #t3 b on (a.id = b.parent_id or a.id = b.id)
	order by id2,a.strid,a.mlink,b.npa_link,b.vypnpa_link,b.div_link		
	
	select *,min(id2) over (partition by strid, mlink) as min_id
	into #data22
	from #data2
	order by id2,strid,mlink
	
	update #data22 set strid = strid + id2 - min_id	
	
	create table #data3(strid int, amount numeric(27,10), mlink int, prim_link int, soder_link int, date datetime
		, npa_link int, vypnpa_link int, div_link int, row_id uniqueidentifier)

	insert #data3
	select strid, amount, mlink, prim_link, soder_link, date, npa_link, 
			convert(int,null) as vypnpa_link,  convert(int,null) as div_link, newid() as row_id
	from #data22
	union all
	select strid, amount, mlink, prim_link, soder_link, date, convert(int,null) as npa_link, 
			vypnpa_link,  convert(int,null) as div_link, newid() as row_id
	from #data22
	union all
	select strid, amount, mlink, prim_link, soder_link, date, convert(int,null) as npa_link, 
			convert(int,null) as vypnpa_link,  div_link, newid() as row_id
	from #data22

	insert into dbo.time(fulldate)
	select a.date
	from 
	(select distinct date from #data3) a left join dbo.time b on a.date = b.fulldate
	where b.timekey is null

	insert into storage(versionid, amount, timekey, row_id, measureid, strid, import_id)
	select @dsid, a.amount, b.timekey, a.row_id, a.mlink, a.strid,@import_id
	from #data3 a left join dbo.time b on a.date = b.fulldate
	where a.amount is not null

	insert into t_storage(storageid, classificatorid, sourcetemplateid)
	select b.storageid, a.prim_link, @st_prim  from #data3 a inner join storage b on a.row_id = b.row_id
	where a.prim_link is not null
	union all
	select b.storageid, a.div_link, @st_division  from #data3 a inner join storage b on a.row_id = b.row_id
	where a.div_link is not null
	union all
	select b.storageid, a.soder_link, @st_soder  from #data3 a inner join storage b on a.row_id = b.row_id
	where a.soder_link is not null
	union all
	select b.storageid, a.npa_link, @st_npa  from #data3 a inner join storage b on a.row_id = b.row_id
	where a.npa_link is not null
	union all
	select b.storageid, a.vypnpa_link, @st_vypnpa  from #data3 a inner join storage b on a.row_id = b.row_id
	where a.vypnpa_link is not null

	exec [InsertMeasures] @versionid = @dsid

	declare @npa_date int, @npa_number int, @npa_uroven int, @npa_begin int,@npa_end int, @npa_type int
	select top 1 @npa_date = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ''
	select top 1 @npa_number = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ''
	select top 1 @npa_uroven = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ' '
	select top 1 @npa_begin = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ' '
	select top 1 @npa_end = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ' '
	select top 1 @npa_type = clattrid from classificators_attr where classificatorid = @clid_npa and [name] = ''

	declare @v_razdel int, @v_stat int, @v_punkt int, @v_ppunkt int
	select top 1 @v_razdel = clattrid from classificators_attr where classificatorid = @clid_vypnpa and [name] = ''
	select top 1 @v_stat = clattrid from classificators_attr where classificatorid = @clid_vypnpa and [name] = ''
	select top 1 @v_punkt = clattrid from classificators_attr where classificatorid = @clid_vypnpa and [name] = ''
	select top 1 @v_ppunkt = clattrid from classificators_attr where classificatorid = @clid_vypnpa and [name] = ''

	declare @comb nvarchar(max)
	set @comb = '<DataTable><xs:schema xmlns="" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata" id="NewDataSet">
		<xs:element name="NewDataSet" msdata:IsDataSet="true" msdata:MainDataTable="" msdata:UseCurrentLocale="true">
		  <xs:complexType>
			<xs:choice minOccurs="0" maxOccurs="unbounded">
			  <xs:element name="">
				<xs:complexType>
				  <xs:sequence>'
	+'<xs:element name="DICTIONARY_CLASSIFICATOR-'+convert(varchar(20),@clid_npa)+'" msdata:Caption="name,'
		+'attr_name_'+convert(varchar(20),@npa_number)+','
		+'attr_name_'+convert(varchar(20),@npa_uroven)+','
		+'attr_name_'+convert(varchar(20),@npa_date)+','
		+'attr_name_'+convert(varchar(20),@npa_number)+','
		+'attr_name_'+convert(varchar(20),@npa_type)+','
		+'attr_name_'+convert(varchar(20),@npa_begin)+','
		+'attr_name_'+convert(varchar(20),@npa_type)+','
	+'" type="xs:string" minOccurs="0" />'
	+'<xs:element name="DICTIONARY_CLASSIFICATOR-'+convert(varchar(20),@clid_vypnpa)+'" msdata:Caption="name,'
	+  'attr_name_'+convert(varchar(20),@v_razdel)+','
		+'attr_name_'+convert(varchar(20),@v_stat)+','
		+'attr_name_'+convert(varchar(20),@v_punkt)+','
		+'attr_name_'+convert(varchar(20),@v_ppunkt)+','
	+'" type="xs:string" minOccurs="0" />'
	set @comb = @comb + '</xs:sequence>
				</xs:complexType>
			  </xs:element>
			</xs:choice>
		  </xs:complexType>
		</xs:element>
	  </xs:schema>'
	+
	'<diffgr:diffgram xmlns:msdata="urn:schemas-microsoft-com:xml-msdata" xmlns:diffgr="urn:schemas-microsoft-com:xml-diffgram-v1">
		<DocumentElement>'
		
	create table #ttt(id int identity(1,1), npa int, vyp int)
	insert #ttt(npa,vyp)
   	select distinct npa_link, vypnpa_link from #t12
	where npa_link is not null and vypnpa_link is not null
	order by npa_link

	select @comb = @comb + '< diffgr:id="'+convert(varchar(20),id)+'" msdata:rowOrder="'+convert(varchar(20),id-1)+'">'
	+'<DICTIONARY_CLASSIFICATOR-'+convert(varchar(20),@clid_npa)+'>'+convert(varchar(20),npa)+'</DICTIONARY_CLASSIFICATOR-'+convert(varchar(20),@clid_npa)+'>'
	+'<DICTIONARY_CLASSIFICATOR-'+convert(varchar(20),@clid_vypnpa)+'>'+convert(varchar(20),vyp)+'</DICTIONARY_CLASSIFICATOR-'+convert(varchar(20),@clid_vypnpa)+'>'
	+'</>'
	from #ttt

	set @comb = @comb +'</DocumentElement>
	  </diffgr:diffgram>
	</DataTable>'

	declare @xml_data xml
	begin try
		set @xml_data = convert(xml,@comb)
		update version
		set data = @xml_data
		where versionid = @dsid
	end try
	begin catch
		select @ErrorMessage = '      :'+ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE();
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState);
		return
	end catch
	update fileloadedhash set successload = 1 where successload = 0 and import_id = @import_id
END
GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8399' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'IMPORTRROXML'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[select_cl_elems]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[select_cl_elems]
GO

create PROCEDURE [dbo].[select_cl_elems]
	@version_id int,
	@classificator_id int,
	@mode int,
	@list varchar(4000)
/*
	mode
		0  - list of attributes id 
		1  - list of attributes names
	list
		xml string  - <list>..<id val=""/> .. </list>
*/
as
begin


	declare @sclid int
	select @sclid = SourceClassificatorId from classificatorproperty where classificatorid = @classificator_id
	select @classificator_id = isnull(@sclid, @classificator_id)
	
	if @mode not in (0,1)
	begin
		raiserror('   mode - "%d"  [dbo].[select_cl_elems]',16,1, @mode)
		return	
	end

	declare @err_msg nvarchar(2048)
	declare @xml_list xml
	begin try
		set @xml_list = convert(xml, @list)
	end try
	begin catch
		--handler here
		set @err_msg = '     [select_cl_elems]:' + error_message()
		raiserror(@err_msg,16,1)
		return
	end catch

	;with orders(num) as
	(
		select 1
		union all
		select num+1
		from orders where num < 100
	)
	select num into #ords from orders

	declare @query nvarchar(max)
	set @query = N''

	
	create table #attr_id (ord int, id int)

	if @mode = 1
	begin
		 declare @attr_code table(ord int, code varchar(200) not null)
		 insert into @attr_code(ord, code)
		 select o.num, l.n.value('@val','varchar(200)')
	     from #ords o cross apply @xml_list.nodes('/list/id[sql:column("o.num")]') l(n) 

		 insert into #attr_id(ord,id)	
		 select ord, -1 from @attr_code where code = ''
		 union all
		 select ord, -2 from @attr_code where code = ''
		 union all
		 select ord, -3 from @attr_code where code = ''
		 union all
		 select a.ord, b.clattrid
		 from @attr_code a left outer join classificators_attr b on (a.code = b.name and b.classificatorid = @classificator_id)
		 where a.code not in ('','','') 
		 
		 if exists(select id from #attr_id where id is null) 	
		 begin
			--todo: get list of unknown attributes
            raiserror('        [dbo].[select_cl_elems]',16,1)
		    return
	     end	
	end
	else
	begin
		 insert into #attr_id(ord, id)
		 select o.num, l.n.value('@val','int')
	     from #ords o cross apply @xml_list.nodes('/list/id[sql:column("o.num")]') l(n)
		
		 if exists(select a.id from #attr_id a left outer join classificators_attr b on (a.id = b.clattrid and b.classificatorid = @classificator_id)
					where b.clattrid is null and a.id not in (-1,-2,-3))
		   or exists(select id from #attr_id where id is null)
		 begin
			--todo: get list of unknown attributes
            raiserror('        [dbo].[select_cl_elems]',16,1)
		    return
	     end
		 
	end
		 if not exists(select * from #attr_id)
		 begin
			raiserror('     [dbo].[select_cl_elems]',16,1)
			return
	     end	
		 declare @attr_list nvarchar(2000)
		 declare @attr_list2 nvarchar(2000)
		 declare @attr_list3 nvarchar(2000)
		 set @attr_list = 
			stuff
			(
				(
					(
					select ','+case id when -1 then '[classificatorcode]' when -2 then '[name]' when -3 then '[description]' 
						else quotename(convert(varchar(20),id))end as [text()]
					from #attr_id
					order by ord asc
					for xml path(''),type
					).value('.','varchar(max)')	
				), 1,1,''
		    )	
		 set @attr_list2 = 
			stuff
			(
				(
					(
					select ','+ quotename(convert(varchar(20),id))as [text()]
					from #attr_id
					order by ord asc
						for xml path(''),type
					).value('.','varchar(max)')
				), 1,1,''
		    )	
		 set @attr_list3 = 'classificatorid as clid,parentclassificatorid as pclid'+(
					(
					select ','+ quotename(convert(varchar(20),id)) + ' as ' + quotename('attr_'+convert(varchar(20),id)) as [text()]
					from #attr_id
					order by ord asc
						for xml path(''),type
					).value('.','varchar(max)')	
				)
		if not exists(select * from #attr_id where id > 0)
		begin
			set @query = N'select classificatorid,parentclassificatorid,' + @attr_list + ' from classificators where classificatorid in (select id from #clr)'
		end
		else
		begin

			set @query = N'select '+@attr_list3+' from ( select a.clattrid, b.classificatorid, b.value, c.parentclassificatorid
			from classificators_attr a inner join classificators_app b on a.clattrid = b.clattrid 
				inner join (select classificatorid,parentclassificatorid from classificators where classificatorid in (select id from #clr)) c on b.classificatorid = c.classificatorid
			where a.classificatorid = @classificator_id and a.clattrid in (select id from #attr_id)' 

			if exists(select * from #attr_id where id = -1)
			begin
				if @query != N''
				begin
					set @query = @query + N' union all'
				end
				set @query = @query + N' select -1,classificatorid, classificatorcode,parentclassificatorid from classificators where classificatorid in (select id from #clr)'
			end
			if exists(select * from #attr_id where id = -2)
			begin
				if @query != N''
				begin
					set @query = @query + N' union all'
				end
				set @query = @query + N' select -2,classificatorid, name,parentclassificatorid from classificators where classificatorid in (select id from #clr)'
			end
			if exists(select * from #attr_id where id = -3)
			begin
				if @query != N''
				begin
					set @query = @query + N' union all'
				end
				set @query = @query + N' select -3,classificatorid, description,parentclassificatorid from classificators where classificatorid in (select id from #clr)'
			end
			
			set @query = @query + N' ) a pivot (max(value) for clattrid in ('+@attr_list2+')) b'
		end

	create table #clr(id int not null)
	begin try
	    
		--declare @nUserId int
		--select @nUserId = user_id(suser_sname())

		--select identity(int, 1, 1) as ORDERS, LINK as VERSIONID into #V3 from dbo.tree_version( @version_id, 'UP')
		--create table #CL(CLASSIFICATORID int)

		--;with DIRECTREPORTS (CLASSIFICATORID) as 
		--(
		--	select CLASSIFICATORID
		--	from CLASSIFICATORS
		--	where CLASSIFICATORID = @classificator_id
		--	union all
		--	select TR.CLASSIFICATORID
		--	from CLASSIFICATORS TR inner join DIRECTREPORTS D on (TR.PARENTCLASSIFICATORID = D.CLASSIFICATORID)
		--)
		--insert #CL(CLASSIFICATORID) select CLASSIFICATORID from DIRECTREPORTS
		--delete #CL where CLASSIFICATORID = @classificator_id

		--select CL.CLASSIFICATORID, max(V.ORDERS) as ORDERS, convert(int, Null) as DELETED
		--into #V31
		--from #V3 V, #CL CL, T_VERSION TV
		--where V.VERSIONID = TV.VERSIONID and TV.CLASSIFICATORID = CL.CLASSIFICATORID
		--group by CL.CLASSIFICATORID

		--update #V31 set DELETED = TV.DELETED from #V3 V, T_VERSION TV
		--where #V31.CLASSIFICATORID = TV.CLASSIFICATORID and V.ORDERS = #V31.ORDERS and TV.VERSIONID = V.VERSIONID

		--delete #V31 where DELETED = 1

		--if dbo.[AdminIsUserAdm](@nUserId) = 0
		--	begin
		--		select distinct [GROUPS] as [UID] into #GRP from [USERS_GROUPS] where [USERS] = @nUserId
		--		insert #GRP ([UID]) values(@nUserId)
		--		delete #GRP where not exists(select * from S_USERS SU where SU.UID = #GRP.[UID])
		--		--update #GRP set [UID] = SU.[UID] from S_USERS SU where SU.UID = #GRP.[UID]

		--		select V.[CLASSIFICATORID], sum(TC.ACCESS) as ACCESS
		--		into #NACC
		--		from [#V31] V, [T_CL_ACCESS] TC, #GRP GR
		--		where TC.[VERSIONID] = @version_id and TC.[CLASSIFICATORID] = V.[CLASSIFICATORID] and TC.[UID] = GR.[UID]
		--		group by V.[CLASSIFICATORID]
		--		having sum(TC.ACCESS)=0

		--		delete #V31 from #NACC NA where NA.[CLASSIFICATORID] = #V31.[CLASSIFICATORID]
			--end 

		exec [dbo].[SELECT_CL_INFO] @nMode  = 13, @nVerID    =@version_id, @nClassId =@classificator_id, @saveTable = '#clr'


	end try
	begin catch
		set @err_msg = '     [select_cl_elems]:'+error_message()
		raiserror(@err_msg,16,1)
		return
	end catch

	begin try
		exec sp_executesql @query, N'@classificator_id int', @classificator_id=@classificator_id
	end try	
	begin catch
		set @err_msg = '    [select_cl_elems]:'+error_message()
		raiserror(@err_msg, 16,1)
		return
	end catch

end
GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8223' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_CL_ELEMS'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[ST_DEPLOY]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[ST_DEPLOY]
GO


create procedure [dbo].[ST_DEPLOY]
	@nStorageId int,						-- 
	@cMeasureList varchar(8000) = null,		--  
	@cClExclList varchar(8000) = null,		--   
	@cClInclList varchar(8000) = null,		--  
	@cTimeList varchar(8000) = null,		--  
	@nProject int = null,					-- 
	@cTable varchar(100) output				--  
as
begin
	set transaction isolation level read uncommitted
	set nocount on

	create table #CL_EXL (CLASSIFICATORID int)
	create table #CL_INCL (CLASSIFICATORID int)
	
		
	if isnull(@cClExclList, '') <> ''
		insert #CL_EXL (CLASSIFICATORID) select VALUE from dbo.StrSplit(@cClExclList,',')

	if isnull(@cClInclList, '') <> ''
		insert #CL_INCL (CLASSIFICATORID) select VALUE from dbo.StrSplit(@cClInclList,',')

--select * from #CL_EXL
--select * from #CL_INCL

	if not exists(select * from dbo.VERSION where VersionID = @nStorageId)
		begin
			raiserror('   ',16,1)
			return
		end

	if not @nProject is null and not exists(select * from dbo.VERSION where VersionID = @nStorageId)
		begin
			raiserror('   ',16,1)
			return
		end
		
	declare @source_template_id_list varchar(max), @query varchar(max), @source_template_id_list1 varchar(max), @source_template_id_list2 varchar(max),
	 @source_template_id_list3 varchar(max), @source_template_id_list4 varchar(max), @cTableProject varchar(100)
	
	if @nProject is null
		begin
			select @cTable = '[KS_DDLControl].[STD_' + convert(varchar(36), newid()) + ']'
			
			if not exists(select * from #CL_INCL)
				insert #CL_INCL (CLASSIFICATORID) select st.ClassificatorID from [sourcetemplate] st where st.versionid = @nStorageId

		
			select @source_template_id_list = stuff((
														select ',' + quotename(convert(nvarchar(20), st.[sourcetemplateid])) as [text()]
														from [sourcetemplate] st
														where
															st.versionid = @nStorageId and
															exists(select * from #CL_INCL where classificatorid = st.classificatorid) and
															not exists(select * from #CL_EXL where classificatorid = st.classificatorid)
														for xml path('')
													), 1, 1, '')
			select @source_template_id_list1 = stuff((
														select ',' + quotename(convert(nvarchar(20),[sourcetemplateid])) + ' as [CL-' + convert(varchar(20), @nStorageId) + '-' + convert(varchar(20), [ClassificatorID]) + ']' as [text()]
														from [sourcetemplate] st
														where
															st.versionid = @nStorageId and
															exists(select * from #CL_INCL where classificatorid = st.classificatorid) and
															not exists(select * from #CL_EXL where classificatorid = st.classificatorid)														for xml path('')
													),1,1,'')
			
--select @source_template_id_list1
--select @source_template_id_list

			select @query = '
			select VERSIONID, MEASUREID, STORAGEID, STORAGE_SELF, FILTERID, STRID, AMOUNT, TIMEKEY, DATE_IN, ' + @source_template_id_list1 + '
			into ' + @cTable + '
			from
				(
					select S.VERSIONID, S.MEASUREID, S.STORAGEID, S.STORAGE_SELF, S.FILTERID, S.STRID, S.AMOUNT, S.DATE_IN, S.TIMEKEY, TS.CLASSIFICATORID, TS.SOURCETEMPLATEID
					from STORAGE S inner join T_STORAGE TS on S.STORAGEID = TS.STORAGEID
					where S.VERSIONID = ' + convert(varchar(20), @nStorageId)

			if not @cMeasureList is null
				select @query = @query + ' and S.MEASUREID in (' + @cMeasureList + ')'
				
			if not @cTimeList is null
				select @query = @query + ' and S.TIMEKEY in (' + @cTimeList + ')'
					
			select @query = @query + 'union
					select SE.VERSIONID, SE.MEASUREID, SE.STORAGEID, SE.STORAGE_SELF, SE.FILTERID, SE.STRID, SE.AMOUNT, SE.DATE_IN, SE.TIMEKEY, TS.CLASSIFICATORID, TS.SOURCETEMPLATEID
					from STORAGE SE
						inner join STORAGE S on SE.STORAGE_SELF = S.STORAGEID
						inner join T_STORAGE TS on S.STORAGEID = TS.STORAGEID
					where not SE.STORAGE_SELF is null and S.VERSIONID = ' + convert(varchar(20), @nStorageId)
					
			
			if not @cMeasureList is null
				select @query = @query + ' and SE.MEASUREID in (' + @cMeasureList + ')'
				
			if not @cTimeList is null
				select @query = @query + ' and SE.TIMEKEY in (' + @cTimeList + ')'
			
			select @query = @query + ')	A
				pivot (max(CLASSIFICATORID) for SOURCETEMPLATEID in (' + @source_template_id_list + ')) as B
			order by STORAGEID, MEASUREID, FILTERID, STRID
			
--	select * from ' + @cTable
--select @query
			if @query is null
				begin
					raiserror('  . @query is null',16,1)
					return
				end

			execute (@query)
		end
	else --     
		begin
			create table #MEASURE (MEASUREID int)
			create table #TIME_INCL (TIMEKEY int)

			if isnull(@cMeasureList, '') <> ''
				insert #MEASURE (MEASUREID) select VALUE from dbo.StrSplit(@cMeasureList,',')

			if isnull(@cTimeList, '') <> ''
				insert #TIME_INCL (TIMEKEY) select VALUE from dbo.StrSplit(@cTimeList,',')
				
			if not @cMeasureList is null and exists(select * from #MEASURE M where not exists (select * from dbo.MEASURES where M.MEASUREID = MEASUREID))
				begin
					raiserror('   ',16,1)
					return
				end

			if not @cMeasureList is null and exists(select * from #MEASURE M where not exists (select * from dbo.T_MEASURE where M.MEASUREID = MEASUREID and VERSIONID = @nStorageId))
				begin
					raiserror('      ',16,1)
					return
				end


			select @cTable = '[KS_DDLControl].[STD_' + convert(varchar(36), newid()) + ']'
			select @cTableProject = '[KS_DDLControl].[STD_' + convert(varchar(36), newid()) + ']'
				
			select @source_template_id_list = stuff((
														select ',' + quotename(convert(nvarchar(20),[SOURCETEMPLATEID])) as [text()]
														from [SOURCETEMPLATE] ST
														where ST.VERSIONID = @nStorageId and not exists(select * from #CL_EXL where classificatorid = ST.classificatorid)
														for xml path('')
													),1,1,'')
			select @source_template_id_list1 = stuff((
														select ',' + quotename(convert(nvarchar(20),[SOURCETEMPLATEID])) + ' as [CL_' + convert(varchar(20), @nProject) + '_' + convert(varchar(20), [ClassificatorID]) + ']' as [text()]
														from [SOURCETEMPLATE] ST
														where ST.VERSIONID = @nStorageId and not exists(select * from #CL_EXL where classificatorid = ST.classificatorid)
														for xml path('')
														),1,1,'')
			select @source_template_id_list2 = stuff((select ',' + quotename(convert(nvarchar(20),[MEASUREID])) + ' as [MEASURE_' + convert(varchar(20), @nProject) + '_' + convert(varchar(20), [MEASUREID]) + ']' as [text()] from #MEASURE for xml path('')),1,1,'')
			select @source_template_id_list3 = '[' + replace(@cMeasureList,',','],[') + ']'
			select @source_template_id_list4 = stuff((
														select ', [CL_' + convert(varchar(20), @nProject) + '_' + convert(varchar(20), [ClassificatorID]) + ']' as [text()]
														from [SOURCETEMPLATE] ST
														where ST.VERSIONID = @nStorageId and not exists(select * from #CL_EXL where classificatorid = ST.classificatorid)
														for xml path('')
													),1,1,'')
			
--select '@source_template_id_list',@source_template_id_list
--select '@source_template_id_list1',@source_template_id_list1
--select '@source_template_id_list2',@source_template_id_list2
--select '@source_template_id_list3',@source_template_id_list3
--select '@source_template_id_list4',@source_template_id_list4

			if @source_template_id_list is null
				begin
					raiserror('    .     .',16,1)
					return
				end

			if @source_template_id_list2 is null
				begin
					raiserror('    .     .',16,1)
					return
				end


			select @query = '
			select VERSIONID, MEASUREID, STORAGEID, FILTERID, STRID, AMOUNT, TIMEKEY, ' + @source_template_id_list1 + '
			into ' + @cTable + '
			from
				(
					select S.VERSIONID, S.MEASUREID, S.STORAGEID, S.FILTERID, S.STRID, S.AMOUNT, S.TIMEKEY, TS.CLASSIFICATORID, TS.SOURCETEMPLATEID
					from STORAGE S inner join T_STORAGE TS on S.STORAGEID = TS.STORAGEID
					where S.VERSIONID = ' + convert(varchar(20), @nStorageId)
					
			if not @cMeasureList is null
				select @query = @query + ' and S.MEASUREID in (' + @cMeasureList + ')'
				
			select @query = @query + '
					union
					select SE.VERSIONID, SE.MEASUREID, SE.STORAGEID, SE.FILTERID, SE.STRID, SE.AMOUNT, SE.TIMEKEY, TS.CLASSIFICATORID, TS.SOURCETEMPLATEID
					from STORAGE SE
						inner join STORAGE S on SE.STORAGE_SELF = S.STORAGEID
						inner join T_STORAGE TS on S.STORAGEID = TS.STORAGEID
					where not SE.STORAGE_SELF is null and S.VERSIONID = ' + convert(varchar(20), @nStorageId)

			if not @cMeasureList is null
				select @query = @query + ' and SE.MEASUREID in (' + @cMeasureList + ')'
		
			select @query = @query + ')	A
				pivot (max(CLASSIFICATORID) for SOURCETEMPLATEID in (' + @source_template_id_list + ')) as B
			
			
			select VERSIONID, STORAGEID, FILTERID, STRID, TIMEKEY, ' + @source_template_id_list2 + ',' + @source_template_id_list4 + '
			into ' + @cTableProject + '
			from
				(select VERSIONID, MEASUREID, STORAGEID, FILTERID, STRID, AMOUNT, TIMEKEY,' + @source_template_id_list4 + ' from ' + @cTable + ') A
				pivot (max(AMOUNT) for MEASUREID in (' + @source_template_id_list3 + ')) B
			order by VERSIONID, STORAGEID, FILTERID, STRID, TIMEKEY

			drop table ' + @cTable + '
			
--	select * from ' + @cTableProject
		
		select @cTable = @cTableProject

		if @query is null
			begin
				raiserror('  . @query is null',16,1)
				return
			end

--select @query
		execute (@query)

	end
end

GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8484' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'ST_DEPLOY'
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SELECT_CL_STRU]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
	drop procedure [dbo].[SELECT_CL_STRU]
GO


/*
: 

 :
	@nVerID		- 
	@nClassId	- 

 :

 : 	
	exec SELECT_CL_STRU @nClassId = 474604

:

:
	 ..
*/


create procedure [dbo].[SELECT_CL_STRU]
	@nClassId int
as
begin
	set nocount on

	declare @nParentClassId int, @nClassIdOrig int
	select @nClassIdOrig = @nClassId

	select @nParentClassId = cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @nClassId
	if isnull(@nParentClassId,0) > 0
		select @nClassId = @nParentClassId

	select
		cl.CLASSIFICATORID, cl.CLASSIFICATORCODE, cl.[NAME], cl.[DESCRIPTION], cl.ISAGGREGATABLE, cl.[TYPE], cl.[OBJECT],
		(select top 1 htype from [ClassificatorDescription] where [CLASSIFICATORID] = @nClassId) as HTYPE,
		isnull(cp.DblControl, 1) as DBLCONTROL,
		isnull(cp.MembersWithData, 0) as SHOWPARENTNODES,
		isnull(cp.AccessControl, 0) as ACCESSCONTROL,
		cp.SourceClassificatorId as SOURCECLASSIFICATORID,
		cp.SourceClassificatorFilter as SOURCECLASSIFICATORFILTER,
		isnull(cp.IsSystem, 0) as ISSYSTEM
	from CLASSIFICATORS cl left outer join CLASSIFICATORPROPERTY cp on (CP.CLASSIFICATORID =CL.CLASSIFICATORID)
	where cl.CLASSIFICATORID = @nClassIdOrig

	select DESCRIPTIONID, CLASSIFICATORID, [NAME], MASK, [LEVEL], [TYPE], [STARTPOSITION], [LENGTH]
	from CLASSIFICATORDESCRIPTION
	where CLASSIFICATORID = @nClassId
	order by [TYPE],[LEVEL]

	-- 
	select *, 'ATTR_NAME_' + convert(varchar(20), [CLATTRID]) as ATTR_NAME
	from CLASSIFICATORS_ATTR
	where CLASSIFICATORID = @nClassId and OBJECT is null

	--  =  
	select *, 'ATTR_NAME_' + convert(varchar(20), [CLATTRID]) as ATTR_NAME
	from CLASSIFICATORS_ATTR
	where CLASSIFICATORID = @nClassId and not OBJECT is null
end

GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8005' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_CL_STRU'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[TREE_SAVE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[TREE_SAVE]
GO





/* :     
     :

     :

    :


SORT 				--  
NODE 				-- .   
NODE_DEST		-- .      
LINK 				--   ( EVENT_TYPE = 'Copy', 'Delete', 'DragDrop', 'Edit', 'New')
LINK_DEST 	--      ( EVENT_TYPE = 'Copy', 'DragDrop', 'New')
NEW_NAME		--    ( EVENT_TYPE = 'Edit', 'New')
EVENT_TYPE	--  
ROW_ID			-- .    'New'
RELATION 		-- .     
 
     .
*/
CREATE procedure [dbo].[TREE_SAVE]
	@cTables	varchar(300) = '#cAlias1'
as
set transaction isolation level read uncommitted
set nocount on

-- 
if object_id('tempdb..' + @cTables) is Null
	begin
		select ' -  ' + @cTables + '  !'
		return 1
	end

declare @cCmd varchar(7000), @nSort int, @cEvent varchar(10), @nRepWord int

declare @nDTS int, @nAlg int, @nDSI_Filter int, @nVer int, @nProj int, @nProjExt int, @nUserId int
select @nDTS = dbo.obj_id('DICTIONARY_DATASOURCE')
select @nAlg = dbo.obj_id('DICTIONARY_ALGORITHM_DWH')
select @nDSI_Filter = dbo.obj_id('DICTIONARY_DATASOURCE_FILTER')
select @nVer = dbo.obj_id('DICTIONARY_VERSION')
select @nProj = dbo.obj_id('DICTIONARY_PROJECT')
select @nProjExt = dbo.obj_id('DICTIONARY_PROJECT_EXT')
select @nRepWord = dbo.obj_id('DICTIONARY_WORD_TEMPLATE')
select @nUserId = user_id(suser_sname())


--    
create table #PROC (SORT int, LINK int, LINK_DEST int, NEW_NAME varchar(254), EVENT_TYPE	varchar(10), ROW_ID uniqueidentifier, RELATION int, [OBJECT] int)
execute ('insert #PROC (SORT, LINK, LINK_DEST, NEW_NAME, EVENT_TYPE, ROW_ID, RELATION, OBJECT) select SORT, LINK, LINK_DEST, left(NEW_NAME,254), EVENT_TYPE, ROW_ID, RELATION, dbo.obj_id([OBJ_CODE]) from ' + @cTables)

--select * from #PROC
--  
if exists(select top 1 1 from #PROC) and exists(select top 1 1 from [#PROC] where EVENT_TYPE = 'Delete')
	begin
		declare @nLink int, @nObject int
		select * into #VER_DEL from #PROC where EVENT_TYPE = 'Delete'

		create table #VER_DEL1 (VERSIONID int, LINK_SELF int, [OBJECT] int)
		create table #CL_DEL ([CLASSIFICATORID] int)
		create table #FILT_DEL ([FILTERID] int)
		create table #DR1 (STORAGEID int)
		create table #DR2 (MEASUREID int)
		create table #PROJ_DEL (VERSIONID int, LINK_SELF int, [OBJECT] int)

		while exists(select * from #VER_DEL)
			begin
				select @nLink = LINK, @nObject = [OBJECT] from #VER_DEL where SORT = (select min(SORT) from #VER_DEL)

				insert [#VER_DEL1] (VERSIONID,[OBJECT]) values(@nLink,@nObject)
				
				if not @nObject in (@nRepWord,@nDSI_Filter)
					insert [#VER_DEL1] (VERSIONID, LINK_SELF) select LINK, LINK_SELF from dbo.[TREE_VERSION](@nLink, 'DOWN')
					
				update [#VER_DEL1] set [OBJECT] = V.[OBJECT] from [VERSION] V where V.VERSIONID = #VER_DEL1.VERSIONID and #VER_DEL1.[OBJECT] is null 
				update [#VER_DEL1] set [OBJECT] = @nDSI_Filter where [OBJECT] is null
				
				--   - 				
				if exists(select * from #VER_DEL1 where [OBJECT] = @nAlg)
					begin
						delete #VER_DEL1
						where #VER_DEL1.OBJECT = @nDTS and exists (select top 1 * from #VER_DEL1 VD where #VER_DEL1.LINK_SELF = VD.VERSIONID and VD.[OBJECT] = @nAlg)
						
						insert #DR2 (MEASUREID) select TM.MEASUREID from #VER_DEL1 VD, [T_MEASURE] TM where VD.[OBJECT] = @nAlg and VD.VERSIONID = TM.[VERSIONID]
						insert #DR2 (MEASUREID) select M.MEASUREID from [MEASURES] M where exists(select 1 from #DR2 where MEASUREID = M.[MEASUREID_PARENT])
						
						delete [T_MEASURE_FILTER] where exists(select 1 from #DR2 where MEASUREID = [T_MEASURE_FILTER].MEASUREID)
						delete [T_MEASURE] where exists(select 1 from #DR2 where MEASUREID = [T_MEASURE].MEASUREID)
						delete [MEASURES] where exists(select 1 from #DR2 where MEASUREID = [MEASURES].[MEASUREID_PARENT])
						delete [MEASURES] where exists(select 1 from #DR2 where MEASUREID = [MEASURES].MEASUREID)
						delete #DR2
					end
					
				if exists (select 1 from #PROC P, [T_RELATION] TR, [VERSION] V
				 where P.EVENT_TYPE = 'Delete' and P.[OBJECT] = @nDTS and TR.RELID = P.RELATION and P.LINK = TR.CHILDID and V.[VERSIONID] = TR.PARENTID and V.OBJECT = @nAlg)
					begin
						delete #VER_DEL1
						from #PROC P, [T_RELATION] TR, #VER_DEL1 VD, [VERSION] V
						where P.EVENT_TYPE = 'Delete' and P.[OBJECT] = @nDTS and VD.[OBJECT] = @nDTS and TR.RELID = P.RELATION and P.LINK = TR.CHILDID and VD.VERSIONID = P.LINK and V.[VERSIONID] = TR.PARENTID and V.OBJECT = @nAlg

						delete [T_RELATION]
						from #PROC P, [T_RELATION] TR
						where P.[OBJECT] = @nDTS and TR.RELID = P.RELATION and P.LINK = TR.CHILDID
						
					end

				--    
				if exists(select * from #VER_DEL1 where [OBJECT] = @nProj)
					begin
						declare @nVerProj int
						insert [#PROJ_DEL] (VERSIONID, LINK_SELF) select VERSIONID, LINK_SELF from #VER_DEL1 where [OBJECT] in (@nProj,@nProjExt)
						
						while exists(select * from #PROJ_DEL)
							begin
								select top 1 @nVerProj = VERSIONID from #PROJ_DEL
								exec [CLEAR_DB] @nMode = 2, @nVerId = @nVerProj, @nNoResult = 1
								delete #PROJ_DEL where VERSIONID = @nVerProj
							end
						delete #PROJ_DEL
					end
 
 				--  ,    
				if exists(select * from #VER_DEL1 where [OBJECT] = @nVer)
					begin
						insert #CL_DEL ([CLASSIFICATORID]) select TV.[CLASSIFICATORID] from [T_VERSION] TV where TV.[VERSIONID] in (select [VERSIONID] from #VER_DEL1 where [OBJECT] = @nVer) and TV.[DELETED] = 0
						delete #CL_DEL from [CLASSIFICATORS] CL where CL.CLASSIFICATORID = #CL_DEL.CLASSIFICATORID and CL.[PARENTCLASSIFICATORID] is null
						delete #CL_DEL from [T_VERSION] TV where TV.CLASSIFICATORID = #CL_DEL.CLASSIFICATORID and not TV.[VERSIONID] in (select [VERSIONID] from #VER_DEL1 where [OBJECT] = @nVer)
						delete #CL_DEL from [T_STORAGE] TS where TS.CLASSIFICATORID = #CL_DEL.CLASSIFICATORID

--select * from [Classificators] where CLASSIFICATORID in (select [CLASSIFICATORID] from  #CL_DEL)
					end

				--    
				if exists(select * from #VER_DEL1 where [OBJECT] = @nDSI_Filter)
					begin
						insert #FILT_DEL ([FILTERID]) select VERSIONID from #VER_DEL1 where [OBJECT] = @nDSI_Filter
						delete #VER_DEL1 where [OBJECT] = @nDSI_Filter
					end
					
				begin transaction 
				begin try
					if exists(select * from [#VER_DEL1])
						begin
							execute DEL_STEP 'VERSION', 'VERSIONID', '#VER_DEL1'
						end

					if exists(select * from [#CL_DEL])
						execute DEL_STEP @prim_table = 'CLASSIFICATORS', @prim_col = 'CLASSIFICATORID', @prim_val_tab = '#CL_DEL'--, @nTestMode = 2

					if exists(select * from #FILT_DEL)
						execute DEL_STEP 'FILTER', 'FILTERID', '#FILT_DEL'
				end try
				begin catch
					declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
					select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
					raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
					print 'Procedure dbo.TREE_SAVE'

					if @@TRANCOUNT > 0
						rollback transaction
					return 1 
				end catch

				if @@TRANCOUNT > 0
					commit transaction

				delete #FILT_DEL
				delete #CL_DEL
				delete #VER_DEL1
				delete #VER_DEL where LINK = @nLink and [OBJECT] = @nObject
				delete #DR1
				delete #DR2
				delete #PROJ_DEL
			end
	end
	

--  
if exists(select * from #PROC)
	begin
		select @nSort = 0
		while exists(select * from #PROC) 
			begin
				select @cEvent = EVENT_TYPE from #PROC where SORT = @nSort

				-- Copy
				if @cEvent = 'Copy'
					begin
						insert T_RELATION (PARENTID, CHILDID) select P.LINK_DEST, P.LINK from #PROC P where P.SORT = @nSort
					end
					
				-- New
				if @cEvent = 'New' and not exists (select * from [#PROC] where [OBJECT] = @nDSI_Filter and SORT = @nSort)
					begin
						update #PROC set ROW_ID = newid() where EVENT_TYPE = 'New'
						select LINK as VERSIONID, NEW_NAME, OBJECT, LINK_DEST into #PROC1 from #PROC where EVENT_TYPE = 'New'

						execute SAVE_TABLE
							@cTable_R = 'VERSION',
							@cTable_S = '#PROC1',
							@cFields_R = 'NAME, DESCRIPTION, OBJECT',
							@cFields_S = 'NEW_NAME, NEW_NAME, OBJECT',
							@cKey_R = 'VERSIONID',
							@cKey_S = 'VERSIONID'
						
						insert [T_RELATION] ([PARENTID],[CHILDID])
						select LINK_DEST, VERSIONID from #PROC1

						insert [T_RELATION] ([PARENTID],[CHILDID])
						select dbo.[VersionParent](P.LINK_DEST), P.VERSIONID
						from [#PROC1] P, VERSION V
						where P.[OBJECT] = @nDTS and P.[LINK_DEST] = V.[VERSIONID] and V.[OBJECT]<>@nVer
						
						if exists (select * from #PROC1 where OBJECT = dbo.obj_id('DICTIONARY_RS_TEMPLATE'))
							begin
								insert dbo.REPORTEMPLATE (VERSIONID)
								select VERSIONID from #PROC1 where OBJECT = dbo.obj_id('DICTIONARY_RS_TEMPLATE')

								insert dbo.T_ACCESS (OBJECT, ID, ACCESS, USERS)
								select OBJECT, VERSIONID, 131071, @nUserId from #PROC1 where OBJECT = dbo.obj_id('DICTIONARY_RS_TEMPLATE')
							end
						
					end
				
				-- New
				if @cEvent = 'New' and exists (select * from [#PROC] where [OBJECT] = @nDSI_Filter and SORT = @nSort)
					begin
						update [FILTER] set [NAVIGATOR] = 1
						from [#PROC] P
						where SORT = @nSort and FILTER.[FILTERID] = P.LINK
					end

				-- DragDrop
				if @cEvent = 'DragDrop'
					begin
						update T_RELATION set PARENTID = P.LINK_DEST from #PROC P, T_RELATION TR where P.SORT = @nSort and P.RELATION = TR.RELID
					end

				delete #PROC where SORT = @nSort
				select @nSort = @nSort + 1
			end
	end


select 1 as LINK

GO















exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8336' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'TREE_SAVE'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[GET_ACCESS_TREE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[GET_ACCESS_TREE]
GO


CREATE procedure [dbo].[GET_ACCESS_TREE]
	@nNode int,
	@nObject int,
	@nDownLevel int = 0
as
begin
	set nocount on
	declare @nObjFilter int, @nUserId int, @nObjDS int, @filesCount int, @nObjUserFiles int, @nObjExportFiles int
	select @nObjFilter = dbo.[obj_id]('DICTIONARY_DATASOURCE_FILTER')
	select @nObjDS = dbo.[obj_id]('DICTIONARY_DATASOURCE')
	select @nObjUserFiles = dbo.[obj_id]('DICTIONARY_ATTACHED_FILE')
	select @nObjExportFiles = dbo.[obj_id]('DICTIONARY_EXPORTED_FILE')
	select @filesCount = 1
	
	
	--  
	if @nUserId is null
		select @nUserId = user_id(suser_sname())

	create table #TREE (SORT int identity(1, 1), LINK int, LINK_SELF int, NAME varchar (254), PARENT int, [OBJECT] int, OBJ_CODE varchar(50), IMAGE_NAME varchar(100), NODE_TYPE varchar(30), RELATION int, PLUGIN varchar(250))

	if @nObject = @nObjFilter
		begin
			insert #TREE (LINK, OBJ_CODE, NAME, RELATION)
			select F.[FILTERID], 'DICTIONARY_DATASOURCE_FILTER', F.[NAME],F.[FILTERID]
			from FILTER F
			where F.[FILTERID] = @nNode

			insert #TREE (LINK, LINK_SELF, OBJ_CODE, name, RELATION)
			select F.[VERSIONID], T.SORT, 'DICTIONARY_ATTACHED_FILE', F.[FILENAME],F.[VERSIONID]
			from #TREE T, ATTACHED_FILES F
			where T.[OBJ_CODE] = 'DICTIONARY_DATASOURCE_FILTER' and T.LINK = F.[RTID]
		end
	else
		begin
			insert #TREE (LINK, LINK_SELF) select top 1 CHILDID, Null from T_RELATION where CHILDID = @nNode
			insert #TREE (LINK, LINK_SELF) select LINK, LINK_SELF from dbo.TREE_VERSION(@nNode, 'DOWN')

			update #TREE set RELATION = TR.RELID from T_RELATION TR where TR.PARENTID = #TREE.LINK_SELF and TR.CHILDID = #TREE.LINK
			update #TREE set OBJ_CODE = dbo.obj_code(V.[OBJECT]) from VERSION V where LINK = V.VERSIONID

			update #TREE set RELATION = TR.RELID from T_RELATION TR where TR.PARENTID = #TREE.LINK_SELF and TR.CHILDID = #TREE.LINK
			update #TREE set OBJ_CODE = dbo.obj_code(V.[OBJECT]) from VERSION V where LINK = V.VERSIONID
			
			--  excel-     word 
			delete #TREE where OBJ_CODE = 'DICTIONARY_REPORT_TEMPLATE' and exists (select top 1 1 from [#TREE] T where T.OBJ_CODE = 'DICTIONARY_WORD_TEMPLATE' and #TREE.LINK_SELF = T.LINK)
			delete #TREE where OBJ_CODE = 'DICTIONARY_QUERY_DWH'
		end

	--  
	insert #TREE (LINK, LINK_SELF, OBJ_CODE, name, RELATION)
	select F.[FILTERID], T.SORT, 'DICTIONARY_DATASOURCE_FILTER', F.[NAME],F.[FILTERID]
	from #TREE T, FILTER F
	where T.[OBJ_CODE] = 'DICTIONARY_DATASOURCE' and F.[NAVIGATOR] = 1 and T.LINK = F.[VERSIONID]

	--    
	select @filesCount = COUNT(1) FROM T_RELATION WHERE CHILDID = @nNode
	if (@nObject = @nObjExportFiles or @nObject = @nObjUserFiles) and @filesCount = 0
		begin
			insert #TREE (LINK, OBJ_CODE, name)
			SELECT VERSIONID, dbo.obj_code([OBJECT]), [FILENAME] from ATTACHED_FILES where VERSIONID = @nNode
		end
		
	update #TREE set LINK_SELF = (select RTID from ATTACHED_FILES AF where AF.VERSIONID = #TREE.LINK) where OBJ_CODE = 'DICTIONARY_ATTACHED_FILE' and exists(select OBJ_CODE from #TREE t where t.LINK = #TREE.LINK_SELF and t.OBJ_CODE = 'DICTIONARY_DATASOURCE')
	
	update #TREE set IMAGE_NAME = 'Version', NODE_TYPE = 'NODE_VERSION' where OBJ_CODE = 'DICTIONARY_VERSION'
	update #TREE set IMAGE_NAME = 'Project', NODE_TYPE = 'NODE_PROJECT' where OBJ_CODE = 'DICTIONARY_PROJECT'
	update #TREE set IMAGE_NAME = 'project_analit', NODE_TYPE = 'NODE_PROJECT_CUBE' where OBJ_CODE = 'DICTIONARY_PROJECT' and exists (select * from T_CUBES TC where #TREE.RELATION = TC.RELID)
	update #TREE set IMAGE_NAME = 'Datasource', NODE_TYPE = 'NODE_DS' where OBJ_CODE = 'DICTIONARY_DATASOURCE'
	update #TREE set IMAGE_NAME = 'heracly', NODE_TYPE = 'NODE_ALGORITM' where OBJ_CODE = 'DICTIONARY_ALGORITHM_DWH'
	update #TREE set IMAGE_NAME = 'report_excel', NODE_TYPE = 'NODE_REP' where OBJ_CODE = 'DICTIONARY_REPORT_TEMPLATE'
	update #TREE set IMAGE_NAME = 'calc_table', NODE_TYPE = 'NODE_DS_FILTER' where OBJ_CODE = 'DICTIONARY_DATASOURCE_FILTER'
	update #TREE set IMAGE_NAME = 'report_query', NODE_TYPE = 'NODE_REP_RS' where OBJ_CODE = 'DICTIONARY_RS_TEMPLATE'
	update #TREE set IMAGE_NAME = 'report_word', NODE_TYPE = 'NODE_REP_WORD' where OBJ_CODE = 'DICTIONARY_WORD_TEMPLATE'
	update #TREE set IMAGE_NAME = 'dict', NODE_TYPE = 'NODE_TREE_VERSION' where OBJ_CODE is null
	update #TREE set #TREE.IMAGE_NAME = 'Datasource_ref' from #TREE, #TREE TR where #TREE.OBJ_CODE = 'DICTIONARY_DATASOURCE' and #TREE.[LINK_SELF] = TR.[SORT] and TR.[OBJ_CODE] = 'DICTIONARY_ALGORITHM_DWH'
	update #TREE set IMAGE_NAME = case when @filesCount = 0 then 'document_user' else 'attach' end, NODE_TYPE = 'NODE_ATTACHED_FILE' where OBJ_CODE = 'DICTIONARY_ATTACHED_FILE'
	update #TREE set IMAGE_NAME = 'export', NODE_TYPE = 'NODE_EXPORTED_FILE' where OBJ_CODE = 'DICTIONARY_EXPORTED_FILE'

	update #TREE set NAME = V.NAME from VERSION V where LINK = V.VERSIONID and #TREE.OBJ_CODE<>'DICTIONARY_DATASOURCE_FILTER'
	update #TREE set [OBJECT] = dbo.obj_id(OBJ_CODE)

	update #TREE set LINK_SELF = T.SORT from #TREE, #TREE T where #TREE.LINK_SELF = T.LINK and #TREE.OBJ_CODE<>'DICTIONARY_DATASOURCE_FILTER'


	alter table #TREE add IsRootLevel int
	update #TREE set IsRootLevel = 1 where SORT in (select LINK_SELF from #TREE where LINK_SELF is not null)

	
	update #TREE set LINK_SELF = (select link from #TREE t where #TREE.link_self = t.sort)
	--     
	if (@nDownLevel = 1) begin			
		delete from #TREE where LINK <> @nNode
	end
	else if (@nDownLevel = 2) begin
		delete from #TREE where LINK_SELF <> (select LINK from #TREE where LINK = @nNode) or LINK = @nNode
	end  		
						
	--    
	create table #GU ([UID] int, PARENT int, [NAME] varchar(250), [TYPE] char(1))
	create table #GU1 (SORT int identity(1,1), LINK_SELF int, [UID] int, [NAME] varchar(250), [TYPE] char(1))

	insert #GU (PARENT, UID, NAME,[TYPE])
	select UG.GROUPS, UG.USERS, SU.LOGINAME, SU.TYPE
	from dbo.USERS_GROUPS UG, dbo.S_USERS SU 
	where UG.USERS = SU.UID and UG.DIRECT = 1 and not UG.GROUPS in (select principal_id from sys.database_principals where name = 'KS_DDLControl' and type = 'R')

	insert #GU (UID, NAME,[TYPE])
	select distinct SU.UID, SU.LOGINAME, SU.TYPE
	from #GU GU, dbo.S_USERS SU
	where GU.PARENT = SU.UID and not exists(select * from #GU GU1 where GU1.UID = SU.UID)
	
	insert #GU (UID, NAME,[TYPE])
	select distinct SU.UID, SU.LOGINAME, SU.TYPE
	from dbo.S_USERS SU
	where not exists(select * from #GU GU1 where GU1.UID = SU.UID)

	delete [#GU] where dbo.[AdminIsUserAdm]([UID]) = 1

	insert #GU1 (LINK_SELF, UID, NAME, TYPE)
	select PARENT, UID, NAME, TYPE
	from #GU
	order by TYPE,PARENT,NAME

	update #GU1 set LINK_SELF = T.SORT from #GU1, #GU1 T where #GU1.LINK_SELF = T.UID
				
  --   
	select T.SORT, T.[OBJECT], T.[LINK], G.[UID], convert(int, Null) as ACCESS, convert(int, Null) as [GROUPS]
	into #TA
	from [#TREE] T, [#GU] G
	update #TA set [GROUPS] = UG.GROUPS from [USERS_GROUPS] UG where [#TA].[UID] = UG.[USERS]
	--   
	update [#TA] set [ACCESS] = dbo.get_access_cur_node ([OBJECT], [UID], [LINK])
	delete from [#TA] where [ACCESS] is null	
	
	--  						 	 		
	select SORT, LINK, LINK_SELF, NAME, PARENT, [OBJECT], OBJ_CODE, IMAGE_NAME, NODE_TYPE, RELATION, PLUGIN, dbo.get_val(OBJ_CODE, 'ACCESS_MASK', null) as ACCESS_MASK,IsRootLevel from #TREE order by LINK_SELF,name

	select [SORT], [LINK_SELF], [UID], [NAME], [TYPE] from [#GU1]

	select [OBJECT], [LINK], [UID], [ACCESS] from #TA order by [OBJECT], [LINK], [UID], [ACCESS]
			
	
end

GO







exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8620' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'GET_ACCESS_TREE'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[CLONE_MEASURE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[CLONE_MEASURE]
GO



/*
	:  

   :

   :
	
  :
 
  :
		 .
*/

Create procedure [dbo].[CLONE_MEASURE]
	@nLink int = 0
as
begin

	set nocount on
	if @nLink >0
		begin
			begin transaction
			begin try
				declare @nNewLink int
				insert dbo.MEASURES (FULLNAME, SHORTNAME, MDXEXPR, DESCRIPTION,
										PRECISION, OBJECT, USERS, ROW_ID, MEASUREID_PARENT,
										GRAPHCOL, FRMCOL, BGRCOL, DIMENSION, ZERO, MS_FORMULA_TYPE, MS_TYPE,ISGROUP,ParentMeasureId,HASH_CALC,DATA_TYPE,DATA_PROPERTY)
				select  left(' ' + FULLNAME, 500), SHORTNAME, MDXEXPR, DESCRIPTION,
										PRECISION, OBJECT, USERS, ROW_ID, MEASUREID_PARENT,
										GRAPHCOL, FRMCOL, BGRCOL, DIMENSION, ZERO, MS_FORMULA_TYPE, MS_TYPE,ISGROUP,ParentMeasureId,HASH_CALC,DATA_TYPE,DATA_PROPERTY
				from dbo.MEASURES
				where MEASUREID = @nLink
				
				select @nNewLink = @@IDENTITY
				
			end try
			begin catch
				select ERROR_NUMBER() as ErrorNumber, ERROR_SEVERITY() as ErrorSeverity, ERROR_STATE() as ErrorState,	ERROR_PROCEDURE() as ErrorProcedure, ERROR_LINE() as ErrorLine
				select 'Procedure dbo.CLONE_MEASURE. ', ERROR_MESSAGE() as ErrorMessage
				
				if @@TRANCOUNT > 0
					rollback transaction

				return -1
			end catch

			if @@TRANCOUNT > 0
				commit transaction
			
			select @nNewLink
		end
end	
	
GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8486' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'CLONE_MEASURE'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[DSI_SAVE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[DSI_SAVE]
GO


/* :      

    :

    :

   :
 
   :
		 .
*/

create procedure [dbo].[DSI_SAVE]
	@cTables	varchar(300) = '#cAlias1;#cAlias2;#cAlias3'
as
begin
	set transaction isolation level read uncommitted
	set nocount on

	declare @cTable2 varchar(100), @cTable3 varchar(100), @cCmd varchar(8000), @nSTID int,
		@cFields_S varchar(1000), @cKey_S varchar(100), @nUser int, @nFilterIdBlock int,@nRashDate varchar(8)

	select @cTable2 = dbo.j_sub_str(@cTables, ';', 2)
	select @cTable3 = dbo.j_sub_str(@cTables, ';', 3)

	select @nUser = user_id(suser_sname())
	select @nRashDate = dbo.get_val('NASTR_RASH_DATE', 'DATE_VALUE', @nUser)

	--  
	select top 1 @nSTID = VERSIONID from #cAlias3
	select top 1 @nFilterIdBlock = FILTERBLOCKED from #cAlias3

	if @nSTID is null
		begin
			raiserror ('     .', 16, 1)
			return
		end
		
	if exists(select top 1 * from #calias2 A where A.STORAGEID > 0 and not exists (select * from STORAGE S where A.STORAGEID = S.STORAGEID))
		begin
			raiserror (' .
	      .
	  .', 16, 1)
			return
		end

	--  
	create table #ST (SOURCETEMPLATEID int, CLASSIFICATORCODE varchar(70))
	create table #MEASURE (ID int, [ZERO] tinyint, [STR] tinyint, DATA_PROPERTY int)

	insert #ST (SOURCETEMPLATEID, CLASSIFICATORCODE)
	select ID, CODE from dbo.STORAGE_STRU(@nSTID) where DOF = 0

	insert #MEASURE (ID, [ZERO], [STR])
	select ID, [ZERO], [STR] from dbo.STORAGE_STRU(@nSTID) where DOF = 1

	--  ROW_ID
	update #cAlias2 set ROW_ID	= newid() where ROW_ID = convert(varbinary(36), '') or ROW_ID is Null

	--   -    Time
	update #cAlias2 set TIME = @nRashDate where TIME is null
	update #cAlias2 set TIMEKEY = T.TIMEKEY from [TIME] T where #cAlias2.TIME = T.FULLDATE and #cAlias2.TIMEKEY is Null

	if exists (select * from #cAlias2 where TIMEKEY is Null)
			insert [TIME] (FullDate) select distinct TIME from #cAlias2 where TIMEKEY is null

	update #cAlias2 set TIMEKEY = T.TIMEKEY from [TIME] T where #cAlias2.TIME = T.FULLDATE and #cAlias2.TIMEKEY is Null


	-- 
	begin transaction 
	begin try
		--   
		select STORAGEID into #ZERO from #cAlias2 where isnull(AMOUNT, 0.00) = 0.00 and exists(select * from #MEASURE where #cAlias2.[MEASUREID] = [ID] and ([STR]+[ZERO])=0)
		insert #ZERO (STORAGEID) select STORAGEID from #cAlias2 where MEASURE_STR is null and exists(select * from #MEASURE where #cAlias2.[MEASUREID] = [ID] and [STR]=1)
		insert #ZERO (STORAGEID) select STORAGEID from #cAlias2 where AMOUNT is null and exists(select * from #MEASURE where #cAlias2.[MEASUREID] = [ID] and [ZERO]=1)
		
		if exists(select * from #ZERO)
			begin
				delete STORAGE_APP from #ZERO Z where Z.STORAGEID = STORAGE_APP.STORAGEID
				delete T_STORAGE from #ZERO Z where Z.STORAGEID = T_STORAGE.STORAGEID
				delete STORAGE from #ZERO Z where Z.STORAGEID = STORAGE.STORAGEID
				delete #cAlias2 from #ZERO Z where Z.STORAGEID = #cAlias2.STORAGEID
			end

		--  "" 
		update #MEASURE set DATA_PROPERTY = MS.DATA_PROPERTY from MEASURES MS where MS.MEASUREID = #MEASURE.ID

		if exists (select * from #MEASURE where isnull(DATA_PROPERTY,0)>0)
			begin
				--     #cAlias1
				delete #cAlias1 from #ZERO Z where Z.STORAGEID = #cAlias1.STORAGEID
				
				--     #cAlias1
				delete #cAlias1 where not MEASUREID in (select ID from #MEASURE where isnull(DATA_PROPERTY,0)>0)
				
				--       #cAlias1
				delete #cAlias1 where isnull(TIMEKEY,0) = @nRashDate

				--    #cAlias1
				delete #cAlias1 
				from #cAlias1 A1, #cAlias2 A2, #MEASURE MS
				where A1.[STORAGEID] = A2.[STORAGEID] and A1.MEASUREID = MS.ID and A2.MEASUREID = MS.ID and isnull(MS.DATA_PROPERTY,0)>0

				-- 
				update #cAlias2 set [STORAGE_SELF] = null
				from #MEASURE MS
				where MS.ID = #cAlias2.MEASUREID and isnull(MS.DATA_PROPERTY,0) > 0
				
				--     #cAlias2
				update #cAlias2 set [STORAGEID] = -[STORAGEID], MODIFY_FLAG = 1
				from #MEASURE MS
				where MS.ID = #cAlias2.MEASUREID and isnull(MS.DATA_PROPERTY,0) > 0 and isnull(#cAlias2.TIMEKEY,0) < @nRashDate and isnull([STORAGEID],0)>0
				
				update #cAlias1 set [STORAGE_SELF] = [STORAGEID] where [STORAGE_SELF] is null and isnull(#cAlias1.TIMEKEY,0) < @nRashDate
				update #cAlias1 set [STORAGEID] = -[STORAGEID], ROW_ID = newid() where isnull(#cAlias1.TIMEKEY,0) < @nRashDate
				insert #cAlias2 select * from #cAlias1

				--   .   0
				update #cAlias2 set AMOUNT = 0 from #MEASURE MS where MS.ID = #cAlias2.MEASUREID and isnull(MS.DATA_PROPERTY,0) = 1 and
					isnull(#cAlias2.MODIFY_FLAG,0) = 0 and isnull(#cAlias2.TIMEKEY,0) < @nRashDate
				
				--  ,  
				update #cAlias2 set TIMEKEY = @nRashDate
				from #MEASURE MS
				where MS.ID = #cAlias2.MEASUREID and isnull(MS.DATA_PROPERTY,0) > 0 and isnull(#cAlias2.TIMEKEY,0) < @nRashDate

				--   -    Time
				update #cAlias2 set [TIME] = null where convert(datetime, convert(varchar(8),TIMEKEY)) <> [TIME]
				update #cAlias2 set [TIME] = T.FULLDATE from [TIME] T where #cAlias2.TIMEKEY = T.TIMEKEY

				if exists (select * from #cAlias2 where [TIME] is Null)
					insert [TIME] (FullDate) select distinct convert(varchar(8),TIMEKEY) from #cAlias2 where [TIME] is null

--select * from #cAlias111111111
--select * from #cAlias1
--select 1, * from #cAlias2

				--  
				insert STORAGE (VERSIONID,AMOUNT,TIMEKEY,MEASUREID,FILTERID,STRID,ROW_ID,STORAGE_SELF)
				select @nSTID,AMOUNT,TIMEKEY,MEASUREID,FILTERID,STRID,ROW_ID,STORAGE_SELF
				from #cAlias2 A, #MEASURE MS
				where isnull(A.STORAGEID,0)<=0 and MS.ID = A.MEASUREID and isnull(MS.DATA_PROPERTY, 0) > 0 and isnull(A.MODIFY_FLAG,0) = 0 and
					not A.STORAGE_SELF is null


--select 2,* from #cAlias2

				delete #cAlias2
				from #cAlias2 A, #MEASURE MS
				where isnull(A.STORAGEID,0)<=0 and MS.ID = A.MEASUREID and isnull(MS.DATA_PROPERTY, 0) > 0 and isnull(A.MODIFY_FLAG,0) = 0 and
					not A.STORAGE_SELF is null
			
				select @cCmd = 'update #cAlias2 set ROW_ID=newid(),' + (select stuff((select ',[' + replace(ST.CLASSIFICATORCODE, 'CL','TSID') + ']=Null' as [text()] from #ST ST for xml path('')),1,1,''))
				+ ' from #cAlias2 A, #MEASURE MS
				where isnull(A.STORAGEID,0)<=0 and MS.ID = A.MEASUREID and isnull(MS.DATA_PROPERTY, 0) > 0 and isnull(A.MODIFY_FLAG,0) = 1'
--select @cCmd
				exec (@cCmd)
			end
			
--select 3,* from #cAlias2
--select 3,* from #cAlias212312321

		--  
		update STORAGE set VERSIONID=@nSTID,AMOUNT=A.AMOUNT,TIMEKEY=A.TIMEKEY,MEASUREID=A.MEASUREID,FILTERID=A.FILTERID,STRID=A.STRID,STORAGE_SELF=A.STORAGE_SELF
		from #cAlias2 A
		where STORAGE.STORAGEID = A.STORAGEID and A.STORAGEID>0 and A.MEASURE_STR is null
	  
		--  
		insert STORAGE (VERSIONID,AMOUNT,TIMEKEY,MEASUREID,FILTERID,STRID,ROW_ID)
		select @nSTID,AMOUNT,TIMEKEY,MEASUREID,FILTERID,STRID,ROW_ID
		from #cAlias2
		where isnull(STORAGEID,0)<=0

		--     Id
		update #cAlias2 set STORAGEID = A.STORAGEID from STORAGE A, #cAlias2 B where A.ROW_ID = B.ROW_ID and isnull(B.STORAGEID,0)<=0
		
		--     
		insert MEASURE_CHANGE (VERSIONID, MEASUREID)
		select distinct @nSTID,T.MEASUREID from #cAlias2 T
		where not exists (select top 1 * from MEASURE_CHANGE MS where T.MEASUREID = MS.MEASUREID and MS.VERSIONID = @nSTID and PROJID is null)

		insert MEASURE_CHANGE (VERSIONID, MEASUREID)
		select @nSTID,ID from dbo.STORAGE_STRU(@nSTID) ST where ST.DOF = 1 and ST.[STR] = 1
		and not exists (select top 1 * from MEASURE_CHANGE MS where ST.ID = MS.MEASUREID and MS.VERSIONID = @nSTID and PROJID is null)


		--   STORAGE_APP
		create table #STA (STORAGEID int, MEASURE_STR varchar(4000), MEASUREID_STR int, ROW_ID uniqueidentifier)
		
		update #cAlias2 set [MEASUREID_STR] = null where [MEASUREID_STR] <=0
		
		insert [#STA] (STORAGEID, MEASURE_STR, MEASUREID_STR, ROW_ID)
		select STORAGEID, left(MEASURE_STR,4000), MEASUREID_STR, newid()
		from #cAlias2
		where not MEASURE_STR is null or not MEASUREID_STR is null

		update STORAGE_APP set STORAGEID=A.STORAGEID,[VALUE]=A.MEASURE_STR
		from #STA A 
		where STORAGE_APP.SAID = A.MEASUREID_STR and A.MEASUREID_STR>0
	
		update STORAGE set FILTERID=A.FILTERID,STRID=A.STRID
		from #cAlias2 A
		where STORAGE.STORAGEID = A.STORAGEID and not A.MEASURE_STR is null and
		 isnull(A.MEASUREID_STR,0)>0 and isnull(A.STORAGEID,0)>0

		
		insert STORAGE_APP (STORAGEID,[VALUE],ROW_ID)
		select STORAGEID,MEASURE_STR,ROW_ID
		from #STA
		where isnull(MEASUREID_STR,0)<=0
		
		update #cAlias2 set [MEASUREID_STR] = SA.SAID
		from STORAGE_APP SA, #STA S
		where SA.ROW_ID = S.ROW_ID and #cAlias2.STORAGEID = SA.STORAGEID and S.STORAGEID = SA.STORAGEID
		
		--      hash
		select ID, [STR] into #FILT_RATE from dbo.STORAGE_STRU(@nSTID) where DOF = 1 and isnull(HASH_CALC,0) > 0

		if exists (select * from #FILT_RATE)
			begin
--select * from #FILT_RATE
				declare @cHashCl varchar(1000)
				select @cHashCl = [HASH] from #cAlias3

--select @cHashCl
				
				if @cHashCl is null
					print '        !'
				else
					begin	
						select @cCmd = '
						select STORAGEID, ' + (select stuff((select '+'',''+convert(varchar(20),[CL-' + convert(varchar(20),@nSTID) + '-' + convert(varchar(20),A.Value) + '])' as [text()] from (select value from dbo.StrSplit(@cHashCl,',')) A for xml path('')),1,1,'')) + ' as STRING, HASH_SUM
						into #HS
						from #cAlias2
						where MEASUREID in (select ID from #FILT_RATE)
--select 1,* from #HS
						update #HS set HASH_SUM = dbo.GetHash([STRING],''MD5'')
--select 2,* from #HS
--select 3 from #cAlias2
						update #cAlias2 set HASH_SUM = H.HASH_SUM from #HS H where #cAlias2.STORAGEID = H.STORAGEID'
						exec (@cCmd)
--select 4,* from #cAlias2
						--   
						delete STORAGE_APP
						from #FILT_RATE FR, #cAlias2 A, STORAGE_APP SA
						where A.MEASUREID = FR.ID and isnull(A.STORAGEID,0) > 0 and SA.STORAGEID = A.STORAGEID and not SA.HASH_SUM is null and FR.[STR] = 0
						
						insert STORAGE_APP (STORAGEID, HASH_SUM)
						select A.STORAGEID, A.HASH_SUM
						from #FILT_RATE FR, #cAlias2 A
						where A.MEASUREID = FR.ID and isnull(A.STORAGEID,0) > 0 and FR.[STR] = 0
						
						--   
						update STORAGE_APP set HASH_SUM = A.HASH_SUM
						from #FILT_RATE FR, #cAlias2 A
						where A.STORAGEID = STORAGE_APP.STORAGEID and A.MEASUREID = FR.ID and isnull(A.STORAGEID,0) > 0 and not A.MEASUREID_STR is null and not A.HASH_SUM is null and FR.[STR] = 1
					end
			end
			
	
		--   T_STORAGE
		declare @nST int, @cCode varchar(70)
		create table #TS (TSID int, STORAGEID int, CLASSIFICATORID int, SOURCETEMPLATEID int)
		create table #TS_DEL (TSID int)

		while exists(select * from #ST)
		begin
			select top 1 @nST = SOURCETEMPLATEID from #ST
			select @cCode = CLASSIFICATORCODE from #ST where SOURCETEMPLATEID = @nST
			
			if col_length('tempdb..' + @cTable2, @cCode) > 0
				begin
					select @cFields_S = 'STORAGEID, [' + @cCode + '], ' + convert(varchar(20), @nST)
					select @cKey_S = '[TSID-' + convert(varchar(20), @nSTID) + '-' + dbo.j_sub_str(@cCode, '-', 3) + ']'
					
					execute('
					insert #TS (TSID, STORAGEID, CLASSIFICATORID, SOURCETEMPLATEID)
					select ' + @cKey_S + ',' + @cFields_S + ' from ' + @cTable2 + ' where not [' + @cCode + '] is null' )
					
					execute('
					insert #TS_DEL (TSID)
					select ' + @cKey_S + ' from ' + @cTable2 + ' where [' + @cCode + '] is null and not ' + @cKey_S + ' is null')

				end
			delete #ST where SOURCETEMPLATEID = @nST
		end


		--    ""  
		declare @Ver int
		select @Ver = dbo.ParentId(@nSTID, 'VERSION')

		--   
		select SourceElementID , TargetElementID
		into #DataMigration
		from dbo.DataMigration
		where SourceElementID in (select ClassificatorID from t_version where deleted = 1 and versionid = @Ver)

		--  id  
		update #TS set ClassificatorID = A.TargetElementID from #DataMigration A where #TS.ClassificatorID = A.SourceElementID


		if exists(select * from #TS where TSID>0)
			update T_STORAGE set STORAGEID=A.STORAGEID,CLASSIFICATORID=A.CLASSIFICATORID,SOURCETEMPLATEID=A.SOURCETEMPLATEID
			from #TS A 
			where T_STORAGE.TSID = A.TSID and A.TSID>0

		if exists(select * from #TS where isnull(TSID,0)<=0)
			insert T_STORAGE (STORAGEID,CLASSIFICATORID,SOURCETEMPLATEID)
			select STORAGEID,CLASSIFICATORID,SOURCETEMPLATEID
			from #TS
			where isnull(TSID,0)<=0
		
		if exists(select * from #TS_DEL)
			delete T_STORAGE from #TS_DEL TS where TS.TSID = T_STORAGE.TSID
	  
		if @nFilterIdBlock > 0
			exec ManageBlock 1, @nFilterIdBlock
	end try
	begin catch
		declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
		select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
		print 'Procedure dbo.DSI_SAVE'

		if @@TRANCOUNT > 0
			rollback transaction
		return 1
	end catch

	if @@TRANCOUNT > 0
		commit transaction

	if left(dbo.get_val('NASTR_USE_EDS','CASE_VALUE', null), 1) = 1 and 
		left(dbo.get_val('NASTR_EDS_SAVEDOC_BEHAVIOR','CASE_VALUE', null), 1) = 1
	begin
		print '  '
	end

	select 1 as LINK
end


GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8660' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'DSI_SAVE'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[GetBindingClass]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[GetBindingClass]
GO

create procedure [dbo].[GetBindingClass]
	@classId int
as
begin
	
	declare @nDictVersion int,@nDictDataSource int,@nDictId int,@isDictId int
	
	select @nDictDataSource = dbo.obj_id('DICTIONARY_DATASOURCE')
	select @nDictVersion = dbo.obj_id('DICTIONARY_VERSION')
	
	
	if (exists(select * from Classificators c where c.ClassificatorID = @classId and c.ParentClassificatorID is null))
	begin	
		set @nDictId = @classId
		set @isDictId = 1
	end 
	else		
		set @nDictId = (select dbo.ClassificatorIdParent(@classId))
		
	--0- 1- 2-
	create table #VER(link int,link_self int,name varchar(1000),description varchar(1024),[object] int,[Type] int default(0))	
	insert into #VER(link,link_self,name,[description],[object])
	select link,link_self,name,[description],[object] from dbo.[TREE_VERSION](Null, 'DOWN') A, VERSION V 
	            where  A.LINK = V.VERSIONID and (V.OBJECT = @nDictVersion or V.OBJECT = @nDictDataSource)

	
	--     
	delete from #VER where link_self in
	( 
		select link_self from #VER v2 where not exists (select * from #VER v1 where v1.link = v2.link_self) and link_self is not null
	)

	--    
	delete from #VER where link not in 
	(
		select link from #VER where dbo.CheckClassInVersion(link,@nDictId) = 1
	) and [object] = @nDictVersion

	--    
	delete from #VER where link not in 
	(
		select link from #VER v
		inner join SourceTemplate ST on ST.classificatorId = @nDictId and  ST.versionId = v.link
		where [object] = @nDictDataSource		
	) and [object] = @nDictDataSource
	
	update #VER set [Type] = 1 where [object] =  @nDictDataSource
	
	--   		
	--     				
	if (@isDictId <> 1)
	begin
	
		select distinct st.VERSIONID,st.FILTERID into #FILT from STORAGE st
		where versionid in (select link from #VER where [object] = @nDictDataSource)
			  and exists (select * from t_storage t_st where t_st.STORAGEID = st.STORAGEID and t_st.classificatorid = @classId)
				  			  
		delete from #VER where link not in (select versionid from #FILT) and [object] = @nDictDataSource
		
		-- insert filter
		insert into #VER(link,link_self,name,[Type])		
		select #FILT.FILTERID,#FILT.VERSIONID,f.NAME,2 from #FILT
		inner join FILTER f on f.FILTERID = #FILT.FILTERID
		where #FILT.FILTERID is not null
				
		--   		
		;with cte(link, link_self) as
		(			
			select b.link, b.link_self
			from #VER a inner join #VER b on a.[link] = b.[link_self]
		)		
								
		delete from #VER where link in 
		( 						
			select link FROM cte 
		where link in (select link from #VER v1 where [object] = @nDictVersion and not exists(select * from #VER v2 where v2.link_self = v1.link))	
		)
		
																					
	end
	
	--     , link_self   null
	update #VER set link_self = null where link_self not in (select link from #VER)
	select * from #VER 
	
end

GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8383' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'GETBINDINGCLASS'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[VERSION_SAVE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[VERSION_SAVE]
GO



/* :  

    :

    :

   :
 
   :
		 .
*/

create procedure [dbo].[VERSION_SAVE]
	@cTables	varchar(300) = '#cAlias;#cAlias1;#cAlias2;#cAlias3',
	@cObjCode	varchar(30) = ''
as

set nocount on

declare @cTable varchar(100), @cTable1 varchar(100), @cTable2 varchar(100), @cTable3 varchar(100), @cCmd varchar(7000)
declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int


select @cTable = dbo.j_sub_str(@cTables, ';', 1)
select @cTable1 = dbo.j_sub_str(@cTables, ';', 2)
select @cTable2 = dbo.j_sub_str(@cTables, ';', 3)
select @cTable3 = dbo.j_sub_str(@cTables, ';', 4)

--  
--    
declare @cObjId varchar(20)
select @cObjId = str(dbo.obj_id(@cObjCode))

if @cObjId is not null
    execute('update ' + @cTable + ' set OBJECT = ' + @cObjId + ' where isnull(OBJECT, 0) = 0')

--  ROW_ID
execute ('update ' + @cTable + '  set ROW_ID	= newid() where ROW_ID = convert(varbinary(36), '''') or ROW_ID is Null')


--      link_self   
create table #SYNC (VERSIONID int, VERSIONID_OLD int, ROW_ID uniqueidentifier, CL varchar(100))

execute ('insert #SYNC (VERSIONID, VERSIONID_OLD, ROW_ID) select VERSIONID, VERSIONID, ROW_ID from ' + @cTable + ' where VERSIONID <= 0')	

--  escape-
execute ('update ' + @cTable + ' set NAME = ltrim(rtrim(NAME)), DESCRIPTION = ltrim(rtrim(DESCRIPTION))')
execute ('update ' + @cTable + ' set NAME = dbo.RegExReplace(isnull(NAME,''''),''[\u0000-\u001F]'',''''), [DESCRIPTION] = dbo.RegExReplace(isnull([DESCRIPTION],''''),''[\u0000-\u001F]'','''')')
		
-- 
begin transaction 
begin try
	execute SAVE_TABLE
		@cTable_R = 'VERSION',
		@cTable_S = @cTable,
		@cFields_R = 'NAME, DESCRIPTION, BEGINDATETIME, ENDDATETIME, ORDERS, CODE, OBJECT, DATA',
		@cFields_S = 'NAME, DESCRIPTION, BEGINDATETIME, ENDDATETIME, ORDERS, CODE, OBJECT, DATA',
		@cKey_R = 'VERSIONID',
		@cKey_S = 'VERSIONID'
end try
begin catch
	select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
	raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
	print 'Procedure dbo.VERSION_SAVE'

	if @@TRANCOUNT > 0
		rollback transaction
	
	return 1 
end catch

if @@TRANCOUNT > 0
	commit transaction

--  
execute ('update #SYNC set VERSIONID = S.VERSIONID from ' + @cTable + ' S where #SYNC.ROW_ID = S.ROW_ID')

if not @cObjCode in ('DICTIONARY_REPORT_TEMPLATE', 'DICTIONARY_QUERY_DWH', 'DICTIONARY_RS_TEMPLATE', 'DICTIONARY_WORD_TEMPLATE', 'DICTIONARY_ATTACHED_FILE')
	begin
		execute('update ' + @cTable1 + ' set PARENT = S.VERSIONID from #SYNC S where ' + @cTable1 + '.PARENT = S.VERSIONID_OLD')
	end

if @cObjCode = 'DICTIONARY_PROJECT'
	begin
		execute SAVE_TABLE
			@cTable_R = 'T_MEASURE_PROJ',
			@cTable_S = @cTable2,
			@cFields_R = 'VERSIONID, MEASUREID, AUTOCALC, PROCESS',
			@cFields_S = 'PARENT, ID, UNITID, DEPLOY',
			@cKey_R = 'TMPID',
			@cKey_S = 'TMID'


		execute SAVE_TABLE
			@cTable_R = 'T_CLASSIFICATORS',
			@cTable_S = @cTable1,
			@cFields_R = 'VERSIONID, CLASSIFICATORID, PROCESS',
			@cFields_S = 'PARENT, ID, ORDERS',
			@cKey_R = 'TCID',
			@cKey_S = 'SOURCETEMPLATEID'

	end

--     
if @cObjCode = 'DICTIONARY_VERSION'
	begin
		begin transaction 
		begin try
	
			execute ('
			if exists (select * from ' + @cTable1 + ')
				begin
					declare @nVerId int
					select @nVerId = VERSIONID from ' + @cTable + '
					
					select distinct SS.CLID
					into #DS
					from dbo.TREE_VERSION(@nVerId, ''DOWN'') A, VERSION V cross apply dbo.STORAGE_STRU(V.VERSIONID) SS
					where
						A.LINK = V.VERSIONID and V.OBJECT = dbo.obj_id(''DICTIONARY_DATASOURCE'') and SS.DOF = 0 and
						not exists (select * from ' + @cTable1 + ' where ID = SS.CLID)
					
					update ' + @cTable1 + ' set PARENT = @nVerId
					
					select
						@nVerId as VERSIONID,
						CL.CLASSIFICATORID,
						(select TV.DELETED from T_VERSION TV where TV.VERSIONID = @nVerId and CL.CLASSIFICATORID = TV.CLASSIFICATORID) as DELETED
					into #aaa 
					from Classificators CL 
					where CL.ParentClassificatorID is null

					insert T_VERSION (VERSIONID,CLASSIFICATORID,DELETED)
					select A.VERSIONID, A.CLASSIFICATORID, 1 from #aaa A
					where
						not exists (select * from T_VERSION TV where TV.CLASSIFICATORID = A.CLASSIFICATORID and TV.VERSIONID = A.VERSIONID)
						and not exists (select * from ' + @cTable1 + ' T1 where A.CLASSIFICATORID = T1.[ID])
						and not exists (select * from #DS D where A.CLASSIFICATORID = D.CLID)

					update T_VERSION set DELETED = 1
					from #aaa TV
					where
						T_VERSION.CLASSIFICATORID = TV.CLASSIFICATORID and T_VERSION.VERSIONID = TV.VERSIONID and
						not exists (select * from ' + @cTable1 + ' T1 where TV.CLASSIFICATORID = T1.[ID]) and
						not exists (select * from #DS D where T_VERSION.CLASSIFICATORID = D.CLID)
						
					delete ' + @cTable1 + ' from T_VERSION TV where TV.VERSIONID = ' + @cTable1 + '.[PARENT] and TV.CLASSIFICATORID = ' + @cTable1 + '.[ID] and DELETED = 0
					update T_VERSION set DELETED = 0 from ' + @cTable1 + ' T1 where T_VERSION.CLASSIFICATORID = T1.[ID] and T_VERSION.VERSIONID = T1.[PARENT]
					insert T_VERSION (CLASSIFICATORID,VERSIONID,DELETED) select distinct [ID],[PARENT],0 from ' + @cTable1 + ' T1 where not exists (select * from T_VERSION TV where TV.CLASSIFICATORID = T1.[ID] and TV.VERSIONID = T1.[PARENT])
				end					
			')

		end try
		begin catch
			select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
			raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
			print 'Procedure dbo.VERSION_SAVE.   DICTIONARY_VERSION'

			if @@TRANCOUNT > 0
				rollback transaction

			return 1 
		end catch
		
		if @@TRANCOUNT > 0
			commit transaction
	end


if @cObjCode = 'DICTIONARY_DATASOURCE'
	begin
		begin transaction 
		begin try
			--  ROW_ID
			execute ('delete #cAlias1 where isnull(ID, -1) < 0
			update #cAlias1 set ORDERS = 0 where ORDERS is null
			update #cAlias1 set ISAGGREGATABLE = 0 where ISAGGREGATABLE is null
			update #cAlias1 set GRP = 1 where GRP is null
			update #cAlias1 set ROW_ID = newid() where ROW_ID = convert(varbinary(36), '''') or ROW_ID is Null

			delete #cAlias1 from #cAlias1 A where exists (select * from #cAlias1 B where not B.sourcetemplateid is null and B.id = A.id) and A.sourcetemplateid is null
			')

			execute SAVE_TABLE
				@cTable_R = 'SOURCETEMPLATE',
				@cTable_S = '#cAlias1',
				@cFields_R = 'VERSIONID, CLASSIFICATORID, MULTISELECTION, MUSTINPUT, GRP',
				@cFields_S = 'PARENT, ID, ORDERS, ISAGGREGATABLE, GRP',
				@cKey_R = 'SOURCETEMPLATEID',
				@cKey_S = 'SOURCETEMPLATEID',
				@cDel_R = 'VERSIONID',
				@cDel_S = 'PARENT'


			--     
			update #cAlias2 set PARENT = S.VERSIONID from #SYNC S where #cAlias2.PARENT = S.VERSIONID_OLD

			--  ROW_ID
			update #cAlias2 set ROW_ID = newid() where ROW_ID = convert(varbinary(36), '') or ROW_ID is Null
			exec ('alter table #cAlias2 add [OBJECT] int')
			exec ('update #cAlias2 set OBJECT = dbo.obj_id(''DICTIONARY_MEASURE'')')

			execute SAVE_TABLE
				@cTable_R = 'MEASURES',
				@cTable_S = '#cAlias2',
				@cFields_R = 'FULLNAME, SHORTNAME, OBJECT',
				@cFields_S = 'NAME, SHORTNAME, OBJECT',
				@cKey_R = 'MEASUREID',
				@cKey_S = 'ID'

			exec('select VERSIONID, MEASUREID into #ZZZ from T_MEASURE TM where exists(select * from #cAlias2 T where T.PARENT = TM.VERSIONID) and not exists(select * from #cAlias2 T where T.PARENT = TM.VERSIONID and T.ID = TM.MEASUREID)
			delete T_MEASURE from #ZZZ Z where Z.VERSIONID = T_MEASURE.VERSIONID and Z.MEASUREID = T_MEASURE.MEASUREID
			select S.STORAGEID into #ZZZ1 from #ZZZ Z inner join STORAGE S on (Z.VERSIONID = S.VERSIONID and Z.MEASUREID = S.MEASUREID)
			delete T_STORAGE from #ZZZ1 Z where T_STORAGE.STORAGEID = Z.STORAGEID
			delete STORAGE from #ZZZ1 Z where STORAGE.STORAGEID = Z.STORAGEID')
			
			exec ('delete #cAlias2 from #cAlias2 A where exists (select * from #cAlias2 B where not B.TMID is null and B.ID = A.ID) and A.TMID is null')

			execute SAVE_TABLE
				@cTable_R = 'T_MEASURE',
				@cTable_S = '#cAlias2',
				@cFields_R = 'VERSIONID, MEASUREID',
				@cFields_S = 'PARENT, ID',
				@cKey_R = 'TMID',
				@cKey_S = 'TMID',
				@cDel_R = 'VERSIONID',
				@cDel_S = 'PARENT'

			--   
			update dbo.VERSION set ROW_ID = newid() from #cAlias A where A.VERSIONID = dbo.VERSION.VERSIONID

		end try
		begin catch
			select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
			raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
			print 'Procedure dbo.VERSION_SAVE.   DICTIONARY_DATASOURCE'

			if @@TRANCOUNT > 0
				rollback transaction

			return 1 
		end catch
		
		if @@TRANCOUNT > 0
			commit transaction
	end


--  
if @cObjCode = 'DICTIONARY_ALGORITHM_DWH'
	begin
		-- 
		create table #EMPTYM (MEASUREID int)
		exec('insert #EMPTYM (MEASUREID) select MEASUREID from ' + @cTable2 + ' where isnull(FULLNAME, '''') = '''' or isnull(SHORTNAME, '''') = ''''')

		if exists (select * from #EMPTYM)
			begin
				raiserror('      .',16,1)
				return
			end
		
		begin transaction
		begin try
			create table #SYNC1 (MEASUREID int, MEASUREID_OLD int, ROW_ID uniqueidentifier)
			

			execute('update ' + @cTable2 + ' set PARENT = S.VERSIONID from #SYNC S where ' + @cTable2 + '.PARENT = S.VERSIONID_OLD')

			--  ROW_ID
			execute ('update ' + @cTable2 + ' set ROW_ID = newid() where ROW_ID = convert(varbinary(36), '''') or ROW_ID is Null')
			execute ('insert #SYNC1 (MEASUREID, MEASUREID_OLD, ROW_ID) select MEASUREID, MEASUREID, ROW_ID from ' + @cTable2 + ' where MEASUREID <= 0')

			execute SAVE_TABLE
				@cTable_R = 'MEASURES',
				@cTable_S = @cTable2,
				@cFields_R = 'FULLNAME, SHORTNAME, MDXEXPR, [PRECISION], DESCRIPTION',
				@cFields_S = 'FULLNAME, SHORTNAME, MDXEXPR, [PRECISION], DESCRIPTION',
				@cKey_R = 'MEASUREID',
				@cKey_S = 'MEASUREID'

			execute('update #SYNC1 set MEASUREID = S.MEASUREID from ' + @cTable2 + ' S where #SYNC1.ROW_ID = S.ROW_ID')
			execute('update ' + @cTable2 + ' set SUBMEASUREID = S.MEASUREID from #SYNC1 S where S.MEASUREID_OLD = ' + @cTable2 + '.SUBMEASUREID')
			--        
			execute('update ' + @cTable2 + ' set OBJECT = dbo.obj_id(''DICTIONARY_CALC_MEASURE'') where OBJECT is Null')

			execute SAVE_TABLE
				@cTable_R = 'MEASURES',
				@cTable_S = @cTable2,
				@cFields_R = 'MEASUREID_PARENT, FULLNAME, SHORTNAME, MDXEXPR, [PRECISION], DESCRIPTION, OBJECT, GRAPHCOL, FRMCOL, BGRCOL, DIMENSION',
				@cFields_S = 'SUBMEASUREID, FULLNAME, SHORTNAME, MDXEXPR, [PRECISION], DESCRIPTION, OBJECT, GRAPHCOL, FRMCOL, BGRCOL, OBJ_CODE',
				@cKey_R = 'MEASUREID',
				@cKey_S = 'MEASUREID'

			execute SAVE_TABLE
				@cTable_R = 'T_MEASURE',
				@cTable_S = @cTable2,
				@cFields_R = 'VERSIONID, MEASUREID',
				@cFields_S = 'PARENT, MEASUREID',
				@cKey_R = 'TMID',
				@cKey_S = 'TMID',
				@cDel_R = 'VERSIONID',
				@cDel_S = 'PARENT'
			
			execute('	
			if not exists(select * from ' + @cTable2 + ')
				begin
					select TM.[MEASUREID]
					into #qqq
					from MEASURES, T_MEASURE TM
					where TM.[MEASUREID] = MEASURES.[MEASUREID] and TM.[VERSIONID] = (select VERSIONID from ' + @cTable + ')

					delete T_MEASURE where VERSIONID = (select VERSIONID from ' + @cTable + ')
			
					delete MEASURES from #qqq TM
					where TM.[MEASUREID] = MEASURES.[MEASUREID]
					
				end
			')

			if exists(select * from #SYNC1)
				begin
					declare @nOrd int, @cMO varchar(20), @cM varchar(20)
					select identity(int,1,1) as ORDERS, * into #REPL from [#SYNC1]
					
					while exists (select * from #REPL)
						begin
							select @nOrd = ORDERS, @cMO = convert(varchar(20), MEASUREID_OLD), @cM  = convert(varchar(20), MEASUREID) from [#REPL]

							execute('
							update MEASURES set MEASURES.MDXEXPR = replace(MEASURES.MDXEXPR, ''_' + @cMO + ''', ''_' + @cM + ''')
							from ' + @cTable2 + ' T
							where T.MEASUREID = MEASURES.MEASUREID
							')

							delete [#REPL] where [ORDERS] = @nOrd
						end
				
					execute('update ' + @cTable3 + ' set MEASUREID = S.MEASUREID from #SYNC1 S where S.MEASUREID_OLD = ' + @cTable3 + '.MEASUREID')
				end
				
			execute('
			select MEASUREID into #AAA from ' + @cTable2 + ' where not MEASUREID in (select MEASUREID from ' + @cTable3 + ')
			delete T_MEASURE_FILTER where MEASUREID in (select MEASUREID from #AAA)
			')
				
			execute SAVE_TABLE
				@cTable_R = 'T_MEASURE_FILTER',
				@cTable_S = @cTable3,
				@cFields_R = 'MEASUREID, CLASSIFICATORID, BEGINPERIOD, ENDPERIOD',
				@cFields_S = 'MEASUREID, CLASSIFICATORID, BEGINPERIOD, ENDPERIOD',
				@cKey_R = 'TMRID',
				@cKey_S = 'TMRID',
				@cDel_R = 'MEASUREID',
				@cDel_S = 'MEASUREID'

		end try
		begin catch
			select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
			raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
			print 'Procedure dbo.VERSION_SAVE.   DICTIONARY_ALGORITHM_DWH'
			
			if @@TRANCOUNT > 0
				rollback transaction
			return 1 
		end catch
		
		if @@TRANCOUNT > 0
			commit transaction
	end


--  
if @cObjCode = 'DICTIONARY_QUERY_DWH'
	begin
		begin transaction
		begin try
		
			execute SAVE_TABLE
				@cTable_R = 'REPORTQUERY',
				@cTable_S = @cTable1,
				@cFields_R = 'VERSIONID, QUERY',
				@cFields_S = 'VERSIONID, QUERY',
				@cKey_R = 'RQID',
				@cKey_S = 'RQID'
			execute ('update dbo.VERSION set ROW_ID = newid() from ' + @cTable + ' A where A.VERSIONID = dbo.VERSION.VERSIONID')
		end try
		begin catch
			select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
			raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
			print 'Procedure dbo.VERSION_SAVE.   DICTIONARY_QUERY_DWH'
			
			if @@TRANCOUNT > 0
				rollback transaction
			return 1 
		end catch
		
		if @@TRANCOUNT > 0
			commit transaction
	end

--   
if @cObjCode = 'DICTIONARY_RS_TEMPLATE'
	begin
		begin transaction
		begin try
			
			execute SAVE_TABLE
				@cTable_R = 'REPORTEMPLATE',
				@cTable_S = @cTable1,
				@cFields_R = 'VERSIONID, TEMPLATE_RS5',
				@cFields_S = 'VERSIONID, TEMPLATE_RS5',
				@cKey_R = 'RTID',
				@cKey_S = 'RTID'
			execute ('update dbo.VERSION set ROW_ID = newid() from ' + @cTable + ' A where A.VERSIONID = dbo.VERSION.VERSIONID')
		end try
		begin catch
			select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
			raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
			print 'Procedure dbo.VERSION_SAVE.   DICTIONARY_RS_TEMPLATE'
			
			if @@TRANCOUNT > 0
				rollback transaction
			return 1 
		end catch
		
		if @@TRANCOUNT > 0
			commit transaction
	end
	
--  
if @cObjCode = 'DICTIONARY_ATTACHED_FILE'
	begin
		begin transaction
		begin try
		
			execute SAVE_TABLE
				@cTable_R = 'ATTACHED_FILES',
				@cTable_S = @cTable1,
				@cFields_R = 'VERSIONID, FILEINFO',
				@cFields_S = 'VERSIONID, FILEINFO',
				@cKey_R = 'RFID',
				@cKey_S = 'RFID'
		
		end try
		begin catch
			select @ErrorMessage = ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
			raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)
			print 'Procedure dbo.VERSION_SAVE.   DICTIONARY_ATTACHED_FILE'
			
			if @@TRANCOUNT > 0
				rollback transaction
			return 1 
		end catch
		
		if @@TRANCOUNT > 0
			commit transaction
	end
	
--   
if not @cObjCode in ('DICTIONARY_REPORT_TEMPLATE', 'DICTIONARY_QUERY', 'DICTIONARY_RS_TEMPLATE', 'DICTIONARY_WORD_TEMPLATE') and exists(select * from #SYNC)
	select VERSIONID as LINK from #SYNC
else
	execute('
		if exists (select * from ' + @cTable + ')
			select VERSIONID as LINK from ' + @cTable + '
		else
			select 1 as LINK')


if @cObjCode = 'DICTIONARY_ALGORITHM_DWH'
	begin
		select MEASUREID, MEASUREID_OLD from #SYNC1
	end


GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8493' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'VERSION_SAVE'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_VER_DEPLOY_TXT]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SELECT_VER_DEPLOY_TXT]
GO



/*
:         .

 :
	@nMode -  
					-2 - : ;
					-1 - :   ;
					0 -      ;

 :	

 : 	
		exec dbo.SELECT_VER_DEPLOY_TXT @nProjectID = 1973

:
	xxxx					- id 
	yyyy					- id 
	zzzz					- id 
	
	FACTS_xxxx				-   
	FACTS_xxxx_yyyy			-    
	FACTS2_xxxx_yyyy		-      
	FACTS2_xxxx_yyyy_zzzz	-     / ,      
	CL_xxxx_zzzz			-   
	CLD_xxxx				-   
	TIME_xxxx				-  
	CL_xxxx_zzzz			-    

   :
	-    
	-    
      .       

:
	 ..

*/
create procedure [dbo].[SELECT_VER_DEPLOY_TXT]
	@nProjectID	int,
	@nDS int,
	@cTableOut varchar(100)
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd

	declare
		@cMeasureList varchar(8000), --    
		@cStr varchar(max),
		@cPostfix varchar(200),
		@cTableOutApp varchar(100)
	
	if exists(select * from #DTS_M where LINK = @nDS and TXT = 1)
		begin
			--  
			select @cTableOutApp = '[KS_DDLControl].[STDA_' + convert(varchar(36), newid()) + ']'
			
			--         
			select @cStr = 'select ST.* into ' + @cTableOutApp + ' from ' + @cTableOut + ' ST, STORAGE_APP STA where ST.STORAGEID = STA.STORAGEID and not STA.VALUE is null'
			execute (@cStr)

			--      
			select @cStr = 'delete ' + @cTableOut + ' from ' + @cTableOut + ' ST, STORAGE_APP STA where ST.STORAGEID = STA.STORAGEID and not STA.VALUE is null'
			execute (@cStr)

			
			declare MS scroll cursor for select MEASUREID from #DTS_M where LINK = @nDS and TXT = 1
			open MS

			if @@CURSOR_ROWS > 0
				begin
					fetch next from MS into @cMeasureList

					while @@FETCH_STATUS = 0
						begin
							select @cPostfix = convert(varchar(20), @nProjectID) + '_' + @cMeasureList
						
							---     .   . 
							if not exists(select * from #MS where MEASUREID = @cMeasureList)
								begin
									select @cStr = 'if not object_id(''[KS_DDLControl].[CLM_' + @cPostfix + ']'') is Null drop table [KS_DDLControl].[CLM_' + @cPostfix + ']
									create table [KS_DDLControl].[CLM_' + @cPostfix + '] (CLASSIFICATORID int, OLD int, STORAGEID int, STRID int, [] varchar(4000))'
									execute (@cStr)
									
									--  ,   
									insert #MS (MEASUREID) values(@cMeasureList)
								end
							
							select @cStr = 'if col_length(''[KS_DDLControl].[CLM_' + @cPostfix + ']'',''OLD'') is null 
							alter table [KS_DDLControl].[CLM_' + @cPostfix + '] add OLD int'
							execute (@cStr)
							
							--     . 
							select @cStr = 'insert [KS_DDLControl].[CLM_' + @cPostfix + '](CLASSIFICATORID, OLD, [], STORAGEID, STRID)
							select STA.SAID, STA.SAID, left(STA.[VALUE],4000), STA.STORAGEID, F.STRID
							from ' + @cTableOutApp + ' F, STORAGE_APP STA, STORAGE ST
							where F.STORAGEID = STA.STORAGEID and ST.STORAGEID = STA.STORAGEID and ST.MEASUREID = ' + @cMeasureList
							execute (@cStr)

							--   VALUE   ID   ,      .
							select @cStr = '
							create table #aaa111 (ORD int identity, [] varchar(4000))
							insert #aaa111 ([]) select distinct [] from [KS_DDLControl].[CLM_' + @cPostfix + ']
							update [KS_DDLControl].[CLM_' + @cPostfix + '] set CLASSIFICATORID = A.ORD
							from #aaa111 A
							where isnull([KS_DDLControl].[CLM_' + @cPostfix + '].[],'''') = isnull(A.[],'''')'
							exec (@cStr)

							--     
							select @cStr = 'alter table ' + @cTableOut + ' add [CLM_' + @cPostfix + '] int'
							execute (@cStr)
							
							--     . 
							select @cStr = 'alter table ' + @cTableOutApp + ' add [CLM_' + @cPostfix + '] int'
							execute (@cStr)
							
							--        
							insert #DTS_CL (LINK, CLASSIFICATORID, MULTISELECTION, DEPLOY_TABLE, [TXT])
							values (@nDS, @cMeasureList, 0, '[KS_DDLControl].[CLM_' + @cPostfix + ']', 1)
							
							--      . 
							select @cStr = '
							update ' + @cTableOutApp + ' set [CLM_' + @cPostfix + '] = CLM.CLASSIFICATORID
							from ' + @cTableOutApp + ' F, STORAGE ST, STORAGE_APP STA, [KS_DDLControl].[CLM_' + @cPostfix + '] CLM
							where F.STORAGEID = ST.STORAGEID and ST.STORAGEID = STA.STORAGEID and ST.STORAGEID = CLM.STORAGEID and ST.MEASUREID = ' + @cMeasureList
							execute (@cStr)
							
							--   
							select @cStr = 'update ' + @cTableOut + ' set [CLM_' + @cPostfix + '] = STA.[CLM_' + @cPostfix + ']
							from ' + @cTableOut + ' ST, ' + @cTableOutApp + ' STA
							where
								not STA.[CLM_' + @cPostfix + '] is null and
								isnull(ST.FILTERID,0) = isnull(STA.FILTERID,0) and
								isnull(ST.STRID,0) = isnull(STA.STRID,0) and
								isnull(ST.TIMEKEY,0) = isnull(STA.TIMEKEY,0) '

							select @cStr = @cStr + stuff((select distinct ' and isnull(ST.[CL_' + convert(varchar(20), @nProjectID) + '_' +  convert(varchar(20), CLASSIFICATORID) + '],0) = isnull(STA.[CL_' + convert(varchar(20), @nProjectID) + '_' +  convert(varchar(20), CLASSIFICATORID) + '],0)' as [text()] from #DTS_CL where LINK = @nDS and TXT = 0 for xml path('')),1,1,'')
							execute (@cStr)
							
							--    
							select @cStr = 'alter table ' + @cTableOut + ' drop column [MEASURE_' + convert(varchar(20), @nProjectID) + '_' + @cMeasureList + ']'
							execute (@cStr)

							--    
							select @cStr = 'alter table [KS_DDLControl].[CLM_' + @cPostfix + '] drop column OLD'
							execute (@cStr)
							
							delete #DTS_M where LINK = @nDS and MEASUREID = @cMeasureList
							
							fetch next from MS into @cMeasureList
						end
				end
			close MS
			deallocate MS
			
			execute ('drop table ' + @cTableOutApp)
		end
end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'7941' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_DEPLOY_TXT'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_VER_DEPLOY]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SELECT_VER_DEPLOY]
GO



/*
:         .

 :
	@nMode -  
					-2 - : ;
					-1 - :   ;
					0 -      ;

 :	

 : 	
		exec dbo.SELECT_VER_DEPLOY @nProjectID = 1973

:
	xxxx					- id 
	yyyy					- id 
	zzzz					- id 
	qqqq					- id   
	
	FACTS_xxxx				-   

	FACTS2_xxxx				-       
	FACTS2_xxxx_yyyy		-      ,   
	FACTS2_xxxx_yyyy_zzzz	-     / ,      
	
	CL_xxxx_zzzz			-   
	CL_xxxx_zzzz_qqqq		-     
	
	--  -
	CLD_xxxx				-   
	TIME_xxxx				-  
	CLA_xxxx_zzzz			-    

   :
	-    
	-    

:
	 ..

*/
create procedure [dbo].[SELECT_VER_DEPLOY]
	@nProjectID	int,
	@nMode int = 0,
	@nOnlyChange int = 0
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd

	declare
		@df datetime, @df1 datetime, --    
		@nDictVersion int, @nDictDataSource int, --  
		@cMeasureList varchar(max), --    
		@cDimension varchar(200),
		@cStr varchar(max),
		@cPostfix varchar(200),
		@nStatus int,
		@cNote varchar(920)

	select @df1 = getdate()
	
	if @nMode = -2
		begin
			select @df = getdate()
		end
		
	--  
	--    
	select @nDictDataSource = dbo.obj_id('DICTIONARY_DATASOURCE')
	select @nDictVersion = dbo.obj_id('DICTIONARY_VERSION')

	select ORDERS, [LINK], [LINK_SELF], LEVELS, convert(int, Null) as [OBJECT] into #VER from dbo.TREE_VERSION(Null, 'DOWN')
	update #VER set [OBJECT] = V.[OBJECT] from VERSION V where V.VersionID = #VER.LINK
	delete #VER where [OBJECT] <> @nDictVersion
	delete #VER where [OBJECT] is Null

	select
		ORDERS, LINK, convert(int, Null) as [OBJECT], dbo.VersionParent(LINK) as PARENT,
		convert(int, null) as LEVELS,	convert(int, null) as BRANCH, convert(int, null) as PARENT1,
		convert(varchar(100), null) as DEPLOY_TABLE, convert(int, 0) as COMB, convert(bit, 0) as F1, convert(int, 0) as CNT_DS
	into #DTS
	from dbo.TREE_VERSION(@nProjectID, 'DOWN')
	
	update #DTS set [OBJECT] = V.[OBJECT] from VERSION V where V.VersionID = #DTS.LINK
	delete #DTS where [OBJECT] <> @nDictDataSource
	
	--     
	update #DTS set COMB = 1 where exists(select * from VERSION V where V.VersionID = #DTS.LINK and not V.DATA is null)
	update #DTS set [LEVELS] = V.[LEVELS] from [#VER] V where V.[LINK] = [#DTS].[PARENT]

	--     
	if not exists (select * from #DTS)
		begin
			raiserror('   () .',16,1)
			return
		end

	--   
	declare @RunMStudio int
	select @RunMStudio = 0
	if exists (select top 1 * from sys.sysprocesses where spid = @@spid and [program_name] like '%Management Studio%')
		select @RunMStudio = 1
		
	select @cPostfix = 'CUBE_' + convert(varchar(20), @nProjectID)
	select @nStatus = isnull(STATUS,0) from dbo.T_CUBES where CUBE = @cPostfix
	
	if @RunMStudio = 0 and @nStatus between 1 and 2
		begin
			raiserror('    .    .',16,1)
			return
		end
		
	--  
	begin try
		if @RunMStudio = 0
			exec dbo.SetCubeInfo @versionid = @nProjectID, @cubeName = @cPostfix, @stat = 1

		declare @nMax int, @nMin int
		select @nMax = max([LEVELS]) from #DTS
		select @nMin = min([LEVELS]) from #DTS
		update [#DTS] set [PARENT1] = [PARENT]
		while @nMax > @nMin
			begin
				update #DTS set BRANCH = dbo.[VersionParent]([PARENT1]), LEVELS = LEVELS - 1 where LEVELS = @nMax
				update #DTS set [PARENT] = D2.[PARENT] from #DTS, #DTS D2 where #DTS.[PARENT] = D2.BRANCH
				select @nMax = @nMax - 1
			end

--select * from #VER
--select * from #DTS

		if @nMode = -2
			begin
				select ' ', datediff(ms, @df, getdate())
				select @df = getdate()
			end

		--   
		create table #CONV_VER (ORDERS int identity, VERSIONID int)
		insert #CONV_VER (VERSIONID) select distinct PARENT1 from #DTS
		
		--   
		exec('alter table #DTS drop column OBJECT, LEVELS, PARENT1, BRANCH')
		
		--        
		select D.LINK, TM.[MEASUREID], (select case when [MS_TYPE] in (3,4) then 1 else 0 end from dbo.MEASURES where MEASUREID = TM.MEASUREID) as TXT
		into #DTS_M
		from #DTS D inner join dbo.T_MEASURE TM on TM.VERSIONID = D.LINK
		where exists (select * from dbo.T_MEASURE_PROJ where TM.[MEASUREID]=[MEASUREID] and VERSIONID = @nProjectID and PROCESS = 1)
		
		select
			D.LINK, ST.CLASSIFICATORID, ST.MULTISELECTION,
			convert(varchar(100), '[KS_DDLControl].[CL_' + convert(varchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + ']') as DEPLOY_TABLE,
			convert(varchar(100), null) as FACTS2, convert(varchar(100), null) as ACCESS, convert(int, 0) as [TXT], convert(int, 0) as [COMB]
		into #DTS_CL
		from #DTS D inner join dbo.SOURCETEMPLATE ST on D.LINK = ST.VERSIONID
		where not exists (select * from dbo.T_CLASSIFICATORS where ST.[CLASSIFICATORID]=[CLASSIFICATORID] and VERSIONID = @nProjectID and PROCESS = 0)
		
		update #DTS_CL set COMB = 1 from #DTS D where #DTS_CL.LINK = D.LINK and D.COMB = 1 and #DTS_CL.MULTISELECTION = 1
		
		select DCL.CLASSIFICATORID, sum(DCL.MULTISELECTION) as [MLT],  sum(DCL.COMB) as COMB, count(*) as CNT
		into #DS_MLT
		from #DTS_CL DCL
		where TXT = 0
		group by DCL.CLASSIFICATORID
		having sum(DCL.MULTISELECTION) > 0 or sum(DCL.COMB) > 0
		
		update #DTS_CL set MULTISELECTION = 1 from #DS_MLT D where #DTS_CL.CLASSIFICATORID = D.CLASSIFICATORID and D.[MLT] <> D.CNT
		
		drop table #DS_MLT

		--    .    
		create table #RECODE (SOURCEELEMENTID int, TARGETELEMENTID int, CLASSIFICATORID int, KOEFDIRECT real)

		if (select count(*) from [#CONV_VER]) > 1
			begin
				declare @nOrd int
				
				--     
				select C.ORDERS, DM.SOURCEELEMENTID, DM.TARGETELEMENTID, TV.VERSIONID, DM.KOEFDIRECT
				into #COMP_CH
				from DATAMIGRATION DM, T_VERSION TV, T_VERSION TV1, #CONV_VER C
				where
					TV.CLASSIFICATORID = DM.SOURCEELEMENTID and TV.DELETED = 1 and
					TV1.CLASSIFICATORID = DM.TARGETELEMENTID and TV1.DELETED = 0 and
					TV.VERSIONID = C.VERSIONID

				while exists (select * from #CONV_VER)
					begin
						select @nOrd = min(ORDERS) from #CONV_VER

						update #RECODE set TARGETELEMENTID = R.TARGETELEMENTID
						from #RECODE L, #COMP_CH R
						where L.TARGETELEMENTID = R.SOURCEELEMENTID and R.ORDERS = @nOrd

						delete #COMP_CH
						from #RECODE L, #COMP_CH R
						where L.TARGETELEMENTID = R.SOURCEELEMENTID and R.ORDERS = @nOrd

						insert #RECODE (SOURCEELEMENTID, TARGETELEMENTID, KOEFDIRECT)
						select SOURCEELEMENTID, TARGETELEMENTID, KOEFDIRECT
						from #COMP_CH
						where ORDERS = @nOrd

						delete #CONV_VER where ORDERS = @nOrd
					end

				update #RECODE set CLASSIFICATORID = dbo.ClassificatorIdParent(SOURCEELEMENTID)
				delete #RECODE where not exists(select * from #DTS_CL where CLASSIFICATORID = #RECODE.CLASSIFICATORID)
			end

		if @nMode = -2
			begin
				select '   ', datediff(ms, @df, getdate())
				select @df = getdate()
			end


		--      .   ,     
		select distinct LINK into #DSE from #DTS D where not exists (select * from #DTS_M where LINK = D.LINK)
		delete #DTS where exists (select * from #DSE where LINK = #DTS.LINK)
		delete #DTS_CL where exists (select * from #DSE where LINK = #DTS_CL.LINK)
		
		--    
		select @cStr = 'if not object_id(''[KS_DDLControl].[CLH_' + convert(varchar(20), @nProjectID) + ']'') is Null drop table [KS_DDLControl].[CLH_' + convert(varchar(20), @nProjectID) + ']'
		exec (@cStr)

		--     
		create table #MS ([MEASUREID] int)
		
		--  
		declare @cTableOut varchar(100), @nDS int, @cClExclList varchar(8000)

		select @cClExclList = stuff((select ',' + convert(nvarchar(20),[CLASSIFICATORID]) as [text()] from dbo.T_CLASSIFICATORS where VERSIONID = @nProjectID and PROCESS = 0 for xml path('')),1,1,'')

		while exists (select * from #DTS where F1 = 0)
			begin
				select top 1 @nDS = LINK from #DTS where F1 = 0
				
				--     
				select @cMeasureList = stuff((select ',' + convert(nvarchar(20), DM.[MEASUREID]) as [text()]
				from #DTS_M DM, T_MEASURE_PROJ TMP
				where DM.[MEASUREID] = TMP.MEASUREID and TMP.VERSIONID = @nProjectID and TMP.PROCESS = 1 and DM.LINK = @nDS for xml path('')),1,1,'')

				--  
				execute dbo.ST_DEPLOY @nStorageId = @nDS, @nProject = @nProjectID, @cMeasureList = @cMeasureList, @cClExclList = @cClExclList, @cTable = @cTableOut output

				update #DTS set DEPLOY_TABLE = @cTableOut where LINK = @nDS
				
				select @cStr = 'update #DTS set CNT_DS = (select count(*) from ' + @cTableOut + ') where LINK = ' + convert(varchar(20),@nDS)
				exec(@cStr)
				
				if @nMode = -2
					begin
						select ' :' + convert(nvarchar(20),@nDS), datediff(ms, @df, getdate())
						select @df = getdate()
					end

				--  c ?
				--  c ?
				
				--    
				declare @nCl int, @cClassList varchar(max)	

				if exists(select * from #DTS_CL D, #RECODE R where D.LINK = @nDS and D.CLASSIFICATORID = R.CLASSIFICATORID)
					begin
						declare CL scroll cursor for select distinct R.CLASSIFICATORID, D.DEPLOY_TABLE from #DTS_CL D, #RECODE R where D.LINK = @nDS and D.CLASSIFICATORID = R.CLASSIFICATORID
						open CL

						if @@CURSOR_ROWS > 0
							begin
								fetch next from CL into @nCl, @cClassList

								while @@FETCH_STATUS = 0
									begin
										--select @cClassList = '[CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), @nCl) + ']'
										select @cClassList = replace(@cClassList, '[KS_DDLControl].', '')
										select @cMeasureList = stuff((select ',[MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + '] = F.[MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + ']*convert(numeric(20,18), R.KOEFDIRECT)' as [text()] from #DTS_M where LINK = @nDS for xml path('')),1,1,'')

										select @cStr = 'update ' + @cTableOut + ' set ' + @cClassList + ' = R.TARGETELEMENTID,' + @cMeasureList + '
										from ' + @cTableOut + ' F inner join #RECODE R on F.' + @cClassList + ' = R.SOURCEELEMENTID and R.CLASSIFICATORID = ' + convert(nvarchar(20), @nCl)
			
										execute (@cStr)
									
										fetch next from CL into @nCl,@cClassList
									end
							end
						close CL
						deallocate CL
					end

					
				if @nMode = -2
				begin
					select '   ', datediff(ms, @df, getdate())
					select @df = getdate()
				end


				--  
				exec dbo.SELECT_VER_DEPLOY_TXT @nProjectID = @nProjectID, @nDS = @nDS, @cTableOut = @cTableOut

				
				if @nMode = -2
					begin
						select ' ', datediff(ms, @df, getdate())
						select @df = getdate()
					end
				
				--  
				exec dbo.SELECT_VER_DEPLOY_HASH @nProjectID = @nProjectID, @nDS = @nDS, @cTableOut = @cTableOut

 				if @nMode = -2
					begin
						select ' ', datediff(ms, @df, getdate())
						select @df = getdate()
					end

				--   
				exec dbo.SELECT_VER_DEPLOY_MLT @nProjectID = @nProjectID, @nDS = @nDS, @cTableOut = @cTableOut


				if @nMode = -2
				begin
					select '  :' + convert(nvarchar(20),@nDS), datediff(ms, @df, getdate())
					select @df = getdate()
				end


				update #DTS set F1 = 1 where LINK = @nDS
			end
			
		if (select sum(CNT_DS) from #DTS) = 0
			begin
				raiserror('   .',16,1)
				return
			end
			

		if @nMode = -2
			begin
				select '  ', datediff(ms, @df, getdate())
				select @df = getdate()
			end

	
		--  
		exec dbo.SELECT_VER_DEPLOY_MERGE_DS @nProjectID = @nProjectID

		if @nMode = -2
			begin
				select ' :', datediff(ms, @df, getdate())
				select @df = getdate()
			end


		--  
		create table #STD (CLASSIFICATORID int, DIMENSION varchar(70), [VERSIONID] int, MEASUREID int, SOURCETEMPLATEID int, MLT int)
		insert #STD (CLASSIFICATORID, DIMENSION, [VERSIONID], MEASUREID, SOURCETEMPLATEID, MLT)
		select distinct CLASSIFICATORID, DEPLOY_TABLE, LINK, 0, 0, 0
		from #DTS_CL
		where TXT = 0

		--   .
		--  ,    
		select distinct DT.CLASSIFICATORID, CL.ClassId
		into #CL
		from (select distinct CLASSIFICATORID from #DTS_CL) DT cross apply dbo.TREE_CLASS(DT.CLASSIFICATORID) CL
		where not CL.ClassId is null

--select * from #DTS_CL
--select * from #CL

		insert #STD (CLASSIFICATORID, DIMENSION, [VERSIONID], MEASUREID, SOURCETEMPLATEID, MLT)
		select distinct C.ClassId, '[KS_DDLControl].[CL_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), C.ClassId) + ']', D.LINK, 0, 0, 0
		from #DTS_CL D, #CL C
		where D.CLASSIFICATORID = C.CLASSIFICATORID

		--  
		exec dbo.SELECT_VER_DEPLOY_CL

		if @nMode = -2
			begin
				select '  ', datediff(ms, @df, getdate())
				select @df = getdate()
			end

		--   
		select @cStr = 'if not object_id(''[KS_DDLControl].[CLD_' + convert(varchar(20), @nProjectID) + ']'') is null drop table [KS_DDLControl].[CLD_' + convert(varchar(20), @nProjectID) + ']'
		exec (@cStr)
		select @cStr = 'select distinct LINK as VERSIONID, (select NAME from VERSION where VERSIONID = #DTS.LINK) as NAME into [KS_DDLControl].[CLD_' + convert(varchar(20), @nProjectID) + '] from #DTS'
		exec (@cStr)

		if @nMode = -2
			begin
				select '  ', datediff(ms, @df, getdate())
				select @df = getdate()
			end

		--          
		select distinct DEPLOY_TABLE as DIMENSION into #STD1 from #DTS_CL where TXT = 0 and MULTISELECTION = 0

		select @cStr = ''
		
		declare @cDimension1 varchar(100)
		
		while exists(select * from #STD1)
			begin
				select top 1 @cDimension = DIMENSION from #STD1
				select
					@nCl = replace(dbo.j_sub_str(dbo.j_sub_str(@cDimension,'.',2),'_',3),']',''),
					@cDimension1 = 'CL_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), @nCl)
				
				select @cStr = @cStr + '
				update [KS_DDLControl].[FACTS_' + convert(varchar(20), @nProjectID) + '] set ' + dbo.j_sub_str(@cDimension,'.',2) + ' = null from [KS_DDLControl].[FACTS_' + convert(varchar(20), @nProjectID) + '] F where not ' + dbo.j_sub_str(@cDimension,'.',2) + ' is null and not exists(select * from [KS_DDLControl].' + @cDimension1 + ' A where F.' + dbo.j_sub_str(@cDimension,'.',2) + ' = A.CLASSIFICATORID)'
				
				delete #STD1 where @cDimension = DIMENSION
			end
		execute (@cStr)
		
		if @nMode = -2
		begin
			select '      ', datediff(ms, @df, getdate())
			select @df = getdate()
		end

		--   
		exec dbo.SELECT_VER_DEPLOY_MERGE_CL @nProjectID = @nProjectID

		if @nMode = -2
			begin
				select ' ', datediff(ms, @df, getdate())
				select @df = getdate()
			end


		--   
		exec dbo.SELECT_VER_DEPLOY_LNK @nProjectID = @nProjectID

		if @nMode = -2
			begin
				select '  ', datediff(ms, @df, getdate())
				select @df = getdate()
			end
			

		--    
		if left(dbo.get_val('NASTR_ACCESS_SSAS','CASE_VALUE',null),1) = '1'
			begin
				declare @nVerID int
				select @nVerID = VERSIONID from #CONV_VER where ORDERS = (select max(ORDERS) from #CONV_VER)

				--     	
				select distinct CLASSIFICATORID, convert(int, 1) as ACCESS into #DTS_CLA from #DTS_CL where TXT = 0

				--  
				declare @cLoginame varchar(128)
				select LOGINSQL as LOGINAME,  convert(int, 0) as F1 into #USERS from dbo.USERS() where LOGINAME <> 'server\user' and USER_TYPE <> 4 and dbo.CheckUsers(LOGINAME) = 1
--select * from #USERS					
				while exists (select * from #DTS_CLA)
					begin
						select top 1 @nCl = CLASSIFICATORID from #DTS_CLA
						select @cPostfix = convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), @nCl)
						
						--   
						select @cStr = 'if not object_id(''[KS_DDLControl].[CLA_' + @cPostfix + ']'') is Null drop table [KS_DDLControl].[CLA_' + @cPostfix + ']
						create table [KS_DDLControl].[CLA_' + @cPostfix + '] ([UID] int, CLASSIFICATORID int)'
						execute (@cStr)

						--  
						while exists (select * from #USERS where F1 = 0)
							begin
								select top 1 @cLoginame = LOGINAME from #USERS where F1 = 0
								
								select @cStr = '
								execute as login = ''' + @cLoginame + '''
								insert [KS_DDLControl].[CLA_' + @cPostfix + '] (CLASSIFICATORID)
								execute SELECT_CL_INFO 8, ' + convert(varchar(20), @nVerID) + ', ' + convert(varchar(20), @nCl) + '
								update [KS_DDLControl].[CLA_' + @cPostfix + '] set [UID] = user_id(suser_sname()) where [UID] is null
								revert'
								execute (@cStr)
						
								update #USERS set F1 = 1 where @cLoginame = LOGINAME
							end
							
						update #USERS set F1 = 0
						delete #DTS_CLA where @nCl = CLASSIFICATORID
						update #DTS_CL set ACCESS = '[KS_DDLControl].[CLA_' + @cPostfix + ']' where @nCl = CLASSIFICATORID
					end

				if @nMode = -2
					begin
						select '   ', datediff(ms, @df, getdate())
						select @df = getdate()
					end
				
			end



--select * from #DTS_CL
--select * from #DTS

		--  XML 
		exec SELECT_VER_DEPLOY_XML @nProjectID = @nProjectID, @nMode = @nMode

		if @nMode = -2
			begin
				select ' XML ', datediff(ms, @df, getdate())
				select @df = getdate()
			end

		if @nMode = 0 and @nOnlyChange = 0
			begin
				delete dbo.MEASURE_CHANGE where VERSIONID = @nProjectID
				delete dbo.DIM_CHANGE where VERSIONID = @nProjectID
				insert dbo.DIM_CHANGE (VERSIONID, CLID, [SIGN]) select distinct @nProjectID,CLASSIFICATORID,0 from #DTS_CL
			end


		--    
		if dbo.j_sub_str(dbo.get_val('NASTR_LOGGING_EVENTS','MCASE_VALUE',null),'#',1)&32 = 32
			begin
				select @cNote = '    "' + isnull((select NAME from dbo.VERSION where VersionID = @nProjectID),'') + '" .  :' + convert(varchar(20), datediff(ms, @df1, getdate())) + ' .'
				exec [dbo].[ELM_ADDEVENT] @TYPE  = 2, @CATEGORY  = '', @MESSAGE = @cNote
			end	

		if @nMode = -2
			begin
				select '  ', datediff(ms, @df1, getdate())
				select ' ', datediff(ms, @df, getdate())
			end

		select @cPostfix = 'CUBE_' + convert(varchar(20), @nProjectID)
		
		if @RunMStudio = 0
			exec dbo.SetCubeInfo @versionid = @nProjectID, @cubeName = @cPostfix, @stat = 2
	
	end try
	begin catch
		declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
		select @ErrorMessage = '     "' + isnull((select NAME from dbo.VERSION where VersionID = @nProjectID),'') + '". ' + ERROR_MESSAGE(), @ErrorSeverity = ERROR_SEVERITY(), @ErrorState = ERROR_STATE()
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)

		exec [dbo].[ELM_ADDEVENT] @TYPE  = 0, @CATEGORY  = '', @MESSAGE = @ErrorMessage
		
		exec dbo.SetCubeInfo @versionid = @nProjectID, @cubeName = @cPostfix, @stat = 0
	end catch
	
end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8020' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_DEPLOY'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[SELECT_CL_INFO]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[SELECT_CL_INFO]
GO

/*
: 

 :
	@nVerID		- 
	@nClassId	- 

 :

 : 	
	exec SELECT_CL_INFO @nMode = 11, @nVerID = 2248, @nClassId = 32744

:

:
	 ..
*/


-- rev 1.11
CREATE PROCEDURE [dbo].[SELECT_CL_INFO]
	@nMode int = 1,
	@nVerID	int,
	@nClassId int = 0,
	@saveTable varchar(255) = ''
as
begin
set nocount on

declare @nUserId int, @nParentClassId int, @nClassIdOrig int,  @cSel varchar(max)

select @nUserId = user_id(suser_sname())

select identity(int, 1, 1) as ORDERS, LINK as VERSIONID into #V3 from dbo.tree_version( @nVerID, 'UP')

select @nClassIdOrig = @nClassId
select @nParentClassId = cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @nClassId

if isnull(@nParentClassId,0) > 0
	select @nClassId = @nParentClassId

create table #V31 (CLASSIFICATORID int, ORDERS int, DELETED int)

--     
declare @uCh_GUID uniqueidentifier, @nCashDB int
select @uCh_GUID = cp.CH_GUID from ClassificatorProperty cp where cp.ClassificatorID = @nClassId
select @nCashDB = left(dbo.get_val('NASTR_CASH_DB','CASE_VALUE',null),1)

if @nCashDB = 1 and exists(select * from CL_LISTEL where Versionid = @nVerID and CH_GUID = @uCh_GUID)
	insert #V31 (CLASSIFICATORID) select CLASSIFICATORID from CL_LISTEL where Versionid = @nVerID and CH_GUID = @uCh_GUID
else
	begin
		create table #CL(CLASSIFICATORID int)

		select @cSel = 'insert #CL(CLASSIFICATORID) select CLASSIFICATORID from CLASSIFICATORS where PARENTCLASSIFICATORID = ' + convert(varchar(20), @nClassId)
		exec (@cSel)

		select @cSel = 'insert #CL (CLASSIFICATORID)
				select TR.CLASSIFICATORID
				from CLASSIFICATORS TR, #CL D
				where TR.PARENTCLASSIFICATORID = D.CLASSIFICATORID and not exists (select * from #CL where TR.ClassificatorID = ClassificatorID)'

		while @@ROWCOUNT > 0
			begin
				exec (@cSel)
			end
		
		
		insert #V31 (CLASSIFICATORID, ORDERS, DELETED)
		select CL.CLASSIFICATORID, max(V.ORDERS) as ORDERS, convert(int, Null) as DELETED
		from #V3 V, #CL CL, T_VERSION TV
		where V.VERSIONID = TV.VERSIONID and TV.CLASSIFICATORID = CL.CLASSIFICATORID
		group by CL.CLASSIFICATORID

		update #V31 set DELETED = TV.DELETED from #V3 V, T_VERSION TV
		where #V31.CLASSIFICATORID = TV.CLASSIFICATORID and V.ORDERS = #V31.ORDERS and TV.VERSIONID = V.VERSIONID

		delete #V31 where DELETED = 1
		
		if @nCashDB = 1 and exists (select * from #V31)
			begin
				delete CL_LISTEL where Versionid = @nVerID and ParentClass = @nClassId
				delete CL_LISTEL where Versionid = @nVerID and CH_GUID = @uCh_GUID
				insert CL_LISTEL (Versionid, ParentClass, ClassificatorID, CH_GUID) select @nVerID, @nClassId, ClassificatorID, @uCh_GUID from #V31
			end
	end

--     
if dbo.[AdminIsUserAdm](@nUserId) = 0
	begin
		if @nMode <> 12 and @nMode <> 13
			begin
				--     ,    
				if isnull(dbo.get_access_cl(@nVerID, @nClassId, @nUserId),8)&8 <> 8
					delete #V31
	
				delete #V31 where isnull(dbo.get_access_cl(@nVerID, #V31.[CLASSIFICATORID], @nUserId), 1) = 0
			end
	end 

select * into #ATTR from CLASSIFICATORS_ATTR where CLASSIFICATORID = @nClassId and OBJECT is null

--   
if @nMode = 1
	begin
		select @nVerID as VERSION, CLASSIFICATORID, [NAME], [DESCRIPTION], convert(datetime,getdate()) as [BEGINDATETIME], convert(datetime,getdate()) as [ENDDATETIME], ISAGGREGATABLE, [TYPE]
		from CLASSIFICATORS
		where CLASSIFICATORID = @nClassId

		select DESCRIPTIONID, CLASSIFICATORID, [NAME], MASK, [LEVEL]
		from CLASSIFICATORDESCRIPTION
		where CLASSIFICATORID = @nClassId
		order by [LEVEL]
		
		select * from #ATTR
	end


--     .
if @nClassId <> @nClassIdOrig and 
	exists(select * from dbo.ClassificatorProperty cp where cp.ClassificatorID = @nClassIdOrig and not cp.SourceClassificatorFilter is null)
	begin
		declare @nExistsCond int
		select @nExistsCond = 0
		create table #CL_COND (CLASSIFICATORID int)
		exec SELECT_CL_INFO_COND @nClassId = @nClassIdOrig, @nExistsCond = @nExistsCond output
		
		if @nExistsCond = 1
			begin
				delete #V31
				insert #V31 (CLASSIFICATORID) select CLASSIFICATORID from #CL_COND
			end
	end


--  #CLASS_MASK    MASK    . .  
-- create table #CLASS_MASK (MASK varchar(200))
if not object_id('tempdb..#CLASS_MASK') is null
	begin
		update #CLASS_MASK set [MASK] = replace([MASK], '_','[_]')
		update #CLASS_MASK set [MASK] = dbo.RegExReplace([MASK], '(?<z>([^\\]|^))\*', '${z}%')
		update #CLASS_MASK set [MASK] = dbo.RegExReplace([MASK], '(?<z>)\?', '${z}_')
		update #CLASS_MASK set [MASK] = dbo.RegExReplace([MASK], '\\((?<z>\*|\?))', '${z}')
		update #CLASS_MASK set [MASK] = replace([MASK], '%%','%')
	
		select CL.CLASSIFICATORID
		into #MASK_CL
		from #V31 V, CLASSIFICATORS CL, #CLASS_MASK CM
		where CL.CLASSIFICATORID = V.CLASSIFICATORID and CL.CLASSIFICATORCODE like CM.MASK

		delete #V31 where not exists (select * from #MASK_CL M where M.CLASSIFICATORID = #V31.CLASSIFICATORID)
	end
	

if @nMode <> 8
	select convert(int, 0) as CHECKED, CL.CLASSIFICATORID, PARENTCLASSIFICATORID, CL.CLASSIFICATORCODE, CL.NAME, CL.DESCRIPTION, CL.GUID
	into #CLASS
	from #V31 V3, CLASSIFICATORS CL
	where CL.CLASSIFICATORID = V3.CLASSIFICATORID
	order by CL.CLASSIFICATORCODE


--select * into ##CLASS from #CLASS

--   ,   - ,  - 
if @nMode = 1 or @nMode = 5 or @nMode = 10
	begin
		declare @cSel_sel varchar(max), @cSel_from varchar(max), @cSel_ins varchar(max), @cSel_alter varchar(max),
			@ParentClId int, @Attr int, @Ord int, @ClId int,
			-- @Lev int,
			@nCnt int,
			@cSel_sel1 varchar(max),@cSel_sel11 varchar(max), @cSel_Stru varchar(max), @cSel_Stru_Ins varchar(max)
		
		select @cSel_Stru = 'create table #CLASS (CHECKED int, CLASSIFICATORID int, PARENTCLASSIFICATORID int, CLASSIFICATORCODE varchar(30), NAME varchar(1000), DESCRIPTION varchar(2000),GUID uniqueidentifier,'
		
		select @cSel = ''
		select @cSel_sel = '
		select 1, CL.CLASSIFICATORID, CL.PARENTCLASSIFICATORID, CL.CLASSIFICATORCODE, CL.NAME, CL.DESCRIPTION, CL.GUID,'
		select @cSel_Stru_Ins = 'insert #CLASS (CHECKED, CLASSIFICATORID, PARENTCLASSIFICATORID, CLASSIFICATORCODE, NAME, DESCRIPTION, GUID,'

		select @cSel_sel1 = '
		create index CLASS_01 on #CLASS (CLASSIFICATORID)
		
		select distinct CL.CHECKED, CL.CLASSIFICATORID, CL.PARENTCLASSIFICATORID, CL.CLASSIFICATORCODE, CL.NAME, CL.DESCRIPTION, CL.GUID,'
		select @cSel_sel11 = ''

		select @cSel_from = '
		from #CLASS CL '
		select @cSel_ins = 'insert #CLASS (CHECKED, CLASSIFICATORID, PARENTCLASSIFICATORID, CLASSIFICATORCODE, NAME, DESCRIPTION, GUID,'
		
		
		select *,convert(int, 0) as DEL into #ATTR1 from dbo.TREE_CLASS(@nClassId) where Levels = 1 order by Orders
--select * from #ATTR1
		select @nCnt = 1

		while exists (select * from #ATTR1 where DEL = 0)
			begin
				select top 1 @Ord = Orders, @Attr = ATTR, @ClId = ClassId, @ParentClId = ParentClassId from [#ATTR1] where DEL = 0 
												order by case isnull(ClassId,0) when 0 then 0 else 1 end,ATTR
				
				if @ClId is null
					begin
						select @cSel_alter = '
						alter table #CLASS add ATTR_' + convert(varchar(20), @Attr) + ' int, ATTR_NAME_' + convert(varchar(20), @Attr) + ' varchar(4000)'
						select @cSel_Stru = @cSel_Stru + ' ATTR_' + convert(varchar(20), @Attr) + ' int, ATTR_NAME_' + convert(varchar(20), @Attr) + ' varchar(4000),'
						select @cSel_Stru_Ins = @cSel_Stru_Ins + ' ATTR_' + convert(varchar(20), @Attr) + ', ATTR_NAME_' + convert(varchar(20), @Attr) + ','
						
						execute (@cSel_alter)

						select @cSel = @cSel + '
						update #CLASS set
							ATTR_NAME_' + convert(varchar(20), @Attr) + ' = (select top 1 [VALUE] from CLASSIFICATORS_APP where CLASSIFICATORID = #CLASS.CLASSIFICATORID and CLATTRID = ' + convert(varchar(20), @Attr) + '),
							ATTR_' + convert(varchar(20), @Attr) + ' = (select top 1 CLAPPID from CLASSIFICATORS_APP where CLASSIFICATORID = #CLASS.CLASSIFICATORID and CLATTRID = ' + convert(varchar(20), @Attr) + ')'
						
						select @cSel_sel1 = @cSel_sel1 + ' null as ATTR_' + convert(varchar(20), @Attr) + ', ATTR_NAME_' + convert(varchar(20), @Attr) + ','
					end
				else
					begin
						select @cSel_alter = 'alter table #CLASS add 
							ATTR_CL_' + convert(varchar(20), @Attr) + ' int,
							ATTR_CL_' + convert(varchar(20), @Attr) + '_CODE varchar(30),
							ATTR_CL_' + convert(varchar(20), @Attr) + '_NAME varchar(1000),
							ATTR_CL_' + convert(varchar(20), @Attr) + '_DESCRIPTION varchar(2000),
							ORDERS_' + convert(varchar(20), @Attr) + ' int '

						select @cSel_Stru = @cSel_Stru + '
							ATTR_CL_' + convert(varchar(20), @Attr) + '_CODE varchar(30),
							ATTR_CL_' + convert(varchar(20), @Attr) + '_NAME varchar(1000),
							ATTR_CL_' + convert(varchar(20), @Attr) + '_DESCRIPTION varchar(2000), '
						
						select @cSel_Stru_Ins = @cSel_Stru_Ins + '
							ATTR_CL_' + convert(varchar(20), @Attr) + '_CODE,
							ATTR_CL_' + convert(varchar(20), @Attr) + '_NAME,
							ATTR_CL_' + convert(varchar(20), @Attr) + '_DESCRIPTION, '

						execute (@cSel_alter)
					
						select @cSel_ins = @cSel_ins + ' ATTR_CL_' + convert(varchar(20), @Attr) + ', ORDERS_' + convert(varchar(20), @Attr) + ','

						select @cSel_sel = @cSel_sel + '
						CLA' + convert(varchar(20), @Attr) + '.[VALUE] as ATTR_CL_' + convert(varchar(20), @Attr) + ',
						CLA' + convert(varchar(20), @Attr) + '.[ORDERS] as ORDERS_' + convert(varchar(20), @Attr) + ','
						
						select @cSel_sel11 = @cSel_sel11 + '
						left(replace((select CASE WHEN len(isnull(ATTR_CL_' + convert(varchar(20), @Attr) +  '_CODE,'''')) = 0 THEN ''-'' ELSE ATTR_CL_' + convert(varchar(20), @Attr) + '_CODE END+char(10) from #CLASS where CLASSIFICATORID = CL.CLASSIFICATORID for xml path(''''))+''~'', char(10)+''~'', ''''), 30) as ATTR_CL_' + convert(varchar(20), @Attr) + '_CODE,
						left(replace((select CASE WHEN len(isnull(ATTR_CL_' + convert(varchar(20), @Attr) +  '_NAME,'''')) = 0 THEN ''-'' ELSE ATTR_CL_' + convert(varchar(20), @Attr) + '_NAME END+char(10) from #CLASS where CLASSIFICATORID = CL.CLASSIFICATORID for xml path(''''))+''~'', char(10)+''~'', ''''), 1000) as ATTR_CL_' + convert(varchar(20), @Attr) + '_NAME,
						left(replace((select CASE WHEN len(isnull(ATTR_CL_' + convert(varchar(20), @Attr) +  '_DESCRIPTION,'''')) = 0 THEN ''-'' ELSE ATTR_CL_' + convert(varchar(20), @Attr) + '_DESCRIPTION END+char(10) from #CLASS where CLASSIFICATORID = CL.CLASSIFICATORID for xml path(''''))+''~'', char(10)+''~'', ''''), 2000) as ATTR_CL_' + convert(varchar(20), @Attr) + '_DESCRIPTION,'
					

						select @cSel_from = @cSel_from + '
							left outer join CLASSIFICATORS_APP CLA' + convert(varchar(20), @Attr) + ' on (CL.CLASSIFICATORID = CLA' + convert(varchar(20), @Attr) + '.CLASSIFICATORID and CLA' + convert(varchar(20), @Attr) + '.CLATTRID = ' + convert(varchar(20), @Attr)

						if @nCnt > 1
							begin
								select @cSel_from = @cSel_from + ' and isnull(CLA' + convert(varchar(20), @Attr) + '.ORDERS,0) = isnull(CLA' + convert(varchar(20),(select min(ATTR) from #ATTR1 where not ClassId is null)) + '.ORDERS,0))'
								select @nCnt = @nCnt + 1
							end
						else
							select @cSel_from = @cSel_from + ')'
							
						select @nCnt = @nCnt + 1	

						select @cSel = @cSel + '
						update #CLASS set 
							ATTR_CL_' + convert(varchar(20), @Attr) + '_CODE = (select CLASSIFICATORCODE from CLASSIFICATORS where CLASSIFICATORID = #CLASS.ATTR_CL_' + convert(varchar(20), @Attr) + '),
							ATTR_CL_' + convert(varchar(20), @Attr) + '_NAME = (select NAME from CLASSIFICATORS where CLASSIFICATORID = #CLASS.ATTR_CL_' + convert(varchar(20), @Attr) + '),
							ATTR_CL_' + convert(varchar(20), @Attr) + '_DESCRIPTION = (select DESCRIPTION from CLASSIFICATORS where CLASSIFICATORID = #CLASS.ATTR_CL_' + convert(varchar(20), @Attr) + ')'
					end

				update [#ATTR1] set DEL = 1 where @Ord = Orders
			end
			
--select @cSel_where			
--select @cSel_ins
--select @cSel_from
--select @cSel_sel
--select @cSel

		select @cSel_sel = left(@cSel_ins, len(@cSel_ins)-1) + ') ' + left(@cSel_sel, len(@cSel_sel)-1) + @cSel_from


		if @cSel_sel11 <> ''
			begin
				select @cSel_sel1 = @cSel_sel1 + left(@cSel_sel11, len(@cSel_sel11)-1) + '
				into #temp from #CLASS CL
				select * from #temp order by '
				
				if left(dbo.get_val('NASTR_LIST_ORDER','CASE_VALUE',null),1)='1'
					select @cSel_sel1 = @cSel_sel1 + 'CLASSIFICATORCODE'
				else
					select @cSel_sel1 = @cSel_sel1 + 'dbo.[NaturalSorting](CLASSIFICATORCODE)'
			end
			
		
--select @cSel_sel1
--select @cSel_sel11
--select * into ##CLASS from #CLASS
--select @cSel_sel
--select @cSel
--return

	if @nMode = 10
		begin
			select left(@cSel_Stru, len(@cSel_Stru)-1) + ')' + char(10) + left(@cSel_Stru_Ins, len(@cSel_Stru_Ins)-1) + ')'
		end
	else
		begin
			execute (@cSel_sel)
			execute (@cSel)

			delete [#CLASS] where CHECKED = 0
			update [#CLASS] set CHECKED = 0
			
			if @cSel_sel11 = ''
				begin
					if left(dbo.get_val('NASTR_LIST_ORDER','CASE_VALUE',null),1)='1'
						select * from [#CLASS] order by CLASSIFICATORCODE
					else
						select * from [#CLASS] order by dbo.[NaturalSorting](CLASSIFICATORCODE)
				end
			else	
				execute (@cSel_sel1)
		end
	end
			
--    
if @nMode = 2
	begin
		select distinct CL.CHECKED, CL.CLASSIFICATORID, PARENTCLASSIFICATORID, CL.CLASSIFICATORCODE, CL.NAME, CL.DESCRIPTION
		from [#CLASS] CL
		order by CL.CLASSIFICATORCODE
	end

--   
if @nMode = 3
	begin
		select distinct CL.CLASSIFICATORID, CL.CLASSIFICATORCODE, CL.NAME, CL.PARENTCLASSIFICATORID, CL.DESCRIPTION
		from [#CLASS] CL
		order by CL.CLASSIFICATORCODE
	end

-- 
if @nMode = 4
	begin
		select CL.CLASSIFICATORID, CL.CLASSIFICATORCODE from [#CLASS] CL
	end


--for import - get elements with attributes
if @nMode = 6
	begin
		select CL.CLASSIFICATORID, PARENTCLASSIFICATORID, CL.CLASSIFICATORCODE, CL.NAME, CL.DESCRIPTION
		into #CLASS4
		from #V31 V3, CLASSIFICATORS CL
		where CL.CLASSIFICATORID = V3.CLASSIFICATORID

		declare @a4 int, @cSel5 varchar(7000)
		while exists (select * from #ATTR)
			begin
				select top 1 @a4 = CLATTRID from [#ATTR] order by clattrid
				select @cSel5 = 'alter table #CLASS4 add ATTR_' + convert(varchar(20), @a4) + ' varchar(4000)'
				execute (@cSel5)
				select @cSel5 = 'update #CLASS4 set ATTR_' + convert(varchar(20), @a4) + ' = (select top 1 value from CLASSIFICATORS_APP where CLASSIFICATORID = #CLASS4.CLASSIFICATORID and CLATTRID = ' + convert(varchar(20), @a4) + ')'
				execute (@cSel5)
				delete [#ATTR] where @a4 = CLATTRID
				print 1
			end
			
		select * from [#CLASS4]
	end

--for import - get only keys with classificatorid
 if @nMode = 7 
	 begin
		declare @obj int
		set @obj = dbo.obj_id('DICTIONARY_CORR_DWH')
		if exists(select * from classificators where classificatorid = @nClassId and [object] = @obj)
			begin
				select CL.CLASSIFICATORID, CL.CLASSIFICATORCODE as [Attr_-1], CL.NAME as [Attr_-2]
				from #V31 V3, CLASSIFICATORS CL
				where CL.CLASSIFICATORID = V3.CLASSIFICATORID
			end
		else
			begin
				select CL.CLASSIFICATORID, CL.CLASSIFICATORCODE as [Attr_-1]
				from #V31 V3, CLASSIFICATORS CL
				where CL.CLASSIFICATORID = V3.CLASSIFICATORID
			end
	 	
	 end

 --for export - get only ids
 if @nMode = 8 
	 begin
			select V3.CLASSIFICATORID from #V31 V3
	 end		

--   
if @nMode = 9
	begin
		select CL.CLASSIFICATORID, CL.CLASSIFICATORCODE, CL.NAME, CL.PARENTCLASSIFICATORID
		from [#CLASS] CL
	end

--  
if @nMode = 11
	begin
		select CL.CLASSIFICATORID, CL.CLASSIFICATORCODE, CL.GUID from [#CLASS] CL
	end

--    ,     !!!
if @nMode = 12
	begin
		select CL.CLASSIFICATORID, CL.CLASSIFICATORCODE from [#CLASS] CL
	end

--  
if @nMode = 13
	begin
		declare @querySaveTable varchar(max)
		
		set @querySaveTable = 'insert into ' + @saveTable + ' ' + 		
							  'select distinct CL.CLASSIFICATORID from [#CLASS] CL'
		exec (@querySaveTable)							
	end 
	
end
GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8379' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_CL_INFO'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_VER_DEPLOY_HASH]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SELECT_VER_DEPLOY_HASH]
GO



/*
:         .

 :
	@nMode -  
					-2 - : ;
					-1 - :   ;
					0 -      ;

 :	

 : 	
		exec dbo.SELECT_VER_DEPLOY_HASH @nProjectID = 1973

:
	xxxx					- id 
	yyyy					- id 
	zzzz					- id 
	
	FACTS_xxxx				-   
	FACTS_xxxx_yyyy			-    
	FACTS2_xxxx_yyyy		-      
	FACTS2_xxxx_yyyy_zzzz	-     / ,      
	CL_xxxx_zzzz			-   
	CLD_xxxx				-   
	TIME_xxxx				-  
	CL_xxxx_zzzz			-    

   :
	-    
	-    
      .       

:
	 ..

*/
create procedure [dbo].[SELECT_VER_DEPLOY_HASH]
	@nProjectID	int,
	@nDS int,
	@cTableOut varchar(100)
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd

	declare
		@cMeasureList varchar(8000), --    
		@cStr varchar(max),
		@cPostfix varchar(200),
		@cTableOutApp varchar(100)
		
	select @cPostfix = convert(varchar(20), @nProjectID)
	
	--     
	select @cStr = 'alter table ' + @cTableOut + ' add [CLH_' + @cPostfix + '] int'
	execute (@cStr)
	
	---       
	select @cStr = 'if object_id(''[KS_DDLControl].[CLH_' + @cPostfix + ']'') is Null
	create table [KS_DDLControl].[CLH_' + @cPostfix + '] (HASH_KEY int identity(1,1), [HASH_SUM] varchar(42))'
	execute (@cStr)


	if exists(select * from #DTS_M DM, dbo.STORAGE_STRU(@nDS) SS
					where DM.LINK = @nDS and DM.MEASUREID = SS.ID and SS.DOF = 1 and isnull(SS.HASH_CALC,0) > 0)
		begin
			select distinct DM.MEASUREID
			into #FILTER_RATE
			from #DTS_M DM, dbo.STORAGE_STRU(@nDS) SS
			where DM.LINK = @nDS and DM.MEASUREID = SS.ID and SS.DOF = 1 and isnull(SS.HASH_CALC,0) > 0

			--  
			select @cTableOutApp = '[KS_DDLControl].[STDH_' + convert(varchar(36), newid()) + ']'

			--         
			select @cStr = 'select STA.*
			into ' + @cTableOutApp + ' 
			from ' + @cTableOut + ' ST, STORAGE_APP STA 
			where ST.STORAGEID = STA.STORAGEID and not STA.HASH_SUM is null'
			execute (@cStr)

			--      
			select @cStr = 'insert [KS_DDLControl].[CLH_' + @cPostfix + ']([HASH_SUM])
			select F.[HASH_SUM]
			from ' + @cTableOutApp + ' F
			where not exists (select * from [KS_DDLControl].[CLH_' + @cPostfix + '] where [HASH_SUM] = F.[HASH_SUM])'
			execute (@cStr)

			--   
			select @cStr = 'update ' + @cTableOut + ' set [CLH_' + @cPostfix + '] = CH.HASH_KEY
			from ' + @cTableOut + ' ST, ' + @cTableOutApp + ' STA, [KS_DDLControl].[CLH_' + @cPostfix + '] CH
			where ST.STORAGEID = STA.STORAGEID and STA.HASH_SUM = CH.HASH_SUM'

			execute (@cStr)
			execute ('drop table ' + @cTableOutApp)
		end
end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'7941' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_DEPLOY_HASH'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_VER_DEPLOY_XML]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SELECT_VER_DEPLOY_XML]
GO



/*
:         .

 :
	@nMode -  
					-2 - : ;
					-1 - :   ;
					0 -      ;

 :	

 : 	
		

:

:
	 ..

*/
create procedure [dbo].[SELECT_VER_DEPLOY_XML]
	@nProjectID	int,
	@nMode int = 0
as
begin
	set transaction isolation level read uncommitted
	set nocount on

	declare @nAccessProc int, @df datetime --    
	
	if @nMode = -2
		begin
			select @df = getdate()
		end
	
	select @nAccessProc = left(dbo.get_val('NASTR_ACCESS_SSAS','CASE_VALUE',null),1)
	
	declare @cXml varchar(max)
	select @cXml = '<Cube Name="CUBE_' + ltrim(rtrim(@nProjectID)) + '" Caption="' + (select dbo.[ReplForXml](NAME) from [VERSION] where VERSIONID = @nProjectID) + '">'

	select @cXml = @cXml + '
	<Dwh>
		<Server>' + @@SERVERNAME + '</Server>
		<Database>' + db_name() + '</Database>
		<Provider>' + case dbo.SqlProductVersion(0) when '10' then 'sqlncli10.1' when '11' then 'sqlncli11' else 'sqlncli' end + '</Provider>
	</Dwh>
	<Ssas>
		<Server>' + dbo.get_val('NASTR_SSAS', 'CHAR_VALUE', 0) + '</Server>
		<Database>' + dbo.get_val('NASTR_SSAS_BASE', 'CHAR_VALUE', 0) + '</Database>
	 </Ssas>'

	create table #XML (DEPLOY_TABLE varchar(100), NAME varchar(1000), FACTS varchar(4000))
	
	--   
	select @cXml = @cXml + '<Dsv>'
	
	insert #XML (DEPLOY_TABLE) select distinct '[KS_DDLControl].[CL_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), CLASSIFICATORID) + ']' from #DTS_CL where TXT = 0
	insert #XML (DEPLOY_TABLE) values('[KS_DDLControl].[CLD_' + convert(varchar(20), @nProjectID) + ']')
	insert #XML (DEPLOY_TABLE) select distinct '[KS_DDLControl].[CLM_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), CLASSIFICATORID) + ']' from #DTS_CL where TXT = 1
	insert #XML (DEPLOY_TABLE) select distinct DEPLOY_TABLE from #DTS
	insert #XML (DEPLOY_TABLE) select distinct FACTS2 from #DTS_CL where MULTISELECTION = 1
	insert #XML (DEPLOY_TABLE) select distinct ACCESS from #DTS_CL where not ACCESS is null

	select @cXml = @cXml + (select dbo.GetObjectStruXML(DEPLOY_TABLE,1) from #XML for xml path(''),type).value('.','varchar(max)')
	
	if @nMode = -2
		begin
			select ' XML  ', datediff(ms, @df, getdate())
			select @df = getdate()
		end
		

	--
	select @cXml = @cXml + 
	'<Table Schema="KS_DDLControl" Name="CLH_' + convert(varchar(20), @nProjectID) + '">
		<Column Name="HASH_KEY">
			<DataType Base="int"/>
		</Column>
		<Column Name="HASH_SUM">
			<DataType Base="string" Length="42"/>
		</Column>
	</Table>
	<Table Schema="dbo" Name="TIME">
		<Column Name="TIMEKEY">
			<DataType Base="int"/>
		</Column>
		<Column Name="FULLDATE">
			<DataType Base="dateTime"/>
		</Column>
		<Column Name="Day">
			<DataType Base="int"/>
			<Expression>(datepart(year, fulldate)*100+datepart(month, fulldate))*100+datepart(day, fulldate)</Expression>
		</Column>
		<Column Name="Month">
			<DataType Base="int"/>
			<Expression>datepart(year, fulldate)*100+datepart(month, fulldate)</Expression>
		</Column>
		<Column Name="Quarter">
			<DataType Base="int"/>
			<Expression>datepart(year, fulldate)*10+datepart(quarter, fulldate)</Expression>
		</Column>
		<Column Name="Year">
			<DataType Base="int"/>
			<Expression>datepart(year, fulldate)</Expression>
		</Column>
		<Column Name="QuarterOfYear">
			<DataType Base="int"/>
			<Expression>datepart(quarter, fulldate)</Expression>
		</Column>
		<Column Name="MonthOfYear">
			<DataType Base="int"/>
			<Expression>datepart(month, fulldate)</Expression>
		</Column>
		<Column Name="DayOfMonth">
			<DataType Base="int"/>
			<Expression>datepart(day, fulldate)</Expression>
		</Column>
		<Column Name="SemesterOfYear">
			<DataType Base="int"/>
			<Expression>case when datepart(quarter, fulldate) &lt;= 2 then 1 else 2 end</Expression>
		</Column>
		<Column Name="Semester">
			<DataType Base="string" Length="30"/>
			<Expression>case when datepart(quarter, fulldate) &lt;= 2 then datepart(year, fulldate)*10+1 else datepart(year, fulldate)*10+2 end</Expression>
		</Column>
		<Column Name="SemesterOfYearName">
			<DataType Base="string" Length="11"/>
			<Expression>case when datepart(quarter, fulldate) &lt;= 2 then '' 1'' else '' 2'' end</Expression>
		</Column>
		<Column Name="SemesterName">
			<DataType Base="string" Length="23"/>
			<Expression>case when datepart(quarter, fulldate) &lt;= 2 then '' 1, ''+ltrim(str(datepart(year, fulldate))) else '' 2, ''+ltrim(str(datepart(year, fulldate))) end</Expression>
		</Column>
		<Column Name="QuarterOfYearName">
			<DataType Base="string" Length="30"/>
			<Expression>'' ''+ltrim(str(datepart(quarter, fulldate)))</Expression>
		</Column>
		<Column Name="QuarterName">
			<DataType Base="string" Length="30"/>
			<Expression>'' ''+ltrim(str(datepart(quarter, fulldate)))+'', ''+ ltrim(str(datepart(year, fulldate)))</Expression>
		</Column>
		<Column Name="MonthOfYearName">
			<DataType Base="string" Length="30"/>
			<Expression>datename(month, fulldate)</Expression>
		</Column>
		<Column Name="MonthName">
			<DataType Base="string" Length="42"/>
			<Expression>datename(month, fulldate)+'', ''+ltrim(str(datepart(year, fulldate)))</Expression>
		</Column>
		<Column Name="DayName">
			<DataType Base="string" Length="53"/>
			<Expression>datename(month, fulldate)+'' ''+ltrim(str(datepart(day, fulldate)))+'', ''+ltrim(str(datepart(year, fulldate)))</Expression>
		</Column>
		<Column Name="Date">
			<DataType Base="string" Length="8"/>
			<Expression>convert(char(8),fulldate,112)</Expression>
		</Column>
	</Table>'
	
	if @nAccessProc = 1
		begin
			-- 
			select @cXml = @cXml + 
			'<Table Schema="dbo" Name="USERS_' + ltrim(rtrim(@nProjectID)) + '" Expression="select UID, LOGINAME from dbo.USERS()">
				<Column Name="UID">
					<DataType Base="int"/>
				</Column>
				<Column Name="LOGINAME">
					<DataType Base="string" Length="256"/>
				</Column>
			</Table>'		
		end


	select @cXml = @cXml + '</Dsv>'
	
	--  
	select @cXml = @cXml + '<Dimensions>'
	delete #XML
	
	insert #XML (DEPLOY_TABLE) select distinct DEPLOY_TABLE from #DTS_CL DC where DC.TXT = 0
	--insert #XML (DEPLOY_TABLE) values('[KS_DDLControl].[CLD_' + ltrim(rtrim(@nProjectID)) + ']')
	insert #XML (DEPLOY_TABLE) select distinct DEPLOY_TABLE from #DTS_CL DC where DC.TXT = 1
	insert #XML (DEPLOY_TABLE) select distinct D.DEPLOY_TABLE from #DTS D, #DTS_CL DC where D.LINK = DC.LINK and DC.MULTISELECTION = 1
	
	select @cXml = @cXml + (select dbo.GetObjectStruXML(DEPLOY_TABLE,3) from #XML for xml path(''),type).value('.','varchar(max)')
	
	if @nMode = -2
		begin
			select ' XML  ', datediff(ms, @df, getdate())
			select @df = getdate()
		end

	select @cXml = @cXml + 
	'<Dimension Name="CLH_'+ltrim(rtrim(@nProjectID))+'" Caption="  ">
      <Table>CLH_'+ltrim(rtrim(@nProjectID))+'</Table>
      <Type>Regular</Type>
      <Attributes>
        <Attribute Name="CLH_'+ltrim(rtrim(@nProjectID))+'" Caption="   - CRC">
          <Usage>Key</Usage>
          <KeyColumn>HASH_KEY</KeyColumn>
          <NameColumn>HASH_SUM</NameColumn>
        </Attribute>
      </Attributes>
    </Dimension>
	<Dimension Name="CLD_'+ltrim(rtrim(@nProjectID))+'" Caption=" ">
      <Table>CLD_'+ltrim(rtrim(@nProjectID))+'</Table>
      <Type>Regular</Type>
      <Attributes>
        <Attribute Name="CLD_'+ltrim(rtrim(@nProjectID))+'" Caption="  - ">
          <Usage>Key</Usage>
          <KeyColumn>VERSIONID</KeyColumn>
          <NameColumn>NAME</NameColumn>
        </Attribute>
      </Attributes>
    </Dimension>
    <Dimension Name="TIME" Caption="">
		<Table>TIME</Table>
		<Type>Hierarchy</Type>
		<All></All>
		<Attributes>
			<Attribute Name="" Caption="">
				<Usage>Key</Usage>
				<KeyColumn>TIMEKEY</KeyColumn>
				<NameColumn>DayName</NameColumn>
			</Attribute>
			<Attribute Name="" Caption="">
				<Usage>Regular</Usage>
				<KeyColumn>TIMEKEY</KeyColumn>
				<NameColumn>Date</NameColumn>
			</Attribute>
			<Attribute Name="" Caption="">
				<Usage>Regular</Usage>
				<KeyColumn>Year</KeyColumn>
				<NameColumn>Year</NameColumn>
			</Attribute>
			<Attribute Name="" Caption="">
				<Usage>Regular</Usage>
				<KeyColumn>Semester</KeyColumn>
				<NameColumn>SemesterName</NameColumn>
			</Attribute>
			<Attribute Name=" " Caption=" ">
				<Usage>Regular</Usage>
				<KeyColumn>SemesterOfYear</KeyColumn>
				<NameColumn>SemesterOfYearName</NameColumn>
			</Attribute>
			<Attribute Name="" Caption="">
				<Usage>Regular</Usage>
				<KeyColumn>Quarter</KeyColumn>
				<NameColumn>QuarterName</NameColumn>
			</Attribute>
			<Attribute Name=" " Caption=" ">
				<Usage>Regular</Usage>
				<KeyColumn>QuarterOfYear</KeyColumn>
				<NameColumn>QuarterOfYearName</NameColumn>
			</Attribute>
			<Attribute Name="" Caption="">
				<Usage>Regular</Usage>
				<KeyColumn>Month</KeyColumn>
				<NameColumn>MonthName</NameColumn>
			</Attribute>
			<Attribute Name=" " Caption=" ">
				<Usage>Regular</Usage>
				<KeyColumn>MonthOfYear</KeyColumn>
				<NameColumn>MonthOfYearName</NameColumn>
			</Attribute>
			<Attribute Name=" " Caption=" ">
				<Usage>Regular</Usage>
				<KeyColumn>DayOfMonth</KeyColumn>
				<NameColumn>DayOfMonth</NameColumn>
			</Attribute>
		</Attributes>
		<Hierarchies>
			<Hierarchy Name="TIME" Caption="">
			<Type>2</Type>
			<All></All>
			<Levels>
				<Level Name="" Caption="" AttributeId="" />
				<Level Name="" Caption="" AttributeId="" />
				<Level Name="" Caption="" AttributeId="" />
				<Level Name="" Caption="" AttributeId="" />
				<Level Name="" Caption="" AttributeId="" />
				</Levels>
			</Hierarchy>
		</Hierarchies>
	</Dimension>'


	if @nAccessProc = 1
		begin
			-- 
 			select @cXml = @cXml + 
			'<Dimension Name="USERS_' + ltrim(rtrim(@nProjectID)) + '" Caption="USERS_' + ltrim(rtrim(@nProjectID)) + '">
				<Table>USERS_' + ltrim(rtrim(@nProjectID)) + '</Table>
				<Type>Regular</Type>
				<Attributes>
					<Attribute Name="UID" Caption="UID">
						<Usage>Key</Usage>
						<KeyColumn>UID</KeyColumn>
						<NameColumn>UID</NameColumn>
					</Attribute>
					<Attribute Name="LOGINAME" Caption="LOGINAME">
						<Usage>Regular</Usage>
						<KeyColumn>LOGINAME</KeyColumn>
						<NameColumn>LOGINAME</NameColumn>
					</Attribute>
				</Attributes>
			</Dimension>'
		end

	select @cXml = @cXml + '</Dimensions>'

	--  
	select @cXml = @cXml + '<MeasureGroups>'
	delete #XML
	
	insert #XML (DEPLOY_TABLE)
	select distinct DT.DEPLOY_TABLE from #DTS DT

	update #XML set FACTS = isnull(stuff((select distinct ',' + DC.FACTS2 as [text()] from #DTS_CL DC where not DC.FACTS2 is null for xml path('')),1,1,''),'')
	
	update #XML set NAME = 
		case
			when dbo.j_sub_str(replace(DEPLOY_TABLE,'KS_DDLControl',''),'_',3)='' then (select Name from dbo.VERSION where VersionID = @nProjectID)
			else
				(select Name from dbo.VERSION where VersionID = replace(dbo.j_sub_str(replace(DEPLOY_TABLE,'KS_DDLControl',''),'_',3),']',''))
		end
	
	insert #XML (DEPLOY_TABLE, NAME, FACTS)
	select distinct DC.FACTS2, dbo.j_sub_str(DC.FACTS2,'.',2), DT.DEPLOY_TABLE
	from #DTS DT, #DTS_CL DC
	where DT.LINK = DC.LINK and not DC.FACTS2 is null
	
	insert #XML (DEPLOY_TABLE, NAME, FACTS) select distinct ACCESS, dbo.j_sub_str(ACCESS,'.',2),dbo.j_sub_str(DEPLOY_TABLE,'.',2) from #DTS_CL where not ACCESS is null

	select @cXml = @cXml + (select dbo.GetMeasureXML(DEPLOY_TABLE, NAME, FACTS) from #XML for xml path(''),type).value('.','varchar(max)')
	
	if @nMode = -2
		begin
			select ' XML  ', datediff(ms, @df, getdate())
			select @df = getdate()
		end

	select @cXml = @cXml + '</MeasureGroups>'

	--   
	select @cXml = @cXml + '<CubeDimensions>'
	delete #XML
	
	insert #XML (DEPLOY_TABLE, NAME) select distinct DC.DEPLOY_TABLE, case
	when replace(dbo.j_sub_str(DC.DEPLOY_TABLE,'_',5),']','') = '' then (select NAME from dbo.Classificators where ClassificatorID = DC.ClassificatorID)
	when replace(dbo.j_sub_str(DC.DEPLOY_TABLE,'_',5),']','') <> '' then (select NAME from dbo.Classificators where ClassificatorID = DC.ClassificatorID) + ' (' + (select NAME from dbo.VERSION where VERSIONID = replace(dbo.j_sub_str(DC.DEPLOY_TABLE,'_',5),']','')) + ')'
	end
	from #DTS_CL DC where DC.TXT = 0
	
	insert #XML (DEPLOY_TABLE, NAME) values('[KS_DDLControl].[CLD_' + ltrim(rtrim(@nProjectID)) + ']', ' ')
	insert #XML (DEPLOY_TABLE, NAME) select distinct DEPLOY_TABLE, (select FULLNAME from dbo.MEASURES where MEASUREID = DC.ClassificatorID) from #DTS_CL DC where DC.TXT = 1
	insert #XML (DEPLOY_TABLE, NAME) select distinct D.DEPLOY_TABLE, replace(replace(dbo.j_sub_str(D.DEPLOY_TABLE,'.',2),']',''),'[','') from #DTS D, #DTS_CL DC where D.LINK = DC.LINK and DC.MULTISELECTION = 1
	
	update #XML set DEPLOY_TABLE = dbo.j_sub_str(DEPLOY_TABLE,'.',2)
	update #XML set DEPLOY_TABLE = replace(DEPLOY_TABLE,'[','')
	update #XML set DEPLOY_TABLE = replace(DEPLOY_TABLE,']','')
	
	update #XML set NAME =
	case
		when dbo.j_sub_str(DEPLOY_TABLE,'_',4) <> '' then (select case when TABLENAME is null then (select name from Classificators c where ST.ClassificatorID = c.ClassificatorID) + ' (' + (select name from Classificators c where dbo.j_sub_str(DEPLOY_TABLE,'_',3) = c.ClassificatorID) + ')'
		else isnull(TABLENAME,'sadsa') + ' (' + (select name from Classificators c where dbo.j_sub_str(DEPLOY_TABLE,'_',3) = c.ClassificatorID) + ')' end from dbo.SOURCETEMPLATE ST where ST.SourceTemplateID = dbo.j_sub_str(DEPLOY_TABLE,'_',4))
	end
	where dbo.j_sub_str(DEPLOY_TABLE,'_',4) <> '' and DEPLOY_TABLE like 'CL[_]%'
	
	update #XML set NAME = dbo.[ReplForXml](NAME)

	select @cXml = @cXml + (
	select '<CubeDimension Name="' + DEPLOY_TABLE + '" Caption="' + NAME + '"><Id /><DimensionId>' + DEPLOY_TABLE + '</DimensionId>' + case when DEPLOY_TABLE like 'FACT%' then '<Visible>false</Visible>' else '<Visible />' end + '</CubeDimension>' from #XML for xml path(''),type).value('.','varchar(max)')
	
	select @cXml = @cXml + '
	<CubeDimension Name="TIME" Caption="">
		<Id />
		<DimensionId>TIME</DimensionId>
		<Visible />
	</CubeDimension>
	<CubeDimension Name="CLH_' + ltrim(rtrim(@nProjectID)) + '" Caption="  ">
      <Id />
      <DimensionId>CLH_' + ltrim(rtrim(@nProjectID)) + '</DimensionId>
      <Visible />
    </CubeDimension>'

	if @nAccessProc = 1
		begin
			select @cXml = @cXml + '<CubeDimension Name="USERS_' + ltrim(rtrim(@nProjectID)) + '" Caption=""><Id /><DimensionId>USERS_' + ltrim(rtrim(@nProjectID)) + '</DimensionId><Visible>False</Visible></CubeDimension>'
		end	
		
	select @cXml = @cXml + '</CubeDimensions>'
	
	-- 	
	select @cXml = @cXml + '<Roles>'
	
	if @nAccessProc = 1
		begin
			--  
			select @cXml = @cXml + '<Role><ID>Role</ID><Name>Role</Name><Members>'
			select @cXml = @cXml + isnull((select '<Member>' + convert(nvarchar(512), LOGINAME) + '</Member>' as [text()] from dbo.USERS() where LOGINAME <> 'server\user' and USER_TYPE <> 4 and dbo.CheckUsers(LOGINAME) = 1 for xml path(''),type).value('.','varchar(max)'),'')
			select @cXml = @cXml + '</Members>'
			
			select @cXml = @cXml + '
			<ObjectPermission>
				<CubePermission>
					<CubeID>CUBE_' + ltrim(rtrim(@nProjectID)) + '</CubeID>
					<Read>Allowed</Read>
					<ReadSourceData>Allowed</ReadSourceData>
					<Process>false</Process>
				</CubePermission>
				<DatabasePermission>
				  <ReadDefinition>Allowed</ReadDefinition>
				  <Read>Allowed</Read>
				</DatabasePermission>'
				
			select @cXml = @cXml + '<DimensionsPermission>'
			
			select @cXml = @cXml + isnull((select distinct '<Dimension><DimensionID>' + replace(replace(DEPLOY_TABLE, '[KS_DDLControl].[',''),']','') + '</DimensionID><AttributeID>' + case when (select TYPE from Classificators where ClassificatorID = #DTS_CL.ClassificatorID) = 3 then '' else replace(replace(DEPLOY_TABLE, '[KS_DDLControl].[',''),']','') end + '</AttributeID><AllowedSet>
			{nonempty (' + replace(DEPLOY_TABLE, '[KS_DDLControl].','') + '.' + replace(DEPLOY_TABLE, '[KS_DDLControl].','') + '.Members, (strtomember("[USERS_' + ltrim(rtrim(@nProjectID)) + '].[LOGINAME].[" + UserName() + "]"),[Measures].[' + replace(replace(replace(replace(ACCESS, ']',''), '[',''), 'KS_DDLControl',''), '.','') + ' Count])), ' + replace(DEPLOY_TABLE, '[KS_DDLControl].','') + '.' + replace(DEPLOY_TABLE, '[KS_DDLControl].','') + '.UNKNOWNMEMBER}</AllowedSet><VisualTotals>1</VisualTotals></Dimension>'
			from #DTS_CL where not ACCESS is null for xml path(''),type).value('.','varchar(max)'), '')

			select @cXml = @cXml + '</DimensionsPermission>'

			select @cXml = @cXml + '</ObjectPermission></Role>'
			
			-- 
			select @cXml = @cXml + '<Role><ID>RoleA</ID><Name>RoleA</Name><Members>'
			select @cXml = @cXml + isnull((select '<Member>' + convert(nvarchar(512), LOGINAME) + '</Member>' as [text()] from dbo.USERS() where LOGINAME <> 'server\user' and USER_TYPE = 4 and dbo.CheckUsers(LOGINAME) = 1 for xml path(''),type).value('.','varchar(max)'),'')
			select @cXml = @cXml + '</Members>'
			
			select @cXml = @cXml + '
				<ObjectPermission>
					<CubePermission>
						<CubeID>CUBE_' + ltrim(rtrim(@nProjectID)) + '</CubeID>
						<Read>Allowed</Read>
						<ReadSourceData>Allowed</ReadSourceData>
						<Process>true</Process>
					</CubePermission>
					<DatabasePermission>
					  <ReadDefinition>Allowed</ReadDefinition>
					  <Read>Allowed</Read>
					</DatabasePermission>
					<DimensionsPermission />
				</ObjectPermission>
			</Role>'
		end
	
	select @cXml = @cXml + '</Roles>'
	
	if @nMode = -2
		begin
			select ' XML  ', datediff(ms, @df, getdate())
			select @df = getdate()
		end
	
	-- 
	declare @nVerAlg int, @XmlAlg varchar(max)
	select @nVerAlg = TV.LINK from dbo.TREE_VERSION(@nProjectID,'DOWN') TV, dbo.VERSION V where TV.LINK = V.VersionID and V.OBJECT = dbo.obj_id('DICTIONARY_ALGORITHM_DWH')

	exec [dbo].[SELECT_VER_ALG] @nVerAlg = @nVerAlg, @Xml = @XmlAlg output
	
	select @cXml = @cXml + @XmlAlg
	
	if @nMode = -2
		begin
			select ' XML  ', datediff(ms, @df, getdate())
			select @df = getdate()
		end


	select @cXml = @cXml + '</Cube>'
	
	if @nMode <> -2
		select convert(xml,@cXml)
	
end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'7941' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_DEPLOY_XML'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_MEASURE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[SELECT_MEASURE]
GO


/*
	:  

   :

   :
	
  :
 
  :
		 .
*/

create procedure [dbo].[SELECT_MEASURE]
	@nLink int = 0,
	@nDsId int = 0
as
begin
	set nocount on

	declare @nFlag int, @nMeasure int

	select @nFlag = 0
	select @nMeasure = dbo.obj_id('DICTIONARY_MEASURE')

	if @nLink <> 0
		select @nFlag = 1

	select
		convert(int, 0) as CHECKED,
		MS.MEASUREID, MS.FULLNAME as [NAME], MS.SHORTNAME, MS.[OBJECT],		
		MS.[PRECISION],
		MS.MS_TYPE,
		MS.MS_FORMULA_TYPE,
		MS.[DESCRIPTION], MS.[ZERO],
		(select count(*) from T_MEASURE where MEASUREID = MS.MEASUREID) as CNT,
		(case when (MS.ISGROUP is null or MS.ISGROUP = 0) then 0 else 1 end) as ISGROUP,
		(case when (MS.HASH_CALC is null or MS.HASH_CALC = 0) then 0 else 1 end) as HASH_CALC,
		(case when (MS.ParentMeasureID is null) then 0 else convert(int, MS.ParentMeasureID) end) as ParentMeasureID,
		MS.DATA_TYPE,
		MS.DATA_PROPERTY
	into #M
	from MEASURES MS
	where MS.[OBJECT] = @nMeasure and @nFlag = 0 or (@nFlag = 1 and MS.MEASUREID = @nLink)

	if (@nDsId > 0)
		delete from #M where measureId not in (select distinct measureid from storage where versionid = @nDsId)
		
	if @nFlag = 0
		select *, 
			case 
				when [MS_TYPE] = 0 then ''
				when [MS_TYPE] = 1 then ''
				when [MS_TYPE] = 2 then ''
				when [MS_TYPE] = 3 then ''
				when [MS_TYPE] = 4 then ''
				when [MS_TYPE] = 5 then ''
				else '          '
			end as [STR_LIST]
		from #M order by [NAME]
	else
		select * from #M order by [NAME]

	if @nLink <> 0
		select V.Name from T_MEASURE TM, [VERSION] V where TM.MEASUREID = @nLink and TM.VERSIONID = V.VERSIONID order by V.NAME
end
	
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8679' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_MEASURE'
GO



if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SELECT_VER_INFO]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[SELECT_VER_INFO]
GO


/*
:      .

 : 
	@nMode		-   : 1 - , 2 - ,   
	@nVerID		- 


 :	 1 -  ,  2 -   

 : 	
		exec SELECT_VER_INFO @nVerID = 2248, @cObjectCode = 'DICTIONARY_PROJECT'
		exec SELECT_VER_INFO @nVerID = 174, @nMode = 2, @cObjectCode = 'DICTIONARY_DATASOURCE' 

:

*/
CREATE PROCEDURE SELECT_VER_INFO
	@nMode  int = 1,
	@nVerID	int,
	@cObjectCode varchar(50)= ''
as
begin
set transaction isolation level read uncommitted
set nocount on

declare @nDictDataSource int, @nDictAlgoritm int, @nDictFormuls int, @nDictQuery int, @nDictVersion int

select @nDictDataSource = dbo.obj_id('DICTIONARY_DATASOURCE')
select @nDictAlgoritm = dbo.obj_id('DICTIONARY_ALGORITHM_DWH')
select @nDictFormuls = dbo.obj_id('DICTIONARY_CALC_MEASURE')
select @nDictQuery = dbo.obj_id('DICTIONARY_QUERY_DWH')

-- 
if @nMode = 1
	begin
		select [VERSIONID], [NAME], [DESCRIPTION], [BEGINDATETIME], [ENDDATETIME], dbo.obj_code([OBJECT]) as [OBJ_CODE], CODE, convert(int, Null) as ORDERS, [OBJECT], [DATA], ROW_ID
		from VERSION
		where [VERSIONID] = @nVerID
	end

if not @cObjectCode in ('DICTIONARY_REPORT_TEMPLATE', 'DICTIONARY_QUERY', 'DICTIONARY_RS_TEMPLATE', 'DICTIONARY_WORD_TEMPLATE', 'DICTIONARY_ATTACHED_FILE')
	begin
		create table #VER_ROWS (
			CHECKED int default(0), SOURCETEMPLATEID int, PARENT int, ID int, [NAME] varchar(1000), [SNAME] varchar(64),
			[DESCRIPTION] varchar(2000), ORDERS int, ISAGGREGATABLE int, GRP int,
			OBJ_CODE varchar(70), ROW_ID uniqueidentifier)
	end

if @cObjectCode = 'DICTIONARY_DATASOURCE' or @cObjectCode = 'DICTIONARY_PROJECT' or @cObjectCode = 'DICTIONARY_PROJECT_EXT'
	create table #aaa (TMID int, ID int, PARENT int, NAME varchar(500), SHORTNAME varchar(50), UNITID int, UNIT varchar(60), [DESCRIPTION] varchar(2000), [PRECISION] int, DEPLOY int, [ZERO] tinyint, [STR] tinyint, [MS_TYPE] int, [MS_FORMULA_TYPE] int, DATA_TYPE int, DATA_PROPERTY int, ROW_ID uniqueidentifier)


--  
if @cObjectCode = 'DICTIONARY_VERSION'
	begin
		select CL.CLASSIFICATORID, convert(int, Null) as DELETED
		into #V21
		from CLASSIFICATORS CL
		where CL.PARENTCLASSIFICATORID is Null

--select * from #V21
		if @nVerID = -1
			delete #V21
		else
			update #V21 set DELETED = dbo.[CheckClassInVersion](@nVerID,CLASSIFICATORID)
--select * from #V21

		delete #V21 where DELETED = 0

		insert #VER_ROWS (PARENT, ID, [NAME], [DESCRIPTION], ISAGGREGATABLE, OBJ_CODE)
		select @nVerID, CL.CLASSIFICATORID, left(CL.NAME,1000), left(CL.DESCRIPTION,2000), CL.ISAGGREGATABLE, dbo.obj_code(CL.OBJECT)
		from #V21 V2, CLASSIFICATORS CL
		where CL.CLASSIFICATORID = V2.CLASSIFICATORID

		alter table #VER_ROWS drop column [SNAME]
	end


-- 
if @cObjectCode = 'DICTIONARY_PROJECT' or @cObjectCode = 'DICTIONARY_PROJECT_EXT'
	begin
		--   
		select LINK, convert(int, null) as [OBJECT] into #VD from dbo.tree_version (@nVerID, 'DOWN')
		update #VD set [OBJECT] = V.[OBJECT] from VERSION V where V.VERSIONID = #VD.LINK

		--insert #VER_ROWS (PARENT, ID, [NAME], ORDERS)
		--select distinct @nVerID, CL.CLASSIFICATORID, left(CL.NAME,1000), case when exists(select * from dbo.T_CLASSIFICATORS TC where @nVerID = TC.VERSIONID and TC.CLASSIFICATORID = CL.CLASSIFICATORID) then 0 else 1 end
		--from SOURCETEMPLATE ST, CLASSIFICATORS CL, #VD V
		--where ST.CLASSIFICATORID = CL.CLASSIFICATORID and ST.VERSIONID = V.LINK and V.OBJECT in (@nDictDataSource,@nDictAlgoritm)
		
		insert #VER_ROWS (SOURCETEMPLATEID,PARENT, ID, [NAME], ORDERS)
		select distinct TC.TCID, TC.VERSIONID, TC.CLASSIFICATORID, left(CL.NAME,1000), TC.PROCESS
		from T_CLASSIFICATORS TC, CLASSIFICATORS CL
		where TC.CLASSIFICATORID = CL.CLASSIFICATORID and TC.VERSIONID = @nVerID
	
		insert #aaa (TMID, ID, NAME, SHORTNAME, ROW_ID)
		select distinct
			TMP.TMPID, MS.MEASUREID, MS.FULLNAME, MS.SHORTNAME, MS.ROW_ID
		from T_MEASURE_PROJ TMP, MEASURES MS
		where TMP.VERSIONID = @nVerID and TMP.MEASUREID = MS.MEASUREID

		update #aaa set UNITID = TMP.AUTOCALC from T_MEASURE_PROJ TMP where #aaa.ID = TMP.MEASUREID and TMP.VERSIONID = @nVerID
		update #aaa set DEPLOY = TMP.PROCESS from T_MEASURE_PROJ TMP where #aaa.ID = TMP.MEASUREID and TMP.VERSIONID = @nVerID
		update #aaa set PARENT = @nVerId
--
	end


--  
if @cObjectCode = 'DICTIONARY_DATASOURCE'
	begin
		-- 
		insert #VER_ROWS (SOURCETEMPLATEID, PARENT, ID, [NAME], ROW_ID, ORDERS, ISAGGREGATABLE, GRP, [DESCRIPTION])
		select ST.SOURCETEMPLATEID, ST.VERSIONID, ST.CLASSIFICATORID, left(CL.NAME,1000), ST.ROW_ID, ST.MULTISELECTION, ST.MUSTINPUT, ST.GRP, ST.TABLENAME
		from SOURCETEMPLATE ST, CLASSIFICATORS CL
		where ST.CLASSIFICATORID = CL.CLASSIFICATORID and ST.VERSIONID = @nVerId

		-- 
		insert #aaa (TMID, ID, NAME, SHORTNAME, [DESCRIPTION], [PRECISION], [ZERO], [MS_TYPE], [MS_FORMULA_TYPE], DATA_TYPE, DATA_PROPERTY, ROW_ID)
		select
			TM.[TMID], MS.MEASUREID, MS.FULLNAME, MS.SHORTNAME, left(MS.DESCRIPTION,2000), MS.[PRECISION], MS.[ZERO], MS.[MS_TYPE], MS.[MS_FORMULA_TYPE], MS.DATA_TYPE, MS.DATA_PROPERTY, MS.ROW_ID
		from T_MEASURE TM, MEASURES MS
		where TM.VERSIONID = @nVerId and TM.MEASUREID = MS.MEASUREID

		update #aaa set PARENT = @nVerId
	end


-- 
if @cObjectCode = 'DICTIONARY_ALGORITHM_DWH'
	begin
		-- 
		insert #VER_ROWS (PARENT, ID, [NAME], ORDERS, OBJ_CODE, DESCRIPTION)
		select @nVerID, [VERSIONID], left([Name],1000), ORDERS, dbo.obj_code(OBJECT), DESCRIPTION
		from Version
		where [VersionID] in (select LINK from dbo.tree_version (@nVerID, 'DOWN')) and([OBJECT] = @nDictDataSource)
		order by ORDERS

		select ORDERS, [LINK], [LINK_SELF], LEVELS, convert(int, Null) as [OBJECT] into #VER from dbo.TREE_VERSION(Null, 'DOWN')
		update #VER set [OBJECT] = V.[OBJECT] from VERSION V where V.VersionID = #VER.LINK
		delete #VER where [OBJECT] <> @nDictVersion
		delete #VER where [OBJECT] is Null

		select ORDERS, LINK, convert(int, Null) as [OBJECT], dbo.VersionParent(LINK) as PARENT, LEVELS, convert(int, null) as BRANCH, convert(int, null) as PARENT1 into #DTS from dbo.TREE_VERSION(@nVerID, 'DOWN')
		update #DTS set [OBJECT] = V.[OBJECT] from VERSION V where V.VersionID = #DTS.LINK
		delete #DTS where [OBJECT] <> @nDictDataSource
		update #DTS set [LEVELS] = V.[LEVELS] from [#VER] V where V.[LINK] = [#DTS].[PARENT]

		declare @nMax int, @nMin int
		select @nMax = max([LEVELS]) from #DTS
		select @nMin = min([LEVELS]) from #DTS
		update [#DTS] set [PARENT1] = [PARENT]
		
		while @nMax > @nMin
			begin
				update #DTS set BRANCH = dbo.[VersionParent]([PARENT1]), LEVELS = LEVELS - 1 where LEVELS = @nMax
				update #DTS set [PARENT] = D2.[PARENT] from #DTS, #DTS D2 where #DTS.[PARENT] = D2.BRANCH
				select @nMax = @nMax - 1
			end

		declare @nProject int
		select @nProject = V.VersionID from T_RELATION TR inner join VERSION V on TR.PARENTID = V.VersionID and TR.CHILDID = @nVerID

		-- 
		alter table #VER_ROWS alter column [NAME] varchar(1000)
		
		insert #VER_ROWS (PARENT, ID, [NAME], [SNAME], [DESCRIPTION], OBJ_CODE)
		select TM.VERSIONID, MS.MEASUREID, left(MS.[FULLNAME],1000), MS.SHORTNAME, 'MEASURE_' + convert(varchar(20), @nProject) + '_' + convert(varchar(20), MS.MEASUREID), 'DICTIONARY_MACRO_RATE'
		from VERSION V inner join T_MEASURE TM on V.VERSIONID = TM.VERSIONID
			inner join MEASURES MS on TM.MEASUREID = MS.MEASUREID
		where V.VERSIONID in (select LINK from dbo.tree_version (@nVerID, 'DOWN')) and V.[OBJECT] = @nDictDataSource
		order by ORDERS

		insert #VER_ROWS (PARENT, ID, [NAME], [SNAME], [DESCRIPTION], OBJ_CODE)
		select V.VERSIONID, CL.CLASSIFICATORID, left(CL.DESCRIPTION,1000) , left(CL.[NAME],64), 'CL_' + convert(varchar(20), @nProject) + '_' + convert(varchar(20), CL.CLASSIFICATORID),
		'DICTIONARY_CLASSIFICATOR' + '-' + (select convert(varchar(20),PARENT) from [#DTS] where LINK = V.VERSIONID) + '-' + convert(varchar(20), CL.CLASSIFICATORID)
		from VERSION V inner join SOURCETEMPLATE ST on V.VERSIONID = ST.VERSIONID
										inner join CLASSIFICATORS CL on ST.CLASSIFICATORID = CL.CLASSIFICATORID
		where V.VERSIONID in (select LINK from dbo.tree_version (@nVerID, 'DOWN')) and V.[OBJECT] = @nDictDataSource
		order by ORDERS
		
				
		select distinct V.ID as PARENT, CD.[DESCRIPTIONID] as ID, CD.[Name] as [NAME], 'CE_' + convert(varchar(20), @nProject) + '_' + convert(varchar(20), V.ID) + '.[' + CD.[Name] + ']' as [DESCRIPTION]
		into #ccc
		from #VER_ROWS V inner join [CLASSIFICATORDESCRIPTION] CD on V.ID = CD.[ClassificatorID]
		
		update #ccc set [NAME] = '[' + CL.name + '].[' + #ccc.[NAME] + ']' from [CLASSIFICATORS] CL where CL.[ClassificatorID] = #ccc.PARENT
		
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -1, '[].[]', 'TIME_' + convert(varchar(20), @nProject) + '.[]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -2, '[].[]', 'TIME_' + convert(varchar(20), @nProject) + '.[]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -3, '[].[]', 'TIME_' + convert(varchar(20), @nProject) + '.[]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -4, '[].[]', 'TIME_' + convert(varchar(20), @nProject) + '.[]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -5, '[].[]', 'TIME_' + convert(varchar(20), @nProject) + '.[]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -6, '[].[]', 'TIME_' + convert(varchar(20), @nProject) + '.' + 'TIME_' + convert(varchar(20), @nProject) + '.[]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -7, '[].[ ]', 'TIME_' + convert(varchar(20), @nProject) + '.[ ]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -8, '[].[ ]', 'TIME_' + convert(varchar(20), @nProject) + '.[ ]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -9, '[].[ ]', 'TIME_' + convert(varchar(20), @nProject) + '.' + 'TIME_' + convert(varchar(20), @nProject) + '.[ ]')
		insert #ccc (PARENT, ID, [NAME], [DESCRIPTION])	values(-1, -10, '[].[ ]', 'TIME_' + convert(varchar(20), @nProject) + '.' + 'TIME_' + convert(varchar(20), @nProject) + '.[ ]')
	
	
	
	
--		insert #VER_ROWS (PARENT, ID, [NAME], [SNAME], [DESCRIPTION], OBJ_CODE)
--		select distinct V.ID, CD.[DESCRIPTIONID], CD.[Name], CD.[Name], 'CE_' + convert(varchar(20), @nProject) + '_' + convert(varchar(20), V.ID) + '.' + CD.[Name],
--		'DICTIONARY_CLASSIFICATOR_ELEMENTS'
--		from #VER_ROWS V inner join [CLASSIFICATORDESCRIPTION] CD on V.ID = CD.[ClassificatorID]
	end

if @cObjectCode = 'DICTIONARY_QUERY_DWH'
	begin
		select * from [REPORTQUERY] where [VERSIONID] = @nVerID
	end
	
if @cObjectCode = 'DICTIONARY_RS_TEMPLATE'
	begin
		select [RTID], [VERSIONID], [TEMPLATE_RS5], [ROW_ID] from [REPORTEMPLATE] where [VERSIONID] = @nVerID
		select dbo.obj_code(V.[OBJECT]) as OBJ_CODE, V.[OBJECT], V.[VERSIONID], V.[NAME], V.[DESCRIPTION], R.[PARENTID], R.[RELID]
			from [VERSION] V left join [T_RELATION] R on V.[VERSIONID] = R.[CHILDID]
			where R.[PARENTID] = @nVerID and dbo.obj_code(V.[OBJECT]) = 'DICTIONARY_QUERY_DWH'
	end

if @cObjectCode = 'DICTIONARY_ATTACHED_FILE'
	begin
		select * from [ATTACHED_FILES] where [VERSIONID] = @nVerID
	end
	
if not @cObjectCode in ('DICTIONARY_REPORT_TEMPLATE', 'DICTIONARY_RS_TEMPLATE', 'DICTIONARY_WORD_TEMPLATE','DICTIONARY_QUERY_DWH', 'DICTIONARY_ATTACHED_FILE')
	select * from #VER_ROWS order by NAME

if @cObjectCode = 'DICTIONARY_DATASOURCE' or @cObjectCode = 'DICTIONARY_PROJECT' or @cObjectCode = 'DICTIONARY_PROJECT_EXT'
	select * from #aaa order by name
	
if @cObjectCode = 'DICTIONARY_ALGORITHM_DWH'
	begin
		create table #FRM_ROWS (PARENT int , TMID int, MEASUREID int, SUBMEASUREID int, ORDERS int, UNIT int, [PRECISION] int,  FULLNAME varchar(250),
			SHORTNAME varchar(50), MDXEXPR varchar(max), [DESCRIPTION] varchar(1024), OBJECT int, OBJ_CODE varchar(300), ROW_ID uniqueidentifier, GRAPHCOL int, FRMCOL int, BGRCOL int)
				
		insert into #FRM_ROWS(PARENT, TMID, SUBMEASUREID, MEASUREID, ORDERS, [PRECISION], FULLNAME, SHORTNAME, MDXEXPR, DESCRIPTION, OBJECT, ROW_ID, GRAPHCOL, FRMCOL, BGRCOL, [OBJ_CODE])
		select @nVerID, TM.TMID, M.MEASUREID_PARENT, M.MEASUREID, ORDERS, M.[PRECISION], M.FULLNAME, M.SHORTNAME, M.MDXEXPR, M.DESCRIPTION, @nDictFormuls, V.ROW_ID, M.GRAPHCOL, M.FRMCOL, M.BGRCOL, M.DIMENSION
		from VERSION V inner join T_MEASURE TM on V.VERSIONID = TM.VERSIONID and V.VERSIONID = @nVerID
			inner join MEASURES M on TM.MEASUREID = M.MEASUREID
		order by ORDERS
		

		--    
		select TMF.*, convert(varchar(1024), Null) as [DESCRIPTION]
		into #bbb
		from VERSION V inner join T_MEASURE TM on V.VERSIONID = TM.VERSIONID
			inner join MEASURES MS on TM.MEASUREID = MS.MEASUREID --and MS.[OBJECT] in (@nSet, @nCalcFilter)
			inner join T_MEASURE_FILTER TMF on TMF.[MEASUREID] = MS.MEASUREID
		where V.VERSIONID = @nVerID

		update #bbb set [DESCRIPTION] = 'CL_' + convert(varchar(20), @nProject) + '_' + convert(varchar(20), dbo.[ClassificatorIdParent]([CLASSIFICATORID])) where not [CLASSIFICATORID] is null
		update #bbb set [DESCRIPTION] = 'TIME' where [DESCRIPTION] is null and [CLASSIFICATORID] is null
		
		select * from #FRM_ROWS

		select * from #bbb
		select * from #ccc
		
	end


end

GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8485' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_INFO'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[CM_CLONE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[CM_CLONE]
GO



/*
	:  

   :

   :
	
  :
 
  :
		 .
*/

Create procedure [dbo].[CM_CLONE]
	@nLink int = 0
as
begin
	set nocount on

	if @nLink >0
		begin
		insert CALC_MEASURES (NAME, REPL, SLICE, REMOLDRES, IGNOREEMPTY,[OBJECT],AUTOCALC,REMBYDATE)
		select left(' ' + NAME, 100), REPL, SLICE, REMOLDRES, IGNOREEMPTY,[OBJECT],AUTOCALC,REMBYDATE from CALC_MEASURES where CMID = @nLink

		end
end		
	
GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8586' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'CM_CLONE'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[GET_SCHEDULED_EXPORTS]') AND type in (N'P', N'PC'))
DROP PROCEDURE [dbo].[GET_SCHEDULED_EXPORTS]
GO


CREATE PROCEDURE [dbo].[GET_SCHEDULED_EXPORTS]
AS
BEGIN
	select distinct a.templateid
	from
	(
		select scriptid, x.n.value('ParentId[1]','int') as taskId, x.n.value('IntValue[1]','int') as templateId
		from dbo.SCHEDULERSCRIPTS cross apply scriptcontent.nodes('/Scheduler/TaskSubSettings[Code="templateId"]') x(n)
	)a inner join
	(
		select scriptid, x.n.value('ParentId[1]','int') as taskId
		from dbo.SCHEDULERSCRIPTS cross apply scriptcontent.nodes('/Scheduler/TaskHeader[Code = "TaskType" and IntValue = "6"]') x(n)
	)b on (a.scriptid = b.scriptid and a.taskid = b.taskid)
END

GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8122' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'GET_SCHEDULED_EXPORTS'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_VER_DEPLOY_MLT]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SELECT_VER_DEPLOY_MLT]
GO



/*
:         .

 :
	@nMode -  
					-2 - : ;
					-1 - :   ;
					0 -      ;

 :	

 : 	
		exec dbo.SELECT_VER_DEPLOY_MLT @nProjectID = 1973

:
	xxxx					- id 
	yyyy					- id 
	zzzz					- id 
	
	FACTS_xxxx				-   
	FACTS_xxxx_yyyy			-    
	FACTS2_xxxx				-       
	FACTS2_xxxx_yyyy		-      ,   
	FACTS2_xxxx_yyyy_zzzz	-     / ,      
	CL_xxxx_zzzz			-   
	CLD_xxxx				-   
	TIME_xxxx				-  
	CLA_xxxx_zzzz			-    

:
	 ..

*/
create procedure [dbo].[SELECT_VER_DEPLOY_MLT]
	@nProjectID	int,
	@nDS int,
	@cTableOut varchar(100)
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd

	declare
		@cMeasureList varchar(max), --    
		@cStr varchar(max),
		@cTableOut2 varchar(100),
		@cClassList varchar(max),
		@cPostfix varchar(200),
		@nCl int

	--   
	if exists(select * from #DTS_CL where MULTISELECTION = 1 and LINK = @nDS)
		begin
			select @cPostfix = convert(varchar(20), @nProjectID) + '_' + convert(nvarchar(20), @nDS)
			
			--      
			select @cStr = 'alter table ' + @cTableOut + ' add MULTI bit, ORD int'
			execute (@cStr)
			select @cStr = 'update ' + @cTableOut + ' set MULTI = 1 where not STRID is null'
			execute (@cStr)
			
			--    .        . .
			select @cClassList = stuff((select ',[CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + ']' as [text()] from #DTS_CL where LINK = @nDS and MULTISELECTION = 0  and TXT = 0 for xml path('')),1,1,'')
			
			if exists(select * from #DTS_CL where LINK = @nDS and TXT = 1)
				select @cClassList = @cClassList + ',' + stuff((select ',[CLM_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + ']' as [text()] from #DTS_CL where LINK = @nDS and MULTISELECTION = 0 and TXT = 1 for xml path('')),1,1,'')
			
			select @cClassList = @cClassList + ',[CLH_' + convert(nvarchar(20), @nProjectID) + ']'
			
			select @cMeasureList = stuff((select ',max([MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + ']) as [MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + ']' as [text()] from #DTS_M where LINK = @nDS for xml path('')),1,1,'')

			select @cTableOut2 = '[KS_DDLControl].[STD_' + convert(varchar(36), newid()) + '-]'


			select @cStr = '
			select VERSIONID, FILTERID, floor(STRID/100) as STRID, TIMEKEY, ' + @cMeasureList + ',' + @cClassList + '
			into ' + @cTableOut2 + '
			from ' + @cTableOut + '
			where MULTI = 1
			group by VERSIONID, FILTERID, floor(STRID/100), TIMEKEY, ' + @cClassList + '
			order by VERSIONID, FILTERID, floor(STRID/100), TIMEKEY'
								
			--     "" .
			select @cStr = @cStr + '
			alter table ' + @cTableOut2 + ' add ORD int
			declare @a int
			select @a = 0
			update ' + @cTableOut2 + ' set @a = ORD = @a + 1'
			execute (@cStr)
	
			--      "" .
			select @cClassList = stuff((select ' and isnull(KA.[CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + '],0) = isnull(K.[CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + '],0)' as [text()] from #DTS_CL where LINK = @nDS and MULTISELECTION = 0 and TXT = 0 for xml path('')),1,1,'')
			
			if exists(select * from #DTS_CL where LINK = @nDS and TXT = 1)
				select @cClassList = @cClassList + stuff((select ' and isnull(KA.[CLM_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + '],0) = isnull(K.[CLM_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + '],0)' as [text()] from #DTS_CL where LINK = @nDS and MULTISELECTION = 0 and TXT = 1 for xml path('')),1,1,'')
			
			select @cMeasureList = stuff((select ' or isnull(KA.[MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + '],0) = isnull(K.[MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + '],0)' as [text()] from #DTS_M where LINK = @nDS for xml path('')),1,1,'')
			select @cMeasureList = '(' + stuff(@cMeasureList,1,3,'') + ')'
			
			select @cStr = 'update ' + @cTableOut + ' set ORD = KA.ORD from ' + @cTableOut2 + ' KA, ' + @cTableOut + ' K where floor(K.STRID/100) = KA.STRID and isnull(K.FILTERID,0) = isnull(KA.FILTERID,0) ' + @cClassList + ' and ' + @cMeasureList
			execute (@cStr)
			

			-- .  
			if exists(select * from #DTS where LINK = @nDS and COMB = 1)
				begin
					--     ,  ..  
					select @cClassList = stuff((select ', max([CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + '])  as [CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + ']' as [text()] from #DTS_CL where LINK = @nDS and MULTISELECTION = 1 for xml path('')),1,1,'')
			
					select @cStr = '
					if not object_id(''[KS_DDLControl].[FACTS2_' + @cPostfix + ']'') is Null
						drop table [KS_DDLControl].[FACTS2_' + @cPostfix + ']
						
					select ORD,FILTERID,STRID, ' + @cClassList + ' into [KS_DDLControl].[FACTS2_' + @cPostfix + ']
					from ' + @cTableOut + '
					where MULTI = 1
					group by ORD,FILTERID,STRID
					order by ORD,FILTERID,STRID'
					
					update #DTS_CL set FACTS2 = '[KS_DDLControl].[FACTS2_' + @cPostfix + ']' where LINK = @nDS and MULTISELECTION = 1
				end
			else
				begin
					--       
		
					if (select count(CLASSIFICATORID) from #DTS_CL where LINK = @nDS and MULTISELECTION = 1) = 1
						begin
							select @nCl = CLASSIFICATORID from #DTS_CL where LINK = @nDS and MULTISELECTION = 1
							select @cClassList = '[CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), @nCl) + ']'
							select @cStr = '
							if not object_id(''[KS_DDLControl].[FACTS2_' + @cPostfix + '_' + convert(nvarchar(20), @nCl) + ']'') is Null
								drop table [KS_DDLControl].[FACTS2_' + @cPostfix + '_' + convert(nvarchar(20), @nCl) + ']
								
							select distinct ORD,FILTERID,STRID, ' + @cClassList + ' into [KS_DDLControl].[FACTS2_' + @cPostfix + '_' + convert(nvarchar(20), @nCl) + '] from ' + @cTableOut + ' where MULTI = 1 and not [CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), @nCl) + '] is null order by ORD,FILTERID,STRID'
							
							update #DTS_CL set FACTS2 = '[KS_DDLControl].[FACTS2_' + @cPostfix + '_' + convert(nvarchar(20), @nCl) + ']' where LINK = @nDS and MULTISELECTION = 1 and CLASSIFICATORID = @nCl
						end
					else
						begin
							select @cStr = ''
							declare CL scroll cursor for select CLASSIFICATORID from #DTS_CL where LINK = @nDS and MULTISELECTION = 1
							open CL
		
							if @@CURSOR_ROWS > 0
								begin
									fetch next from CL into @nCl
		
									while @@FETCH_STATUS = 0
										begin
											select @cClassList = 'max([CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), @nCl) + ']) as [CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), @nCl) + ']'
											select @cStr = @cStr + '
											if not object_id(''[KS_DDLControl].[FACTS2_' + @cPostfix + '_' + convert(nvarchar(20), @nCl) + ']'') is Null
												drop table [KS_DDLControl].[FACTS2_' + @cPostfix + '_' + convert(nvarchar(20), @nCl) + ']
												
											select ORD,FILTERID,STRID, ' + @cClassList + ' into [KS_DDLControl].[FACTS2_' + @cPostfix + '_' + convert(nvarchar(20), @nCl) + '] from ' + @cTableOut + ' where MULTI = 1 and not [CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), @nCl) + '] is null group by ORD,FILTERID,STRID order by ORD,FILTERID,STRID'
											
											update #DTS_CL set FACTS2 = '[KS_DDLControl].[FACTS2_' + @cPostfix + '_' + convert(nvarchar(20), @nCl) + ']' where LINK = @nDS and MULTISELECTION = 1 and CLASSIFICATORID = @nCl
		
											fetch next from CL into @nCl
										end
								end
							close CL
							deallocate CL
						end		
				end

			execute (@cStr)

			--   "" ,        .
			select @cClassList = stuff((select ',[CL_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + ']' as [text()] from #DTS_CL where LINK = @nDS and MULTISELECTION = 0  and TXT = 0 for xml path('')),1,1,'')
			
			if exists(select * from #DTS_CL where LINK = @nDS and TXT = 1)
				select @cClassList = @cClassList + ',' + stuff((select ',[CLM_' + convert(nvarchar(20), @nProjectID) + '_' + convert(nvarchar(20), CLASSIFICATORID) + ']' as [text()] from #DTS_CL where LINK = @nDS and MULTISELECTION = 0 and TXT = 1 for xml path('')),1,1,'')
			
			select @cMeasureList = stuff((select ',[MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + ']' as [text()] from #DTS_M where LINK = @nDS for xml path('')),1,1,'')
				
			select @cStr = '
			insert ' + @cTableOut2 + ' (VERSIONID, FILTERID, STRID, TIMEKEY, ' + @cMeasureList + ',' + @cClassList + ')'
			
			select @cMeasureList = stuff((select ',max([MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + ']) as [MEASURE_' + convert(varchar(20), @nProjectID) + '_' + convert(varchar(20), [MEASUREID]) + ']' as [text()] from #DTS_M where LINK = @nDS for xml path('')),1,1,'')
			
			select @cStr = @cStr + '
			select VERSIONID, FILTERID, floor(STRID/100), TIMEKEY, ' + @cMeasureList + ',' + @cClassList + '
			from ' + @cTableOut + '
			where MULTI is null
			group by VERSIONID, FILTERID, floor(STRID/100), TIMEKEY, ' + @cClassList + '
			order by VERSIONID, FILTERID, floor(STRID/100), TIMEKEY'
			execute (@cStr)

			--  STORAGEID  
			execute ('alter table ' + @cTableOut2 + ' add STORAGEID int')
			--  FACTS2 
			
			--  ,  
			select @cStr = 'drop table ' + (select DEPLOY_TABLE from #DTS where LINK = @nDS)
			execute (@cStr)
			
			--  
			update #DTS set DEPLOY_TABLE = @cTableOut2 where LINK = @nDS
		end

end
GO





exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8473' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_DEPLOY_MLT'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[SELECT_VER_DEPLOY_CL]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
	DROP PROCEDURE [dbo].[SELECT_VER_DEPLOY_CL]
GO



/*
:         .

 :
	@nMode -  
					-2 - : ;
					-1 - :   ;
					0 -      ;

 :	

 : 	
		exec dbo.SELECT_VER_DEPLOY_CL @nProjectID = 1973

:
	xxxx					- id 
	yyyy					- id 
	zzzz					- id 
	
	FACTS_xxxx				-   
	FACTS_xxxx_yyyy			-    
	FACTS3_xxxx_yyyy		-      
	FACTS3_xxxx_yyyy_zzzz	-     / ,      
	CL_xxxx_zzzz			-   
	CLD_xxxx				-   
	TIME_xxxx				-  
	CL_xxxx_zzzz			-    

   :
	-    
	-    
      .       

:
	 ..

*/
create procedure [dbo].[SELECT_VER_DEPLOY_CL]
as
begin
	set transaction isolation level read uncommitted
	set nocount on
	set dateformat ymd

	declare @cStr varchar(max), @nClassId int, @cDimension varchar(200), @nVersionST int, @nParentClassId int, @nClassIdOld int,
		@cIns varchar(max), @cUpdate varchar(max), @cUpdate1 varchar(max), @cDel varchar(max), @cParent varchar(20), @nHType int


	declare @V32 table (DESCRIPTIONID int, [NAME] varchar(128), [MASK] varchar(24), [LEVEL] int, STARTPOSITION int, [LENGTH] int, [TYPE] int)

	select @cStr = '', @cIns = '', @cUpdate = '', @cUpdate1 = '', @cDel = ''
	
	--      .   ,   "  "
	select A.CLASSIFICATORID, count(*) as CNT
	into #V321
	from (select distinct CLASSIFICATORID, [TYPE] from [CLASSIFICATORDESCRIPTION] where [TYPE] > 0) A
	group by CLASSIFICATORID
	having count(*)>1
	
	if exists(select * from #V321)
		update ClassificatorDescription set [TYPE] = 3 from #V321 V where ClassificatorDescription.ClassificatorID = V.ClassificatorID


	--     
	while exists (select * from #STD)
		begin
			select top 1 @nClassId = CLASSIFICATORID, @cDimension = DIMENSION, @nVersionST = [VERSIONID] from #STD
			select @nClassIdOld = @nClassId
			
			select @cStr = @cStr + '
				if not object_id(''' + @cDimension + ''') is Null drop table ' + @cDimension

			select @cStr = @cStr + '
			create table ' + @cDimension + ' (CLASSIFICATORID int, [] varchar(30), [] varchar(1000), [] varchar(1024)'

			--   
			select @nParentClassId = cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @nClassId

			--  
			if isnull(@nParentClassId,0) > 0
				select @nClassId = @nParentClassId

			insert @V32 (DESCRIPTIONID, [NAME], [MASK], [LEVEL], STARTPOSITION, [LENGTH], [TYPE])
			select distinct DESCRIPTIONID, [NAME], [MASK], [LEVEL], STARTPOSITION, [LENGTH], [TYPE]
			from [CLASSIFICATORDESCRIPTION]
			where CLASSIFICATORID = @nClassId and [TYPE] > 0
			order by [TYPE], [LEVEL]
			
			--   
			insert @V32 (DESCRIPTIONID, [NAME], [TYPE])
			select CLATTRID,left(NAME,128),-1
			from CLASSIFICATORS_ATTR
			where CLASSIFICATORID = @nClassId and OBJECT is null

			declare @nClsType int,@cClFieldName nvarchar(30)
			select @nClsType = [TYPE] from [CLASSIFICATORS] where [CLASSIFICATORID] = @nClassId

			if @nClsType = 3
				select @cStr = @cStr + ', HShow varchar(1060)'
						
			if exists (select * from @V32)
				begin
					select @cStr = @cStr + ','
												
					declare @nLevel int, @nStartPosition int, @nLength int, @nType int, @cMask varchar(24),
						@nSumLevel int, @nMaxLevel int, @nLevelUpd int, @nDescrId int, @cFieldKey varchar(300), @cFieldShow varchar(300)
						
					select @nSumLevel = 0
					select @nMaxLevel = max([LEVEL]) from @V32
					select @cDel = 'delete ' + @cDimension + ' where'

					declare CLDESCR scroll cursor for select distinct DESCRIPTIONID, [MASK], [LEVEL], STARTPOSITION, [LENGTH], [TYPE] from @V32 order by [TYPE], [LEVEL]

					open CLDESCR

					if @@CURSOR_ROWS > 0
						begin
							fetch next from CLDESCR into @nDescrId, @cMask, @nLevel, @nStartPosition, @nLength, @nType

							if @nType <> -2
								select @cUpdate =  @cUpdate + char(9) + char(13) + 'update ' + @cDimension + ' set '

							while @@FETCH_STATUS = 0
								begin
									if @nType = 1 --   
										begin
											select @cFieldKey = '[D_KEY_' + convert(varchar(20),@nDescrId) + ']'
											select @cFieldShow = '[D_SHOW_' + convert(varchar(20),@nDescrId) + ']'
						
											select @cStr = @cStr + @cFieldKey + ' varchar(30),'
												
											if @nClsType = 1
												select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldKey + ' = substring(D.[], ' + rtrim(ltrim(@nStartPosition)) + ', ' + rtrim(ltrim(@nLength)) + '),'

											if @nClsType = 2
												select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldKey + ' = left(D.[], ' + convert(varchar(20), @nLength) + ') + isnull(replicate(''0'',' + convert(varchar(20), len(@cMask) - @nLength) + '),''''),'

											select @cStr = @cStr + @cFieldShow + ' varchar(' + rtrim(ltrim(@nLength)) + '),'
											select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldShow + ' = substring(D.[], ' + rtrim(ltrim(@nStartPosition)) + ', ' + rtrim(ltrim(@nLength)) + '),'

										end
										
									if @nType = 2 --   
										begin
											select @cFieldKey = '[D_KEY_' + convert(varchar(20),@nDescrId) + ']'
											select @cFieldShow = '[D_SHOW_' + convert(varchar(20),@nDescrId) + ']'

											select @cStr = @cStr + @cFieldKey + ' varchar(30),'

											if @nClsType = 1
												select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldKey + ' = substring(D.[], ' + rtrim(ltrim(@nStartPosition)) + ', ' + rtrim(ltrim(@nLength)) + '),'

											if @nClsType = 2
												select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldKey + ' = left(D.[], ' + convert(varchar(20), @nLength) + ') + isnull(replicate(''0'',' + convert(varchar(20), len(@cMask) - @nLength) + '),''''),'

											select @cStr = @cStr + @cFieldShow + ' varchar(1060),'
											
											if @nLevel < @nMaxLevel
												begin
													select @nLevelUpd = @nLevel
													select @nSumLevel = @nSumLevel + @nLength
													
													if @nClsType = 1
													select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldShow + ' = (select top 1 left(CL.[], 1000) from ' + @cDimension + ' CL where right(CL.[], ' + convert(varchar(20),len(@cMask) - @nSumLevel) + ') = ''' + isnull(replicate('0', len(@cMask) - @nSumLevel),'') + ''' and left(CL.[],' + convert(varchar(20),@nSumLevel) + ')=left(D.[],' + convert(varchar(20),@nSumLevel) + ')),'
													if @nClsType = 2
														select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldShow + ' = (select top 1 left(CL.[], 1000) from ' + @cDimension + ' CL where right(CL.[], ' + convert(varchar(20),len(@cMask) - @nLength) + ') = ''' + isnull(replicate('0', len(@cMask) - @nLength),'') + ''' and left(CL.[],' + convert(varchar(20),@nLength) + ')=left(D.[],' + convert(varchar(20),@nLength) + ')),'
													
													while @nLevelUpd < @nMaxLevel
														begin
															select @nLevelUpd = @nLevelUpd + 1
															if @nClsType = 1
															select @cUpdate1 = @cUpdate1 + char(9) + char(13) + '
															update ' + @cDimension + ' set [D_SHOW_' + (select convert(varchar(20), [DESCRIPTIONID]) from @V32 where [TYPE] = @nType and [LEVEL] = @nLevelUpd) + '] = null where right([], ' + convert(varchar(20),len(@cMask) - @nSumLevel) + ') = ''' + isnull(replicate('0', len(@cMask) - @nSumLevel),'') + ''''
															if @nClsType = 2
																select @cUpdate1 = @cUpdate1 + char(9) + char(13) + '
																update ' + @cDimension + ' set [D_SHOW_' + (select convert(varchar(20), [DESCRIPTIONID]) from @V32 where [TYPE] = @nType and [LEVEL] = @nLevelUpd) + '] = null where right([], ' + convert(varchar(20),len(@cMask) - @nLength) + ') = ''' + isnull(replicate('0', len(@cMask) - @nLength),'') + ''''

														end
												end
											else
												begin
													select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldShow + ' = left([], 1000),'
												end									
										end
										
										--          
										if ((@nType = 3) or (@nType = 4))
											begin

												--       
												if (@nType = 3)
													select @cClFieldName = ''
												else 
													select @cClFieldName = ''

												select @cFieldKey = '[D_KEY_' + convert(varchar(20),@nDescrId) + ']'
												select @cFieldShow = '[D_SHOW_' + convert(varchar(20),@nDescrId) + ']'
												
												select @cStr = @cStr + @cFieldKey + ' varchar(30),'

												if @nClsType = 1
													select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldKey + ' = substring(D.[], ' + rtrim(ltrim(@nStartPosition)) + ', ' + rtrim(ltrim(@nLength)) + '),'

												if @nClsType = 2
													select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldKey + ' = left(D.[], ' + convert(varchar(20), @nLength) + ') + isnull(replicate(''0'',' + convert(varchar(20), len(@cMask) - @nLength) + '),''''),'

												select @cStr = @cStr + @cFieldShow + ' varchar(1060),'
												
												if @nLevel < @nMaxLevel
													begin
														select @nLevelUpd = @nLevel
														select @nSumLevel = @nSumLevel + @nLength
														select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldShow + ' = (select top 1 left(CL.[], 30) + '': '' + left(CL.[' + @cClFieldName + '], 1025) from ' + @cDimension + ' CL where CL.[]=(''' + isnull(replicate('0', @nStartPosition - 1),'') + ''' + substring(D.[], ' + convert(varchar(20),@nStartPosition) + ', ' + convert(varchar(20), @nLength) + ') + ''' + isnull(replicate('0', len(@cMask) - @nStartPosition - @nLength + 1),'') + ''') and substring(CL.[], ' + convert(varchar(20),@nStartPosition) + ', ' + convert(varchar(20), @nLength) + ') = substring(D.[], ' + convert(varchar(20),@nStartPosition) + ', ' + convert(varchar(20), @nLength) + ')),'
														select @nLevelUpd = @nLevelUpd + 1
--select 1, @nClassId, @cUpdate1
														select @cUpdate1 = @cUpdate1 + char(9) + char(13) + '
														update ' + @cDimension + ' set [D_SHOW_' + (select convert(varchar(20), [DESCRIPTIONID]) from @V32 where [TYPE] = @nType and [LEVEL] = @nLevelUpd) + '] = null where (''' + isnull(replicate('0', @nStartPosition - 1),'') + ''' + substring([], ' + convert(varchar(20),@nStartPosition) + ', ' + convert(varchar(20), @nLength) + ') + ''' + isnull(replicate('0', len(@cMask) - @nStartPosition - @nLength + 1),'') + ''') = []'
--select 2, @nClassId, @cUpdate1
													end
												else
													begin
														select @cUpdate = @cUpdate + char(9) + char(13) + @cFieldShow + ' = (select top 1 left(CL.[], 30) + '': '' + left(CL.[' +  @cClFieldName + '], 1025) from ' + @cDimension + ' CL where CL.[]=(''' + isnull(replicate('0', @nStartPosition - 1),'') + ''' + substring(D.[], ' + convert(varchar(20),@nStartPosition) + ', ' + convert(varchar(20), @nLength) + ')) and substring(CL.[], ' + convert(varchar(20),@nStartPosition) + ', ' + convert(varchar(20), @nLength) + ') = substring( D.[], ' + convert(varchar(20),@nStartPosition) + ', ' + convert(varchar(20), @nLength) + ')),'
													end
											end
											
										if @nType = -1 -- 
											begin
												select @cStr = @cStr + '[ATTR_NAME_' + convert(varchar(20), @nDescrId) + '] varchar(4000),'
												select @cUpdate = @cUpdate + char(9) + char(13) + '[ATTR_NAME_' + convert(varchar(20), @nDescrId) + '] = (select top 1 left(CLA.VALUE, 4000) from CLASSIFICATORS_APP CLA where CLA.CLASSIFICATORID = D.CLASSIFICATORID and CLA.CLATTRID = ' + convert(varchar(20), @nDescrId) + '),'
											end
										
									fetch next from CLDESCR into @nDescrId, @cMask, @nLevel, @nStartPosition, @nLength, @nType
								end
						end

					select @cStr = left(@cStr, len(@cStr) - 1)
					
					if @cUpdate <> ''
						begin
							select @cUpdate = left(@cUpdate, len(@cUpdate) - 1)
							select @cUpdate =  @cUpdate + ' '
						end
					
					select @cUpdate = @cUpdate + '
					from ' + @cDimension + ' D'

					if right(@cDel, 5) = 'where'
						begin
							select @cDel = ''
						end
					else
						begin
							select @cDel =  left(@cDel, len(@cDel) - 3) + char(9) + char(13)	
						end

					close CLDESCR
					deallocate CLDESCR
				end

			select @cStr = @cStr + ', PARENTCLASSIFICATORID int)'

			select @cParent = convert(varchar(20), [PARENT]) from [#DTS] where LINK = @nVersionST

			--  
			select @cIns = @cIns + '
				insert ' + @cDimension + ' (CLASSIFICATORID, [], [], PARENTCLASSIFICATORID, []) execute SELECT_CL_INFO @nMode = 3, @nVerID = ' + @cParent + ', @nClassId = ' + convert(varchar(20), @nClassId)

			if @cUpdate <> '' and right(@cUpdate, 1) = ','
				select @cUpdate = left(@cUpdate, len(@cUpdate) - 1)
				
			if @nClsType = 3
				begin
					select @nHType = isnull((select top 1 htype from dbo.ClassificatorDescription where CLASSIFICATORID = @nClassId),2)

					select @cUpdate1 = isnull(@cUpdate1,'') + char(9) + char(13) + '
					update ' + @cDimension + ' set HShow = left(' + 
					case
						when @nHType = 1 then '[]'
						when @nHType = 2 then '[]'
						when @nHType = 3 then '[] + '': '' + []'
						when @nHType = 4 then '[] + '': '' + []'
					end
					+ ', 1060)'
				end	

			delete @V32 
			
			--  
			if isnull(@nParentClassId,0) > 0
				select @nClassId = @nClassIdOld
			 
			delete #STD where CLASSIFICATORID = @nClassId
		end


--select @cStr
--select @cIns
--select @cDel
--select @cUpdate
--select @cUpdate1
			
	execute (@cStr)
	execute (@cIns)
	execute (@cDel)
	execute (@cUpdate)
	execute (@cUpdate1)

end
GO



exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8573' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'SELECT_VER_DEPLOY_CL'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[PACKAGE_REPLACE]') AND type in (N'P', N'PC'))
	DROP PROCEDURE [dbo].[PACKAGE_REPLACE]
GO


-- =============================================
-- Author:		<FEST>
-- Create date: <02.11.2010>
-- Description:	< >
-- =============================================
--     #InputClassTable(SourceClassificatorID int,TargetClassificatorID int,Stat int)
--  SourceClassificatorID -  
--  TargetClassificatorID -  

create procedure [dbo].[PACKAGE_REPLACE]
	@nVerID	int,
	@paramStr varchar(1000)=''
as
begin
	set nocount on
	
	--  
	create table #Param (ParaName varchar(100), Value int)
	insert #Param (ParaName, Value) select dbo.j_sub_str(VALUE,'=',1),dbo.j_sub_str(VALUE,'=',2) from dbo.StrSplit(@paramStr,'#')

	--   
	if object_id('tempdb..#InputClassTable') is null
		begin
			raiserror('   #InputClassTable',16,1)
			return
		end	
		
	declare @nDictVersion int, @nDictDataSource int, @nDictProj int, @nDictAlgoritm int, @cSourceClassificatorID varchar(20),
		@cTargetClassificatorID varchar(20), @cXml varchar(max), @nFilterId int, @cStr varchar(8000), @uniqId varchar(50),
		@Message nvarchar(1000)
	
	-- 
	select @nDictVersion    = dbo.obj_id('DICTIONARY_VERSION')	
	select @nDictDataSource = dbo.obj_id('DICTIONARY_DATASOURCE')
	select @nDictProj		= dbo.obj_id('DICTIONARY_PROJECT')
	select @nDictAlgoritm	= dbo.obj_id('DICTIONARY_ALGORITHM_DWH')
	select @uniqId = newid()

	--      
	create table #DataSources (VersionID int)
	
	--   -  (nDataSourceId)
	if exists(select * from #param where ParaName = 'nDataSourceId' and Value > 0)
		insert #DataSources (VersionID) select Value from #param where ParaName = 'nDataSourceId'
	else
		insert #DataSources (VersionID)
		select distinct V.VersionID
		from dbo.tree_version (@nVerID, 'DOWN') TV, VERSION V
		where TV.LINK = V.VersionID and V.[OBJECT] = @nDictDataSource

	--   -    @nVerID
	select TV.ORDERS, [LINK], [LINK_SELF], LEVELS, convert(int, Null) as [OBJECT]
	into #VER
	from dbo.TREE_VERSION(@nVerID, 'DOWN')  TV, VERSION V
	where TV.LINK = V.VersionID and V.OBJECT = dbo.obj_id('DICTIONARY_VERSION')
	
	--    
	declare @TranCounter int
    select @TranCounter = @@TRANCOUNT
	
    if @TranCounter > 0
        save transaction package_replace
    else
    	begin transaction
    
    --  
    begin try
		--   "" -----------------------------------------------------
		--  , ,      
		create table #DM1 (DatamigrationId int, SourceElementID int, ClassificatorID int)
		while exists(select * from #VER)
			begin
				select @nFilterId = LINK from #VER where ORDERS = (select min(ORDERS) from #VER)
		
				delete #DM1

				--  ,           
				insert #DM1 (DatamigrationId, SourceElementID, ClassificatorID)
				select DM.DATAMIGRATIONID, DM1.TargetElementID as SourceElementID, IC.SourceClassificatorID
				from dbo.DataMigration DM, #InputClassTable IC, dbo.DataMigration DM1
				where
					IC.SourceClassificatorID = DM.SourceElementID and
					exists (select * from t_version where deleted = 1 and versionid = @nFilterId and IC.SourceClassificatorID = ClassificatorID) and
					exists (select * from t_version where deleted = 0 and versionid = @nFilterId and DM.TargetElementID = ClassificatorID) and
					IC.SourceClassificatorID = DM1.SourceElementID and
					exists (select * from t_version where deleted = 1 and versionid = @nVerID and IC.SourceClassificatorID = ClassificatorID) and
					exists (select * from t_version where deleted = 0 and versionid = @nVerID and DM1.TargetElementID = ClassificatorID)

				--  
				update T_VERSION set ClassificatorID = DM.SourceElementID
				from #DM1 DM
				where T_VERSION.VersionID = @nFilterId and DM.ClassificatorID = T_VERSION.ClassificatorID and T_VERSION.Deleted = 1
				
				--  
				update DataMigration set SourceElementID = DM.SourceElementID
				from #DM1 DM
				where DataMigration.DATAMIGRATIONID = DM.DatamigrationId
				
				delete #VER where @nFilterId = LINK
			end
    
    
		--   -----------------------------------------------------
		--  ,     
		declare @nCMID int

		select CM.CMID
		into #CALC
		from CALC_MEASURES CM cross apply SLICE.nodes('/SourceMeasureSlice') a(col)
		where a.col.value('@SourceDsId', 'int') in (select VersionID from #DataSources)
			or a.col.value('@TargetDsId', 'int') in (select VersionID from #DataSources)
			
--select 1, count(*) from #CALC

		while exists(select * from #CALC)
			begin
				select top 1 @nCMID = CMID from #CALC
				
				select @cXml = convert(varchar(max), SLICE) from CALC_MEASURES where CMID = @nCMID
				
				update #InputClassTable set Stat = 0
				while exists(select * from #InputClassTable where Stat = 0)
					begin
						select top 1 @cSourceClassificatorID = SourceClassificatorID , @cTargetClassificatorID = TargetClassificatorID from #InputClassTable where Stat = 0
						
						--  
						select @cXml = replace(@cXml,'<el>' + @cSourceClassificatorID + '</el>','<el>' + @cTargetClassificatorID + '</el>')
						
						--   
						select @Message = left('   id=' + @cSourceClassificatorID
						+ '   c id=' + @cTargetClassificatorID
						+ '; :' + convert(varchar(20), dbo.ClassificatorIdParent(@cSourceClassificatorID))
						+ ';  : (' + convert(varchar(20),@nCMID) + ') "' + (select NAME from CALC_MEASURES where CMID = @nCMID) + '"'
						,1000)
						
						exec [dbo].[ELM_ADDEVENT] @TYPE  = 1, @CATEGORY  = ' ', @MESSAGE = @Message, @OBJECT = @uniqId
						----------------------
						
						update #InputClassTable set Stat = 1 where @cSourceClassificatorID = SourceClassificatorID and @cTargetClassificatorID = TargetClassificatorID
					end
				
				update CALC_MEASURES set SLICE = convert(xml, @cXml) where CMID = @nCMID
				
				delete #CALC where @nCMID = CMID
			end
		
		--   -----------------------------------------------------
		--   -    (nFilterReplace)
		if exists(select * from #param where ParaName = 'nFilterReplace' and Value > 0)
			begin
				--     
				declare @cClId varchar(20)
				
				select FT.FILTERID
				into #RT
				from FILTER FT, #DataSources DT
				where DT.VersionID = FT.VersionID

--select 2, count(*) from #RT

				while exists(select * from #RT)
					begin
						select top 1 @nFilterId = FILTERID from #RT
						
						select @cXml = convert(varchar(max), [XML]) from FILTER where FILTERID = @nFilterId
						
						update #InputClassTable set Stat = 0
						while exists(select * from #InputClassTable where Stat = 0)
							begin
								select top 1 @cSourceClassificatorID = SourceClassificatorID , @cTargetClassificatorID = TargetClassificatorID from #InputClassTable where Stat = 0
								
								--  
								-- <DICTIONARY_CLASSIFICATOR-472872>810416</DICTIONARY_CLASSIFICATOR-472872>
								select @cClId = dbo.ClassificatorIdParent(@cSourceClassificatorID)
								select @cXml = replace(@cXml,'<DICTIONARY_CLASSIFICATOR-' + @cClId + '>' + @cSourceClassificatorID + '</DICTIONARY_CLASSIFICATOR-' + @cClId + '>','<DICTIONARY_CLASSIFICATOR-' + @cClId + '>' + @cTargetClassificatorID + '</DICTIONARY_CLASSIFICATOR-' + @cClId + '>')
								
								--    
								-- <ClassificatorId>876064</ClassificatorId>
								select @cXml = replace(@cXml,'<ClassificatorId>' + @cSourceClassificatorID + '</ClassificatorId>','<ClassificatorId>' + @cTargetClassificatorID + '</ClassificatorId>')
								
								--  ,  
								-- <string>815436</string> 
								select @cXml = replace(@cXml,'<string>' + @cSourceClassificatorID + '</string>','<string>' + @cTargetClassificatorID + '</string>')
								

								--   
								select @Message = left('   id=' + @cSourceClassificatorID
								+ '   c id=' + @cTargetClassificatorID
								+ '; :' + convert(varchar(20), dbo.ClassificatorIdParent(@cSourceClassificatorID))
								+ ';  : (' + convert(varchar(20),@nFilterId) + ') "' + (select NAME from FILTER where FILTERID = @nFilterId) + '"'
								,1000)
								
								exec [dbo].[ELM_ADDEVENT] @TYPE  = 1, @CATEGORY  = ' ', @MESSAGE = @Message, @OBJECT = @uniqId
								----------------------
								
								update #InputClassTable set Stat = 1 where @cSourceClassificatorID = SourceClassificatorID and @cTargetClassificatorID = TargetClassificatorID
							end
						
						update FILTER set [XML] = convert(xml, @cXml) where FILTERID = @nFilterId
						
						delete #RT where @nFilterId = FILTERID
					end
			end		

		--    --------------------------------------
		select V.VERSIONID, convert(int,0) as Stat, V.DATA
		into #DS
		from VERSION V, #DataSources DT
		where V.VersionID = DT.VersionID and not V.DATA is null

		while exists(select * from #DS where Stat = 0)
			begin
				select top 1 @nFilterId = VERSIONID, @cXml = convert(varchar(max), [DATA]) from #DS
				
				update #InputClassTable set Stat = 0
				while exists(select * from #InputClassTable where Stat = 0)
					begin
						select top 1 @cSourceClassificatorID = SourceClassificatorID , @cTargetClassificatorID = TargetClassificatorID from #InputClassTable where Stat = 0
						
						--  
						-- <DICTIONARY_CLASSIFICATOR-472872>810416</DICTIONARY_CLASSIFICATOR-472872>
						select @cClId = dbo.ClassificatorIdParent(@cSourceClassificatorID)
						select @cXml = replace(@cXml,'<DICTIONARY_CLASSIFICATOR-' + @cClId + '>' + @cSourceClassificatorID + '</DICTIONARY_CLASSIFICATOR-' + @cClId + '>','<DICTIONARY_CLASSIFICATOR-' + @cClId + '>' + @cTargetClassificatorID + '</DICTIONARY_CLASSIFICATOR-' + @cClId + '>')
						
						--   
						select @Message = left('   id=' + @cSourceClassificatorID
						+ '   c id=' + @cTargetClassificatorID
						+ '; :' + convert(varchar(20), dbo.ClassificatorIdParent(@cSourceClassificatorID))
						+ '; : (' + convert(varchar(20),@nFilterId) + ') "' + (select Name from VERSION where VERSIONID = @nFilterId) + '"'
						,1000)
						
						exec [dbo].[ELM_ADDEVENT] @TYPE  = 1, @CATEGORY  = ' ', @MESSAGE = @Message, @OBJECT = @uniqId
						----------------------

						
						update #InputClassTable set Stat = 1 where @cSourceClassificatorID = SourceClassificatorID and @cTargetClassificatorID = TargetClassificatorID
					end
				
				update VERSION set [DATA] = convert(xml, @cXml) where VERSIONID = @nFilterId
				
				delete #DS where @nFilterId = VERSIONID
			end

		--     ------------------------------------
		select @cStr = '
		update T_STORAGE set ClassificatorID = IC.TargetClassificatorID
		from STORAGE ST, T_STORAGE TS, #DataSources DT, #InputClassTable IC
		where DT.VersionID = ST.VersionID and ST.STORAGEID = TS.STORAGEID and TS.ClassificatorID = IC.SourceClassificatorID'
		
		if exists(select * from #param where ParaName = 'nMeasureId' and Value > 0)
			select @cStr = @cStr + ' and ST.MeasureId = ' + (select convert(varchar(20),Value) from #param where ParaName = 'nMeasureId' and Value > 0) + ')'

		if exists(select * from #param where ParaName = 'dtBeg' and Value > 0) and exists(select * from #param where ParaName = 'dtEnd' and Value > 0)
			select @cStr = @cStr + ' and ST.Timekey beetween ' + (select convert(varchar(20),Value) from #param where ParaName = 'dtBeg' and Value > 0) + ' and ' + (select convert(varchar(20),Value) from #param where ParaName = 'dtEnd' and Value > 0)
			
		exec (@cStr)
		
		--   
		select @Message = left('    .',1000)
		exec [dbo].[ELM_ADDEVENT] @TYPE  = 1, @CATEGORY  = ' ', @MESSAGE = @Message, @OBJECT = @uniqId
		----------------------

		
		--  -----------------------------------------------------
		--  
		insert #VER (ORDERS, LINK, LINK_SELF, LEVELS, OBJECT)
		select TV.ORDERS, [LINK], [LINK_SELF], LEVELS, convert(int, Null) as [OBJECT]
		from dbo.TREE_VERSION(Null, 'DOWN')  TV, VERSION V
		where TV.LINK = V.VersionID and V.OBJECT = dbo.obj_id('DICTIONARY_VERSION')

		--     
		select distinct V.VersionID
		into #PROJ
		from #DataSources DS cross apply dbo.TREE_VERSION(DS.VersionID,'UP') TV, VERSION V
		where V.VersionID = TV.LINK and V.OBJECT = dbo.obj_id('DICTIONARY_PROJECT')

		--         
		select A.VersionID, TV.LINK, dbo.VersionParent(TV.LINK) as PARENT, convert(int, null) as LEVELS, convert(int, null) as BRANCH, convert(int, null) as PARENT1
		into #DTS
		from #PROJ A cross apply dbo.TREE_VERSION(A.VersionID, 'DOWN') TV, VERSION V
		where TV.LINK = V.VersionID and V.OBJECT = dbo.obj_id('DICTIONARY_DATASOURCE')

		update #DTS set [LEVELS] = V.[LEVELS] from [#VER] V where V.[LINK] = [#DTS].[PARENT]

		declare @nMax int, @nMin int
		select @nMax = max([LEVELS]) from #DTS
		select @nMin = min([LEVELS]) from #DTS
		update [#DTS] set [PARENT1] = [PARENT]
		while @nMax > @nMin
			begin
				update #DTS set BRANCH = dbo.[VersionParent]([PARENT1]), LEVELS = LEVELS - 1 where LEVELS = @nMax
				update #DTS set [PARENT] = D2.[PARENT] from #DTS, #DTS D2 where #DTS.[PARENT] = D2.BRANCH
				select @nMax = @nMax - 1
			end

		select V.VersionID
		into #ALG
		from (select distinct VersionID from #DTS) P cross apply dbo.TREE_VERSION(P.VersionID, 'DOWN') TV, VERSION V
		where TV.LINK = V.VersionID and V.OBJECT = @nDictAlgoritm
		
		update T_MEASURE_FILTER set CLASSIFICATORID = IC.TargetClassificatorID
		from #ALG A, T_MEASURE TM, T_MEASURE_FILTER TMF, #InputClassTable IC
		where A.VersionID = TM.VERSIONID and TM.MEASUREID = TMF.MEASUREID and TMF.CLASSIFICATORID = IC.SourceClassificatorID

		--   
		select @Message = left('    .',1000)
		exec [dbo].[ELM_ADDEVENT] @TYPE  = 1, @CATEGORY  = ' ', @MESSAGE = @Message, @OBJECT = @uniqId
		----------------------
	
		-- classificators_app -----------------------------------------------------
		update CLASSIFICATORS_APP set VALUE = IC.TargetClassificatorID
		from #InputClassTable IC, CLASSIFICATORS_APP CA, CLASSIFICATORS_ATTR CAT
		where not CAT.LINKEDCLASSIFICATORID is null and CAT.LINKEDCLASSIFICATORID = dbo.ClassificatorIdParent(IC.SourceClassificatorID) and
			CA.CLATTRID = CAT.CLATTRID and dbo.CheckClassInVersion(@nVerID, CAT.LINKEDCLASSIFICATORID) = 1 and CA.VALUE = IC.SourceClassificatorID

		--   
	
		--    -----------------------------------------------------
		if exists(select * from #param where ParaName = 'nDelCl' and Value > 0)
			begin
				create table #t_doc_links (link [varchar](100) NULL, versionid [varchar](100) null,classId int)

				insert into #t_doc_links (link, versionid, classId)
				select SourceClassificatorID, @nVerID, dbo.ClassificatorIdParent(SourceClassificatorID) from #InputClassTable
				exec CLASIFICATORS_ITEM_DEL
				
				--   
				select @Message = left('   .',1000)
				exec [dbo].[ELM_ADDEVENT] @TYPE  = 1, @CATEGORY  = ' ', @MESSAGE = @Message, @OBJECT = @uniqId
				----------------------
			end

		if @TranCounter = 0
			commit transaction
	end try
	begin catch
		declare @ErrorMessage nvarchar(4000), @ErrorSeverity int, @ErrorState int
		raiserror (@ErrorMessage, @ErrorSeverity, @ErrorState)

		if @TranCounter = 0
			rollback transaction
        else
            if xact_state() <> -1
                rollback transaction package_replace;

		return 1

	end catch
	
	return	1
end

GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8410' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'PROCEDURE',@level1name=N'PACKAGE_REPLACE'
GO



